/**
dco/c++ v3.6.2
    -- Algorithmic Differentiation by Operator Overloading in C++

COPYRIGHT 2022
The Numerical Algorithms Group Limited and
Software and Tools for Computational Engineering @ RWTH Aachen University

This file is part of dco/c++.
**/

#include "g.hpp"

template <typename DCO_BASE_TYPE> void gt1(int n, DCO_BASE_TYPE& x, DCO_BASE_TYPE& xt1) {
  for (int i = 0; i < n; i++) {
    xt1 = cos(x) * xt1;
    x = sin(x);
  }
}

void g_make_gap(int n, DCO_TYPE& x) {
  typedef DCO_MODE::value_t DCO_VALUE_TYPE;
  typedef DCO_MODE::local_gradient_t local_gradient_t;

  DCO_TYPE xc = x; // copy required because output=input
  local_gradient_t y1o(x);
  // new tape index for output x

  DCO_VALUE_TYPE xt1 = 1.;
  gt1(n, value(x), xt1); // value of x changed

  y1o.put(xc, xt1); // add edge from new output to input
}
