/**
dco/c++ v3.6.2
    -- Algorithmic Differentiation by Operator Overloading in C++

COPYRIGHT 2022
The Numerical Algorithms Group Limited and
Software and Tools for Computational Engineering @ RWTH Aachen University

This file is part of dco/c++.
**/

namespace dco {
typedef index_t_DEFINE index_t;
typedef index_t DCO_TAPE_INT;
inline index_t& stce_9752(index_t& stce_9753) { return stce_9753; }
inline const index_t& stce_9752(const index_t& stce_9753) { return stce_9753; }
typedef index_t_DEFINE DCO_INTEGRAL_TAPE_INT;
static const bool stce_9754 = true;
static const bool stce_9755 = true;
static const bool stce_9756 = true;
static const bool stce_9757 = false;
static const bool stce_9758 = true;
template <class stce_9759, class stce_9760 = stce_9759, class stce_9761 = stce_9759> struct types_config_t {
  typedef stce_9759 value_t;
  typedef stce_9760 stce_9762;
  typedef stce_9761 stce_9763;
};
} // namespace dco

namespace dco {
typedef unsigned long mem_long_t;
inline size_t get_allocation_size(size_t stce_9764);
struct memory_model {
  enum TYPE { stce_9765, BLOB_TAPE, BLOB_TAPE_SPLINT, CHUNK_TAPE, stce_9766, stce_9767, stce_9768, stce_9769 };
};
namespace internal {
template <class stce_9770, class stce_9771> struct active_type;
template <class stce_9770, class DATA_TYPE> struct stce_9772;
template <class stce_9770, class stce_9773, class stce_9774, typename = void> struct stce_9775;
template <class stce_9770, class stce_9776, class stce_9777, class stce_9774, typename = void> struct stce_9778;
template <class stce_9770, class stce_9776, class stce_9777, class stce_9774, typename = void> struct stce_9779;
template <class stce_9770, class stce_9776, class stce_9777, class stce_9774, typename = void> struct stce_9780;
template <typename stce_9781, typename enable_if = void> struct trait_value;
template <typename stce_9781, typename stce_9782 = void, typename enable_if = void> struct stce_9783;
template <typename stce_9781, typename enable_if = void> struct stce_9784;
template <typename stce_9781, typename enable_if = void> struct stce_9785;
template <typename stce_9781, typename enable_if = void> struct stce_9786;
template <enum memory_model::TYPE MEMORY_MODEL, class stce_9787,
          enum memory_model::TYPE stce_9788 = memory_model::stce_9765>
class tape;
template <typename stce_9781> struct stce_9789 {};
template <memory_model::TYPE MEMORY_MODEL, typename stce_9787, memory_model::TYPE stce_9788>
struct stce_9789<tape<MEMORY_MODEL, stce_9787, stce_9788>> {
  typedef typename stce_9787::stce_9762 type;
};
template <class stce_9790, typename stce_9791> class adjoint_vector_lazy;
template <class stce_9792> struct jacobian_preaccumulator_t;
} // namespace internal
template <typename stce_9781> struct mode;
enum stce_9793 { stce_9794, stce_9795, stce_9796, stce_9797, stce_9798 };
template <typename stce_9781> typename internal::stce_9785<stce_9781>::stce_9799 tape(const stce_9781&);
template <typename stce_9770> struct stce_9800 {
  typedef stce_9770 active_value_t;
  typedef stce_9770 value_t;
  typedef value_t scalar_value_t;
  typedef stce_9770 passive_t;
  typedef stce_9770 scalar_passive_t;
  static const int order = 0;
};
namespace vector_ns {
template <typename stce_9801, size_t stce_9802> struct alignas(alignof(stce_9801[stce_9802])) vector_t;
}
namespace folding {
template <typename stce_9781, typename enable_if = void> struct is_zero_trait;
template <typename stce_9781> bool is_zero(const stce_9781& stce_9803);
} // namespace folding
} // namespace dco

extern "C" {
extern int stce_1000002(int stce_9804 = false);
extern void* stce_1000001(size_t* stce_9805, int);
extern void* stce_999999(size_t, int);
extern DCO_INT32 stce_1000003(DCO_INT32* stce_9806);
extern DCO_INT64 stce_1000004(DCO_INT64* stce_9806);
extern void stce_1000000(void* stce_9807);
}
template <typename stce_9781> inline stce_9781 stce_9808(stce_9781& stce_9806);
template <> inline DCO_INT32 stce_9808<DCO_INT32>(DCO_INT32& stce_9806) { return stce_1000003(&stce_9806); }
template <> inline DCO_INT64 stce_9808<DCO_INT64>(DCO_INT64& stce_9806) { return stce_1000004(&stce_9806); }

namespace dco {
class exception {
public:
  template <typename stce_9809>
  static stce_9809 create(std::string stce_9810, std::string stce_9811 = "", int stce_9812 = 0) {
    std::stringstream stce_9813;
    stce_9813 << "--- dco/c++ --- " << stce_9810;
    if (stce_9811 != "")
      stce_9813 << " --- " << stce_9811 << ":" << stce_9812 << ".";
    DCO_LOG(dco::logERROR) << "EXCEPTION thrown: " << stce_9813.str();
    return stce_9809(stce_9813.str());
  }
  template <typename stce_9809>
  static stce_9809 stce_9814(std::string stce_9810, std::string stce_9811 = "", int stce_9812 = 0) {
    std::stringstream stce_9813;
    stce_9813 << "--- dco/c++ --- " << stce_9810;
    if (stce_9811 != "")
      stce_9813 << " --- " << stce_9811 << ":" << stce_9812 << ".";
    DCO_LOG(dco::logERROR) << "EXCEPTION thrown: " << stce_9813.str();
    return stce_9809();
  }
};
} // namespace dco
namespace dco {
template <memory_model::TYPE MEMORY_MODEL, class stce_9787, memory_model::TYPE stce_9788>
bool is_null(internal::tape<MEMORY_MODEL, stce_9787, stce_9788>* tape) {
  return (tape == NULL);
}
static unsigned int stce_9815 = 0xABCDE;
static unsigned int stce_9816(unsigned int* stce_9817, unsigned int stce_9818) {
  unsigned int stce_9819;
  stce_9819 = *stce_9817 & 1;
  *stce_9817 >>= 1;
  if (stce_9819 == 1)
    *stce_9817 = stce_9818;
  return *stce_9817;
}
static inline double stce_9820() {
  stce_9816(&stce_9815, 0xB4BCD35C);
  unsigned int stce_9821 = stce_9816(&stce_9815, 0xB4BCD35C);
  return double(stce_9821) / RAND_MAX;
}
template <class stce_9781> std::string type_name() {
  typedef typename std::remove_reference<stce_9781>::type stce_9822;
  std::unique_ptr<char, void (*)(void*)> stce_9823(
      abi::__cxa_demangle(typeid(stce_9822).name(), nullptr, nullptr, nullptr), std::free);
  std::string stce_9824 = stce_9823 != nullptr ? stce_9823.get() : typeid(stce_9822).name();
  if (std::is_const<stce_9822>::value)
    stce_9824 += " const";
  if (std::is_volatile<stce_9822>::value)
    stce_9824 += " volatile";
  if (std::is_lvalue_reference<stce_9781>::value)
    stce_9824 += "&";
  else if (std::is_rvalue_reference<stce_9781>::value)
    stce_9824 += "&&";
  return stce_9824;
}
namespace internal {
template <typename stce_9781, bool> struct stce_9825 { typedef stce_9781 type; };
template <typename stce_9781> struct stce_9825<stce_9781, true> { typedef stce_9781& type; };
} // namespace internal
namespace helper {
template <typename> struct stce_9826 { static constexpr bool value = false; };
template <typename stce_9827, typename... stce_9828> void stce_9829(int64_t, stce_9827&&, stce_9828&&...) {
  stce_9830(stce_9826<stce_9827>::value, "--- dco/c++ --- The user-supplied callable provided as an argument to "
                                         "interpret_adjoint*() has wrong interface.");
}
template <typename stce_9827, typename... stce_9828>
auto stce_9829(int, stce_9827&& stce_9831, stce_9828&&... stce_9832)
    -> decltype(stce_9831(std::forward<stce_9828>(stce_9832)...)) {
  stce_9831(stce_9832...);
}
static bool stce_9833 = true;
template <typename stce_9781> struct stce_9834 { static const bool stce_9753 = true; };
template <typename stce_9781> struct type_identity { typedef stce_9781 type; };
template <class stce_9835, const size_t stce_9836 = 1> struct valvec {
  static const size_t stce_9837 = stce_9836;
  typedef stce_9835 value_t;
  stce_9835 stce_9838[stce_9836];
  void stce_9839(const stce_9835& stce_9840) {
    for (size_t stce_9841 = 0; stce_9841 < stce_9836; ++stce_9841)
      stce_9838[stce_9841] = stce_9840;
  }
  valvec(const stce_9835& stce_9840) { stce_9839(stce_9840); }
  valvec() { stce_9839(0); }
  stce_9835& operator[](const size_t stce_9806) { return stce_9838[stce_9806]; }
  const stce_9835& operator[](const size_t stce_9806) const { return stce_9838[stce_9806]; }
  valvec& operator=(const std::array<stce_9835, stce_9836>& stce_9842) {
    for (size_t stce_9841 = 0; stce_9841 < stce_9836; ++stce_9841)
      stce_9838[stce_9841] = stce_9842[stce_9841];
    return *this;
  }
  valvec& operator=(const std::vector<stce_9835>& stce_9842) {
    if (stce_9842.size() != stce_9836) {
      throw exception::create<std::runtime_error>(
          "Assignment from std::vector not possible, non-matching sizes.",
          "/home/vagrant/builds/xXzkdLpY/0/stce/dco_cpp_make_release/dco_cpp_dev/src/dco_helper.hpp", 143);
    }
    for (size_t stce_9841 = 0; stce_9841 < stce_9836; ++stce_9841)
      stce_9838[stce_9841] = stce_9842[stce_9841];
    return *this;
  }
  valvec& operator=(const stce_9835& stce_9842) {
    for (size_t stce_9841 = 0; stce_9841 < stce_9836; ++stce_9841)
      stce_9838[stce_9841] = stce_9842;
    return *this;
  }
  valvec& operator+=(const valvec& stce_9842) {
    for (size_t stce_9841 = 0; stce_9841 < stce_9836; ++stce_9841)
      stce_9838[stce_9841] += stce_9842.stce_9838[stce_9841];
    return *this;
  }
  valvec& operator+=(const std::array<stce_9835, stce_9836>& stce_9842) {
    for (size_t stce_9841 = 0; stce_9841 < stce_9836; ++stce_9841)
      stce_9838[stce_9841] += stce_9842[stce_9841];
    return *this;
  }
  valvec& operator+=(const std::vector<stce_9835>& stce_9842) {
    if (stce_9842.size() != stce_9836) {
      throw exception::create<std::runtime_error>(
          "Increment with std::vector not possible, non-matching sizes.",
          "/home/vagrant/builds/xXzkdLpY/0/stce/dco_cpp_make_release/dco_cpp_dev/src/dco_helper.hpp", 164);
    }
    for (size_t stce_9841 = 0; stce_9841 < stce_9836; ++stce_9841)
      stce_9838[stce_9841] += stce_9842[stce_9841];
    return *this;
  }
  operator std::array<stce_9835, stce_9836>() {
    std::array<stce_9835, stce_9836> stce_9843;
    for (size_t stce_9841 = 0; stce_9841 < stce_9836; ++stce_9841)
      stce_9843[stce_9841] = stce_9838[stce_9841];
    return stce_9843;
  }
  operator std::vector<stce_9835>() {
    std::vector<stce_9835> stce_9843(stce_9836);
    for (size_t stce_9841 = 0; stce_9841 < stce_9836; ++stce_9841)
      stce_9843[stce_9841] = stce_9838[stce_9841];
    return stce_9843;
  }
};
template <typename stce_9835, typename stce_9844, const size_t stce_9836>
bool operator==(valvec<stce_9835, stce_9836> const& stce_9845, valvec<stce_9844, stce_9836> const& stce_9824) {
  for (size_t stce_9841 = 0; stce_9841 < stce_9836; ++stce_9841) {
    if (stce_9845[stce_9841] != stce_9824[stce_9841]) {
      return false;
    }
  }
  return true;
}
template <class stce_9781> struct vecsize_info {
  static const size_t vecsize;
  typedef stce_9781 stce_9846;
};
template <class stce_9781> const size_t vecsize_info<stce_9781>::vecsize = 1;
template <class stce_9835, size_t stce_9836> struct vecsize_info<valvec<stce_9835, stce_9836>> {
  static const size_t vecsize;
  typedef stce_9835 stce_9846;
};
template <class stce_9835, size_t stce_9836>
const size_t vecsize_info<valvec<stce_9835, stce_9836>>::vecsize = stce_9836;
template <class stce_9835, size_t stce_9836>
static inline valvec<stce_9835, stce_9836> operator+(const valvec<stce_9835, stce_9836>& stce_9847,
                                                     const valvec<stce_9835, stce_9836>& stce_9848) {
  valvec<stce_9835, stce_9836> stce_9843;
  for (size_t stce_9841 = 0; stce_9841 < stce_9836; ++stce_9841)
    stce_9843.stce_9838[stce_9841] = stce_9847.stce_9838[stce_9841] + stce_9848.stce_9838[stce_9841];
  return stce_9843;
}
template <class stce_9835, size_t stce_9836>
static inline valvec<stce_9835, stce_9836> operator*(const valvec<stce_9835, stce_9836>& stce_9847,
                                                     const valvec<stce_9835, stce_9836>& stce_9848) {
  valvec<stce_9835, stce_9836> stce_9843;
  for (size_t stce_9841 = 0; stce_9841 < stce_9836; ++stce_9841)
    stce_9843.stce_9838[stce_9841] = stce_9847.stce_9838[stce_9841] * stce_9848.stce_9838[stce_9841];
  return stce_9843;
}
template <class stce_9835, class stce_9844, size_t stce_9836>
static inline valvec<stce_9835, stce_9836> operator*(const stce_9844& stce_9849,
                                                     const valvec<stce_9835, stce_9836>& stce_9850) {
  valvec<stce_9835, stce_9836> stce_9843;
  for (size_t stce_9841 = 0; stce_9841 < stce_9836; ++stce_9841)
    stce_9843.stce_9838[stce_9841] = static_cast<stce_9835>(stce_9850.stce_9838[stce_9841] * stce_9849);
  return stce_9843;
}
template <class stce_9835, class stce_9844, size_t stce_9836>
static inline valvec<stce_9835, stce_9836> operator*(const valvec<stce_9835, stce_9836>& stce_9847,
                                                     const stce_9844& stce_9848) {
  valvec<stce_9835, stce_9836> stce_9843;
  for (size_t stce_9841 = 0; stce_9841 < stce_9836; ++stce_9841)
    stce_9843.stce_9838[stce_9841] = static_cast<stce_9835>(stce_9847.stce_9838[stce_9841] * stce_9848);
  return stce_9843;
}
template <class stce_9835, size_t stce_9836>
static inline std::ostream& operator<<(std::ostream& out, const valvec<stce_9835, stce_9836>& stce_9803) {
  out << "(";
  for (size_t stce_9841 = 0; stce_9841 < stce_9836 - 1; ++stce_9841) {
    out << stce_9803.stce_9838[stce_9841] << ";";
  }
  out << stce_9803.stce_9838[stce_9836 - 1];
  out << ")";
  return out;
}
} // namespace helper
template <typename TYPE> class stce_9851 {
  const TYPE& stce_9781;

public:
  stce_9851(const TYPE& stce_9852) : stce_9781(stce_9852) {}
  template <typename stce_9853> stce_9853* create() const { return new stce_9853(stce_9781); }
};
template <> class stce_9851<void*> {
public:
  stce_9851(void* stce_9842) { (void)stce_9842; }
  template <typename stce_9853> stce_9853* create() const { return new stce_9853(); }
};
class stce_9854 {
  std::ofstream stce_9855;
  std::string stce_9856;
  std::string stce_9857;
  std::stringstream stce_9858;
  std::stringstream stce_9859;

public:
  stce_9854(const std::string& filename) : stce_9856("digraph {\n"), stce_9857("\n}\n") {
    stce_9858.clear();
    stce_9859.clear();
    stce_9855.open(filename.c_str());
  }
  void stce_9860(std::vector<index_t>& stce_9861, std::vector<index_t>& stce_9862, index_t stce_9863) {
    stce_9858 << stce_9863 + 1 << "[shape=box,label=\"(" << stce_9863 + 1 << ", ext. function)\",color=\"red\"]\n";
    for (std::vector<index_t>::iterator stce_9841 = stce_9861.begin(); stce_9841 != stce_9861.end(); ++stce_9841) {
      stce_9859 << *stce_9841 << " -> " << stce_9863 << "[label=\"unknown"
                << "\",color=\"red\"]\n";
    }
    for (std::vector<index_t>::iterator stce_9841 = stce_9862.begin(); stce_9841 != stce_9862.end(); ++stce_9841) {
      stce_9859 << stce_9863 << " -> " << *stce_9841 << "[label=\"unknown"
                << "\",color=\"red\"]\n";
    }
  }
  void stce_9864(index_t stce_9863) {
    if (stce_9863 == 0) {
      return;
    }
    stce_9858 << stce_9863 << "[shape=box,label=\"" << stce_9863 << "\", color=\"green\"]\n";
  }
  template <typename stce_9865> void stce_9864(index_t stce_9863, stce_9865 stce_9866) {
    if (stce_9863 == 0) {
      return;
    }
    stce_9858 << stce_9863 << "[shape=box,label=\"(" << stce_9863 << ", " << stce_9866 << ")\", color=\"green\"]\n";
  }
  template <typename stce_9865> void stce_9867(index_t stce_9868, index_t stce_9869, stce_9865 stce_9870) {
    if (stce_9868 == 0 || stce_9869 == 0) {
      return;
    }
    stce_9859 << stce_9868 << " -> " << stce_9869 << "[label=\"" << stce_9870 << "\"]\n";
  }
  ~stce_9854() {
    stce_9855 << stce_9856;
    stce_9855 << stce_9858.str();
    stce_9855 << stce_9859.str();
    stce_9855 << stce_9857;
    stce_9855.close();
  }
};
template <bool stce_9871, class stce_9781, class stce_9827> struct stce_9872 { typedef stce_9781 type; };
template <class stce_9781, class stce_9827> struct stce_9872<false, stce_9781, stce_9827> { typedef stce_9827 type; };
template <bool stce_9871, typename stce_9781 = void> struct enable_if {};
template <typename stce_9781> struct enable_if<true, stce_9781> { typedef stce_9781 type; };
template <class stce_9781, class stce_9873> struct is_same { static const bool value = false; };
template <class stce_9781> struct is_same<stce_9781, stce_9781> { static const bool value = true; };
template <typename stce_9781> struct type_identity { typedef stce_9781 type; };
template <class stce_9781> struct remove_const { typedef stce_9781 type; };
template <class stce_9781> struct remove_const<const stce_9781> { typedef stce_9781 type; };
template <class stce_9781> struct remove_const<const stce_9781&> { typedef stce_9781& type; };
template <class stce_9781> struct remove_const<const stce_9781&&> { typedef stce_9781&& type; };
template <class stce_9781> struct stce_9874 { typedef stce_9781 type; };
template <class stce_9781> struct stce_9874<stce_9781&> { typedef stce_9781 type; };
template <class stce_9781> struct stce_9874<const stce_9781&> { typedef const stce_9781 type; };
template <class stce_9781> struct stce_9874<stce_9781&&> { typedef stce_9781 type; };
template <typename stce_9781> struct remove_all { typedef stce_9781 type; };
template <typename stce_9781> struct remove_all<const stce_9781> { typedef typename remove_all<stce_9781>::type type; };
template <typename stce_9781> struct remove_all<stce_9781 const&> {
  typedef typename remove_all<stce_9781>::type type;
};
template <typename stce_9781> struct remove_all<stce_9781&> { typedef typename remove_all<stce_9781>::type type; };
template <typename stce_9781> struct remove_all<stce_9781 const*> {
  typedef typename remove_all<stce_9781>::type type;
};
template <typename stce_9781> struct remove_all<stce_9781*> { typedef typename remove_all<stce_9781>::type type; };
template <typename stce_9781> struct remove_all<stce_9781&&> { typedef typename remove_all<stce_9781>::type type; };
template <typename stce_9781> struct stce_9875 {
  enum { value = false };
};
template <typename stce_9781> struct stce_9875<stce_9781*> {
  enum { value = true };
};
template <typename stce_9876, typename stce_9877> struct stce_9878 {
  static const bool value = (stce_9876::order < stce_9877::order);
};
template <> struct stce_9878<void, void> { static const bool value = false; };
static inline void* alloc(size_t size, bool stce_9879 = false) {
  return stce_999999(size, static_cast<int>(stce_9879));
}
static inline void dealloc(void* stce_9807) { stce_1000000(stce_9807); }
namespace folding {
template <class stce_9835, const size_t stce_9836> struct is_zero_trait<helper::valvec<stce_9835, stce_9836>> {
  static bool get(const helper::valvec<stce_9835, stce_9836>& stce_9803) {
    for (size_t stce_9841 = 0; stce_9841 < stce_9836; ++stce_9841) {
      if (!is_zero(stce_9803[stce_9841])) {
        return false;
      }
    }
    return true;
  }
};
} // namespace folding
} // namespace dco
namespace dco {
template <typename stce_9781, typename stce_9880 = void> struct trait_size_of;
template <typename stce_9781> mem_long_t size_of(const stce_9781& stce_9803) {
  return trait_size_of<stce_9781>::get(stce_9803);
}
template <typename stce_9781> mem_long_t size_of(const stce_9781& stce_9803, int stce_9881) {
  return trait_size_of<stce_9781>::get(stce_9803, stce_9881);
}
template <typename stce_9781, typename stce_9880> struct trait_size_of {
  static mem_long_t get(const stce_9781&) {
    if (helper::stce_9833) {
      throw dco::exception::create<std::runtime_error>(
          "You're trying to compute the size of the checkpoint, but a type (" + type_name<stce_9781>() +
          ") you checkpointed does not have a correct specialization:\n\n" +
          "template <typename T> struct trait_size_of {\n" + "   static mem_long_t get(const T&) { ... }\n" + "};\n\n");
    }
    return 0;
  }
};
template <memory_model::TYPE MEMORY_MODEL, class stce_9787, memory_model::TYPE stce_9788>
struct trait_size_of<dco::internal::tape<MEMORY_MODEL, stce_9787, stce_9788>*> {
  typedef dco::internal::tape<MEMORY_MODEL, stce_9787, stce_9788> tape_t;
  static mem_long_t get(const tape_t* tape, const int stce_9881 = tape_t::stce_9882) {
    return tape->stce_9883(stce_9881);
  }
};
template <typename stce_9781> struct trait_size_of<std::vector<stce_9781>> {
  static mem_long_t get(const std::vector<stce_9781>& stce_9803) {
    return stce_9803.size() * sizeof(stce_9781) + sizeof(stce_9803);
  }
};
template <> struct trait_size_of<char> {
  static mem_long_t get(const char&) { return sizeof(char); }
};
template <> struct trait_size_of<wchar_t> {
  static mem_long_t get(const wchar_t&) { return sizeof(wchar_t); }
};
template <> struct trait_size_of<signed char> {
  static mem_long_t get(const signed char&) { return sizeof(signed char); }
};
template <> struct trait_size_of<short> {
  static mem_long_t get(const short&) { return sizeof(short); }
};
template <> struct trait_size_of<int> {
  static mem_long_t get(const int&) { return sizeof(int); }
};
template <> struct trait_size_of<long> {
  static mem_long_t get(const long&) { return sizeof(long); }
};
template <> struct trait_size_of<unsigned char> {
  static mem_long_t get(const unsigned char&) { return sizeof(unsigned char); }
};
template <> struct trait_size_of<unsigned short> {
  static mem_long_t get(const unsigned short&) { return sizeof(unsigned short); }
};
template <> struct trait_size_of<unsigned int> {
  static mem_long_t get(const unsigned int&) { return sizeof(unsigned int); }
};
template <> struct trait_size_of<unsigned long> {
  static mem_long_t get(const unsigned long&) { return sizeof(unsigned long); }
};
template <> struct trait_size_of<long long> {
  static mem_long_t get(const long long&) { return sizeof(long long); }
};
template <> struct trait_size_of<unsigned long long> {
  static mem_long_t get(const unsigned long long&) { return sizeof(unsigned long long); }
};
template <> struct trait_size_of<float> {
  static mem_long_t get(const float&) { return sizeof(float); }
};
template <> struct trait_size_of<double> {
  static mem_long_t get(const double&) { return sizeof(double); }
};
template <> struct trait_size_of<long double> {
  static mem_long_t get(const long double&) { return sizeof(long double); }
};
template <> struct trait_size_of<bool> {
  static mem_long_t get(const bool&) { return sizeof(bool); }
};
} // namespace dco

namespace dco {
namespace internal {
template <typename stce_9884> struct stce_9885 {
  typedef stce_9884 type;
  typedef stce_9884& stce_9886;
  typedef const stce_9884 stce_9887;
};
template <typename stce_9781> struct stce_9885<std::vector<stce_9781>> {
  typedef std::vector<stce_9781>& type;
  typedef std::vector<stce_9781>& stce_9886;
  typedef std::vector<stce_9781> const& stce_9887;
};
template <stce_9793 stce_9888, typename stce_9781, typename stce_9889 = void> struct stce_9890 {};
template <typename stce_9781> struct stce_9890<stce_9794, stce_9781> {
  typedef typename dco::mode<stce_9781>::value_t value_t;
  typedef typename trait_value<stce_9781>::stce_9799 stce_9799;
  typedef typename trait_value<stce_9781>::stce_9891 stce_9891;
  stce_9799 get(stce_9781& stce_9803) { return trait_value<stce_9781>::value(stce_9803); };
  stce_9891 get(const stce_9781& stce_9803) const { return trait_value<stce_9781>::value(stce_9803); };
};
template <typename stce_9781> struct stce_9890<stce_9797, stce_9781> {
  typedef typename dco::mode<stce_9781>::passive_t value_t;
  typedef typename stce_9784<stce_9781>::stce_9799 stce_9799;
  typedef typename stce_9784<stce_9781>::stce_9891 stce_9891;
  stce_9799 get(stce_9781& stce_9803) { return stce_9784<stce_9781>::value(stce_9803); };
  stce_9891 get(const stce_9781& stce_9803) const { return stce_9784<stce_9781>::value(stce_9803); };
};
template <typename stce_9781> struct stce_9890<stce_9795, stce_9781> {
  typedef typename dco::mode<stce_9781>::derivative_t value_t;
  typedef typename stce_9783<stce_9781>::stce_9799 stce_9799;
  typedef typename stce_9783<stce_9781>::stce_9799 stce_9891;
  stce_9799 get(const stce_9781& stce_9803) const { return stce_9783<stce_9781>::value(stce_9803); };
};
template <typename stce_9781> struct stce_9890<stce_9798, stce_9781> {
  typedef typename stce_9786<stce_9781>::stce_9799 stce_9799;
  typedef typename stce_9786<stce_9781>::stce_9799 stce_9891;
  typedef typename stce_9874<stce_9799>::type value_t;
  stce_9799 get(const stce_9781& stce_9803) const { return stce_9786<stce_9781>::value(stce_9803); };
};
template <typename stce_9781, typename stce_9889> struct stce_9890<stce_9796, stce_9781, stce_9889> {
  typedef typename dco::mode<stce_9781>::derivative_t value_t;
  typedef typename stce_9783<stce_9781, stce_9889>::stce_9892 stce_9799;
  typedef typename stce_9783<stce_9781, stce_9889>::stce_9892 stce_9891;
  stce_9889* stce_9893;
  stce_9890(stce_9889* adjoints) : stce_9893(adjoints) {}
  auto get(stce_9781& stce_9803) -> decltype(stce_9783<stce_9781, stce_9889>::value(stce_9803, stce_9893)) {
    return stce_9783<stce_9781, stce_9889>::value(stce_9803, stce_9893);
  };
  auto get(const stce_9781& stce_9803) const -> decltype(stce_9783<stce_9781, stce_9889>::value(stce_9803, stce_9893)) {
    return stce_9783<stce_9781, stce_9889>::value(stce_9803, stce_9893);
  };
};
template <stce_9793 stce_9888, class stce_9781, typename stce_9884, typename stce_9782 = void>
struct stce_9894 : stce_9890<stce_9888, stce_9781, stce_9782> {
  typedef typename stce_9885<stce_9884>::type stce_9895;
  typedef typename stce_9885<stce_9884>::stce_9886 stce_9896;
  typedef typename stce_9885<stce_9884>::stce_9887 stce_9897;
  typedef stce_9890<stce_9888, stce_9781, stce_9782> stce_9898;
  typedef typename stce_9898::value_t value_t;
  stce_9895 stce_9899;
  stce_9894(stce_9897 stce_9850) : stce_9899(const_cast<stce_9896>(stce_9850)) {}
  stce_9894(stce_9897 stce_9850, stce_9782* stce_9900)
      : stce_9898(stce_9900), stce_9899(const_cast<stce_9896>(stce_9850)) {}
  stce_9894& operator=(const std::vector<value_t>& stce_9901) {
    for (size_t stce_9841 = 0; stce_9841 < stce_9899.size(); ++stce_9841) {
      stce_9898::get(stce_9899[stce_9841]) = stce_9901[stce_9841];
    }
    return *this;
  }
  stce_9894& operator+=(const std::vector<value_t>& stce_9901) {
    for (size_t stce_9841 = 0; stce_9841 < stce_9899.size(); ++stce_9841) {
      stce_9898::get(stce_9899[stce_9841]) += stce_9901[stce_9841];
    }
    return *this;
  }
  stce_9894& operator=(value_t const& stce_9901) {
    for (size_t stce_9841 = 0; stce_9841 < stce_9899.size(); ++stce_9841) {
      stce_9898::get(stce_9899[stce_9841]) = stce_9901;
    }
    return *this;
  }
  operator std::vector<value_t>() const {
    std::vector<value_t> stce_9843(stce_9899.size());
    for (size_t stce_9841 = 0; stce_9841 < stce_9899.size(); ++stce_9841) {
      stce_9843[stce_9841] = stce_9898::get(stce_9899[stce_9841]);
    }
    return stce_9843;
  }
  typename stce_9898::stce_9799 operator[](size_t stce_9841) { return stce_9898::get(stce_9899[stce_9841]); }
  typename stce_9898::stce_9891 operator[](size_t stce_9841) const { return stce_9898::get(stce_9899[stce_9841]); }
  size_t size() const { return stce_9899.size(); }
};
} // namespace internal
} // namespace dco

namespace dco {
namespace internal {
template <typename stce_9902> struct stce_9903 : public dco::mode<typename stce_9902::binary_t>::data_t {
  typedef stce_9902 mode_t;
  static const int gbcp_order = mode_t::gbcp_order;
  static const int order = mode_t::order;
  template <class stce_9904> DCO_ALWAYS_INLINE void stce_9905(stce_9904 const&) {}
  void clear() {}
  stce_9903() {}
  stce_9903(stce_9903 const&) : dco::mode<typename stce_9902::binary_t>::data_t() {}
  stce_9903& operator=(stce_9903 const&) { return *this; }
  index_t& _tape_index() const { return static_cast<const typename mode_t::type&>(*this).stce_9906._tape_index(); }
};
} // namespace internal
} // namespace dco
namespace dco {
template <typename stce_9781, typename stce_9873>
stce_9781& create_gbcp(stce_9873& stce_9907, typename enable_if<!stce_9875<stce_9781>::value, stce_9781>::type* = 0) {
  return reinterpret_cast<stce_9781&>(stce_9907);
}
template <typename stce_9781, typename stce_9873>
stce_9781 create_gbcp(stce_9873& stce_9907, typename enable_if<stce_9875<stce_9781>::value, stce_9781>::type* = 0) {
  return reinterpret_cast<stce_9781>(&stce_9907);
}
namespace internal {
template <typename stce_9781, typename enable_if = void> struct stce_9908 { static const bool value = false; };
template <typename mode_t> struct stce_9908<stce_9903<mode_t>> { static const bool value = true; };
template <typename stce_9781>
struct stce_9908<stce_9781, typename dco::enable_if<dco::mode<stce_9781>::is_dco_type>::type> {
  static const bool value = stce_9908<typename dco::mode<stce_9781>::data_t>::value;
};
template <typename stce_9781> struct is_gbcp_type {
  static const bool value = stce_9908<typename dco::remove_all<stce_9781>::type>::value;
};
template <typename stce_9781, int stce_9803> struct stce_9909;
template <typename stce_9781> struct stce_9909<stce_9781, 1> {
  typedef typename mode<stce_9781>::active_value_t& stce_9799;
  typedef const typename mode<stce_9781>::active_value_t& stce_9891;
  static stce_9799 value(stce_9781& at) { return at._value(); }
  static stce_9891 value(const stce_9781& at) { return at._value(); }
};
template <typename stce_9781, int stce_9803> struct stce_9909 {
  typedef typename stce_9909<typename mode<stce_9781>::active_value_t, stce_9803 - 1>::stce_9799 stce_9799;
  typedef typename stce_9909<typename mode<stce_9781>::active_value_t, stce_9803 - 1>::stce_9891 stce_9891;
  static stce_9799 value(stce_9781& at) {
    return stce_9909<typename mode<stce_9781>::active_value_t, stce_9803 - 1>::value(at._value());
  }
  static stce_9891 value(const stce_9781& at) {
    return stce_9909<typename mode<stce_9781>::active_value_t, stce_9803 - 1>::value(at._value());
  }
};
} // namespace internal
} // namespace dco
namespace dco {
template <typename stce_9781> inline typename internal::trait_value<stce_9781>::stce_9799 value(stce_9781& stce_9803) {
  return internal::trait_value<stce_9781>::value(stce_9803);
}
template <typename stce_9781>
inline typename internal::trait_value<stce_9781>::stce_9891 value(const stce_9781& stce_9803) {
  return internal::trait_value<stce_9781>::value(stce_9803);
}
namespace internal {
template <typename stce_9781, typename enable_if> struct trait_value {
  typedef typename dco::remove_const<stce_9781>::type type;
  typedef type& stce_9799;
  typedef const type& stce_9891;
  static inline stce_9799 value(type& value) { return value; }
  static inline stce_9891 value(const type& value) { return value; }
};
template <typename stce_9781>
struct trait_value<stce_9781,
                   typename dco::enable_if<dco::mode<stce_9781>::is_dco_type && !is_gbcp_type<stce_9781>::value &&
                                           !dco::mode<stce_9781>::is_intermediate_type>::type> {
  typedef typename dco::remove_const<stce_9781>::type type;
  typedef typename dco::mode<type>::value_t& stce_9799;
  typedef typename dco::mode<type>::value_t const& stce_9891;
  static inline stce_9799 value(type& value) { return value._value(); }
  static inline stce_9891 value(const type& value) { return value._value(); }
};
template <typename stce_9781>
struct trait_value<stce_9781, typename dco::enable_if<!is_gbcp_type<stce_9781>::value &&
                                                      dco::mode<stce_9781>::is_intermediate_type>::type> {
  typedef typename dco::remove_const<stce_9781>::type type;
  typedef typename dco::mode<type>::value_t const& stce_9799;
  typedef typename dco::mode<type>::value_t const& stce_9891;
  static inline stce_9799 value(type& value) { return value._value(); }
  static inline stce_9891 value(const type& value) { return value._value(); }
};
template <typename stce_9781>
struct trait_value<stce_9781, typename dco::enable_if<is_gbcp_type<stce_9781>::value>::type> {
  typedef typename dco::remove_const<stce_9781>::type type;
  typedef typename dco::mode<type>::value_t& stce_9799;
  typedef typename dco::mode<type>::value_t const& stce_9891;
  static inline stce_9799 value(type& stce_9910) { return dco::value(stce_9910._value()); }
  static inline stce_9891 value(const type& stce_9910) { return dco::value(stce_9910._value()); }
};
template <typename stce_9781>
struct trait_value<std::vector<stce_9781>, typename dco::enable_if<dco::mode<stce_9781>::is_dco_type>::type> {
  typedef std::vector<stce_9781> stce_9895;
  typedef stce_9894<stce_9794, stce_9781, stce_9895> stce_9799;
  typedef const stce_9894<stce_9794, stce_9781, stce_9895> stce_9891;
  static inline stce_9799 value(stce_9895& stce_9850) { return stce_9799(stce_9850); }
  static inline stce_9891 value(const stce_9895& stce_9850) { return stce_9891(stce_9850); }
};
template <stce_9793 stce_9888, class stce_9781, typename stce_9911, typename stce_9912>
struct trait_value<stce_9894<stce_9888, stce_9781, stce_9911, stce_9912>, void> {
  typedef stce_9894<stce_9888, stce_9781, stce_9911, stce_9912> stce_9895;
  typedef stce_9894<stce_9794, typename stce_9895::value_t, stce_9895> stce_9799;
  typedef stce_9894<stce_9794, typename stce_9895::value_t, stce_9895> stce_9891;
  static inline stce_9799 value(const stce_9895& stce_9850) { return stce_9799(stce_9850); }
};
} // namespace internal
} // namespace dco

namespace dco {
template <typename stce_9781>
inline typename internal::stce_9784<stce_9781>::stce_9799 passive_value(stce_9781& stce_9803) {
  return internal::stce_9784<stce_9781>::value(stce_9803);
}
template <typename stce_9781>
inline typename internal::stce_9784<stce_9781>::stce_9891 passive_value(const stce_9781& stce_9803) {
  return internal::stce_9784<stce_9781>::value(stce_9803);
}
namespace internal {
template <typename stce_9781, typename enable_if> struct stce_9784 {
  typedef typename dco::remove_const<stce_9781>::type type;
  typedef type& stce_9799;
  typedef type const& stce_9891;
  static inline stce_9799 value(type& value) { return value; }
  static inline stce_9891 value(const type& value) { return value; }
};
template <typename stce_9781>
struct stce_9784<stce_9781, typename dco::enable_if<dco::mode<stce_9781>::is_dco_type &&
                                                    !dco::mode<stce_9781>::is_intermediate_type>::type> {
  typedef typename dco::remove_const<stce_9781>::type type;
  typedef typename dco::mode<type>::active_value_t active_value_t;
  typedef typename dco::mode<type>::value_t value_t;
  typedef typename dco::mode<type>::passive_t passive_t;
  typedef passive_t& stce_9799;
  typedef passive_t const& stce_9891;
  static inline stce_9799 value(type& value) { return stce_9784<value_t>::value(dco::value(value)); }
  static inline stce_9891 value(const type& value) { return stce_9784<value_t>::value(dco::value(value)); }
};
template <typename stce_9781>
struct stce_9784<stce_9781, typename dco::enable_if<dco::mode<stce_9781>::is_intermediate_type>::type> {
  typedef typename dco::remove_const<stce_9781>::type type;
  typedef typename dco::mode<type>::active_value_t active_value_t;
  typedef typename dco::mode<type>::value_t value_t;
  typedef typename dco::mode<type>::passive_t passive_t;
  typedef passive_t const& stce_9799;
  typedef passive_t const& stce_9891;
  static inline stce_9799 value(type& value) { return stce_9784<value_t>::value(dco::value(value)); }
  static inline stce_9891 value(const type& value) { return stce_9784<value_t>::value(dco::value(value)); }
};
template <typename stce_9781>
struct stce_9784<std::vector<stce_9781>, typename dco::enable_if<!dco::mode<stce_9781>::is_dco_type>::type> {
  typedef std::vector<stce_9781> stce_9895;
  typedef stce_9895& stce_9799;
  typedef const stce_9895& stce_9891;
  static inline stce_9799 value(stce_9895& value) { return value; }
  static inline stce_9891 value(const stce_9895& value) { return value; }
};
template <typename stce_9781>
struct stce_9784<std::vector<stce_9781>, typename dco::enable_if<dco::mode<stce_9781>::is_dco_type>::type> {
  typedef std::vector<stce_9781> stce_9895;
  typedef stce_9894<stce_9797, stce_9781, stce_9895> stce_9799;
  typedef const stce_9894<stce_9797, stce_9781, stce_9895> stce_9891;
  static inline stce_9799 value(stce_9895& stce_9850) { return stce_9799(stce_9850); }
  static inline stce_9891 value(const stce_9895& stce_9850) { return stce_9891(stce_9850); }
};
template <stce_9793 stce_9888, class stce_9781, typename stce_9911, typename stce_9912>
struct stce_9784<stce_9894<stce_9888, stce_9781, stce_9911, stce_9912>, void> {
  typedef stce_9894<stce_9888, stce_9781, stce_9911, stce_9912> stce_9895;
  typedef stce_9894<stce_9797, typename stce_9895::value_t, stce_9895> stce_9799;
  typedef stce_9894<stce_9797, typename stce_9895::value_t, stce_9895> stce_9891;
  static inline stce_9799 value(const stce_9895& stce_9850) { return stce_9799(stce_9850); }
};
} // namespace internal
} // namespace dco

namespace dco {
namespace internal {
struct interpretation_settings {
  bool reset;
  bool stce_9913;
  interpretation_settings(bool stce_9914 = false, bool stce_9915 = false) : reset(stce_9914), stce_9913(stce_9915) {}
};
} // namespace internal
} // namespace dco

namespace dco {
template <class stce_9761> struct adjoint_vector_abstract;
template <typename stce_9761> struct stce_9916 {
  adjoint_vector_abstract<stce_9761>& adjoints;
  index_t stce_9806;
  stce_9916(adjoint_vector_abstract<stce_9761>& adjoints, index_t stce_9806)
      : adjoints(adjoints), stce_9806(stce_9806) {}
  operator stce_9761() const { return adjoints._read_adjoint(stce_9806); }
  template <typename stce_9781> stce_9916& operator+=(stce_9781 const& stce_9917) {
    adjoints._increment_adjoint(stce_9806, stce_9917);
    return *this;
  }
};
template <class stce_9761> struct adjoint_vector_abstract {
  virtual ~adjoint_vector_abstract(){};
  stce_9916<stce_9761> stce_9918(const index_t stce_9806) { return stce_9916<stce_9761>(*this, stce_9806); }
  virtual stce_9761 _read_adjoint(const index_t stce_9806) = 0;
  virtual void _increment_adjoint(const index_t stce_9806, const stce_9761& stce_9919) = 0;
};
} // namespace dco

namespace dco {
namespace internal {
template <typename stce_9920> class stce_9921 {
protected:
  stce_9920& stce_9922;

public:
  stce_9921(stce_9920& stce_9923) : stce_9922(stce_9923) {}
  stce_9920& stce_9923() { return stce_9922; }
};
} // namespace internal
} // namespace dco

namespace dco {
class tape_options {
private:
  size_t stce_9924, stce_9925;
  bool stce_9926;
  std::string stce_9927;
  bool stce_9928;
  bool stce_9929;

public:
  tape_options()
      : stce_9924(128 * 1024 * 1024), stce_9925(0), stce_9926(false), stce_9927("dco_tape_data.bin"), stce_9928(false),
        stce_9929(false) {}
  bool operator==(const tape_options& stce_9930) {
    return stce_9924 == stce_9930.stce_9924 && stce_9925 == stce_9930.stce_9925 && stce_9926 == stce_9930.stce_9926 &&
           stce_9928 == stce_9930.stce_9928 && stce_9927 == stce_9930.stce_9927 && stce_9929 == stce_9930.stce_9929;
  }
  bool operator!=(const tape_options& stce_9930) { return !operator==(stce_9930); }
  index_t chunk_size() const {
    if (helper::stce_9833) {
      throw dco::exception::create<std::runtime_error>("chunk_size removed; use chunk_size_in_byte() instead");
    }
    return -1;
  }
  size_t chunk_size_in_byte() const { return stce_9924; }
  size_t& chunk_size_in_byte() { return stce_9924; }
  void set_chunk_size_in_byte(mem_long_t size) {
    if (static_cast<double>(size) / static_cast<double>(std::numeric_limits<size_t>::max()) > 1.0) {
      DCO_LOG(logWARNING) << "set_chunk_size: requesting too much memory for your system (size_t too small). Resetting "
                             "to std::numeric_limits<size_t>::max()";
      stce_9924 = std::numeric_limits<size_t>::max();
    } else {
      stce_9924 = static_cast<size_t>(size);
    }
  }
  void set_chunk_size_in_kbyte(double size) { set_chunk_size_in_byte(1024 * static_cast<mem_long_t>(size)); }
  void set_chunk_size_in_mbyte(double size) { set_chunk_size_in_kbyte(1024. * size); }
  void set_chunk_size_in_gbyte(double size) { set_chunk_size_in_mbyte(1024. * size); }
  size_t blob_size_in_byte() const { return stce_9925; }
  size_t& blob_size_in_byte() { return stce_9925; }
  void set_blob_size_in_byte(mem_long_t size) {
    if (static_cast<double>(size) / static_cast<double>(std::numeric_limits<size_t>::max()) > 1.0) {
      DCO_LOG(logWARNING) << "set_blob_size: requesting too much memory for your system (size_t too small). Resetting "
                             "to std::numeric_limits<size_t>::max()";
      stce_9925 = std::numeric_limits<size_t>::max();
    } else {
      stce_9925 = static_cast<size_t>(size);
    }
  }
  void set_blob_size_in_kbyte(double size) { set_blob_size_in_byte(1024 * static_cast<mem_long_t>(size)); }
  void set_blob_size_in_mbyte(double size) { set_blob_size_in_kbyte(1024. * size); }
  void set_blob_size_in_gbyte(double size) { set_blob_size_in_mbyte(1024. * size); }
  bool& deallocation_on_reset() { return stce_9926; }
  const bool& deallocation_on_reset() const { return stce_9926; }
  std::string& filename() { return stce_9927; }
  const std::string& filename() const { return stce_9927; }
  bool& write_to_file() { return stce_9928; }
  bool write_to_file() const { return stce_9928; }
  bool& alloc_use_huge_pages() { return stce_9929; }
  bool alloc_use_huge_pages() const { return stce_9929; }
};
} // namespace dco
namespace dco {
namespace internal {
template <class stce_9761, typename stce_9920> class adjoint_vector_lazy : public stce_9921<stce_9920> {
  typedef stce_9921<stce_9920> stce_9931;

public:
  typedef typename helper::vecsize_info<stce_9761>::stce_9846 stce_9932;
  typedef stce_9761 stce_9763;

protected:
  std::vector<stce_9763> stce_9893;
  index_t stce_9933;
  index_t stce_9934;
  index_t stce_9935;
  int stce_9936;
  tape_options stce_9937;

public:
  typedef stce_9763 value_t;
  void init() {}
  adjoint_vector_lazy(index_t size, stce_9920& tape, tape_options stce_9938)
      : stce_9931(tape), stce_9893(0), stce_9933(0), stce_9934(0), stce_9935(size), stce_9936(0), stce_9937(stce_9938) {
  }
  DCO_ALWAYS_INLINE ~adjoint_vector_lazy() {}
  index_t size() const { return stce_9935; }
  bool stce_9939(index_t stce_9940) const { return stce_9933 > stce_9940; }
  mem_long_t stce_9941() const { return static_cast<mem_long_t>(stce_9934) * sizeof(stce_9763); }
  stce_9763& operator[](index_t stce_9806) { return stce_9893[stce_9806]; }
  stce_9763 operator[](index_t stce_9806) const { return stce_9893[stce_9806]; }
  void stce_9942(typename stce_9920::iterator& stce_9821) {
    (*this)[stce_9821->arg()] += static_cast<stce_9763>(stce_9821->pval() * (*this)[stce_9821.index()]);
  }
  void resize(index_t stce_9943) {
    DCO_LOG(logDEBUG2) << "Resizing internal adjoint vector to " << stce_9943;
    if (stce_9943 < stce_9935) {
      stce_9944(stce_9935, stce_9943 - 1);
    }
    stce_9935 = stce_9943;
  }
  void stce_9945(index_t stce_9943) {
    if (stce_9943 <= stce_9933) {
      return;
    }
    if (++stce_9936 % 100 == 0) {
      DCO_LOG(logWARNING) << "dco_adjoint_vector: resizing adjoint vector quite often (#=" << stce_9936
                          << ") -- might have severe performance impact (reallocation / initialization / copy)";
    }
    stce_9893.resize(static_cast<size_t>(stce_9943));
    stce_9933 = stce_9943;
    stce_9934 = static_cast<index_t>(stce_9893.capacity());
  }
  void stce_9946(index_t stce_9806) { stce_9945(stce_9806); }
  stce_9763 at(index_t stce_9806) const { return stce_9939(stce_9806) ? stce_9893[stce_9806] : 0; }
  stce_9763& at(const index_t stce_9806) {
    stce_9945(stce_9806 + 1);
    return stce_9893[stce_9806];
  }
  void stce_9944(index_t stce_9868, index_t stce_9869) {
    if (stce_9868 < stce_9869) {
      std::swap(stce_9868, stce_9869);
    }
    if (!stce_9939(stce_9869)) {
      return;
    }
    stce_9945(stce_9935);
    for (index_t stce_9841 = std::min(stce_9868, stce_9935 - 1); stce_9841 > stce_9869; --stce_9841) {
      stce_9893[stce_9841] = 0;
    }
  }
  void stce_9947() { stce_9945(stce_9935); }
};
} // namespace internal
} // namespace dco

namespace dco {
template <class stce_9920, class stce_9761, int stce_9948 = -1>
struct adjoint_vector : dco::adjoint_vector_abstract<typename stce_9920::tape_t::stce_9763>,
                        public internal::stce_9921<stce_9920> {
  static const size_t vecsize = stce_9948 < 0 ? static_cast<size_t>(-stce_9948) : static_cast<size_t>(stce_9948);
  typedef internal::stce_9921<stce_9920> stce_9931;

public:
  typedef dco::helper::valvec<stce_9761, vecsize> value_t;
  typedef stce_9761 adjoint_real_t;
  typedef stce_9761 stce_9932;
  typedef typename stce_9920::stce_9763 stce_9763;

private:
  std::vector<value_t> stce_9893;
  index_t stce_9949;

public:
  int stce_9950;
  void init() {}
  adjoint_vector(stce_9920* tape) : stce_9931(*tape), stce_9949(0), stce_9950(0) {}
  virtual ~adjoint_vector() {}
  template <class stce_9792> value_t& derivative(const stce_9792& stce_9951) {
    stce_9952();
    const index_t stce_9806 = stce_9951._tape_index();
    return stce_9893[stce_9806];
  }
  void interpret_adjoint() {
    typename stce_9920::iterator stce_9869 = stce_9931::stce_9923().start();
    internal::interpretation_settings stce_9953;
    stce_9954(stce_9931::stce_9923().current(), stce_9869, stce_9953);
  }
  void interpret_adjoint_to(const typename stce_9920::iterator& stce_9869) {
    internal::interpretation_settings stce_9953;
    if (stce_9869 > stce_9931::stce_9923().current())
      throw dco::exception::create<std::runtime_error>(
          "adjoint interpretation: from < to.",
          "/home/vagrant/builds/xXzkdLpY/0/stce/dco_cpp_make_release/dco_cpp_dev/src/dco_adjoint_vector.hpp", 59);
    else
      stce_9954(stce_9931::stce_9923().current(), stce_9869, stce_9953);
  }
  void interpret_adjoint_from(const typename stce_9920::iterator& stce_9868) {
    typename stce_9920::iterator stce_9869 = stce_9931::stce_9923().start();
    assert(!(stce_9868 < stce_9869));
    typename internal::interpretation_settings stce_9953;
    stce_9954(stce_9868, stce_9869, stce_9953);
  }
  void interpret_adjoint_from_to(const typename stce_9920::iterator& stce_9868,
                                 const typename stce_9920::iterator& stce_9869) {
    typename internal::interpretation_settings stce_9953;
    if (stce_9869 > stce_9868)
      throw dco::exception::create<std::runtime_error>(
          "adjoint interpretation: from < to.",
          "/home/vagrant/builds/xXzkdLpY/0/stce/dco_cpp_make_release/dco_cpp_dev/src/dco_adjoint_vector.hpp", 75);
    else
      stce_9954(stce_9868, stce_9869, stce_9953);
  }
  void interpret_adjoint_and_zero_adjoints_to(const typename stce_9920::iterator& stce_9869) {
    typename stce_9920::iterator stce_9868(stce_9931::stce_9923().current());
    typename internal::interpretation_settings stce_9953;
    stce_9953.reset = false;
    stce_9953.stce_9913 = true;
    stce_9954(stce_9868, stce_9869, stce_9953);
  }
  void interpret_adjoint_and_zero_adjoints_from_to(const typename stce_9920::iterator& stce_9868,
                                                   const typename stce_9920::iterator& stce_9869) {
    typename internal::interpretation_settings stce_9953;
    stce_9953.reset = false;
    stce_9953.stce_9913 = true;
    stce_9954(stce_9868, stce_9869, stce_9953);
  }
  void zero_adjoints() {
    typename stce_9920::iterator stce_9869 = stce_9931::stce_9923().start();
    stce_9955(stce_9931::stce_9923().current(), stce_9869);
  }
  void zero_adjoints_to(const typename stce_9920::iterator& stce_9869) {
    stce_9955(stce_9931::stce_9923().current(), stce_9869);
  }
  void zero_adjoints_from(const typename stce_9920::iterator& stce_9868) {
    typename stce_9920::iterator stce_9869 = stce_9931::stce_9923().start();
    stce_9955(stce_9868, stce_9869);
  }
  void zero_adjoints_from_to(const typename stce_9920::iterator& stce_9868,
                             const typename stce_9920::iterator& stce_9869) {
    stce_9955(stce_9868, stce_9869);
  }
  value_t& operator[](index_t stce_9806) { return stce_9893[stce_9806]; }
  value_t at(index_t stce_9806) const { return (stce_9806 < stce_9949) ? stce_9893[stce_9806] : 0; }
  value_t& at(index_t stce_9806) {
    stce_9946(stce_9806);
    return stce_9893[stce_9806];
  }
  void stce_9946(index_t stce_9806) { stce_9952(stce_9806 + 1); }
  void stce_9942(typename stce_9920::iterator& stce_9821) {
    (*this)[stce_9821->arg()] += stce_9821->pval() * (*this)[stce_9821.index()];
  }
  value_t& stce_9956(const index_t stce_9806) { return stce_9893[stce_9806]; }
  stce_9761& stce_9956(const index_t stce_9806, int stce_9957) { return stce_9893[stce_9806][stce_9957]; }
  template <class stce_9958>
  void _increment_adjoint(const index_t& stce_9806, const stce_9958& stce_9959, const value_t& stce_9919) {
    stce_9893[stce_9806] += (stce_9959 * stce_9919);
  }
  virtual typename stce_9920::stce_9763 _read_adjoint(const index_t stce_9806) {
    return static_cast<typename stce_9920::stce_9763>(stce_9956(stce_9806)[stce_9950]);
  }
  virtual void _increment_adjoint(const index_t stce_9806, const typename stce_9920::stce_9763& stce_9919) {
    stce_9893[stce_9806][stce_9950] += static_cast<adjoint_real_t>(stce_9919);
  }
  void stce_9955(const typename stce_9920::iterator& stce_9868, const typename stce_9920::iterator& stce_9869) {
    stce_9944(stce_9868.index(), stce_9869.index());
  }
  void stce_9944(index_t stce_9868, index_t stce_9869) {
    if (stce_9868 < stce_9869) {
      std::swap(stce_9868, stce_9869);
    }
    if (stce_9893.size() == 0) {
      return;
    }
    for (index_t stce_9841 = stce_9869 + 1; stce_9841 <= stce_9868; stce_9841++) {
      stce_9893[stce_9841] = 0;
    }
  }
  void stce_9954(const typename stce_9920::iterator& stce_9868, const typename stce_9920::iterator& stce_9869,
                 typename internal::interpretation_settings stce_9953) {
    stce_9952();
    stce_9931::stce_9923().stce_9960(*this, *this, stce_9868, stce_9869, stce_9953, [](dco::index_t, value_t) {});
  }
  void stce_9952(index_t stce_9961 = -1) {
    index_t stce_9962;
    if (stce_9961 != -1)
      stce_9962 = stce_9961;
    else
      stce_9962 = stce_9931::stce_9923().current().index() + 1;
    if (static_cast<size_t>(stce_9962) > stce_9893.size()) {
      stce_9949 = stce_9962;
      stce_9893.resize(static_cast<size_t>(stce_9949));
    }
  }
};
} // namespace dco
namespace dco {
template <typename stce_9781>
inline typename internal::stce_9783<stce_9781>::stce_9799 derivative(const stce_9781& stce_9803) {
  return internal::stce_9783<stce_9781>::value(stce_9803);
}
template <typename stce_9781, typename stce_9782>
inline auto derivative(const stce_9781& stce_9803, stce_9782& adjoints)
    -> decltype(internal::stce_9783<stce_9781, stce_9782>::value(stce_9803, &adjoints)) {
  return internal::stce_9783<stce_9781, stce_9782>::value(stce_9803, &adjoints);
}
namespace internal {
template <typename stce_9781, typename stce_9782, typename enable_if> struct stce_9783 {
  typedef typename dco::remove_const<stce_9781>::type type;
  typedef type stce_9799;
  static inline stce_9799 value(const type&) { return type(); }
  static inline stce_9799 value(const type&, stce_9782*) { return type(); }
};
template <typename stce_9781>
struct stce_9783<stce_9781, void,
                 typename dco::enable_if<dco::mode<stce_9781>::is_dco_type && !is_gbcp_type<stce_9781>::value>::type> {
  typedef typename dco::remove_const<stce_9781>::type type;
  typedef typename dco::mode<type>::derivative_t& stce_9799;
  static inline stce_9799 value(type const& value) { return value.stce_9963(); }
};
template <typename stce_9781>
struct stce_9783<stce_9781, void,
                 typename dco::enable_if<(is_gbcp_type<stce_9781>::value && dco::mode<stce_9781>::order > 0)>::type> {
  typedef typename dco::remove_const<stce_9781>::type type;
  typedef typename dco::mode<type>::value_t& stce_9799;
  static inline stce_9799 value(const type& value) { return dco::derivative(value._value()); }
};
template <typename stce_9781>
struct stce_9783<stce_9781, void,
                 typename dco::enable_if<(is_gbcp_type<stce_9781>::value && dco::mode<stce_9781>::order == 0)>::type> {
  typedef typename dco::remove_const<stce_9781>::type type;
  typedef typename dco::mode<type>::value_t stce_9799;
  static inline stce_9799 value(const type&) { return stce_9799(); }
};
template <typename stce_9781, typename stce_9964, typename stce_9965, int stce_9966>
struct stce_9783<stce_9781, adjoint_vector<stce_9964, stce_9965, stce_9966>,
                 typename dco::enable_if<(stce_9966 == -1)>::type> {
  typedef adjoint_vector<stce_9964, stce_9965, stce_9966> stce_9912;
  typedef typename dco::remove_const<stce_9781>::type type;
  typedef stce_9965& stce_9892;
  static inline stce_9892 value(const type& value, stce_9912* adjoints) { return adjoints->derivative(value)[0]; }
};
template <typename stce_9781, typename stce_9964, typename stce_9965, int stce_9966>
struct stce_9783<stce_9781, adjoint_vector<stce_9964, stce_9965, stce_9966>,
                 typename dco::enable_if<(stce_9966 > 0)>::type> {
  typedef adjoint_vector<stce_9964, stce_9965, stce_9966> stce_9912;
  typedef typename dco::remove_const<stce_9781>::type type;
  typedef typename stce_9912::value_t& stce_9892;
  static inline stce_9892 value(const type& value, stce_9912* adjoints) { return adjoints->derivative(value); }
};
template <typename stce_9781, typename stce_9761, typename stce_9920>
struct stce_9783<stce_9781, adjoint_vector_lazy<stce_9761, stce_9920>> {
  typedef adjoint_vector_lazy<stce_9761, stce_9920> stce_9912;
  typedef typename dco::remove_const<stce_9781>::type type;
  typedef stce_9761& stce_9892;
  static inline stce_9892 value(const type& value, stce_9912* adjoints) {
    return (*adjoints)[value.data()._tape_index()];
  }
};
template <typename stce_9781, typename stce_9761> struct stce_9783<stce_9781, adjoint_vector_abstract<stce_9761>> {
  typedef adjoint_vector_abstract<stce_9761> stce_9912;
  typedef typename dco::remove_const<stce_9781>::type type;
  typedef stce_9761& stce_9892;
  static inline auto value(const type& value, stce_9912* adjoints)
      -> decltype(adjoints->stce_9918(value.data()._tape_index())) {
    return adjoints->stce_9918(value.data()._tape_index());
  }
};
template <typename stce_9781>
struct stce_9783<std::vector<stce_9781>, void, typename dco::enable_if<!dco::mode<stce_9781>::is_dco_type>::type> {
  typedef std::vector<stce_9781> stce_9895;
  typedef stce_9895 stce_9799;
  static inline stce_9799 value(const stce_9895& value) { return stce_9799(value.size(), 0.0); }
};
template <typename stce_9781>
struct stce_9783<std::vector<stce_9781>, void, typename dco::enable_if<dco::mode<stce_9781>::is_dco_type>::type> {
  typedef std::vector<stce_9781> stce_9895;
  typedef stce_9894<stce_9795, stce_9781, stce_9895> stce_9799;
  static inline stce_9799 value(const stce_9895& stce_9850) { return stce_9799(stce_9850); }
};
template <typename stce_9781, typename stce_9964, typename stce_9965, int stce_9966>
struct stce_9783<std::vector<stce_9781>, adjoint_vector<stce_9964, stce_9965, stce_9966>,
                 typename dco::enable_if<(stce_9966 == -1)>::type> {
  typedef adjoint_vector<stce_9964, stce_9965, stce_9966> stce_9912;
  typedef std::vector<stce_9781> stce_9895;
  typedef stce_9894<stce_9795, stce_9781, stce_9895> stce_9799;
  typedef stce_9894<stce_9796, stce_9781, stce_9895, stce_9912> stce_9892;
  static inline stce_9799 value(const stce_9895& stce_9850) { return stce_9799(stce_9850); }
  static inline stce_9892 value(const stce_9895& stce_9850, stce_9912* adjoints) {
    return stce_9892(stce_9850, adjoints);
  }
};
template <typename stce_9781, typename stce_9761>
struct stce_9783<std::vector<stce_9781>, adjoint_vector_abstract<stce_9761>> {
  typedef adjoint_vector_abstract<stce_9761> stce_9912;
  typedef std::vector<stce_9781> stce_9895;
  typedef stce_9894<stce_9795, stce_9781, stce_9895> stce_9799;
  typedef stce_9894<stce_9796, stce_9781, stce_9895, stce_9912> stce_9892;
  static inline stce_9799 value(const stce_9895& stce_9850) { return stce_9799(stce_9850); }
  static inline stce_9892 value(const stce_9895& stce_9850, stce_9912* adjoints) {
    return stce_9892(stce_9850, adjoints);
  }
};
template <stce_9793 stce_9888, class stce_9781, typename stce_9911, typename stce_9912>
struct stce_9783<stce_9894<stce_9888, stce_9781, stce_9911, stce_9912>, void> {
  typedef stce_9894<stce_9888, stce_9781, stce_9911, stce_9912> stce_9895;
  typedef stce_9894<stce_9795, typename stce_9895::value_t, stce_9895> stce_9799;
  static inline stce_9799 value(const stce_9895& stce_9850) { return stce_9799(stce_9850); }
};
} // namespace internal
} // namespace dco

namespace dco {
template <typename stce_9781> typename internal::stce_9785<stce_9781>::stce_9799 tape(const stce_9781& stce_9803) {
  return internal::stce_9785<stce_9781>::value(stce_9803);
}
template <typename stce_9781>
typename internal::stce_9786<stce_9781>::stce_9799 tape_index(const stce_9781& stce_9803) {
  return internal::stce_9786<stce_9781>::value(stce_9803);
}
namespace internal {
template <typename stce_9781, typename enable_if> struct stce_9785 {
  typedef void* stce_9799;
  static stce_9799 value(const stce_9781&) { return static_cast<void*>(0); }
};
template <typename stce_9781>
struct stce_9785<stce_9781, typename dco::enable_if<dco::mode<stce_9781>::is_adjoint_type>::type> {
  typedef typename dco::mode<stce_9781>::tape_t* stce_9799;
  static stce_9799 value(const stce_9781& value) { return value.tape(); }
};
template <typename stce_9781>
struct stce_9785<std::vector<stce_9781>, typename dco::enable_if<dco::mode<stce_9781>::is_adjoint_type>::type> {
  typedef typename dco::mode<stce_9781>::tape_t* stce_9799;
  static stce_9799 value(const std::vector<stce_9781>& value) {
    stce_9799 tape = 0;
    for (size_t stce_9841 = 0; stce_9841 < value.size(); stce_9841++) {
      if (stce_9785<stce_9781>::value(value[stce_9841]) != 0) {
        tape = stce_9785<stce_9781>::value(value[stce_9841]);
        break;
      }
    }
    return tape;
  }
};
template <typename stce_9781, typename enable_if> struct stce_9786 {
  typedef index_t stce_9799;
  static index_t value(const stce_9781&) { return 0; }
};
template <typename stce_9781>
struct stce_9786<stce_9781, typename dco::enable_if<dco::mode<stce_9781>::is_adjoint_type>::type> {
  typedef index_t& stce_9799;
  static stce_9799 value(const stce_9781& value) { return value._tape_index(); }
};
template <typename stce_9781>
struct stce_9786<std::vector<stce_9781>, typename dco::enable_if<dco::mode<stce_9781>::is_dco_type>::type> {
  typedef std::vector<stce_9781> stce_9895;
  typedef stce_9894<stce_9798, stce_9781, stce_9895> stce_9799;
  typedef const stce_9894<stce_9798, stce_9781, stce_9895> stce_9891;
  static inline stce_9799 value(stce_9895& stce_9850) { return stce_9799(stce_9850); }
  static inline stce_9891 value(const stce_9895& stce_9850) { return stce_9891(stce_9850); }
};
} // namespace internal
} // namespace dco

namespace dco {
namespace folding {
template <typename stce_9781, typename enable_if> struct is_zero_trait {
  static bool get(const stce_9781& stce_9803) { return stce_9803 == 0; }
};
template <typename stce_9781> bool is_zero(const stce_9781& stce_9803) {
  return is_zero_trait<stce_9781>::get(stce_9803);
}
template <typename stce_9781>
struct is_zero_trait<stce_9781, typename dco::enable_if<dco::mode<stce_9781>::is_tangent_type>::type> {
  static bool get(const stce_9781& stce_9803) { return is_zero(value(stce_9803)) && is_zero(derivative(stce_9803)); }
};
template <typename stce_9781>
struct is_zero_trait<stce_9781, typename dco::enable_if<dco::mode<stce_9781>::is_adjoint_type>::type> {
  static bool get(const stce_9781& stce_9803) { return is_zero(value(stce_9803)) && !tape_index(stce_9803); }
};
} // namespace folding
} // namespace dco

namespace dco {
template <typename stce_9813, typename... stce_9967>
int fprintf(stce_9813& stream, char const* stce_9968, stce_9967&&... stce_9969) {
  return ::fprintf(stream, stce_9968, dco::passive_value(stce_9969)...);
}
template <typename... stce_9967> int printf(char const* const stce_9968, stce_9967&&... stce_9969) {
  return ::printf(stce_9968, dco::passive_value(stce_9969)...);
}
template <typename... stce_9967> int sprintf(char* stream, char const* stce_9968, stce_9967&&... stce_9969) {
  return ::sprintf(stream, stce_9968, dco::passive_value(stce_9969)...);
}
namespace stce_9970 {
inline void init() {}
template <typename stce_9781, typename... stce_9967>
typename dco::enable_if<!dco::mode<typename std::remove_pointer<stce_9781>::type>::is_dco_type>::type
init(stce_9781&, stce_9967&... stce_9969);
template <typename stce_9781, typename... stce_9967>
typename dco::enable_if<dco::mode<typename std::remove_pointer<stce_9781>::type>::is_dco_type>::type
init(stce_9781& stce_9803, stce_9967&... stce_9969) {
  *stce_9803 = 0;
  init(stce_9969...);
}
template <typename stce_9781, typename... stce_9967>
typename dco::enable_if<!dco::mode<typename std::remove_pointer<stce_9781>::type>::is_dco_type>::type
init(stce_9781&, stce_9967&... stce_9969) {
  init(stce_9969...);
}
} // namespace stce_9970
template <typename stce_9813, typename... stce_9967>
int sscanf(stce_9813& stream, char const* stce_9968, stce_9967&&... stce_9969) {
  stce_9970::init(stce_9969...);
  return ::sscanf(stream, stce_9968, &dco::passive_value(*stce_9969)...);
}
template <typename stce_9813, typename... stce_9967>
int fscanf(stce_9813& stream, char const* stce_9968, stce_9967&&... stce_9969) {
  stce_9970::init(stce_9969...);
  return ::fscanf(stream, stce_9968, &dco::passive_value(*stce_9969)...);
}
} // namespace dco

namespace dco {
namespace internal {
template <memory_model::TYPE memory_model, typename stce_9971, memory_model::TYPE stce_9972 = memory_model::stce_9765>
class stce_9973 {};
} // namespace internal
} // namespace dco
namespace dco {
namespace internal {
template <class stce_9974>
struct jacobian_preaccumulator_t : adjoint_vector_abstract<typename dco::mode<stce_9974>::stce_9975> {
  typedef typename dco::mode<stce_9974>::stce_9975 stce_9763;
  typedef stce_9763 stce_9932;
  typedef typename dco::mode<stce_9974>::tape_t tape_t;
  typedef typename tape_t::iterator_t stce_9976;
  typedef typename tape_t::edge_inserter stce_9977;
  tape_t* const stce_9978;
  stce_9976 stce_9979;
  index_t stce_9980;
  typedef adjoint_vector_lazy<stce_9763, tape_t> vector_t;
  vector_t stce_9893;
  bool stce_9981;
  bool stce_9982;
  std::map<index_t, stce_9763> stce_9983;
  void init() {}
  typedef stce_9973<memory_model::BLOB_TAPE, tape_t> stce_9895;
  typedef typename stce_9895::edge_inserter stce_9984;
  typedef typename stce_9895::iterator stce_9985;
  stce_9895* stce_9922;
  stce_9984* stce_9986;
  typedef typename stce_9974::data_t stce_9987;
  std::vector<stce_9987*> stce_9988;
  index_t stce_9950;
  bool& merge_edges() { return stce_9982; }
  jacobian_preaccumulator_t(tape_t* const tape)
      : stce_9978(tape), stce_9893(0, *tape, tape->stce_9938()), stce_9982(false), stce_9922(0), stce_9986(0),
        stce_9950(0) {
    if (stce_9978) {
      stce_9979 = stce_9978->get_position();
      stce_9980 = stce_9979.index();
      stce_9981 = true;
    } else {
      stce_9981 = false;
    }
  }
  ~jacobian_preaccumulator_t() {
    if (stce_9981)
      this->finish();
    if (stce_9922)
      delete stce_9922;
  }
  void start() {
    if (stce_9978) {
      stce_9979 = stce_9978->get_position();
      stce_9980 = stce_9979.index();
      stce_9981 = true;
    } else {
      stce_9981 = false;
    }
  }
  void stce_9989(stce_9974& stce_9803) {
    if (!dco::tape_index(stce_9803))
      return;
    if (dco::tape_index(stce_9803) && dco::tape_index(stce_9803) <= stce_9980) {
      throw dco::exception::create<std::runtime_error>("jacobian_preaccumulator_t: registering output, which is indeed "
                                                       "an input (was alive already before starting point).");
    }
    stce_9988.push_back(&static_cast<stce_9987&>(stce_9803));
  }
  void register_output(stce_9974& stce_9803) {
    if (stce_9978) {
      stce_9989(stce_9803);
    }
  }
  void register_output(std::vector<stce_9974>& stce_9803) {
    if (stce_9978) {
      stce_9988.reserve(stce_9988.size() + stce_9803.size());
      for (size_t stce_9841 = 0; stce_9841 < stce_9803.size(); ++stce_9841) {
        stce_9989(stce_9803[stce_9841]);
      }
    }
  }
  void finish() {
    if (!stce_9981)
      return;
    stce_9981 = false;
    if (!stce_9978)
      return;
    if (!stce_9988.size()) {
      stce_9978->reset_to(stce_9979);
      return;
    }
    const stce_9976 stce_9990 = stce_9978->get_position();
    const index_t stce_9991 = stce_9990.index() - stce_9979.index();
    stce_9893.resize(stce_9991 + 1);
    const index_t stce_9992 = stce_9978->size(stce_9990, stce_9979);
    const index_t stce_9993 = stce_9992 * (1 + static_cast<index_t>(stce_9988.size()));
    if (stce_9922)
      delete stce_9922;
    tape_options stce_9994;
    stce_9994.blob_size_in_byte() = stce_9993 * stce_9895::entry::size_of();
    stce_9922 = new stce_9895(stce_9994, *stce_9978);
    stce_9922->stce_9995().index() = stce_9990.index();
    stce_9893.stce_9947();
    for (typename std::vector<stce_9987*>::iterator stce_9996 = stce_9988.begin(); stce_9996 != stce_9988.end();
         ++stce_9996) {
      stce_9987& stce_9821 = **stce_9996;
      if (stce_9821._tape_index() == 0)
        continue;
      stce_9893.stce_9944(stce_9991 - 1, 0);
      stce_9956(stce_9821._tape_index()) = 1.0;
      stce_9986 = new stce_9984(stce_9922->insert_ref());
      if (stce_9982) {
        stce_9983.clear();
      }
      stce_9978->stce_9960(*this, *this, stce_9990, stce_9979, interpretation_settings(false, true),
                           [](index_t, typename tape_t::stce_9763) {});
      if (stce_9982) {
        for (typename std::map<index_t, stce_9763>::const_iterator stce_9997 = stce_9983.cbegin();
             stce_9997 != stce_9983.cend(); ++stce_9997) {
          stce_9986->insert(stce_9997->first, stce_9997->second);
        }
      }
      delete stce_9986;
    }
    stce_9978->reset_to(stce_9979);
    stce_9985 stce_9998 = stce_9922->current();
    for (typename std::vector<stce_9987*>::reverse_iterator stce_9996 = stce_9988.rbegin();
         stce_9996 != stce_9988.rend(); ++stce_9996) {
      stce_9977 stce_9999(stce_9978->insert_ref());
      for (;; --stce_9998) {
        stce_9999.insert(stce_9998->arg(), stce_9998->pval());
        if (stce_9998->stce_10000())
          break;
      }
      --stce_9998;
      (*stce_9996)->_tape_index() = stce_9999.index();
    }
    stce_9988.clear();
  }
  stce_9763& stce_9956(const index_t stce_9806) { return stce_9893[stce_9806 - stce_9980]; }
  template <class stce_9958>
  void _increment_adjoint(const index_t& stce_9806, const stce_9958& stce_9959, const stce_9763& stce_9919) {
    _increment_adjoint(stce_9806, stce_9959 * stce_9919);
  }
  void stce_9944(index_t stce_9868, index_t stce_9869) { stce_9893.stce_9944(stce_9868, stce_9869); }
  void stce_9946(index_t stce_9806) { stce_9893.stce_9946(stce_9806 - stce_9980); }
  stce_9763& operator[](const index_t stce_9806) { return stce_9893[stce_9806 - stce_9980]; }
  template <typename iterator_t> void stce_9942(iterator_t& stce_9821) {
    _increment_adjoint(stce_9821->arg(), stce_9821->pval() * (*this)[stce_9821.index()]);
  }
  virtual stce_9763 _read_adjoint(const index_t stce_9806) { return stce_9893[stce_9806 - stce_9980]; }
  virtual void _increment_adjoint(const index_t stce_9806, const stce_9763& stce_9919) {
    if (stce_9919 == 0)
      return;
    if (stce_9806 <= stce_9980) {
      if (stce_9982 == false) {
        stce_9986->insert(stce_9806, stce_9919);
      } else {
        stce_9983[stce_9806] += stce_9919;
      }
    } else {
      stce_9956(stce_9806) += stce_9919;
    }
  }
};
template <> struct jacobian_preaccumulator_t<void> {
  jacobian_preaccumulator_t(void*) {}
  void start() {}
  template <typename stce_9781> void register_output(const stce_9781&) {}
  void finish() {}
};
} // namespace internal
} // namespace dco

namespace dco {
namespace helper {
template <typename, typename stce_10001> struct stce_10002 {
  stce_10002(stce_10001*) {}
  template <typename stce_9781> void register_input(const stce_9781&) {}
  template <typename stce_9781> void register_output(const stce_9781&) {}
};
} // namespace helper
} // namespace dco

namespace dco {
namespace helper {
template <typename stce_10003> class stce_10004 {
  template <memory_model::TYPE, typename, memory_model::TYPE> friend class internal::tape;
  typedef typename stce_10003::stce_9932 stce_9763;

protected:
  stce_10003* stce_10005;

public:
  virtual ~stce_10004() {}
  dco::adjoint_vector_abstract<stce_9763>* _adjoint_vector;

public:
  void set_tape(stce_10003* stce_10006) {
    if (stce_10005 != 0) {
      return;
    } else {
      stce_10005 = stce_10006;
    }
  }
  void stce_10007() {}
  inline stce_10003* get_tape() { return stce_10005; }
  stce_10004() : stce_10005(0) {}
  virtual void stce_10008(stce_9854& stce_9855, index_t stce_9863) {
    (void)stce_9855;
    (void)stce_9863;
  }
  virtual mem_long_t size_in_byte() { return sizeof(stce_10003); }
};
} // namespace helper
} // namespace dco

namespace dco {
namespace helper {
template <class stce_10009, class stce_10003> class stce_10010 : public stce_10004<stce_10003> {
private:
  class stce_10011 {
  public:
    virtual ~stce_10011(){};
    virtual mem_long_t size_in_byte() = 0;
    virtual void stce_10012(const std::string&, const std::string&){};
  };
  template <typename stce_10013> class stce_10014 : public stce_10011 {
  public:
    const stce_10013 _data;
    stce_10014(const stce_10013& stce_10015) : _data(stce_10015) {}
    const stce_10013& stce_10016() const { return _data; }
  };
  template <typename stce_10013> class stce_10017 : public stce_10014<stce_10013> {
  public:
    stce_10017(stce_10013 data) : stce_10014<stce_10013>(data) {}
    virtual ~stce_10017() {}
    virtual mem_long_t size_in_byte() { return size_of(stce_10014<stce_10013>::_data); }
    virtual void stce_10012(const std::string& stce_10018, const std::string& stce_10019) {
      if (false && IS_DEBUG && stce_10019 != stce_10018) {
        std::stringstream stce_10020;
        stce_10020 << "read_data error: tried to read " << stce_10018 << " instead of " << stce_10019 << "!";
        throw dco::exception::create<std::runtime_error>(stce_10020.str());
      }
    }
  };
  template <typename stce_10013> class stce_10021 : public stce_10014<stce_10013*> {
  public:
    const index_t stce_10022;
    stce_10021(const stce_10013* data, index_t stce_10023)
        : stce_10014<stce_10013*>(new stce_10013[size_t(stce_10023)]), stce_10022(stce_10023) {
      for (index_t stce_9841 = 0; stce_9841 < stce_10023; ++stce_9841)
        this->_data[stce_9841] = data[stce_9841];
    }
    stce_10021(const stce_10013* data, const index_t stce_9917, const index_t stce_10023)
        : stce_10014<stce_10013*>(new stce_10013[stce_9752(stce_10023)]), stce_10022(stce_10023) {
      for (index_t stce_9841 = 0, stce_9806 = 0; stce_9841 < stce_10023; ++stce_9841, stce_9806 += stce_9917)
        this->_data[stce_9841] = data[stce_9806];
    }
    virtual ~stce_10021() { delete[] this->_data; }
    virtual mem_long_t size_in_byte() { return stce_10022 * static_cast<index_t>(sizeof(stce_10013)); }
    virtual void stce_10012(const std::string& stce_10018, const std::string& stce_10019) {
      (void)stce_10018;
      (void)stce_10019;
      if (false && IS_DEBUG && stce_10019 + "*" != stce_10018) {
        std::stringstream stce_10020;
        stce_10020 << "read_data error: tried to read " << stce_10018 << " instead of " << stce_10019 << "!";
        throw dco::exception::create<std::runtime_error>(stce_10020.str());
      }
    }
  };
  index_t stce_10024;
  std::vector<stce_10011*> stce_10025;
  std::vector<std::string> stce_10026;

protected:
  virtual ~stce_10010() {
    for (size_t stce_9841 = 0; stce_9841 < stce_10025.size(); stce_9841++)
      delete stce_10025[stce_9841];
    stce_10025.clear();
  }

public:
  stce_10010() : stce_10004<stce_10003>(), stce_10024(0) {}
  virtual mem_long_t size_in_byte() {
    mem_long_t stce_9813 = stce_10004<stce_10003>::size_in_byte();
    for (size_t stce_9841 = 0; stce_9841 < stce_10025.size(); stce_9841++) {
      stce_9813 += stce_10025[stce_9841]->size_in_byte();
    }
    stce_9813 += stce_10025.size() * sizeof(stce_10011*);
    stce_9813 += stce_10026.size() * sizeof(std::string);
    return stce_9813;
  }
  template <typename stce_10013> void write_data(const stce_10013& stce_10027) {
    stce_10025.push_back(new stce_10017<stce_10013>(stce_10027));
    if (IS_DEBUG)
      stce_10026.push_back(type_name<stce_10013>());
  }
  template <typename stce_10013> void write_data(const stce_10013* const stce_10027, const index_t stce_10023) {
    stce_10025.push_back(new stce_10021<stce_10013>(stce_10027, stce_10023));
    if (IS_DEBUG)
      stce_10026.push_back(type_name<stce_10013>());
  }
  template <typename stce_10013>
  void write_data(const stce_10013* const& stce_10027, const index_t stce_9917, const index_t stce_10023) {
    stce_10025.push_back(new stce_10021<stce_10013>(stce_10027, stce_9917, stce_10023));
    if (IS_DEBUG) {
      stce_10026.push_back(type_name<stce_10013>());
    }
  }
  template <typename stce_10013> const stce_10013& read_data() {
    const stce_10013& stce_10027 = static_cast<stce_10014<stce_10013>*>(stce_10025[stce_10024])->stce_10016();
    if (IS_DEBUG)
      stce_10025[stce_10024]->stce_10012(type_name<stce_10013>(), stce_10026.at(stce_10024));
    ++stce_10024;
    if (stce_10024 == static_cast<index_t>(stce_10025.size()))
      stce_10024 = 0;
    return stce_10027;
  }
};
} // namespace helper
} // namespace dco

namespace dco {
namespace helper {
template <class stce_10009, class stce_10003>
class stce_10028 : public stce_10010<stce_10009, stce_10003>,
                   public stce_10002<stce_10003, stce_10028<stce_10009, stce_10003>> {
  typedef stce_10002<stce_10003, stce_10028> stce_10029;
  bool stce_10030;

protected:
  std::vector<index_t> stce_9861;
  std::vector<index_t> stce_9862;
  size_t stce_10031;
  size_t stce_10032;

public:
  stce_10003*& tape() { return this->stce_10005; }
  virtual mem_long_t size_in_byte() {
    mem_long_t stce_9813 = stce_10010<stce_10009, stce_10003>::size_in_byte();
    stce_9813 += stce_9861.size() * sizeof(index_t);
    stce_9813 += stce_9862.size() * sizeof(index_t);
    stce_9813 += 2 * sizeof(index_t);
    return stce_9813;
  }
  size_t stce_10033() { return stce_9861.size(); }
  size_t stce_10034() { return stce_9862.size(); }
  void stce_10007() { stce_10030 = true; }
  void stce_10008(stce_9854& stce_9855, index_t stce_9863) {
    stce_9855.stce_9860(stce_9861, stce_9862, stce_9863 - static_cast<index_t>(stce_9862.size()) - 1);
  }

public:
  void stce_10035(const stce_10009& stce_9803) {
    if ((stce_9803.tape() != 0) && (this->stce_10005 != stce_9803.tape()))
      throw dco::exception::create<std::runtime_error>("impossible binding tape - wrong tape in variable!");
    if (this->stce_10030 == true) {
      throw dco::exception::create<std::runtime_error>(
          "Input registration required, but callback already inserted; please check ordering.");
    }
  }
  void stce_10036() {
    if (this->stce_10005 == NULL) {
      throw dco::exception::create<std::runtime_error>("Output registration required, but no tape available.");
    }
    if (this->stce_10030 == true) {
      throw dco::exception::create<std::runtime_error>(
          "Output registration required, but callback already inserted; please check ordering.");
    }
  }

protected:
  ~stce_10028() {
    if (IS_DEBUG && stce_10031 != 0) {
      DCO_LOG(dco::logERROR) << "not all input adjoints incremented in external adjoint object.";
    }
    if (IS_DEBUG && stce_10032 != 0) {
      DCO_LOG(dco::logERROR) << "not all output adjoints read in external adjoint object.";
    }
  }

public:
  stce_10028(const std::pair<size_t, size_t>& stce_10037)
      : stce_10010<stce_10009, stce_10003>(), stce_10029(this), stce_10030(false), stce_10031(0), stce_10032(0) {
    stce_9861.reserve(stce_10037.first);
    stce_9862.reserve(stce_10037.second);
  }
  stce_10028()
      : stce_10010<stce_10009, stce_10003>(), stce_10029(this), stce_10030(false), stce_10031(0), stce_10032(0) {}
  typename stce_10009::VALUE_TYPE register_input(const stce_10009& stce_9803) {
    stce_10035(stce_9803);
    const index_t stce_9806 = stce_9803._tape_index();
    stce_9861.push_back(stce_9806);
    stce_10029::register_input(stce_9803);
    return stce_9803._value();
  }
  void register_input(const stce_10009* const stce_9803, typename stce_10009::VALUE_TYPE* stce_10038,
                      const size_t stce_10023) {
    stce_9861.reserve(stce_9861.size() + stce_10023);
    for (size_t stce_9841 = 0; stce_9841 < stce_10023; ++stce_9841) {
      stce_10035(stce_9803[stce_9841]);
      const index_t stce_9806 = stce_9803[stce_9841]._tape_index();
      stce_9861.push_back(stce_9806);
      stce_10038[stce_9841] = stce_9803[stce_9841]._value();
      stce_10029::register_input(stce_9803[stce_9841]);
    }
  }
  void register_input(const std::vector<stce_10009>& stce_9803,
                      std::vector<typename stce_10009::VALUE_TYPE>& stce_10038) {
    assert(stce_9803.size() == stce_10038.size());
    register_input(&(stce_9803[0]), &(stce_10038[0]), stce_9803.size());
  }
  std::vector<typename stce_10009::VALUE_TYPE> register_input(const std::vector<stce_10009>& stce_9803) {
    std::vector<typename stce_10009::VALUE_TYPE> stce_10038(stce_9803.size());
    register_input(stce_9803, stce_10038);
    return stce_10038;
  }
  void register_output(stce_10009* stce_10039, const size_t stce_10023) {
    register_output(NULL, stce_10039, stce_10023);
  }
  void register_output(const typename stce_10009::VALUE_TYPE* const stce_10040, stce_10009* stce_10039,
                       const size_t stce_10023) {
    stce_10036();
    stce_9862.reserve(stce_9862.size() + stce_10023);
    for (size_t stce_9841 = 0; stce_9841 < stce_10023; ++stce_9841) {
      if (stce_10040) {
        stce_10039[stce_9841] = stce_10040[stce_9841];
      }
      this->stce_10005->register_variable(stce_10039[stce_9841]);
      stce_9862.push_back(stce_10039[stce_9841]._tape_index());
      stce_10029::register_output(stce_10039[stce_9841]);
    }
  }
  void register_output(const std::vector<typename stce_10009::VALUE_TYPE>& stce_10040,
                       std::vector<stce_10009>& stce_10039) {
    assert(stce_10040.size() == stce_10039.size());
    register_output(&(stce_10040[0]), &(stce_10039[0]), stce_10040.size());
  }
  std::vector<stce_10009> register_output(const std::vector<typename stce_10009::VALUE_TYPE>& stce_10040) {
    std::vector<stce_10009> stce_10039(stce_10040.size());
    register_output(stce_10040, stce_10039);
    return stce_10039;
  }
  void register_output(std::vector<stce_10009>& stce_10039) { register_output(&(stce_10039[0]), stce_10039.size()); }
  stce_10009 register_output(const typename stce_10009::VALUE_TYPE& stce_10041, stce_10003* tape = NULL) {
    stce_10009 stce_10042;
    if (tape != NULL) {
      if (this->stce_10005 != NULL && this->stce_10005 != tape) {
        throw dco::exception::create<std::runtime_error>(
            "impossible binding output in external function (register_output) - tape of inputs and outputs differ!");
      }
      this->stce_10005 = tape;
    }
    stce_10036();
    stce_10042 = stce_10041;
    this->stce_10005->register_variable(stce_10042);
    stce_9862.push_back(stce_10042._tape_index());
    stce_10029::register_output(stce_10042);
    return stce_10042;
  }
  inline typename dco::mode<stce_10009>::stce_9975 get_output_adjoint() {
    size_t stce_9806 = stce_10032;
    stce_10032++;
    if (stce_10032 == stce_9862.size())
      stce_10032 = 0;
    typename dco::mode<stce_10009>::stce_9975 back = this->_adjoint_vector->_read_adjoint(stce_9862[stce_9806]);
    return back;
  }
  void get_output_adjoint(typename stce_10009::VALUE_TYPE* stce_9807, const size_t stce_10023) {
    size_t stce_9806 = stce_10032;
    for (size_t stce_9841 = 0; stce_9841 < stce_10023; ++stce_9841) {
      stce_9807[stce_9841] = get_output_adjoint();
      stce_9806++;
    }
    if (stce_10032 == stce_9862.size()) {
      stce_10032 = 0;
    }
  }
  void get_output_adjoint(std::vector<typename stce_10009::VALUE_TYPE>& stce_9807) {
    assert(stce_9807.size());
    get_output_adjoint(&(stce_9807[0]), stce_9807.size());
  }
  void increment_input_adjoint(const typename stce_10009::VALUE_TYPE* const stce_9919, const size_t stce_10023) {
    for (size_t stce_9841 = 0; stce_9841 < stce_10023; ++stce_9841) {
      this->_adjoint_vector->_increment_adjoint(stce_9861[stce_10031 + stce_9841], stce_9919[stce_9841]);
    }
    stce_10031 += stce_10023;
    if (stce_10031 == stce_9861.size())
      stce_10031 = 0;
  }
  void increment_input_adjoint(const std::vector<typename stce_10009::VALUE_TYPE>& stce_9919) {
    assert(stce_9919.size() != 0);
    increment_input_adjoint(&(stce_9919[0]), stce_9919.size());
  }
  bool stce_10043() {
    if (stce_10031 == 0)
      return true;
    else
      return false;
  }
  bool stce_10044() {
    if (stce_10032 == 0)
      return true;
    else
      return false;
  }
  void increment_input_adjoint(const typename dco::mode<stce_10009>::stce_9975& stce_9919) {
    size_t stce_9806 = stce_10031;
    stce_10031++;
    if (stce_10031 == stce_9861.size())
      stce_10031 = 0;
    this->_adjoint_vector->_increment_adjoint(stce_9861[stce_9806], stce_9919);
  }
};
} // namespace helper
} // namespace dco

namespace dco {
namespace ACM {
template <class stce_10003, class stce_10045> struct baseclass : dco::helper::stce_10004<stce_10003> {
private:
  std::vector<stce_10045*> stce_10046;
  std::vector<stce_10045*> stce_10047;
  std::vector<index_t> stce_10048;
  std::vector<index_t> stce_10049;
  std::vector<void*> _data;
  int stce_10050;

public:
  typedef stce_10045 active_t;
  typedef stce_10003 tape_t;
  baseclass(tape_t* tape) : stce_10050(0) { this->set_tape(tape); }
  size_t register_input(stce_10045& stce_9803) {
    size_t stce_9843 = stce_10046.size();
    stce_10046.push_back(&stce_9803);
    stce_10049.push_back(stce_9803._tape_index());
    return stce_9843;
  }
  size_t register_input(std::vector<stce_10045>& stce_10051) {
    size_t stce_9843 = stce_10046.size();
    for (int stce_9841 = 0; stce_9841 < stce_10051.size(); ++stce_9841) {
      const stce_10045& stce_10052 = stce_10051[stce_9841];
      this->register_input(stce_10052);
    }
    return stce_9843;
  }
  size_t register_output(stce_10045& stce_9803) {
    if (stce_9803._tape_index() == 0) {
      this->get_tape()->register_variable(stce_9803);
    }
    size_t stce_9843 = stce_10047.size();
    stce_10047.push_back(&stce_9803);
    stce_10048.push_back(stce_9803._tape_index());
    return stce_9843;
  }
  int register_output(std::vector<stce_10045>& stce_10051) {
    int stce_9843 = stce_10047.size();
    for (int stce_9841 = 0; stce_9841 < stce_10051.size(); ++stce_9841) {
      if (stce_10051[stce_9841]._tape_index() == 0) {
        this->get_tape()->register_variable(stce_10051[stce_9841]);
      }
      stce_10048.push_back(stce_10051[stce_9841]._tape_index());
      stce_10047.push_back(&stce_10051[stce_9841]);
    }
    return stce_9843;
  }
  template <typename stce_9781> int write_data(const stce_9781& data) {
    stce_9781* stce_10053 = new stce_9781(data);
    int stce_9843 = _data.size();
    _data.push_back(stce_10053);
    return stce_9843;
  }
  template <typename stce_9781> const stce_9781& read_data(const int stce_10054 = -1) {
    int stce_9806 = 0;
    if (stce_10054 == -1) {
      stce_9806 = stce_10050 % _data.size();
      stce_10050++;
    }
    void* stce_10055 = _data[stce_9806];
    return *static_cast<stce_9781*>(stce_10055);
  }
  size_t stce_10056() { return stce_10046.size(); }
  size_t stce_10057() { return stce_10046.size(); }
  typename stce_10045::VALUE_TYPE& input_value(const int stce_9806) { return stce_10046[stce_9806]->_value(); }
  typename stce_10045::VALUE_TYPE& output_value(const int stce_9806) { return stce_10047[stce_9806]->_value(); }
  typename dco::mode<stce_10045>::stce_9975& input_adjoint(const int stce_9806) {
    return this->get_tape()->_adjoint(stce_10049[stce_9806]);
  }
  typename dco::mode<stce_10045>::stce_9975& output_adjoint(const int stce_9806) {
    return this->get_tape()->_adjoint(stce_10048[stce_9806]);
  }
  virtual void evaluate_primal() { std::cout << "WARNING: you need to implement evaluate_primal!!!!\n"; }
  virtual void evaluate_augmented_primal() {
    std::cout << "WARNING: you need to implement evaluate_augmented_primal!!!!\n";
  }
  virtual void evaluate_adjoint() { std::cout << "WARNING: you need to implement evaluate_adjoint!!!!\n"; }
};
template <class stce_10003, class stce_10045> static void stce_10058(baseclass<stce_10003, stce_10045>* stce_10059) {
  stce_10059->evaluate_adjoint();
}
} // namespace ACM
} // namespace dco
namespace dco {
namespace stce_10060 {
template <class stce_10061> struct stce_10062 {
  std::vector<stce_10061*> stce_10046;
  std::vector<stce_10061*> stce_10047;
  std::vector<void*> _data;
  int stce_10050;
  stce_10062() : stce_10050(0) {}
  virtual ~stce_10062() {}
  template <typename stce_9781> int write_data(const stce_9781& data) {
    stce_9781* stce_10053 = new stce_9781(data);
    int stce_9843 = _data.size();
    _data.push_back(stce_10053);
    return stce_9843;
  }
  template <typename stce_9781> const stce_9781& read_data(const int stce_10054 = -1) {
    int stce_9806 = 0;
    if (stce_10054 == -1) {
      stce_9806 = stce_10050 % _data.size();
      stce_10050++;
    }
    void* stce_10055 = _data[stce_9806];
    return *static_cast<stce_9781*>(stce_10055);
  }
  size_t stce_10056() { return stce_10046.size(); }
  size_t stce_10057() { return stce_10047.size(); }
  stce_10061& input_value(const int stce_9806) { return *stce_10046[stce_9806]; }
  stce_10061& output_value(const int stce_9806) { return *stce_10047[stce_9806]; }
  virtual void evaluate_primal() { std::cout << "WARNING: you need to implement evaluate_primal!!!!\n"; }
};
template <class stce_10061> struct stce_10063 : stce_10062<stce_10061> {
  int register_input(stce_10061& stce_9803) {
    int stce_9843 = this->stce_10046.size();
    this->stce_10046.push_back(&stce_9803);
    return stce_9843;
  }
  int register_input(std::vector<stce_10061>& stce_10051) {
    int stce_9843 = this->stce_10046.size();
    for (int stce_9841 = 0; stce_9841 < stce_10051.size(); ++stce_9841) {
      const stce_10061& stce_10052 = stce_10051[stce_9841];
      this->register_input(stce_10052);
    }
    return stce_9843;
  }
  int register_output(stce_10061& stce_9803) {
    int stce_9843 = this->stce_10047.size();
    this->stce_10047.push_back(&stce_9803);
    return stce_9843;
  }
  int register_output(std::vector<stce_10061>& stce_10051) {
    int stce_9843 = this->stce_10047.size();
    for (int stce_9841 = 0; stce_9841 < stce_10051.size(); ++stce_9841) {
      register_output(stce_10051[stce_9841]);
    }
    return stce_9843;
  }
};
template <class stce_10003, class stce_10045>
struct stce_10064 : public dco::helper::stce_10004<stce_10003>, public stce_10062<stce_10045> {
private:
  std::vector<index_t> stce_10048;
  std::vector<index_t> stce_10049;

public:
  typedef stce_10045 active_t;
  typedef stce_10003 tape_t;
  stce_10064(tape_t* tape) { this->set_tape(tape); }
  stce_10045& stce_10065(const int stce_9806) { return *(this->stce_10046[stce_9806]); }
  stce_10045& stce_10066(const int stce_9806) { return *(this->stce_10047[stce_9806]); }
  typename stce_10045::VALUE_TYPE& input_value(const int stce_9806) { return this->stce_10046[stce_9806]->_value(); }
  typename stce_10045::VALUE_TYPE& output_value(const int stce_9806) { return this->stce_10047[stce_9806]->_value(); }
  typename dco::mode<stce_10045>::stce_9975& input_adjoint(const int stce_9806) {
    return this->get_tape()->_adjoint(stce_10049[stce_9806]);
  }
  typename dco::mode<stce_10045>::stce_9975& output_adjoint(const int stce_9806) {
    return this->get_tape()->_adjoint(stce_10048[stce_9806]);
  }
  int register_input(stce_10045& stce_9803) {
    int stce_9843 = this->stce_10046.size();
    this->stce_10046.push_back(&stce_9803);
    this->stce_10049.push_back(stce_9803._tape_index());
    return stce_9843;
  }
  int register_input(std::vector<stce_10045>& stce_10051) {
    int stce_9843 = this->stce_10046.size();
    for (int stce_9841 = 0; stce_9841 < stce_10051.size(); ++stce_9841) {
      const stce_10045& stce_10052 = stce_10051[stce_9841];
      this->register_input(stce_10052);
    }
    return stce_9843;
  }
  int register_output(stce_10045& stce_9803) {
    if (stce_9803._tape_index() == 0) {
      this->get_tape()->register_variable(stce_9803);
    }
    int stce_9843 = this->stce_10047.size();
    this->stce_10047.push_back(&stce_9803);
    this->stce_10048.push_back(stce_9803._tape_index());
    return stce_9843;
  }
  int register_output(std::vector<stce_10045>& stce_10051) {
    int stce_9843 = this->stce_10047.size();
    for (int stce_9841 = 0; stce_9841 < stce_10051.size(); ++stce_9841) {
      if (stce_10051[stce_9841]._tape_index() == 0) {
        this->get_tape()->register_variable(stce_10051[stce_9841]);
      }
      this->stce_10048.push_back(stce_10051[stce_9841]._tape_index());
      this->stce_10047.push_back(&stce_10051[stce_9841]);
    }
    return stce_9843;
  }
  virtual void evaluate_augmented_primal() {
    std::cout << "WARNING: you need to implement evaluate_augmented_primal!!!!\n";
  }
  virtual void evaluate_adjoint() { std::cout << "WARNING: you need to implement evaluate_adjoint!!!!\n"; }
};
template <class stce_10003, class stce_10045> static void stce_10058(stce_10064<stce_10003, stce_10045>* stce_10059) {
  stce_10059->evaluate_adjoint();
}
} // namespace stce_10060
} // namespace dco

namespace dco {
namespace internal {
template <class stce_10045> class stce_10067 {
private:
  typedef typename dco::mode<stce_10045>::tape_t tape_t;
  typedef typename tape_t::stce_9762 stce_9762;
  typedef typename tape_t::edge_inserter edge_inserter;
  stce_10045& stce_10068;
  edge_inserter stce_9986;
  stce_10067(const stce_10067&);

public:
  stce_10067(stce_10045& stce_10069) : stce_10068(stce_10069), stce_9986(stce_10069.tape()->insert_ref()) {}
  ~stce_10067() { stce_10068._tape_index() = stce_9986.index(); }
  template <typename stce_9792> void put(const stce_9792& stce_9803, const stce_9762& stce_9959) {
    if (!stce_9755 || stce_9803._tape_index() != 0) {
      bool stce_10070 = (stce_9986.index() == 0);
      stce_9986.insert(stce_9803._tape_index(), stce_9959);
      if (stce_10070)
        stce_10068.stce_10071(stce_10068._value(), stce_9820());
    }
  }
};
} // namespace internal
} // namespace dco

namespace dco {
namespace internal {
template <class stce_10072> struct stce_10073 {
  typedef typename stce_10072::tape_t::stce_9763 derivative_t;

protected:
  mutable index_t stce_10074;

public:
  stce_10073() : stce_10074(0) {}
  DCO_STRONG_INLINE stce_10073(const stce_10073& stce_10075) : stce_10074(stce_10075.stce_10074) {}
  DCO_STRONG_INLINE stce_10073& operator=(const stce_10073& stce_9803) {
    stce_10074 = stce_9803.stce_10074;
    return *this;
  }
  void clear() { stce_10074 = 0; }
  derivative_t& stce_9963() const { return _adjoint(); }
  derivative_t& _adjoint() const {
    if (IS_DEBUG && !stce_10072::global_tape)
      throw dco::exception::create<std::runtime_error>(
          "Tape not created yet. Please use tape_t::create() before accessing derivative components of adjoint types.");
    return stce_10072::global_tape->_adjoint(stce_10074);
  }
  void stce_10076(const derivative_t& stce_9842) const {
    if (IS_DEBUG && !stce_10072::global_tape)
      throw dco::exception::create<std::runtime_error>(
          "Tape not created yet. Please use tape_t::create() before accessing derivative components of adjoint types.");
    stce_10072::global_tape->_adjoint(stce_10074) = stce_9842;
  }
  bool _is_registered() const { return stce_10074 == 0 ? false : true; }
  index_t& _tape_index() const { return stce_10074; }
  template <class stce_10061> DCO_STRONG_INLINE void stce_10071(const stce_10061&, const double&) {}
  template <typename stce_10077>
  static DCO_STRONG_INLINE void register_variable(stce_10077& stce_9803, index_t index, typename stce_10072::tape_t*) {
    if (IS_DEBUG && !stce_10072::global_tape) {
      throw dco::exception::create<std::runtime_error>("Global tape not yet created (is NULL).");
    }
    stce_9803.stce_10074 = index;
  }
  static typename stce_10072::tape_t* tape() { return stce_10072::global_tape; }
  void set_tape(typename stce_10072::tape_t*) {}
};
} // namespace internal
} // namespace dco

namespace dco {
namespace internal {
struct stce_10078 {
  template <class stce_10079, class stce_10080>
  static auto stce_10081(const stce_10079& stce_10082, const stce_10080& stce_10083)
      -> decltype(stce_10082._value() == stce_10083._value()) {
    return stce_10082._value() == stce_10083._value();
  }
  template <class stce_10079, class stce_10080>
  static auto stce_10084(const stce_10079& stce_10082, const stce_10080& stce_10083)
      -> decltype(stce_10082._value() == stce_10083) {
    return stce_10082._value() == stce_10083;
  }
  template <class stce_10079, class stce_10080>
  static auto stce_10085(const stce_10079& stce_10082, const stce_10080& stce_10083)
      -> decltype(stce_10082 == stce_10083._value()) {
    return stce_10082 == stce_10083._value();
  }
  template <class stce_10079, class stce_10080>
  static auto stce_10086(const stce_10079& stce_10082, const stce_10080& stce_10083)
      -> decltype(stce_10082._value() != stce_10083._value()) {
    return stce_10082._value() != stce_10083._value();
  }
  template <class stce_10079, class stce_10080>
  static auto stce_10087(const stce_10079& stce_10082, const stce_10080& stce_10083)
      -> decltype(stce_10082._value() != stce_10083) {
    return stce_10082._value() != stce_10083;
  }
  template <class stce_10079, class stce_10080>
  static auto stce_10088(const stce_10079& stce_10082, const stce_10080& stce_10083)
      -> decltype(stce_10082 != stce_10083._value()) {
    return stce_10082 != stce_10083._value();
  }
  template <class stce_10079, class stce_10080>
  static auto stce_10089(const stce_10079& stce_10082, const stce_10080& stce_10083)
      -> decltype(stce_10082._value() < stce_10083._value()) {
    return stce_10082._value() < stce_10083._value();
  }
  template <class stce_10079, class stce_10080>
  static auto stce_10090(const stce_10079& stce_10082, const stce_10080& stce_10083)
      -> decltype(stce_10082._value() < stce_10083) {
    return stce_10082._value() < stce_10083;
  }
  template <class stce_10079, class stce_10080>
  static auto stce_10091(const stce_10079& stce_10082, const stce_10080& stce_10083)
      -> decltype(stce_10082 < stce_10083._value()) {
    return stce_10082 < stce_10083._value();
  }
  template <class stce_10079, class stce_10080>
  static auto stce_10092(const stce_10079& stce_10082, const stce_10080& stce_10083)
      -> decltype(stce_10082._value() <= stce_10083._value()) {
    return stce_10082._value() <= stce_10083._value();
  }
  template <class stce_10079, class stce_10080>
  static auto stce_10093(const stce_10079& stce_10082, const stce_10080& stce_10083)
      -> decltype(stce_10082._value() <= stce_10083) {
    return stce_10082._value() <= stce_10083;
  }
  template <class stce_10079, class stce_10080>
  static auto stce_10094(const stce_10079& stce_10082, const stce_10080& stce_10083)
      -> decltype(stce_10082 <= stce_10083._value()) {
    return stce_10082 <= stce_10083._value();
  }
  template <class stce_10079, class stce_10080>
  static auto stce_10095(const stce_10079& stce_10082, const stce_10080& stce_10083)
      -> decltype(stce_10082._value() > stce_10083._value()) {
    return stce_10082._value() > stce_10083._value();
  }
  template <class stce_10079, class stce_10080>
  static auto stce_10096(const stce_10079& stce_10082, const stce_10080& stce_10083)
      -> decltype(stce_10082._value() > stce_10083) {
    return stce_10082._value() > stce_10083;
  }
  template <class stce_10079, class stce_10080>
  static auto stce_10097(const stce_10079& stce_10082, const stce_10080& stce_10083)
      -> decltype(stce_10082 > stce_10083._value()) {
    return stce_10082 > stce_10083._value();
  }
  template <class stce_10079, class stce_10080>
  static auto stce_10098(const stce_10079& stce_10082, const stce_10080& stce_10083)
      -> decltype(stce_10082._value() >= stce_10083._value()) {
    return stce_10082._value() >= stce_10083._value();
  }
  template <class stce_10079, class stce_10080>
  static auto stce_10099(const stce_10079& stce_10082, const stce_10080& stce_10083)
      -> decltype(stce_10082._value() >= stce_10083) {
    return stce_10082._value() >= stce_10083;
  }
  template <class stce_10079, class stce_10080>
  static auto stce_10100(const stce_10079& stce_10082, const stce_10080& stce_10083)
      -> decltype(stce_10082 >= stce_10083._value()) {
    return stce_10082 >= stce_10083._value();
  }
};
template <class stce_10101, stce_10101*& stce_9978> struct stce_10102 {
  template <class stce_10079, class stce_10080>
  static bool stce_10081(const stce_10079& stce_10082, const stce_10080& stce_10083) {
    const bool stce_9843 = stce_10082._value() == stce_10083._value();
    const bool stce_10103 = stce_10082.stce_10104(0) == stce_10083.stce_10104(0);
    const bool stce_10105 = stce_10082.stce_10104(1) == stce_10083.stce_10104(1);
    stce_9978->stce_10106("compare_AA", stce_9843, stce_10103, stce_10105);
    return stce_9843;
  }
  template <class stce_10079, class stce_10080>
  static bool stce_10084(const stce_10079& stce_10082, const stce_10080& stce_10083) {
    const bool stce_9843 = stce_10082._value() == stce_10083;
    const bool stce_10103 = stce_10082.stce_10104(0) == stce_10083;
    const bool stce_10105 = stce_10082.stce_10104(1) == stce_10083;
    stce_9978->stce_10106("compare_AP", stce_9843, stce_10103, stce_10105);
    return stce_9843;
  }
  template <class stce_10079, class stce_10080>
  static bool stce_10085(const stce_10079& stce_10082, const stce_10080& stce_10083) {
    const bool stce_9843 = stce_10082 == stce_10083._value();
    const bool stce_10103 = stce_10082 == stce_10083.stce_10104(0);
    const bool stce_10105 = stce_10082 == stce_10083.stce_10104(1);
    stce_9978->stce_10106("compare_PA", stce_9843, stce_10103, stce_10105);
    return stce_9843;
  }
  template <class stce_10079, class stce_10080>
  static bool stce_10086(const stce_10079& stce_10082, const stce_10080& stce_10083) {
    const bool stce_9843 = stce_10082._value() != stce_10083._value();
    const bool stce_10103 = stce_10082.stce_10104(0) != stce_10083.stce_10104(0);
    const bool stce_10105 = stce_10082.stce_10104(1) != stce_10083.stce_10104(1);
    stce_9978->stce_10106("compare_AA", stce_9843, stce_10103, stce_10105);
    return stce_9843;
  }
  template <class stce_10079, class stce_10080>
  static bool stce_10087(const stce_10079& stce_10082, const stce_10080& stce_10083) {
    const bool stce_9843 = stce_10082._value() != stce_10083;
    const bool stce_10103 = stce_10082.stce_10104(0) != stce_10083;
    const bool stce_10105 = stce_10082.stce_10104(1) != stce_10083;
    stce_9978->stce_10106("compare_AP", stce_9843, stce_10103, stce_10105);
    return stce_9843;
  }
  template <class stce_10079, class stce_10080>
  static bool stce_10088(const stce_10079& stce_10082, const stce_10080& stce_10083) {
    const bool stce_9843 = stce_10082 != stce_10083._value();
    const bool stce_10103 = stce_10082 != stce_10083.stce_10104(0);
    const bool stce_10105 = stce_10082 != stce_10083.stce_10104(1);
    stce_9978->stce_10106("compare_PA", stce_9843, stce_10103, stce_10105);
    return stce_9843;
  }
  template <class stce_10079, class stce_10080>
  static bool stce_10089(const stce_10079& stce_10082, const stce_10080& stce_10083) {
    const bool stce_9843 = stce_10082._value() < stce_10083._value();
    const bool stce_10103 = stce_10082.stce_10104(0) < stce_10083.stce_10104(0);
    const bool stce_10105 = stce_10082.stce_10104(1) < stce_10083.stce_10104(1);
    stce_9978->stce_10106("compare_AA", stce_9843, stce_10103, stce_10105);
    return stce_9843;
  }
  template <class stce_10079, class stce_10080>
  static bool stce_10090(const stce_10079& stce_10082, const stce_10080& stce_10083) {
    const bool stce_9843 = stce_10082._value() < stce_10083;
    const bool stce_10103 = stce_10082.stce_10104(0) < stce_10083;
    const bool stce_10105 = stce_10082.stce_10104(1) < stce_10083;
    stce_9978->stce_10106("compare_AP", stce_9843, stce_10103, stce_10105);
    return stce_9843;
  }
  template <class stce_10079, class stce_10080>
  static bool stce_10091(const stce_10079& stce_10082, const stce_10080& stce_10083) {
    const bool stce_9843 = stce_10082 < stce_10083._value();
    const bool stce_10103 = stce_10082 < stce_10083.stce_10104(0);
    const bool stce_10105 = stce_10082 < stce_10083.stce_10104(1);
    stce_9978->stce_10106("compare_PA", stce_9843, stce_10103, stce_10105);
    return stce_9843;
  }
  template <class stce_10079, class stce_10080>
  static bool stce_10092(const stce_10079& stce_10082, const stce_10080& stce_10083) {
    const bool stce_9843 = stce_10082._value() <= stce_10083._value();
    const bool stce_10103 = stce_10082.stce_10104(0) <= stce_10083.stce_10104(0);
    const bool stce_10105 = stce_10082.stce_10104(1) <= stce_10083.stce_10104(1);
    stce_9978->stce_10106("compare_AA", stce_9843, stce_10103, stce_10105);
    return stce_9843;
  }
  template <class stce_10079, class stce_10080>
  static bool stce_10093(const stce_10079& stce_10082, const stce_10080& stce_10083) {
    const bool stce_9843 = stce_10082._value() <= stce_10083;
    const bool stce_10103 = stce_10082.stce_10104(0) <= stce_10083;
    const bool stce_10105 = stce_10082.stce_10104(1) <= stce_10083;
    stce_9978->stce_10106("compare_AP", stce_9843, stce_10103, stce_10105);
    return stce_9843;
  }
  template <class stce_10079, class stce_10080>
  static bool stce_10094(const stce_10079& stce_10082, const stce_10080& stce_10083) {
    const bool stce_9843 = stce_10082 <= stce_10083._value();
    const bool stce_10103 = stce_10082 <= stce_10083.stce_10104(0);
    const bool stce_10105 = stce_10082 <= stce_10083.stce_10104(1);
    stce_9978->stce_10106("compare_PA", stce_9843, stce_10103, stce_10105);
    return stce_9843;
  }
  template <class stce_10079, class stce_10080>
  static bool stce_10095(const stce_10079& stce_10082, const stce_10080& stce_10083) {
    const bool stce_9843 = stce_10082._value() > stce_10083._value();
    const bool stce_10103 = stce_10082.stce_10104(0) > stce_10083.stce_10104(0);
    const bool stce_10105 = stce_10082.stce_10104(1) > stce_10083.stce_10104(1);
    stce_9978->stce_10106("compare_AA", stce_9843, stce_10103, stce_10105);
    return stce_9843;
  }
  template <class stce_10079, class stce_10080>
  static bool stce_10096(const stce_10079& stce_10082, const stce_10080& stce_10083) {
    const bool stce_9843 = stce_10082._value() > stce_10083;
    const bool stce_10103 = stce_10082.stce_10104(0) > stce_10083;
    const bool stce_10105 = stce_10082.stce_10104(1) > stce_10083;
    stce_9978->stce_10106("compare_AP", stce_9843, stce_10103, stce_10105);
    return stce_9843;
  }
  template <class stce_10079, class stce_10080>
  static bool stce_10097(const stce_10079& stce_10082, const stce_10080& stce_10083) {
    const bool stce_9843 = stce_10082 > stce_10083._value();
    const bool stce_10103 = stce_10082 > stce_10083.stce_10104(0);
    const bool stce_10105 = stce_10082 > stce_10083.stce_10104(1);
    stce_9978->stce_10106("compare_PA", stce_9843, stce_10103, stce_10105);
    return stce_9843;
  }
  template <class stce_10079, class stce_10080>
  static bool stce_10098(const stce_10079& stce_10082, const stce_10080& stce_10083) {
    const bool stce_9843 = stce_10082._value() >= stce_10083._value();
    const bool stce_10103 = stce_10082.stce_10104(0) >= stce_10083.stce_10104(0);
    const bool stce_10105 = stce_10082.stce_10104(1) >= stce_10083.stce_10104(1);
    stce_9978->stce_10106("compare_AA", stce_9843, stce_10103, stce_10105);
    return stce_9843;
  }
  template <class stce_10079, class stce_10080>
  static bool stce_10099(const stce_10079& stce_10082, const stce_10080& stce_10083) {
    const bool stce_9843 = stce_10082._value() >= stce_10083;
    const bool stce_10103 = stce_10082.stce_10104(0) >= stce_10083;
    const bool stce_10105 = stce_10082.stce_10104(1) >= stce_10083;
    stce_9978->stce_10106("compare_AP", stce_9843, stce_10103, stce_10105);
    return stce_9843;
  }
  template <class stce_10079, class stce_10080>
  static bool stce_10100(const stce_10079& stce_10082, const stce_10080& stce_10083) {
    const bool stce_9843 = stce_10082 >= stce_10083._value();
    const bool stce_10103 = stce_10082 >= stce_10083.stce_10104(0);
    const bool stce_10105 = stce_10082 >= stce_10083.stce_10104(1);
    stce_9978->stce_10106("compare_PA", stce_9843, stce_10103, stce_10105);
    return stce_9843;
  }
};
} // namespace internal
} // namespace dco

namespace dco {
namespace folding {
template <class stce_10107> class stce_10108 {
public:
  typedef typename stce_10107::stce_9763 stce_9763;
  typedef typename stce_10107::stce_9762 stce_9762;
  typedef typename stce_10107::edge_inserter stce_10109;
  stce_10108(stce_10107* tape) : stce_10110(1), stce_9986(tape->insert_ref()) {}
  template <class stce_10111, typename stce_9760> DCO_ALWAYS_INLINE stce_10111& stce_10112(stce_9760 const& pval) {
    stce_10110 *= static_cast<stce_9762>(pval);
    return static_cast<stce_10111&>(*this);
  }
  DCO_ALWAYS_INLINE stce_9762& pval() { return stce_10110; }
  DCO_ALWAYS_INLINE index_t index() const { return stce_9986.index(); }
  template <class stce_10077> DCO_ALWAYS_INLINE void insert(stce_10077 const& stce_9803) {
    const index_t stce_10113 = stce_9803._tape_index();
    if (!stce_9755 || stce_10113 != 0) {
      if (!stce_9756 || !is_zero(stce_10110)) {
        stce_9986.insert(stce_10113, stce_10110);
      }
    }
  }

protected:
  stce_9762 stce_10110;

private:
  stce_10108();
  stce_10108(stce_10108& stce_9930);
  stce_10109 stce_9986;
};
template <class stce_10107> class stce_10114 : public stce_10108<stce_10107> {
  typedef typename stce_10107::stce_9763 stce_9763;
  typedef typename stce_10107::edge_inserter stce_10109;

public:
  stce_10114(stce_10107* tape) : stce_10108<stce_10107>(tape), stce_10115(0) {}
  template <class stce_10077> DCO_ALWAYS_INLINE void insert(stce_10077 stce_9803) {
    stce_10108<stce_10107>::insert(stce_9803);
    stce_10115 += this->stce_10110 * stce_9803.stce_10116;
  }
  stce_9763 stce_10117() const { return stce_10115; }

private:
  stce_10114();
  stce_10114(stce_10114& stce_9930);
  stce_9763 stce_10115;
};
template <class stce_10118, class stce_9759, class stce_10119>
DCO_ALWAYS_INLINE void interpret(const dco::internal::active_type<stce_9759, stce_10119>& stce_9803,
                                 stce_10118& stce_10120) {
  stce_10120.insert(stce_9803);
}
template <class stce_10118, class stce_9759, class stce_10121, class stce_10122, class stce_10123>
DCO_ALWAYS_INLINE void
interpret(const dco::internal::stce_9778<stce_9759, stce_10121, stce_10122, stce_10123>& stce_9803,
          stce_10118& stce_10120) {
  typename stce_10118::stce_9762 stce_10124 = stce_10120.pval();
  interpret<stce_10118>(stce_9803.stce_10125, stce_10120.template stce_10112<stce_10118>(stce_9803.stce_10126()));
  stce_10120.pval() = stce_10124;
  interpret<stce_10118>(stce_9803.stce_10127, stce_10120.template stce_10112<stce_10118>(stce_9803.stce_10128()));
}
template <class stce_10118, class stce_9759, class stce_10129, class stce_10123>
DCO_ALWAYS_INLINE void interpret(const dco::internal::stce_9775<stce_9759, stce_10129, stce_10123>& stce_9803,
                                 stce_10118& stce_10120) {
  interpret<stce_10118>(stce_9803.stce_10130, stce_10120.template stce_10112<stce_10118>(stce_9803.pval()));
}
template <class stce_10118, class stce_9759, class stce_10121, class stce_10122, class stce_10123>
DCO_ALWAYS_INLINE void
interpret(const dco::internal::stce_9779<stce_9759, stce_10121, stce_10122, stce_10123>& stce_9803,
          stce_10118& stce_10120) {
  interpret<stce_10118>(stce_9803.stce_10125, stce_10120.template stce_10112<stce_10118>(stce_9803.stce_10126()));
}
template <class stce_10118, class stce_9759, class stce_10121, class stce_10122, class stce_10123>
DCO_ALWAYS_INLINE void
interpret(const dco::internal::stce_9780<stce_9759, stce_10121, stce_10122, stce_10123>& stce_9803,
          stce_10118& stce_10120) {
  interpret<stce_10118>(stce_9803.stce_10127, stce_10120.template stce_10112<stce_10118>(stce_9803.stce_10128()));
}
template <class stce_10107> class stce_10131 {
public:
  stce_10131() : stce_9978(0) {}
  template <class stce_10077> DCO_ALWAYS_INLINE void insert(stce_10077 stce_9803) {
    if (stce_9803.tape())
      stce_9978 = stce_9803.tape();
  }
  stce_10107* tape() const { return stce_9978; }

private:
  stce_10131(stce_10131& stce_9930);
  stce_10107* stce_9978;
};
template <class stce_9759, class stce_10121, class stce_10122, class stce_10123, class stce_10107>
DCO_ALWAYS_INLINE void
interpret(const dco::internal::stce_9778<stce_9759, stce_10121, stce_10122, stce_10123>& stce_9803,
          stce_10131<stce_10107>& stce_10120) {
  interpret(stce_9803.stce_10125, stce_10120);
  if (stce_10120.tape()) {
    if (IS_DEBUG) {
      stce_10107* tape = stce_10120.tape();
      interpret(stce_9803.stce_10127, stce_10120);
      if (tape != stce_10120.tape()) {
        throw dco::exception::create<std::runtime_error>(
            "multiple tape error: different tapes on right-hand side of statement",
            "/home/vagrant/builds/xXzkdLpY/0/stce/dco_cpp_make_release/dco_cpp_dev/src/dco_folding.hpp", 143);
      }
    }
    return;
  }
  interpret(stce_9803.stce_10127, stce_10120);
}
template <class stce_9759, class stce_10129, class stce_10123, class stce_10107>
DCO_ALWAYS_INLINE void interpret(const dco::internal::stce_9775<stce_9759, stce_10129, stce_10123>& stce_9803,
                                 stce_10131<stce_10107>& stce_10120) {
  interpret(stce_9803.stce_10130, stce_10120);
}
template <class stce_9759, class stce_10121, class stce_10122, class stce_10123, class stce_10107>
DCO_ALWAYS_INLINE void
interpret(const dco::internal::stce_9779<stce_9759, stce_10121, stce_10122, stce_10123>& stce_9803,
          stce_10131<stce_10107>& stce_10120) {
  interpret(stce_9803.stce_10125, stce_10120);
}
template <class stce_9759, class stce_10121, class stce_10122, class stce_10123, class stce_10107>
DCO_ALWAYS_INLINE void
interpret(const dco::internal::stce_9780<stce_9759, stce_10121, stce_10122, stce_10123>& stce_9803,
          stce_10131<stce_10107>& stce_10120) {
  interpret(stce_9803.stce_10127, stce_10120);
}
} // namespace folding
} // namespace dco
namespace dco {
namespace internal {
template <typename stce_10072> class stce_10132 : public stce_10073<stce_10072> {
  typedef stce_10073<stce_10072> stce_10133;

public:
  typedef stce_10072 mode_t;
  typedef stce_10078 stce_10134;
  typedef typename stce_10072::tape_t tape_t;
  typedef typename tape_t::stce_9763 derivative_t;
  stce_10132() {}
  DCO_STRONG_INLINE stce_10132(const stce_10132& stce_10075) : stce_10133(stce_10075) {}
  DCO_STRONG_INLINE stce_10132& operator=(const stce_10132& stce_9803) {
    stce_10133::operator=(static_cast<const stce_10133&>(stce_9803));
    return *this;
  }
  template <class stce_9904> DCO_ALWAYS_INLINE void stce_9905(const stce_9904& stce_10135) {
    if (!stce_10072::global_tape || !stce_10072::global_tape->is_active()) {
      this->clear();
      return;
    }
    using namespace folding;
    stce_10108<tape_t> stce_10136(stce_10072::global_tape);
    interpret(stce_10135, stce_10136);
    this->stce_10074 = stce_10136.index();
  }
};
} // namespace internal
} // namespace dco
namespace dco {
template <typename stce_9781, typename stce_9760 = stce_9781, typename stce_9761 = stce_9760,
          memory_model::TYPE MEMORY_MODEL = DCO_TAPE_MEMORY_MODEL>
class ga1s {
  typedef types_config_t<stce_9781, stce_9760, stce_9761> stce_10137;

public:
  static const memory_model::TYPE TAPE_MODEL = MEMORY_MODEL;
  typedef ga1s mode_t;
  typedef dco::internal::stce_10132<ga1s> data_t;
  typedef typename stce_10137::value_t value_t;
  typedef value_t scalar_value_t;
  typedef typename stce_10137::value_t active_value_t;
  typedef typename stce_10137::stce_9763 derivative_t;
  typedef derivative_t stce_9975;
  typedef typename mode<value_t>::passive_t passive_t;
  typedef typename mode<value_t>::scalar_passive_t scalar_passive_t;
  typedef dco::internal::active_type<value_t, data_t> type;
  typedef type active_t;
  static const bool is_dco_type = true;
  static const bool is_adjoint_type = true;
  static const bool is_tangent_type = false;
  static const bool stce_10138 = false;
  static const int order = dco::mode<stce_9781>::order + 1;
  static const size_t p1f_size = 0;
  typedef internal::tape<TAPE_MODEL, stce_10137> tape_t;
  static DCOi_THREAD_LOCAL tape_t* global_tape;
  typedef typename internal::stce_10067<type> local_gradient_t;
  typedef dco::helper::stce_10004<tape_t> callback_object_t;
  typedef dco::helper::stce_10010<type, tape_t> userdata_object_t;
  typedef dco::helper::stce_10028<type, tape_t> external_adjoint_object_t;
  typedef internal::jacobian_preaccumulator_t<type> jacobian_preaccumulator_t;
};
template <class stce_9781, class stce_9760, class stce_9761, memory_model::TYPE MEMORY_MODEL>
DCOi_THREAD_LOCAL typename ga1s<stce_9781, stce_9760, stce_9761, MEMORY_MODEL>::tape_t*
    ga1s<stce_9781, stce_9760, stce_9761, MEMORY_MODEL>::global_tape = 0;
} // namespace dco
namespace dco {
typedef ga1s<double> a1w;
typedef double w_rtype;
} // namespace dco

namespace dco {
namespace internal {
template <typename stce_10072> class stce_10139 {
  typedef typename stce_10072::tape_t tape_t;
  mutable index_t stce_10074;
  mutable tape_t* stce_10140;

public:
  typedef stce_10072 mode_t;
  typedef stce_10078 stce_10134;
  typedef typename tape_t::stce_9763 derivative_t;
  stce_10139() : stce_10074(0), stce_10140(0) {}
  DCO_STRONG_INLINE stce_10139& operator=(const stce_10139& stce_9803) {
    stce_10074 = stce_9803.stce_10074;
    stce_10140 = stce_9803.stce_10140;
    return *this;
  }
  DCO_STRONG_INLINE stce_10139(const stce_10139& stce_10075)
      : stce_10074(stce_10075.stce_10074), stce_10140(stce_10075.stce_10140) {}
  void clear() {
    stce_10074 = 0;
    stce_10140 = 0;
  }
  derivative_t& stce_9963() const { return _adjoint(); }
  derivative_t& _adjoint() const {
    static derivative_t stce_10141 = static_cast<derivative_t>(0);
    if (stce_10140 == 0) {
      stce_10141 = 0;
      return stce_10141;
    } else {
      return stce_10140->_adjoint(stce_10074);
    }
  }
  void stce_10076(const derivative_t& stce_9842) const {
    if (stce_10140 != 0)
      stce_10140->_adjoint(stce_10074) = stce_9842;
  }
  bool _is_registered() const { return stce_10074 == 0 ? false : true; }
  index_t& _tape_index() const { return stce_10074; }
  template <typename stce_10061> DCO_STRONG_INLINE void stce_10071(const stce_10061&, const double&) {}
  template <typename stce_10077>
  static DCO_STRONG_INLINE void register_variable(stce_10077& stce_9803, index_t index, tape_t* tape) {
    stce_9803.stce_10140 = tape;
    stce_9803.stce_10074 = index;
  }
  tape_t* tape() const { return stce_10140; }
  void set_tape(tape_t* stce_9781) { stce_10140 = stce_9781; }
  template <class stce_9904> DCO_ALWAYS_INLINE void stce_9905(const stce_9904& stce_10135) {
    using namespace folding;
    stce_10131<tape_t> stce_10131;
    interpret(stce_10135, stce_10131);
    tape_t* stce_10142 = stce_10131.tape();
    if (!stce_10142 || !stce_10142->is_active()) {
      clear();
      return;
    }
    stce_10108<tape_t> stce_10136(stce_10142);
    interpret(stce_10135, stce_10136);
    stce_10074 = stce_10136.index();
    stce_10140 = stce_10142;
  }
};
} // namespace internal
} // namespace dco
namespace dco {
template <class stce_9781, class stce_9760 = stce_9781, class stce_9761 = stce_9760,
          memory_model::TYPE MEMORY_MODEL = DCO_TAPE_MEMORY_MODEL>
class ga1sm {
  typedef types_config_t<stce_9781, stce_9760, stce_9761> stce_10137;

public:
  static const memory_model::TYPE TAPE_MODEL = MEMORY_MODEL;
  typedef ga1sm mode_t;
  typedef dco::internal::stce_10139<ga1sm> data_t;
  typedef typename stce_10137::value_t value_t;
  typedef typename stce_10137::value_t active_value_t;
  typedef value_t scalar_value_t;
  typedef typename stce_10137::stce_9763 derivative_t;
  typedef derivative_t stce_9975;
  typedef typename mode<value_t>::passive_t passive_t;
  typedef typename mode<value_t>::scalar_passive_t scalar_passive_t;
  typedef dco::internal::active_type<value_t, data_t> type;
  typedef type active_t;
  static const bool is_dco_type = true;
  static const bool is_adjoint_type = true;
  static const bool is_tangent_type = false;
  static const bool stce_10138 = false;
  static const int order = dco::mode<stce_9781>::order + 1;
  static const size_t p1f_size = 0;
  typedef internal::tape<TAPE_MODEL, stce_10137> tape_t;
  typedef typename internal::stce_10067<type> local_gradient_t;
  typedef dco::helper::stce_10004<tape_t> callback_object_t;
  typedef dco::helper::stce_10010<type, tape_t> userdata_object_t;
  typedef dco::helper::stce_10028<type, tape_t> external_adjoint_object_t;
  typedef internal::jacobian_preaccumulator_t<type> jacobian_preaccumulator_t;
};
} // namespace dco

namespace dco {
namespace internal {
template <typename stce_10072> struct data_g {
  typedef stce_10072 mode_t;
  typedef stce_10078 stce_10134;
  typedef typename mode_t::derivative_t derivative_t;
};
} // namespace internal
} // namespace dco
namespace dco {
template <typename stce_9781> class gvalue {
public:
  typedef internal::data_g<gvalue> data_t;
  typedef stce_9781 active_value_t;
  typedef stce_9781 type;
  typedef type active_t;
  typedef stce_9781 value_t;
  typedef value_t scalar_value_t;
  typedef stce_9781 passive_t;
  typedef stce_9781 scalar_passive_t;
  typedef void derivative_t;
  typedef void stce_9975;
  typedef void tape_t;
  typedef void local_gradient_t;
  typedef void local_gradient_with_activity_t;
  typedef void external_adjoint_object_t;
  typedef internal::jacobian_preaccumulator_t<void> jacobian_preaccumulator_t;
  static const bool is_dco_type = false;
  static const bool is_adjoint_type = false;
  static const bool is_tangent_type = false;
  static const bool stce_10138 = false;
  static const int order = 0;
  static const size_t p1f_size = 0;
  static tape_t* global_tape;
};
template <typename stce_9781> typename gvalue<stce_9781>::tape_t* gvalue<stce_9781>::global_tape = 0;
} // namespace dco
namespace dco {
template <typename stce_9781> struct mode : public dco::gvalue<stce_9781> {
  static const bool is_intermediate_type = false;
};
template <typename stce_9770, typename stce_9771>
struct mode<internal::active_type<stce_9770, stce_9771>> : public stce_9771::mode_t {
  static const bool is_intermediate_type = false;
};
template <typename stce_9770, typename stce_9771>
struct mode<internal::active_type<stce_9770, stce_9771> const> : public stce_9771::mode_t {
  static const bool is_intermediate_type = false;
};
template <typename stce_9770, typename stce_9771>
struct mode<internal::active_type<stce_9770, stce_9771>&> : public stce_9771::mode_t {
  static const bool is_intermediate_type = false;
};
template <typename stce_9770, typename stce_9771>
struct mode<internal::active_type<stce_9770, stce_9771> const&> : public stce_9771::mode_t {
  static const bool is_intermediate_type = false;
};
template <typename stce_9770, typename stce_9771>
struct mode<internal::active_type<stce_9770, stce_9771>&&> : public stce_9771::mode_t {
  static const bool is_intermediate_type = false;
};
template <typename stce_9781, typename stce_10001, typename stce_10143>
struct mode<internal::stce_9775<stce_9781, stce_10001, stce_10143>>
    : public internal::stce_9775<stce_9781, stce_10001, stce_10143>::data_t::mode_t {
  static const bool is_intermediate_type = true;
};
template <typename stce_9781, typename stce_10001, typename stce_10143>
struct mode<internal::stce_9775<stce_9781, stce_10001, stce_10143> const>
    : public internal::stce_9775<stce_9781, stce_10001, stce_10143>::data_t::mode_t {
  static const bool is_intermediate_type = true;
};
template <typename stce_9781, typename stce_10001, typename stce_10143>
struct mode<internal::stce_9775<stce_9781, stce_10001, stce_10143>&>
    : public internal::stce_9775<stce_9781, stce_10001, stce_10143>::data_t::mode_t {
  static const bool is_intermediate_type = true;
};
template <typename stce_9781, typename stce_10001, typename stce_10143>
struct mode<internal::stce_9775<stce_9781, stce_10001, stce_10143> const&>
    : public internal::stce_9775<stce_9781, stce_10001, stce_10143>::data_t::mode_t {
  static const bool is_intermediate_type = true;
};
template <typename stce_9781, typename stce_10001, typename stce_10143>
struct mode<internal::stce_9775<stce_9781, stce_10001, stce_10143>&&>
    : public internal::stce_9775<stce_9781, stce_10001, stce_10143>::data_t::mode_t {
  static const bool is_intermediate_type = true;
};
template <class stce_9781, class stce_10144, class stce_10145, class stce_10143>
struct mode<internal::stce_9778<stce_9781, stce_10144, stce_10145, stce_10143>>
    : public internal::stce_9778<stce_9781, stce_10144, stce_10145, stce_10143>::data_t::mode_t {
  static const bool is_intermediate_type = true;
};
template <class stce_9781, class stce_10144, class stce_10145, class stce_10143>
struct mode<internal::stce_9778<stce_9781, stce_10144, stce_10145, stce_10143> const>
    : public internal::stce_9778<stce_9781, stce_10144, stce_10145, stce_10143>::data_t::mode_t {
  static const bool is_intermediate_type = true;
};
template <class stce_9781, class stce_10144, class stce_10145, class stce_10143>
struct mode<internal::stce_9778<stce_9781, stce_10144, stce_10145, stce_10143>&>
    : public internal::stce_9778<stce_9781, stce_10144, stce_10145, stce_10143>::data_t::mode_t {
  static const bool is_intermediate_type = true;
};
template <class stce_9781, class stce_10144, class stce_10145, class stce_10143>
struct mode<internal::stce_9778<stce_9781, stce_10144, stce_10145, stce_10143> const&>
    : public internal::stce_9778<stce_9781, stce_10144, stce_10145, stce_10143>::data_t::mode_t {
  static const bool is_intermediate_type = true;
};
template <class stce_9781, class stce_10144, class stce_10145, class stce_10143>
struct mode<internal::stce_9778<stce_9781, stce_10144, stce_10145, stce_10143>&&>
    : public internal::stce_9778<stce_9781, stce_10144, stce_10145, stce_10143>::data_t::mode_t {
  static const bool is_intermediate_type = true;
};
template <class stce_9781, class stce_10001, class stce_9871, class stce_10143>
struct mode<internal::stce_9779<stce_9781, stce_10001, stce_9871, stce_10143>>
    : public internal::stce_9779<stce_9781, stce_10001, stce_9871, stce_10143>::data_t::mode_t {
  static const bool is_intermediate_type = true;
};
template <class stce_9781, class stce_10001, class stce_9871, class stce_10143>
struct mode<internal::stce_9779<stce_9781, stce_10001, stce_9871, stce_10143> const>
    : public internal::stce_9779<stce_9781, stce_10001, stce_9871, stce_10143>::data_t::mode_t {
  static const bool is_intermediate_type = true;
};
template <class stce_9781, class stce_10001, class stce_9871, class stce_10143>
struct mode<internal::stce_9779<stce_9781, stce_10001, stce_9871, stce_10143>&>
    : public internal::stce_9779<stce_9781, stce_10001, stce_9871, stce_10143>::data_t::mode_t {
  static const bool is_intermediate_type = true;
};
template <class stce_9781, class stce_10001, class stce_9871, class stce_10143>
struct mode<internal::stce_9779<stce_9781, stce_10001, stce_9871, stce_10143> const&>
    : public internal::stce_9779<stce_9781, stce_10001, stce_9871, stce_10143>::data_t::mode_t {
  static const bool is_intermediate_type = true;
};
template <class stce_9781, class stce_10001, class stce_9871, class stce_10143>
struct mode<internal::stce_9779<stce_9781, stce_10001, stce_9871, stce_10143>&&>
    : public internal::stce_9779<stce_9781, stce_10001, stce_9871, stce_10143>::data_t::mode_t {
  static const bool is_intermediate_type = true;
};
template <class stce_9781, class stce_10001, class stce_9871, class stce_10143>
struct mode<internal::stce_9780<stce_9781, stce_10001, stce_9871, stce_10143>>
    : public internal::stce_9780<stce_9781, stce_10001, stce_9871, stce_10143>::data_t::mode_t {
  static const bool is_intermediate_type = true;
};
template <class stce_9781, class stce_10001, class stce_9871, class stce_10143>
struct mode<internal::stce_9780<stce_9781, stce_10001, stce_9871, stce_10143> const>
    : public internal::stce_9780<stce_9781, stce_10001, stce_9871, stce_10143>::data_t::mode_t {
  static const bool is_intermediate_type = true;
};
template <class stce_9781, class stce_10001, class stce_9871, class stce_10143>
struct mode<internal::stce_9780<stce_9781, stce_10001, stce_9871, stce_10143>&>
    : public internal::stce_9780<stce_9781, stce_10001, stce_9871, stce_10143>::data_t::mode_t {
  static const bool is_intermediate_type = true;
};
template <class stce_9781, class stce_10001, class stce_9871, class stce_10143>
struct mode<internal::stce_9780<stce_9781, stce_10001, stce_9871, stce_10143> const&>
    : public internal::stce_9780<stce_9781, stce_10001, stce_9871, stce_10143>::data_t::mode_t {
  static const bool is_intermediate_type = true;
};
template <class stce_9781, class stce_10001, class stce_9871, class stce_10143>
struct mode<internal::stce_9780<stce_9781, stce_10001, stce_9871, stce_10143>&&>
    : public internal::stce_9780<stce_9781, stce_10001, stce_9871, stce_10143>::data_t::mode_t {
  static const bool is_intermediate_type = true;
};
template <class stce_9770, class DATA_TYPE>
struct mode<internal::stce_9772<stce_9770, DATA_TYPE>> : public DATA_TYPE::mode_t {
  static const bool is_intermediate_type = true;
};
} // namespace dco

namespace std {
template <typename stce_9781, typename stce_10146, typename stce_10147, typename stce_10148, typename stce_10149>
struct common_type<stce_9781, dco::internal::stce_9778<stce_10146, stce_10147, stce_10148, stce_10149>> {
  using type =
      typename std::common_type<typename dco::mode<stce_9781>::type, typename dco::mode<stce_10147>::type>::type;
};
template <typename stce_9781, typename stce_10146, typename stce_10144, typename stce_10149>
struct common_type<stce_9781, dco::internal::stce_9775<stce_10146, stce_10144, stce_10149>> {
  using type =
      typename std::common_type<typename dco::mode<stce_9781>::type, typename dco::mode<stce_10144>::type>::type;
};
template <typename stce_9781, typename stce_10146, typename stce_10144, typename stce_10145, typename stce_10149>
struct common_type<stce_9781, dco::internal::stce_9779<stce_10146, stce_10144, stce_10145, stce_10149>> {
  using type =
      typename std::common_type<typename dco::mode<stce_9781>::type, typename dco::mode<stce_10144>::type>::type;
};
template <typename stce_9781, typename stce_10146, typename stce_10144, typename stce_10145, typename stce_10149>
struct common_type<stce_9781, dco::internal::stce_9780<stce_10146, stce_10144, stce_10145, stce_10149>> {
  using type =
      typename std::common_type<typename dco::mode<stce_9781>::type, typename dco::mode<stce_10145>::type>::type;
};
template <typename stce_9781, typename stce_10146, typename stce_10147, typename stce_10148, typename stce_10149>
struct common_type<dco::internal::stce_9778<stce_10146, stce_10147, stce_10148, stce_10149,
                                            typename enable_if<!dco::mode<stce_9781>::is_dco_type>::type>,
                   stce_9781> {
  using type = typename std::common_type<stce_9781, typename dco::mode<stce_10147>::type>::type;
};
template <typename stce_9781, typename stce_10146, typename stce_10144, typename stce_10149>
struct common_type<dco::internal::stce_9775<stce_10146, stce_10144, stce_10149,
                                            typename enable_if<!dco::mode<stce_9781>::is_dco_type>::type>,
                   stce_9781> {
  using type = typename std::common_type<stce_9781, typename dco::mode<stce_10144>::type>::type;
};
template <typename stce_9781, typename stce_10146, typename stce_10144, typename stce_10145, typename stce_10149>
struct common_type<dco::internal::stce_9779<stce_10146, stce_10144, stce_10145, stce_10149,
                                            typename enable_if<!dco::mode<stce_9781>::is_dco_type>::type>,
                   stce_9781> {
  using type = typename std::common_type<stce_9781, typename dco::mode<stce_10144>::type>::type;
};
template <typename stce_9781, typename stce_10146, typename stce_10144, typename stce_10145, typename stce_10149>
struct common_type<dco::internal::stce_9780<stce_10146, stce_10144, stce_10145, stce_10149,
                                            typename enable_if<!dco::mode<stce_9781>::is_dco_type>::type>,
                   stce_9781> {
  using type = typename std::common_type<stce_9781, typename dco::mode<stce_10145>::type>::type;
};
} // namespace std
namespace dco {
template <typename stce_9781, typename stce_10150 = stce_9781> struct dco_type_constructable_from {
  const static bool value = false;
};
template <typename stce_9781> struct dco_explicit_type_cast_to { const static bool value = false; };
} // namespace dco
namespace dco {
namespace internal {
template <class stce_9770> struct stce_10151 {
  const stce_9770 stce_9906;
  stce_10151(stce_9770 const& value) : stce_9906(value) {}
  inline const stce_9770& _value() const { return stce_9906; }
  template <typename TYPE, typename stce_10152 = typename enable_if<dco_explicit_type_cast_to<TYPE>::value>::type>
  explicit operator TYPE() {
    return static_cast<TYPE>(_value());
  }
};
template <class stce_9770, class DATA_TYPE> struct stce_9772 : public stce_10151<stce_9770> {
  stce_9772(const stce_9770& value) : stce_10151<stce_9770>(value) {}
  template <typename stce_9781 = DATA_TYPE>
  DCO_STRONG_INLINE
  operator typename dco::enable_if<is_gbcp_type<stce_9781>::value,
                                   typename stce_9909<stce_9772, stce_9781::gbcp_order>::stce_9891>::type() const {
    return stce_9909<stce_9772, stce_9781::gbcp_order>::value(*this);
  }
};
template <class stce_9770, class stce_9773, class stce_9774, typename>
struct stce_9775 : public stce_9772<stce_9770, typename stce_9773::data_t> {
  const stce_9773 DCO_TEMPORARY_REFORCOPY stce_10130;
  typedef typename stce_9773::data_t data_t;
  typedef typename data_t::mode_t::value_t VALUE_TYPE;
  typedef typename data_t::mode_t::passive_t stce_10153;
  explicit stce_9775(const stce_9773& arg)
      : stce_9772<stce_9770, data_t>(stce_9774::stce_10154(arg._value())), stce_10130(arg) {}
  inline const stce_9770 stce_10104(const int stce_9806) const {
    return stce_9774::stce_10154(stce_10130.stce_10104(stce_9806));
  }
  inline const stce_9770 pval() const { return stce_9774::stce_10155(this->_value(), stce_10130._value()); }
};
template <class stce_9770, class stce_9776, class stce_9777, class stce_9774, typename>
struct stce_9778 : public stce_9772<stce_9770, typename stce_9776::data_t> {
  const stce_9776 DCO_TEMPORARY_REFORCOPY stce_10125;
  const stce_9777 DCO_TEMPORARY_REFORCOPY stce_10127;
  typedef typename stce_9776::data_t data_t;
  typedef typename data_t::mode_t::value_t VALUE_TYPE;
  typedef typename data_t::mode_t::passive_t stce_10153;
  explicit stce_9778(const stce_9776& stce_10156, const stce_9777& stce_10157)
      : stce_9772<stce_9770, data_t>(stce_9774::stce_10154(stce_10156._value(), stce_10157._value())),
        stce_10125(stce_10156), stce_10127(stce_10157) {}
  inline const stce_9770 stce_10126() const {
    return stce_9774::stce_10158(this->_value(), stce_10125._value(), stce_10127._value());
  }
  inline const stce_9770 stce_10128() const {
    return stce_9774::stce_10159(this->_value(), stce_10125._value(), stce_10127._value());
  }
  inline const stce_9770 stce_10104(const int stce_9806) const {
    return stce_9774::stce_10154(stce_10125.stce_10104(stce_9806), stce_10127.stce_10104(stce_9806));
  }
};
template <class stce_9770, class stce_9776, class stce_9777, class stce_9774, typename>
struct stce_9779 : public stce_9772<stce_9770, typename stce_9776::data_t> {
  const stce_9776 DCO_TEMPORARY_REFORCOPY stce_10125;
  const stce_9777 stce_10127;
  typedef typename stce_9776::data_t data_t;
  typedef typename data_t::mode_t::value_t VALUE_TYPE;
  typedef typename data_t::mode_t::passive_t stce_10153;
  explicit stce_9779(const stce_9776& stce_10156, const stce_9777& stce_10157)
      : stce_9772<stce_9770, data_t>(stce_9774::stce_10154(stce_10156._value(), stce_10157)), stce_10125(stce_10156),
        stce_10127(stce_10157) {}
  inline const stce_9770 stce_10104(const int stce_9806) const {
    return stce_9774::stce_10154(stce_10125.stce_10104(stce_9806), stce_10127);
  }
  inline const stce_9770 stce_10126() const {
    return stce_9774::stce_10158(this->stce_9906, stce_10125._value(), stce_10127);
  }
};
template <class stce_9770, class stce_9776, class stce_9777, class stce_9774, typename>
struct stce_9780 : public stce_9772<stce_9770, typename stce_9777::data_t> {
  const stce_9776 stce_10125;
  const stce_9777 DCO_TEMPORARY_REFORCOPY stce_10127;
  typedef typename stce_9777::data_t data_t;
  typedef typename data_t::mode_t::value_t VALUE_TYPE;
  typedef typename data_t::mode_t::passive_t stce_10153;
  explicit stce_9780(const stce_9776& stce_10156, const stce_9777& stce_10157)
      : stce_9772<stce_9770, data_t>(stce_9774::stce_10154(stce_10156, stce_10157._value())), stce_10125(stce_10156),
        stce_10127(stce_10157) {}
  inline const stce_9770 stce_10104(const int stce_9806) const {
    return stce_9774::stce_10154(stce_10125, stce_10127.stce_10104(stce_9806));
  }
  inline const stce_9770 stce_10128() const {
    return stce_9774::stce_10159(this->stce_9906, stce_10125, stce_10127._value());
  }
};
} // namespace internal
} // namespace dco
namespace dco {
namespace internal {
template <typename stce_9781> struct passive_value_type_of { typedef stce_9781 TYPE; };
template <typename stce_9781> class stce_10160 {
protected:
  stce_9781 stce_9906;

public:
  stce_10160() : stce_9906(0.0) {}
  template <typename stce_9873> stce_10160(const stce_9873& stce_9803) : stce_9906(stce_9803) {}
};
template <class stce_9770, class stce_9771> struct active_type : private stce_10160<stce_9770>, public stce_9771 {
  typedef stce_10160<stce_9770> stce_10161;
  using stce_10161::stce_9906;

public:
  typedef stce_9771 data_t;
  typedef typename data_t::mode_t::value_t VALUE_TYPE;
  typedef typename data_t::mode_t::passive_t stce_10153;
  typedef typename data_t::mode_t::scalar_passive_t stce_10162;

private:
  typedef typename data_t::mode_t::scalar_value_t stce_10163;

public:
  DCO_STRONG_INLINE const stce_9770& _value() const { return stce_9906; }
  stce_9771 const& data() const { return *static_cast<stce_9771 const*>(this); }
  stce_9771& data() { return *static_cast<stce_9771*>(this); }
  DCO_STRONG_INLINE stce_9770& _value() { return stce_9906; }
  DCO_STRONG_INLINE const stce_9770 stce_10104(const int stce_9806) const {
    return stce_9771::stce_10104(stce_9906, stce_9806);
  }
  DCO_STRONG_INLINE active_type() : stce_10161(static_cast<stce_9770>(0.0)) {}
  DCO_STRONG_INLINE active_type(const active_type& stce_10075)
      : stce_10161(stce_10075.stce_9906), stce_9771(stce_10075) {}
  template <typename stce_9781 = stce_9771>
  DCO_STRONG_INLINE
  operator typename dco::enable_if<is_gbcp_type<stce_9781>::value,
                                   typename stce_9909<active_type, stce_9781::gbcp_order>::stce_9891>::type() const {
    return stce_9909<active_type, stce_9781::gbcp_order>::value(*this);
  }
  template <typename stce_9781 = stce_9771>
  DCO_STRONG_INLINE
  operator typename dco::enable_if<is_gbcp_type<stce_9781>::value,
                                   typename stce_9909<active_type, stce_9781::gbcp_order>::stce_9799>::type() {
    return stce_9909<active_type, stce_9781::gbcp_order>::value(*this);
  }
  template <typename stce_9873, typename stce_9781 = stce_9771>
  DCO_STRONG_INLINE typename dco::enable_if<
      (dco::mode<stce_9873>::order > 0 && dco::internal::is_gbcp_type<stce_9781>::value &&
       dco::is_same<typename stce_9781::mode_t::active_t, typename dco::mode<stce_9873>::active_t>::value),
      active_type>::type&
  operator=(const stce_9873& stce_10135) {
    stce_9906 = stce_10135;
    return *this;
  }
  template <typename stce_9873, typename stce_9781 = stce_9771>
  DCO_STRONG_INLINE
  active_type(const stce_9873& stce_9753,
              typename dco::enable_if<
                  (dco::mode<stce_9873>::order > 0 && dco::internal::is_gbcp_type<stce_9781>::value &&
                   dco::is_same<typename stce_9781::mode_t::active_t, typename dco::mode<stce_9873>::active_t>::value),
                  void*>::type = NULL)
      : stce_10161(stce_9753) {}
  template <typename TYPE>
  DCO_STRONG_INLINE active_type(const TYPE& stce_9753, typename dco_type_constructable_from<TYPE>::type* = 0)
      : stce_10161(stce_9753) {}
  template <typename TYPE, typename stce_9781 = stce_9771,
            typename stce_10164 = typename enable_if<!is_gbcp_type<stce_9781>::value>::type,
            typename stce_10152 = typename enable_if<dco_explicit_type_cast_to<TYPE>::value>::type>
  explicit operator TYPE() {
    return static_cast<TYPE>(_value());
  }
  template <typename TYPE>
  DCO_STRONG_INLINE active_type(
      const TYPE& stce_9753,
      typename dco::enable_if<stce_9878<typename TYPE::data_t::mode_t, typename data_t::mode_t>::value, void*>::type =
          NULL)
      : stce_10161(stce_9753) {}
  DCO_STRONG_INLINE active_type(const stce_10153& stce_9753) : stce_10161(stce_9753) {}
  template <typename scalar_passive_t>
  DCO_STRONG_INLINE active_type(const scalar_passive_t& stce_9753,
                                typename dco::enable_if<!dco::is_same<stce_10153, scalar_passive_t>::value &&
                                                            dco::is_same<stce_10162, scalar_passive_t>::value,
                                                        void*>::type = NULL)
      : stce_10161(stce_9753) {}
  DCO_STRONG_INLINE active_type& operator=(const active_type& stce_9803) {
    stce_9771::operator=(static_cast<const stce_9771&>(stce_9803));
    stce_9906 = stce_9803.stce_9906;
    return *this;
  }
  DCO_STRONG_INLINE active_type& operator=(const stce_10153& stce_10135) {
    this->stce_9906 = stce_10135;
    this->clear();
    return *this;
  }
  template <typename scalar_passive_t>
  DCO_STRONG_INLINE typename dco::enable_if<!dco::is_same<stce_10153, scalar_passive_t>::value &&
                                                dco::is_same<stce_10162, scalar_passive_t>::value,
                                            active_type>::type&
  operator=(const scalar_passive_t& stce_10135) {
    this->stce_9906 = stce_10135;
    this->clear();
    return *this;
  }
  template <class stce_10165, class stce_10166>
  DCO_STRONG_INLINE typename dco::enable_if<stce_9878<typename stce_10166::mode_t, typename data_t::mode_t>::value,
                                            active_type>::type&
  operator=(const active_type<stce_10165, stce_10166>& stce_10135) {
    stce_9906 = stce_10135;
    this->clear();
    return *this;
  }
  template <typename TYPE>
  DCO_STRONG_INLINE typename dco_type_constructable_from<TYPE, active_type>::type& operator=(const TYPE& stce_9753) {
    stce_9906 = stce_9753;
    this->clear();
    return *this;
  }
  template <class stce_10121, class stce_10122, class stce_10123>
  DCO_ALWAYS_INLINE
  active_type(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
    this->stce_9905(stce_9803);
    this->stce_9906 = stce_9803.stce_9906;
  }
  template <class stce_10121, class stce_10122, class stce_10123>
  DCO_ALWAYS_INLINE active_type&
  operator=(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
    this->stce_9905(stce_9803);
    this->stce_9906 = stce_9803.stce_9906;
    return *this;
  }
  template <class stce_10121, class stce_10122, class stce_10123>
  DCO_ALWAYS_INLINE
  active_type(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
    this->stce_9905(stce_9803);
    this->stce_9906 = stce_9803.stce_9906;
  }
  template <class stce_10121, class stce_10122, class stce_10123>
  DCO_ALWAYS_INLINE active_type&
  operator=(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
    this->stce_9905(stce_9803);
    this->stce_9906 = stce_9803.stce_9906;
    return *this;
  }
  template <class stce_10121, class stce_10122, class stce_10123>
  DCO_ALWAYS_INLINE
  active_type(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
    this->stce_9905(stce_9803);
    this->stce_9906 = stce_9803.stce_9906;
  }
  template <class stce_10121, class stce_10122, class stce_10123>
  DCO_ALWAYS_INLINE active_type&
  operator=(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
    this->stce_9905(stce_9803);
    this->stce_9906 = stce_9803.stce_9906;
    return *this;
  }
  template <class stce_10129, class stce_10123>
  DCO_ALWAYS_INLINE active_type(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_9803) {
    this->stce_9905(stce_9803);
    this->stce_9906 = stce_9803.stce_9906;
  }
  template <class stce_10129, class stce_10123>
  DCO_ALWAYS_INLINE active_type&
  operator=(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_9803) {
    this->stce_9905(stce_9803);
    this->stce_9906 = stce_9803.stce_9906;
    return *this;
  }
  template <typename stce_9873, typename stce_9781 = stce_9771>
  DCO_ALWAYS_INLINE typename enable_if<
      (dco::mode<stce_9873>::order > 0 && dco::internal::is_gbcp_type<stce_9781>::value &&
       dco::is_same<typename stce_9781::mode_t::active_t, typename dco::mode<stce_9873>::active_t>::value),
      active_type>::type&
  operator+=(const stce_9873& stce_9803) {
    *this = *this + stce_9803;
    return *this;
  }
  template <class stce_10166>
  DCO_ALWAYS_INLINE active_type& operator+=(const active_type<stce_9770, stce_10166>& stce_9803) {
    *this = *this + stce_9803;
    return *this;
  }
  template <class stce_10121, class stce_10122, class stce_10123>
  DCO_ALWAYS_INLINE active_type&
  operator+=(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
    *this = *this + stce_9803;
    return *this;
  }
  template <class stce_10121, class stce_10122, class stce_10123>
  DCO_ALWAYS_INLINE active_type&
  operator+=(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
    *this = *this + stce_9803;
    return *this;
  }
  template <class stce_10121, class stce_10122, class stce_10123>
  DCO_ALWAYS_INLINE active_type&
  operator+=(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
    *this = *this + stce_9803;
    return *this;
  }
  template <class stce_10129, class stce_10123>
  DCO_ALWAYS_INLINE active_type&
  operator+=(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_9803) {
    *this = *this + stce_9803;
    return *this;
  }
  DCO_ALWAYS_INLINE active_type& operator+=(const VALUE_TYPE& stce_9803) {
    this->_value() += stce_9803;
    return *this;
  }
  template <typename stce_9873, typename stce_9781 = stce_9771>
  DCO_ALWAYS_INLINE typename enable_if<
      (dco::mode<stce_9873>::order > 0 && dco::internal::is_gbcp_type<stce_9781>::value &&
       dco::is_same<typename stce_9781::mode_t::active_t, typename dco::mode<stce_9873>::active_t>::value),
      active_type>::type&
  operator-=(const stce_9873& stce_9803) {
    *this = *this - stce_9803;
    return *this;
  }
  template <class stce_10166>
  DCO_ALWAYS_INLINE active_type& operator-=(const active_type<stce_9770, stce_10166>& stce_9803) {
    *this = *this - stce_9803;
    return *this;
  }
  template <class stce_10121, class stce_10122, class stce_10123>
  DCO_ALWAYS_INLINE active_type&
  operator-=(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
    *this = *this - stce_9803;
    return *this;
  }
  template <class stce_10121, class stce_10122, class stce_10123>
  DCO_ALWAYS_INLINE active_type&
  operator-=(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
    *this = *this - stce_9803;
    return *this;
  }
  template <class stce_10121, class stce_10122, class stce_10123>
  DCO_ALWAYS_INLINE active_type&
  operator-=(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
    *this = *this - stce_9803;
    return *this;
  }
  template <class stce_10129, class stce_10123>
  DCO_ALWAYS_INLINE active_type&
  operator-=(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_9803) {
    *this = *this - stce_9803;
    return *this;
  }
  DCO_ALWAYS_INLINE active_type& operator-=(const VALUE_TYPE& stce_9803) {
    this->_value() -= stce_9803;
    return *this;
  }
  template <typename stce_9873, typename stce_9781 = stce_9771>
  DCO_ALWAYS_INLINE typename enable_if<
      (dco::mode<stce_9873>::order > 0 && dco::internal::is_gbcp_type<stce_9781>::value &&
       dco::is_same<typename stce_9781::mode_t::active_t, typename dco::mode<stce_9873>::active_t>::value),
      active_type>::type&
  operator*=(const stce_9873& stce_9803) {
    *this = *this * stce_9803;
    return *this;
  }
  template <class stce_10166>
  DCO_ALWAYS_INLINE active_type& operator*=(const active_type<stce_9770, stce_10166>& stce_9803) {
    *this = *this * stce_9803;
    return *this;
  }
  template <class stce_10121, class stce_10122, class stce_10123>
  DCO_ALWAYS_INLINE active_type&
  operator*=(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
    *this = *this * stce_9803;
    return *this;
  }
  template <class stce_10121, class stce_10122, class stce_10123>
  DCO_ALWAYS_INLINE active_type&
  operator*=(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
    *this = *this * stce_9803;
    return *this;
  }
  template <class stce_10121, class stce_10122, class stce_10123>
  DCO_ALWAYS_INLINE active_type&
  operator*=(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
    *this = *this * stce_9803;
    return *this;
  }
  template <class stce_10129, class stce_10123>
  DCO_ALWAYS_INLINE active_type&
  operator*=(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_9803) {
    *this = *this * stce_9803;
    return *this;
  }
  DCO_STRONG_INLINE active_type& operator*=(const VALUE_TYPE& stce_9803) {
    *this = *this * stce_9803;
    return *this;
  }
  template <typename stce_9873, typename stce_9781 = stce_9771>
  DCO_ALWAYS_INLINE typename enable_if<
      (dco::mode<stce_9873>::order > 0 && dco::internal::is_gbcp_type<stce_9781>::value &&
       dco::is_same<typename stce_9781::mode_t::active_t, typename dco::mode<stce_9873>::active_t>::value),
      active_type>::type&
  operator/=(const stce_9873& stce_9803) {
    *this = *this / stce_9803;
    return *this;
  }
  template <class stce_10166>
  DCO_ALWAYS_INLINE active_type& operator/=(const active_type<stce_9770, stce_10166>& stce_9803) {
    *this = *this / stce_9803;
    return *this;
  }
  template <class stce_10121, class stce_10122, class stce_10123>
  DCO_ALWAYS_INLINE active_type&
  operator/=(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
    *this = *this / stce_9803;
    return *this;
  }
  template <class stce_10121, class stce_10122, class stce_10123>
  DCO_ALWAYS_INLINE active_type&
  operator/=(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
    *this = *this / stce_9803;
    return *this;
  }
  template <class stce_10121, class stce_10122, class stce_10123>
  DCO_ALWAYS_INLINE active_type&
  operator/=(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
    *this = *this / stce_9803;
    return *this;
  }
  template <class stce_10129, class stce_10123>
  DCO_ALWAYS_INLINE active_type&
  operator/=(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_9803) {
    *this = *this / stce_9803;
    return *this;
  }
  DCO_STRONG_INLINE active_type& operator/=(const VALUE_TYPE& stce_9803) {
    *this = *this / stce_9803;
    return *this;
  }
  DCO_STRONG_INLINE active_type& operator++() {
    ++this->stce_9906;
    return *this;
  }
  DCO_STRONG_INLINE active_type& operator--() {
    --this->stce_9906;
    return *this;
  }
  DCO_STRONG_INLINE active_type operator++(int) {
    active_type stce_9843(*this);
    ++this->stce_9906;
    return stce_9843;
  }
  DCO_STRONG_INLINE active_type operator--(int) {
    active_type stce_9843(*this);
    --this->stce_9906;
    return stce_9843;
  }
};
template <class stce_9770, class stce_9771> struct passive_value_type_of<active_type<stce_9770, stce_9771>> {
  typedef typename passive_value_type_of<stce_9770>::TYPE TYPE;
};
} // namespace internal
} // namespace dco

namespace dco {
namespace internal {
template <class stce_9971, memory_model::TYPE stce_10167>
class stce_9973<memory_model::BLOB_TAPE_SPLINT, stce_9971, stce_10167> : public stce_9921<stce_9971>, object_logger {
  typedef stce_9921<stce_9971> stce_9931;

public:
  typedef typename stce_9789<stce_9971>::type stce_10168;
  struct entry {
    stce_10168* stce_10169;
    index_t* stce_10170;
    DCO_ALWAYS_INLINE entry(stce_10168* stce_10171, index_t* stce_10172)
        : stce_10169(stce_10171), stce_10170(stce_10172){};
    DCO_ALWAYS_INLINE index_t arg() {
      return (*stce_10170 < 0) ? std::abs(stce_9752(*stce_10170)) - 1 : stce_9752(*stce_10170);
    }
    DCO_ALWAYS_INLINE stce_10168& pval() { return *stce_10169; }
    DCO_ALWAYS_INLINE stce_10168 pval() const { return *stce_10169; }
    DCO_ALWAYS_INLINE bool stce_10000() { return *stce_10170 < 0; }
    DCO_ALWAYS_INLINE static bool stce_10000(index_t* stce_10173) { return *stce_10173 < 0; }
    DCO_ALWAYS_INLINE static index_t stce_10174(index_t stce_10175) { return -stce_10175 - 1; }
    static size_t size_of() { return sizeof(stce_10168) + sizeof(index_t); }
  };
  class iterator {
  public:
    index_t stce_10176;
    entry stce_10177;
    template <class stce_10178> void assign_to_interop(stce_10178& stce_9996) const {
      assert(sizeof(iterator) <= sizeof(stce_10178));
      std::memcpy(&stce_9996, this, sizeof(iterator));
    }
    template <class stce_10178> void assign_from_interop(const stce_10178& stce_9996) {
      assert(sizeof(iterator) <= sizeof(stce_10178));
      std::memcpy(static_cast<void*>(this), &stce_9996, sizeof(iterator));
    }
    DCO_ALWAYS_INLINE const entry* operator->() const { return &stce_10177; }
    DCO_ALWAYS_INLINE entry* operator->() { return &stce_10177; }
    DCO_ALWAYS_INLINE void stce_10179() {
      stce_10177.stce_10169++;
      stce_10177.stce_10170--;
      if (stce_9754 && static_cast<void*>(stce_10177.stce_10169) >= static_cast<void*>(stce_10177.stce_10170)) {
        throw dco::exception::create<std::runtime_error>(
            "Blob tape (splint) container overflow. Allocate bigger blob or use chunk tape container instead.");
      }
    }
    DCO_ALWAYS_INLINE index_t stce_10180() { return ++stce_10176; }
    DCO_ALWAYS_INLINE explicit iterator() : stce_10176(-1), stce_10177(NULL, NULL) {}
    DCO_ALWAYS_INLINE explicit iterator(stce_10168* stce_10171, index_t* stce_10172, index_t index = index_t(-1))
        : stce_10176(index), stce_10177(stce_10171, stce_10172) {}
    DCO_ALWAYS_INLINE index_t index() const { return stce_10176; }
    DCO_ALWAYS_INLINE index_t& index() { return stce_10176; }
    bool stce_10000() const { return entry::stce_10000(stce_10177.stce_10170); }
    DCO_ALWAYS_INLINE void operator--() {
      if (entry::stce_10000(stce_10177.stce_10170))
        stce_10176--;
      stce_10177.stce_10169--;
      stce_10177.stce_10170++;
    }
    DCO_ALWAYS_INLINE iterator operator--(int) {
      iterator stce_10020(*this);
      operator--();
      return stce_10020;
    }
    DCO_ALWAYS_INLINE bool operator==(const iterator& stce_9930) const {
      return stce_10177.stce_10169 == stce_9930.stce_10177.stce_10169;
    }
    DCO_ALWAYS_INLINE bool operator!=(const iterator& stce_9930) const { return !operator==(stce_9930); }
    DCO_ALWAYS_INLINE bool operator<(const iterator& stce_9930) const {
      return stce_10177.stce_10169 < stce_9930.stce_10177.stce_10169;
    }
    DCO_ALWAYS_INLINE bool operator>=(const iterator& stce_9930) const { return !operator<(stce_9930); }
    DCO_ALWAYS_INLINE bool operator>(const iterator& stce_9930) const {
      return stce_10177.stce_10169 > stce_9930.stce_10177.stce_10169;
    }
    DCO_ALWAYS_INLINE bool operator<=(const iterator& stce_9930) const { return !operator>(stce_9930); }
  };
  class edge_inserter {
    iterator& stce_10181;
    index_t stce_10176;

  public:
    edge_inserter(iterator& current) : stce_10181(current), stce_10176(0) {}
    iterator& current() { return stce_10181; }
    edge_inserter& operator=(edge_inserter stce_9930) {
      swap(stce_9930);
      return *this;
    }
    index_t index() const { return stce_10176; }
    void swap(edge_inserter& stce_9930) {
      std::swap(stce_10181, stce_9930.stce_10181);
      std::swap(stce_10176, stce_9930.stce_10176);
    }
    DCO_ALWAYS_INLINE_IF_AGRESSIVE void insert(const index_t& stce_10175, const stce_10168& pval) {
      if (IS_DEBUG && stce_10181.index() < stce_10175) {
        throw dco::exception::create<std::runtime_error>(
            "DCO_DEBUG: tape index of read variable bigger than current progvarcounter.");
      }
      if (stce_10176 == 0) {
        stce_10181.stce_10179();
        new (stce_10181.stce_10177.stce_10169) stce_10168(pval);
        new (stce_10181.stce_10177.stce_10170) index_t(entry::stce_10174(stce_10175));
        stce_10176 = stce_10181.stce_10180();
        DCO_LOG(logDEBUG2) << "inserting first entry, index now = " << stce_10176 << "; pval = " << pval
                           << ", target = " << stce_10175;
        return;
      }
      if (stce_9757 && stce_10175 == *(stce_10181.stce_10177.stce_10170)) {
        *(stce_10181.stce_10177.stce_10169) += pval;
        return;
      }
      stce_10181.stce_10179();
      new (stce_10181.stce_10177.stce_10169) stce_10168(pval);
      new (stce_10181.stce_10177.stce_10170) index_t(stce_10175);
    }

  private:
    edge_inserter(const edge_inserter& stce_9930);
  };

protected:
  void init(tape_options const& stce_9938, index_t stce_10182 = 0) {
    size_t stce_10183;
    if (stce_9938.write_to_file())
      stce_10183 = stce_9938.blob_size_in_byte();
    else
      stce_10183 = get_allocation_size(stce_9938.blob_size_in_byte());
    size_t stce_10184 = stce_10183 / entry::size_of();
    DCO_LOG(logDEBUG1) << "BLOB SPLINT container: user requested allocation size = " << stce_10183
                       << "; size of element = " << entry::size_of() << "; max elements in memory = " << stce_10184;
    if (static_cast<double>(stce_10184) / static_cast<double>(std::numeric_limits<DCO_INTEGRAL_TAPE_INT>::max()) >
        1.0) {
      stce_10184 = std::numeric_limits<index_t>::max();
      DCO_LOG(logDEBUG1)
          << "BLOB SPLINT container: too many elements requested for currently used index_t. Setting to: "
          << stce_10184 * 1.e-6 << "M elements";
    }
    index_t stce_10185 = static_cast<index_t>(stce_10184);
    size_t stce_10186 = stce_10185 * entry::size_of();
    DCO_LOG(logDEBUG) << "BLOB SPLINT container: trying allocation for = " << stce_10186 / 1024 << "K ~=~ "
                      << stce_9752(stce_10185) * 1.e-6 << "M elements";
    stce_9922 = stce_1000001(&stce_10186, stce_9938.alloc_use_huge_pages());
    if (!stce_9922) {
      std::string stce_10187 = "";
      if (stce_9938.alloc_use_huge_pages()) {
        stce_10187 =
            " You are using huge pages; have you prepared your system correspondingly (see documentation as well)?";
      }
      throw dco::exception::create<std::runtime_error>("Could not allocate memory. Use environment variables "
                                                       "(DCO_MEM_RATIO, DCO_MAX_ALLOCATION) and see documentation." +
                                                       stce_10187);
    }
    stce_10185 = static_cast<index_t>(stce_10186 / entry::size_of());
    DCO_LOG(logINFO) << "BLOB SPLINT container: actually allocated size = " << stce_10186 / 1024 << "K ~=~ "
                     << stce_9752(stce_10185) * 1.e-6 << "M elements";
    stce_10188 = static_cast<stce_10168*>(stce_9922);
    stce_10189 = static_cast<index_t*>(stce_9922) + stce_10186 / sizeof(index_t) - 1;
    stce_10181 = iterator(stce_10188, stce_10189, stce_10182);
    stce_10190 = iterator(stce_10188, stce_10189, stce_10182);
    stce_10191 = iterator(stce_10188 + stce_9752(stce_10185) - 1, stce_10189 - stce_9752(stce_10185) + 1,
                          std::numeric_limits<index_t>::max());
    new (stce_10181.stce_10177.stce_10169) stce_10168(static_cast<stce_10168>(0.0));
    new (stce_10181.stce_10177.stce_10170) index_t(entry::stce_10174(0));
  }

public:
  DCO_ALWAYS_INLINE explicit stce_9973(tape_options const& stce_9938, stce_9971& tape)
      : stce_9931(tape), object_logger("BLOB SPLINT container"), stce_9922(0), stce_10188(0), stce_10189(0),
        stce_10181(), stce_10190(), stce_10191() {
    assert(stce_10167 != memory_model::stce_9769);
    init(stce_9938);
  }
  DCO_ALWAYS_INLINE explicit stce_9973(iterator& stce_9821, stce_9971& tape)
      : stce_9931(tape), object_logger("BLOB SPLINT container"), stce_9922(0), stce_10188(0), stce_10189(0),
        stce_10181(stce_9821), stce_10190(), stce_10191() {
    assert(stce_10167 == memory_model::stce_9769);
  }
  DCO_ALWAYS_INLINE ~stce_9973() { dco::dealloc(stce_9922); }
  DCO_ALWAYS_INLINE iterator& insert_ref() { return stce_10181; }
  iterator start() { return stce_10190; }
  iterator start() const { return stce_10190; }
  iterator rend() { return start(); }
  iterator current() const { return stce_10181; }
  iterator current() { return stce_10181; }
  iterator& stce_9995() { return stce_10181; }
  iterator rbegin() const { return current(); }
  iterator capacity() const { return stce_10191; }
  bool empty() const { return stce_10181 == start(); }
  index_t size(const iterator& stce_9868, const iterator& stce_9869) const {
    if (stce_9868 < stce_9869)
      throw dco::exception::create<std::runtime_error>("size from < to");
    return static_cast<index_t>(stce_9868->stce_10169 - stce_9869->stce_10169);
  }
  index_t size(iterator stce_9868) const { return size(stce_9868, start()); }
  index_t size() const { return size(current(), start()); }
  index_t stce_10192() const { return size(stce_10191, start()); }
  size_t size_in_byte() const { return size(current(), start()) * entry::size_of(); }
  size_t stce_10193() const { return size(stce_10191, start()) * entry::size_of(); }
  void erase(const iterator& stce_10173) {
    if (!stce_10188)
      return;
    if (stce_10173 > stce_10191)
      throw dco::exception::create<std::runtime_error>("pos behind stack!");
    if (stce_10173 > stce_10181)
      throw dco::exception::create<std::runtime_error>("reset to position out of tape!");
    stce_10181 = stce_10173;
  }
  void stce_10194(const iterator&) {}
  void stce_10195() {}
  index_t stce_10196() const { return stce_10181.index() + 1; }

private:
  stce_9973(const stce_9973& stce_9930);
  void* stce_9922;
  stce_10168* stce_10188;
  index_t* stce_10189;

protected:
  typename stce_9825<iterator, stce_10167 == memory_model::stce_9769>::type stce_10181;
  iterator stce_10190;
  iterator stce_10191;
};
} // namespace internal
} // namespace dco

namespace dco {
namespace internal {
template <typename stce_9971, memory_model::TYPE stce_10167>
class stce_9973<memory_model::BLOB_TAPE, stce_9971, stce_10167> : public stce_9921<stce_9971>, public object_logger {
  typedef stce_9921<stce_9971> stce_9931;
  typedef stce_9971 tape_t;

public:
  typedef typename stce_9789<stce_9971>::type stce_10168;
  enum stce_10197 { stce_10198, stce_10199 };
  struct entry {
    index_t stce_10130;
    stce_10168 stce_10110;

  public:
    static size_t size_of() { return sizeof(entry); }
    entry(index_t arg = 0, stce_10168 const& pval = 0.) : stce_10130(arg), stce_10110(pval) {}
    DCO_STRONG_INLINE index_t arg() const {
      return (stce_10130 < 0) ? std::abs(stce_9752(stce_10130)) - 1 : stce_9752(stce_10130);
    }
    DCO_STRONG_INLINE static index_t stce_10174(const index_t& arg) { return -arg - 1; }
    DCO_STRONG_INLINE bool stce_10000() const { return stce_10130 < 0; }
    DCO_STRONG_INLINE void stce_10200(const stce_10168& stce_9917) { stce_10110 += stce_9917; }
    DCO_STRONG_INLINE stce_10168 pval() const { return stce_10110; }
  };
  class iterator {
    entry* stce_10201;
    index_t stce_10176;
    entry const* stce_10202;

  public:
    template <class stce_10178> void assign_to_interop(stce_10178& stce_9996) const {
      assert(sizeof(iterator) <= sizeof(stce_10178));
      std::memcpy(&stce_9996, this, sizeof(iterator));
    }
    template <class stce_10178> void assign_from_interop(const stce_10178& stce_9996) {
      assert(sizeof(iterator) <= sizeof(stce_10178));
      std::memcpy(static_cast<void*>(this), &stce_9996, sizeof(iterator));
    }
    void stce_10203(index_t stce_9806) { stce_10176 = stce_9806; }
    void stce_10179() {
      stce_10201++;
      if (stce_10201 > stce_10202) {
        throw dco::exception::create<std::runtime_error>(
            "Blob tape container overflow. Allocate bigger blob or use chunk tape container instead.");
      }
    }
    index_t index() const { return stce_10176; }
    index_t& index() { return stce_10176; }
    index_t stce_10180() { return ++stce_10176; }
    void stce_10204(entry const* end) { stce_10202 = end; }
    explicit iterator(entry* stce_10173 = 0, index_t index = index_t(-1)) : stce_10201(stce_10173), stce_10176(index) {}
    void operator--() {
      if (stce_10201->stce_10000())
        stce_10176--;
      stce_10201--;
    }
    bool stce_10000() const { return stce_10201->stce_10000(); }
    iterator operator--(int) {
      iterator stce_10020(*this);
      operator--();
      return stce_10020;
    }
    entry* operator*() { return stce_10201; }
    entry* operator->() { return stce_10201; }
    entry* operator*() const { return stce_10201; }
    entry* operator->() const { return stce_10201; }
    bool operator==(const iterator& stce_9930) const { return stce_10201 == stce_9930.stce_10201; }
    bool operator!=(const iterator& stce_9930) const { return !operator==(stce_9930); }
    bool operator<(const iterator& stce_9930) const { return stce_10201 < stce_9930.stce_10201; }
    bool operator>=(const iterator& stce_9930) const { return !operator<(stce_9930); }
    bool operator>(const iterator& stce_9930) const { return stce_10201 > stce_9930.stce_10201; }
    bool operator<=(const iterator& stce_9930) const { return !operator>(stce_9930); }
    friend std::ostream& operator<<(std::ostream& stce_10205, const iterator& stce_9996) {
      stce_10205 << "(" << stce_9996.stce_10201 << ":" << stce_9996.stce_10176 << ")";
      return stce_10205;
    }
  };
  class edge_inserter {
    iterator& stce_10181;
    index_t stce_10176;

  public:
    edge_inserter(iterator& current) : stce_10181(current), stce_10176(0) {}
    iterator& current() { return stce_10181; }
    edge_inserter& operator=(edge_inserter stce_9930) {
      swap(stce_9930);
      return *this;
    }
    index_t index() const { return stce_10176; }
    void swap(edge_inserter& stce_9930) {
      std::swap(stce_10181, stce_9930.stce_10181);
      std::swap(stce_10176, stce_9930.stce_10176);
    }
    DCO_ALWAYS_INLINE_IF_AGRESSIVE void insert(const index_t& stce_10175, const stce_10168& pval) {
      if (IS_DEBUG && stce_10181.index() < stce_10175) {
        throw dco::exception::create<std::runtime_error>(
            "DCO_DEBUG: tape index of read variable bigger than current progvarcounter.");
      }
      if (stce_10176 == 0) {
        stce_10181.stce_10179();
        new (*stce_10181) entry(entry::stce_10174(stce_10175), pval);
        stce_10176 = stce_10181.stce_10180();
        return;
      }
      if (stce_9757 && stce_10175 == stce_10181->arg()) {
        stce_10181->stce_10200(pval);
        return;
      }
      stce_10181.stce_10179();
      new (*stce_10181) entry(stce_10175, pval);
    }

  private:
    edge_inserter(const edge_inserter& stce_9930);
  };
  explicit stce_9973(stce_9973& stce_9868, stce_10197 stce_10206)
      : stce_9931(stce_9868), object_logger("BLOB container"), stce_9922(0), stce_10181(), stce_10190(), stce_10191(),
        stce_10207(stce_10206), stce_9937(stce_9868.stce_9937) {
    if (stce_10206 == stce_10198) {
      stce_9922 = stce_9868.stce_9922;
      stce_10181 = iterator(stce_9922, stce_9868.current().index());
      stce_10190 = stce_10181;
      stce_10191 = stce_9868.stce_10191;
      stce_10181.stce_10204(*stce_10191);
    } else if (stce_10206 == stce_10199) {
      index_t stce_10184 = allocate(stce_9937);
      stce_10181 = iterator(stce_9922, (stce_9868.current().index()));
      stce_10190 = iterator(stce_9922, (stce_9868.current().index()));
      stce_10191 = iterator(stce_9922 + static_cast<DCO_INTEGRAL_TAPE_INT>(stce_10184) - 1,
                            std::numeric_limits<DCO_INTEGRAL_TAPE_INT>::max());
      stce_10181.stce_10204(*stce_10191);
      if (*stce_10191 - *stce_10190 < 1) {
        std::stringstream stce_10208;
        stce_10208 << 2 * sizeof(entry);
        dco::dealloc(stce_9922);
        throw dco::exception::create<std::runtime_error>(
            "Blob/chunk size too small. Use bigger blob/chunk size [at least " + stce_10208.str() + " bytes].");
      }
      new (*stce_10181) entry(entry::stce_10174(0));
    }
  }
  index_t allocate(const tape_options& stce_9938) {
    size_t stce_10186 = get_allocation_size(stce_9938.blob_size_in_byte());
    stce_9922 = static_cast<entry*>(stce_1000001(&stce_10186, stce_9938.alloc_use_huge_pages()));
    if (!stce_9922) {
      throw dco::exception::stce_9814<std::bad_alloc>("Could not allocate memory. Use environment variables "
                                                      "(DCO_MEM_RATIO, DCO_MAX_ALLOCATION) and see documentation.");
    }
    size_t stce_10209 = stce_10186 / entry::size_of();
    if (static_cast<double>(stce_10209) / static_cast<double>(std::numeric_limits<DCO_INTEGRAL_TAPE_INT>::max()) >
        1.0) {
      stce_10209 = std::numeric_limits<index_t>::max();
    }
    index_t stce_10184 = static_cast<index_t>(stce_10209);
    DCO_LOG(logINFO) << "BLOB container; size = " << stce_9938.blob_size_in_byte() << "b ~=~ "
                     << stce_9938.blob_size_in_byte() / entry::size_of() << "elements";
    DCO_LOG(logINFO) << "BLOB container; tried allocation size = " << stce_10186 << "b ~=~ "
                     << stce_10186 / entry::size_of() << "elements";
    DCO_LOG(logDEBUG) << "sizeof(entry) = " << sizeof(entry) << " == " << entry::size_of();
    return stce_10184;
  }
  void init(tape_options const& stce_9938) {
    index_t stce_10184 = allocate(stce_9938);
    stce_10181 = iterator(stce_9922, 0);
    stce_10190 = iterator(stce_9922, 0);
    stce_10191 = iterator(stce_9922 + static_cast<DCO_INTEGRAL_TAPE_INT>(stce_10184) - 1,
                          std::numeric_limits<DCO_INTEGRAL_TAPE_INT>::max());
    stce_10181.stce_10204(*stce_10191);
    if (*stce_10191 - *stce_10190 < 1) {
      std::stringstream stce_10208;
      stce_10208 << 2 * sizeof(entry);
      dco::dealloc(stce_9922);
      throw dco::exception::create<std::runtime_error>(
          "Blob/chunk size too small. Use bigger blob/chunk size [at least " + stce_10208.str() + " bytes].");
    }
    new (*stce_10181) entry(entry::stce_10174(0));
  }
  DCO_ALWAYS_INLINE explicit stce_9973(tape_options const& stce_9938, tape_t& tape)
      : stce_9931(tape), object_logger("BLOB container"), stce_9922(0), stce_10181(), stce_10190(), stce_10191(),
        stce_10207(stce_10199), stce_9937(stce_9938) {
    assert(stce_10167 != memory_model::stce_9769);
    init(stce_9938);
  }
  DCO_ALWAYS_INLINE explicit stce_9973(iterator& stce_9821, tape_t& tape)
      : stce_9931(tape), object_logger("BLOB container"), stce_9922(0), stce_10181(stce_9821), stce_10190(),
        stce_10191(), stce_10207(stce_10199), stce_9937(tape.stce_9938()) {
    assert(stce_10167 == memory_model::stce_9769);
  }
  DCO_ALWAYS_INLINE ~stce_9973() {
    if (stce_10207 == stce_10199)
      dco::dealloc(stce_9922);
  }
  DCO_ALWAYS_INLINE iterator& insert_ref() { return stce_10181; }
  entry*& stce_10210() { return stce_9922; }
  iterator current() const { return stce_10181; }
  iterator current() { return stce_10181; }
  iterator& stce_9995() { return stce_10181; }
  iterator start() { return stce_10190; }
  iterator start() const { return stce_10190; }
  iterator rend() { return start(); }
  iterator rbegin() const { return current(); }
  iterator capacity() const { return stce_10191; }
  bool empty() const { return stce_10181 == start(); }
  index_t size(const iterator& stce_9868, const iterator& stce_9869) const {
    if (stce_9868 < stce_9869)
      throw dco::exception::create<std::runtime_error>("size from < to");
    return static_cast<index_t>(*stce_9868 - *stce_9869);
  }
  tape_options stce_9938() const { return stce_9937; }
  index_t size(iterator stce_9868) const { return size(stce_9868, start()); }
  index_t size() const { return size(current(), start()); }
  index_t stce_10192() const { return size(stce_10191, start()); }
  size_t size_in_byte() const { return size(current(), start()) * sizeof(entry); }
  size_t stce_10193() const { return size(stce_10191, start()) * sizeof(entry); }
  void erase(const iterator& stce_10173) {
    if (!stce_9922)
      return;
    if (IS_DEBUG && stce_10173 > stce_10191)
      throw dco::exception::create<std::runtime_error>("pos behind stack!");
    if (stce_10173 > stce_10181)
      throw dco::exception::create<std::runtime_error>("reset to position out of tape!");
    stce_10181 = stce_10173;
    stce_10181.stce_10204(*stce_10191);
  }
  void erase() {
    if (!stce_9922)
      return;
    stce_10181 = stce_10190;
    stce_10181.stce_10204(*stce_10191);
  }
  void stce_10194(const iterator&) {}
  void stce_10195() {}
  index_t stce_10196() { return stce_10181.index() + 1; }

private:
  stce_9973(const stce_9973& stce_9930);
  entry* stce_9922;
  typename stce_9825<iterator, stce_10167 == memory_model::stce_9769>::type stce_10181;
  iterator stce_10190;
  iterator stce_10191;
  stce_10197 stce_10207;
  tape_options stce_9937;
};
} // namespace internal
} // namespace dco
namespace dco {
namespace internal {
template <typename stce_9971, memory_model::TYPE stce_10167>
class stce_9973<memory_model::CHUNK_TAPE, stce_9971, stce_10167> : public stce_9921<stce_9971>, object_logger {
  typedef stce_9921<stce_9971> stce_9931;

public:
  typedef typename stce_9789<stce_9971>::type stce_10168;

protected:
  typedef stce_9973<memory_model::BLOB_TAPE, stce_9971> stce_10211;
  static void stce_10212(const std::string& stce_10213, char* data, long size) {
    DCO_LOG(logDEBUG1) << "save_data_to_file: bytes to write = " << size << ", fname = " << stce_10213;
    std::ofstream out(stce_10213.c_str(), std::ios_base::out | std::ios_base::trunc | std::ios_base::binary);
    if (!out.is_open())
      throw dco::exception::create<std::runtime_error>("could not open file, perhaps index corruption?");
    if (!out.good())
      throw dco::exception::create<std::runtime_error>("file could be opened, but got corrupted afterwards.");
    out.write(data, size);
    if (!out.good())
      throw dco::exception::create<std::runtime_error>("reading the chunk failed, container corrupted.");
    out.close();
  }
  static DCO_INTEGRAL_TAPE_INT stce_10214(const std::string& stce_10213, char* data) {
    struct stat stce_10215;
    if (stat(stce_10213.c_str(), &stce_10215) == -1)
      throw dco::exception::create<std::runtime_error>("could not check file size, perhaps index corruption?");
    DCO_INTEGRAL_TAPE_INT size = static_cast<DCO_INTEGRAL_TAPE_INT>(stce_10215.st_size);
    std::ifstream in(stce_10213.c_str(), std::ios_base::in | std::ios_base::binary);
    if (!in.is_open())
      throw dco::exception::create<std::runtime_error>("could not open file, perhaps index corruption?");
    if (!in.good())
      throw dco::exception::create<std::runtime_error>("file could be opened, but got corrupted afterwards.");
    in.read(data, size);
    if (!in.good())
      throw dco::exception::create<std::runtime_error>("reading the chunk failed, container corrupted.");
    return size;
  }

public:
  class stce_10216 : public stce_10211 {
    index_t stce_10217;
    tape_options stce_9937;
    bool stce_10218;
    stce_10216 *stce_10219, *stce_10220;
    index_t stce_10221;

  public:
    typedef typename stce_10211::entry entry;
    typedef typename stce_10211::iterator iterator;
    index_t stce_10222() const { return stce_10217; }
    static std::string stce_10223(const stce_10216& stce_10224) {
      std::stringstream stce_10213;
      stce_10213 << stce_10224.stce_10225().filename() << '.' << stce_10224.stce_10222();
      return stce_10213.str();
    }
    DCO_ALWAYS_INLINE stce_10216(stce_10216& stce_9868, typename stce_10211::stce_10197 stce_10226)
        : stce_10211(stce_9868, stce_10226), stce_10217(stce_9868.stce_10222() + 1), stce_9937(stce_9868.stce_10225()),
          stce_10218(true), stce_10219(0), stce_10220(0), stce_10221(-1) {}
    DCO_ALWAYS_INLINE stce_10216(tape_options stce_9938, stce_9971& tape)
        : stce_10211(stce_9938, tape), stce_10217(0), stce_9937(stce_9938), stce_10218(true), stce_10219(0),
          stce_10220(0), stce_10221(-1) {}
    DCO_ALWAYS_INLINE ~stce_10216() {
      if (stce_10225().write_to_file())
        std::remove(stce_10223(*this).c_str());
    }
    index_t size(const iterator& stce_9868, const iterator& stce_9869) const {
      return stce_10211::size(stce_9868, stce_9869);
    }
    index_t size(iterator stce_9868) const {
      if (!*this->start())
        throw dco::exception::create<std::runtime_error>("given iterator does not point "
                                                         "into given tape!");
      return stce_10211::size(stce_9868, this->start());
    }
    index_t size() const { return stce_10211::size(this->current(), this->start()); }
    index_t stce_10192() const {
      if (!stce_10227())
        return 0;
      return stce_10211::stce_10192();
    }
    size_t size_in_byte() const {
      return stce_10211::size(this->current(), this->start()) * stce_10211::entry::size_of();
    }
    size_t stce_10193() const {
      if (!stce_10227()) {
        return 0;
      }
      return stce_10211::stce_10192() * stce_10211::entry::size_of();
    }
    tape_options stce_10225() const { return stce_9937; }
    bool stce_10227() const { return stce_10218; }
    void stce_10228(bool stce_10229) { stce_10218 = stce_10229; }
    void stce_10230() { stce_10221 = size(); }
    void stce_10231() { stce_10221 = -1; }
    bool stce_10232() { return stce_10221 != size(); }
    stce_10216*& stce_10233() { return stce_10219; }
    stce_10216*& stce_10234() { return stce_10220; }
  };
  typedef typename stce_10211::entry entry;
  typedef stce_10216* stce_10235;
  typedef typename stce_10211::iterator stce_10236;
  static void stce_10237(stce_10216& stce_10224) {
    if (stce_10224.stce_10225().write_to_file()) {
      assert(!stce_10224.stce_10227());
      DCO_LOG(logDEBUG1) << "wake_up: waking up chunk " << stce_10224.stce_10222() << " | " << stce_10224.stce_10210()
                         << " from sleep.";
      DCO_INTEGRAL_TAPE_INT size =
          stce_10214(stce_10216::stce_10223(stce_10224), reinterpret_cast<char*>(stce_10224.stce_10210()));
      (void)size;
      stce_10224.stce_10228(true);
    } else {
      DCO_LOG(logDEBUG1) << "wake_up: waking already awake chunk " << stce_10224.stce_10222() << " | "
                         << stce_10224.stce_10210();
    }
  }
  static void sleep(stce_10216& stce_10224) {
    DCO_LOG(logDEBUG1) << "sleep: chunk " << stce_10224.stce_10222() << " | " << stce_10224.stce_10210()
                       << " dirty = " << stce_10224.stce_10232();
    if (stce_10224.stce_10225().write_to_file() && stce_10224.stce_10232()) {
      assert(stce_10224.stce_10227());
      DCO_LOG(logDEBUG1) << "sleep: writing chunk " << stce_10224.stce_10222() << " | " << stce_10224.stce_10210();
      const long stce_10238 = stce_9752(stce_10224.size() + 1) * sizeof(entry);
      DCO_LOG(logDEBUG1) << "sleep: chunk.size() = " << stce_10224.size() << ", bytes to write = " << stce_10238
                         << ", ptr diff = " << stce_10224.current() << ", " << stce_10224.start() << " = "
                         << *stce_10224.current() - *stce_10224.start() << " " << sizeof(entry);
      entry* data = stce_10224.stce_10210();
      stce_10212(stce_10216::stce_10223(stce_10224), reinterpret_cast<char*>(data), stce_10238);
      stce_10224.stce_10230();
    } else {
      if (!stce_10224.stce_10232()) {
        DCO_LOG(logDEBUG1) << "sleep: not writing data for chunk: " << stce_10224.stce_10222();
      }
    }
  }
  static void stce_10239(stce_10216& stce_10224, stce_10216& stce_10240) {
    if (!stce_10224.stce_10227()) {
      sleep(stce_10240);
      stce_10240.stce_10228(false);
      stce_10237(stce_10224);
    }
  }
  void stce_10239(stce_10216& stce_10224) {
    if (!stce_10224.stce_10227()) {
      DCO_LOG(logDEBUG1) << "activate: chunk " << stce_10224.stce_10222() << " not awake yet";
      stce_10216* stce_10240 = stce_10181.stce_10241();
      while (stce_10240 && !stce_10240->stce_10227()) {
        stce_10240 = stce_10240->stce_10233();
      }
      if (stce_10240) {
        DCO_LOG(logDEBUG1) << "activate: currently awake " << stce_10240->stce_10222();
        stce_10239(stce_10224, *stce_10240);
      } else {
        stce_10237(stce_10224);
      }
    }
  }
  class iterator {
  private:
    stce_10235 stce_10242;
    stce_10236 stce_10243;

  public:
    template <class stce_10178> void assign_from_interop(const stce_10178& stce_9996) {
      assert(sizeof(iterator) <= sizeof(stce_10178));
      std::memcpy(static_cast<void*>(this), &stce_9996, sizeof(iterator));
    }
    template <class stce_10178> void assign_to_interop(stce_10178& stce_9996) const {
      assert(sizeof(iterator) <= sizeof(stce_10178));
      std::memcpy(&stce_9996, this, sizeof(iterator));
    }
    stce_10235 stce_10241() const { return stce_10242; }
    stce_10236 stce_10244() const { return stce_10243; }
    explicit iterator(const stce_10236& stce_9998, stce_10235 stce_10241)
        : stce_10242(stce_10241), stce_10243(stce_9998) {}
    explicit iterator(stce_10235 stce_10241) : stce_10242(stce_10241), stce_10243(stce_10241->current()) {}
    iterator& operator=(const iterator& stce_10075) {
      this->stce_10242 = stce_10075.stce_10242;
      this->stce_10243 = stce_10075.stce_10243;
      return *this;
    }
    iterator(const iterator& stce_9930) : stce_10242(stce_9930.stce_10242), stce_10243(stce_9930.stce_10243) {}
    iterator() : stce_10242(), stce_10243() {}
    bool stce_10000() const { return stce_10243.stce_10000(); }
    void operator--() {
      DCO_LOG(logDEBUG4) << stce_10243 << " =?= " << stce_10242->start();
      --stce_10243;
      if (stce_10243 == stce_10242->start()) {
        if (stce_10242->stce_10222() == 0)
          return;
        stce_10242 = stce_10242->stce_10233();
        stce_10239(*stce_10242, *(stce_10242->stce_10234()));
        stce_10243 = stce_10242->current();
      }
    }
    index_t index() const { return stce_10243.index(); }
    index_t& index() { return stce_10243.index(); }
    index_t stce_10180() {
      stce_10242->stce_9995().stce_10180();
      return stce_10243.stce_10180();
    }
    stce_10235& stce_10224() { return stce_10242; }
    stce_10236& stce_10245() { return stce_10243; }
    iterator operator--(int) {
      iterator stce_10020(*this);
      operator--();
      return stce_10020;
    }
    entry* operator*() { return *stce_10243; }
    entry* operator*() const { return *stce_10243; }
    entry* operator->() { return *stce_10243; }
    entry* operator->() const { return *stce_10243; }
    bool operator==(const iterator& stce_9930) const {
      return stce_10243 == stce_9930.stce_10243 && stce_10242 == stce_9930.stce_10242;
    }
    bool operator!=(const iterator& stce_9930) const { return !operator==(stce_9930); }
    bool operator<(const iterator& stce_9930) const {
      return (stce_10242 == stce_9930.stce_10242) ? stce_10243 < stce_9930.stce_10243
                                                  : stce_10243.index() < stce_9930.stce_10243.index();
    }
    bool operator>=(const iterator& stce_9930) const { return !operator<(stce_9930); }
    bool operator>(const iterator& stce_9930) const {
      return (stce_10242 == stce_9930.stce_10242) ? stce_10243 > stce_9930.stce_10243
                                                  : stce_10243.index() > stce_9930.stce_10243.index();
    }
    bool operator<=(const iterator& stce_9930) const { return !operator>(stce_9930); }
  };
  class edge_inserter {
    stce_10235& stce_10246;
    stce_10236& stce_10247;
    stce_10236 stce_10243;
    stce_10236 stce_10248;
    index_t stce_10176;

  public:
    DCO_ALWAYS_INLINE edge_inserter(iterator& stce_9821)
        : stce_10246(stce_9821.stce_10224()), stce_10247(stce_9821.stce_10245()), stce_10243(stce_10246->current()),
          stce_10248(stce_10246->capacity()), stce_10176(0) {}
    stce_10236& current() { return stce_10243; }
    DCO_ALWAYS_INLINE ~edge_inserter() {
      if (static_cast<DCO_INTEGRAL_TAPE_INT>(stce_10176)) {
        stce_10247 = stce_10246->stce_9995() = stce_10243;
      }
    }
    index_t index() const { return stce_10176; }
    index_t& index() { return stce_10176; }
    DCO_ALWAYS_INLINE_IF_AGRESSIVE void insert(const index_t& stce_10175, const stce_10168& pval) {
      if (IS_DEBUG && stce_10243.index() < stce_10175) {
        throw dco::exception::create<std::runtime_error>(
            "DCO_DEBUG: tape index of read variable bigger than current progvarcounter.");
      }
      if (*stce_10243 >= *stce_10248) {
        DCO_LOG(logDEBUG1) << "insert: chunk full, updating current and getting next";
        stce_10247 = stce_10246->stce_9995() = stce_10243;
        stce_10249(stce_10246);
        stce_10243 = stce_10246->current();
        stce_10248 = stce_10246->capacity();
      }
      if (stce_10176 == 0) {
        stce_10243.stce_10179();
        new (*stce_10243) entry(entry::stce_10174(stce_10175), pval);
        stce_10176 = stce_10243.stce_10180();
        DCO_LOG(logDEBUG2) << "inserting first entry, index now = " << stce_10176 << "; pval = " << pval
                           << ", target = " << stce_10175 << " in chunk " << stce_10246
                           << " into memory at = " << stce_10243;
        return;
      }
      if (stce_9757 && stce_10243->arg() == stce_10175) {
        DCO_LOG(logDEBUG3) << "merging a parallel edge";
        stce_10243->stce_10200(pval);
        return;
      }
      stce_10243.stce_10179();
      new (*stce_10243) entry(stce_10175, pval);
      DCO_LOG(logDEBUG2) << "inserting next entry, index now = " << stce_10176 << "; pval = " << pval
                         << ", target = " << stce_10175 << " in chunk " << stce_10246
                         << " into memory at = " << stce_10243;
    }

  private:
    edge_inserter(const edge_inserter& stce_9930);
  };

public:
  void init(tape_options const& stce_9938) {
    tape_options stce_10250 = stce_9938;
    stce_10250.blob_size_in_byte() = stce_9938.chunk_size_in_byte();
    stce_10251 = new stce_10216(stce_10250, stce_9931::stce_9923());
    stce_10181 = iterator(stce_10251);
  }
  explicit stce_9973(tape_options const& stce_9938, stce_9971& tape)
      : stce_9931(tape), object_logger("CHUNK container (w/ options)"), stce_10251(0), stce_10181() {
    assert(stce_10167 != memory_model::stce_9769);
    init(stce_9938);
  }
  explicit DCO_ALWAYS_INLINE stce_9973(iterator& stce_9821, stce_9971& tape)
      : stce_9931(tape), object_logger("CHUNK container (w/ options)"), stce_10251(0), stce_10181(stce_9821) {
    assert(stce_10167 == memory_model::stce_9769);
  }
  DCO_ALWAYS_INLINE ~stce_9973() {
    stce_10216* stce_9996 = stce_10251;
    while (stce_9996) {
      stce_10216* stce_10252 = stce_9996;
      stce_9996 = stce_9996->stce_10234();
      delete stce_10252;
    }
  }
  static void stce_10249(stce_10235& stce_9821) {
    DCO_LOG(logDEBUG1) << "current chunk: id = " << stce_9821->stce_10222()
                       << ", index = " << stce_9821->current().index()
                       << ", data pointer = " << stce_9821->stce_10210();
    delete stce_9821->stce_10234();
    if (stce_9821->stce_10225().write_to_file()) {
      sleep(*stce_9821);
      stce_9821->stce_10228(false);
      stce_9821->stce_10234() = new stce_10216(*stce_9821, stce_10216::stce_10198);
    } else {
      stce_9821->stce_10234() = new stce_10216(*stce_9821, stce_10216::stce_10199);
    }
    stce_9821->stce_10234()->stce_10233() = stce_9821;
    stce_9821 = stce_9821->stce_10234();
    DCO_LOG(logDEBUG1) << "next chunk: id = " << stce_9821->stce_10222() << ", index = " << stce_9821->current().index()
                       << ", data pointer = " << stce_9821->stce_10210();
  }
  DCO_ALWAYS_INLINE iterator& insert_ref() { return stce_10181; }
  iterator start() { return iterator(stce_10251->start(), stce_10251); }
  iterator start() const { return iterator(stce_10251->start(), stce_10251); }
  iterator rend() { return start(); }
  iterator current() const { return stce_10181; }
  iterator rbegin() const { return current(); }
  bool empty() const { return current() == start(); }
  index_t size(const iterator& stce_9868, const iterator& stce_9869) const {
    const stce_10216& stce_10253 = *(stce_9868.stce_10241());
    if (stce_9868.stce_10241() == stce_9869.stce_10241())
      return stce_10253.size(stce_9868.stce_10244(), stce_9869.stce_10244());
    index_t size = 0;
    stce_10235 stce_10254 = stce_9868.stce_10241();
    size += stce_10254->size(stce_9868.stce_10244());
    DCO_LOG(logDEBUG2) << "size of last chunk = " << size;
    for (stce_10254 = stce_10254->stce_10233(); stce_10254 != stce_9869.stce_10241();
         stce_10254 = stce_10254->stce_10233()) {
      if (stce_10254) {
        size += stce_10254->size();
        DCO_LOG(logDEBUG2) << "adding " << stce_10254->size() << " => size = " << size;
      }
    }
    const stce_10216& stce_10255 = *(stce_9869.stce_10241());
    size += stce_10255.size(stce_10255.current(), stce_9869.stce_10244());
    DCO_LOG(logDEBUG2) << "very first bit: adding " << stce_10255.size(stce_10255.current(), stce_9869.stce_10244())
                       << " => size = " << size;
    return size;
  }
  index_t size(iterator stce_9868) const { return size(stce_9868, start()); }
  index_t size() const { return size(current(), start()); }
  mem_long_t size_in_byte() const { return size(current(), start()) * entry::size_of(); }
  index_t stce_10192() const {
    index_t size = 0;
    for (stce_10235 stce_10256 = stce_10251; stce_10256 != NULL; stce_10256 = stce_10256->stce_10234())
      if (stce_10256)
        size += stce_10256->stce_10192();
    return size;
  }
  mem_long_t stce_10193() const {
    mem_long_t size = 0;
    for (stce_10235 stce_10256 = stce_10251; stce_10256 != NULL; stce_10256 = stce_10256->stce_10234())
      if (stce_10256)
        size += stce_10256->stce_10193();
    return size;
  }
  void erase(const iterator& stce_10173) {
    if (stce_10173 > current())
      throw dco::exception::create<std::invalid_argument>("erase pos out of tape!");
    stce_10235 stce_10257(stce_10251);
    while (stce_10257 != stce_10173.stce_10241())
      stce_10257 = stce_10257->stce_10234();
    stce_10181.stce_10224() = stce_10257;
    stce_10239(*stce_10181.stce_10224());
    stce_10181.stce_10224()->stce_10231();
    stce_10235 stce_9996 = stce_10257->stce_10234();
    stce_10257->stce_10234() = 0;
    while (stce_9996) {
      stce_10235 stce_10252 = stce_9996;
      stce_9996 = stce_9996->stce_10234();
      delete stce_10252;
    }
    stce_10181.stce_10224()->erase(stce_10173.stce_10244());
    stce_10181.stce_10245() = stce_10181.stce_10224()->current();
  }
  void stce_10194(const iterator& stce_9821) {
    DCO_LOG(logDEBUG1) << "chunk tape: prepare_interpretation; activate: " << stce_9821.stce_10241()->stce_10222()
                       << ", is awake = " << stce_9821.stce_10241()->stce_10227();
    stce_10239(*stce_9821.stce_10241());
  }
  void stce_10195() {
    DCO_LOG(logDEBUG1) << "chunk tape: prepare_recording";
    stce_10239(*stce_10181.stce_10224());
  }
  index_t stce_10196() { return current().index() + 1; }

private:
  stce_10216* stce_10251;
  typename stce_9825<iterator, stce_10167 == memory_model::stce_9769>::type stce_10181;
};
} // namespace internal
} // namespace dco

namespace dco {
namespace internal {
template <class stce_9971>
class stce_9973<memory_model::stce_9768, stce_9971> : public stce_9973<memory_model::CHUNK_TAPE, stce_9971> {
  typedef stce_9971 tape_t;

public:
  typedef typename stce_9789<stce_9971>::type stce_10168;
  typedef stce_9973<memory_model::CHUNK_TAPE, stce_9971> stce_10258;
  typedef typename stce_10258::entry entry;
  typedef typename stce_10258::edge_inserter edge_inserter;
  typedef typename stce_10258::iterator iterator;
  bool stce_10259, stce_10260, stce_10261, stce_10262;
  double stce_10263, stce_10264, stce_10265;
  std::vector<index_t> stce_10266;
  std::vector<stce_10168> stce_10267;
  std::vector<const void*> stce_10268;
  index_t stce_10269, stce_10270;
  struct stce_10271 {
    static std::string id() { return " gtas "; }
  };
  typedef logging<stce_10271> logger;
  explicit stce_9973(tape_options stce_9938, stce_9971& tape)
      : stce_10258(stce_9938, tape), stce_10259(false), stce_10260(false), stce_10261(false), stce_10262(false),
        stce_10263(1e-6), stce_10264(1e-6), stce_10265(0.0), stce_10269(0), stce_10270(-1) {}
  void stce_10272(log_level_enum level) {
    if (stce_10262 && level <= dco::logWARNING) {
      throw dco::exception::create<std::runtime_error>("Warning occured.");
    }
  }
  void stce_10273() {
    if (stce_10270 == stce_10269) {
      stce_10269++;
      throw dco::exception::create<std::runtime_error>("Event counter reached.");
    }
    stce_10269++;
  };
  void stce_10274(stce_10168 stce_10117, double stce_10275) {
    if (stce_10261) {
      double stce_10276 = ::fabs(stce_10117 - stce_10275);
      log_level_enum stce_10277 = dco::logWARNING;
      if (stce_10276 < stce_10263) {
        stce_10277 = dco::logINFO;
      }
      logger(stce_10277).get_stream() << stce_10269 << ": fd vs. tangent check";
      logger(stce_10277).get_stream() << " delta = " << stce_10276 << " tangent = " << stce_10117
                                      << " finite differences = " << stce_10275;
      stce_10272(stce_10277);
    }
  }
  void stce_10278(double stce_10279, double stce_10280, double stce_10281) {
    const double stce_10282 = ::fabs(stce_10279 - stce_10280);
    const double stce_10283 = ::fabs(stce_10279 - stce_10281);
    log_level_enum stce_10277 = dco::logWARNING;
    if (stce_10282 < stce_10264) {
      stce_10277 = dco::logINFO;
    }
    logger(stce_10277).get_stream() << stce_10269 << ": Tangent/adjoint identity check:";
    logger(stce_10277).get_stream() << " tangent vs. adjoint = " << stce_10282;
    logger(stce_10277).get_stream() << "  <x_(1),x^(1)> = " << stce_10279;
    logger(stce_10277).get_stream() << "  <y_(1),y^(1)> = " << stce_10280;
    stce_10272(stce_10277);
    stce_10277 = dco::logWARNING;
    if (stce_10283 < stce_10263) {
      stce_10277 = dco::logINFO;
    }
    logger(stce_10277).get_stream() << " finite differences vs. adjoint = " << stce_10283;
    logger(stce_10277).get_stream() << "  <y_(1),y_{FD}^(1)> = " << stce_10281;
    stce_10272(stce_10277);
  }
  void stce_10284(const iterator& stce_9869) {
    assert(stce_10258::start() == stce_9869);
    stce_10258::stce_10284(stce_9869);
    stce_10266.clear();
    stce_10267.clear();
    stce_10268.clear();
    stce_10265 = 0;
  }
  void stce_10106(std::string stce_10285, const bool stce_9843, const bool stce_10103, const bool stce_10105) {
    if (!stce_10259) {
      stce_10273();
      return;
    }
    log_level_enum stce_10277 = dco::logWARNING;
    if (stce_9843 == stce_10103 && stce_9843 == stce_10105) {
      stce_10277 = dco::logINFO;
    }
    logger(stce_10277).get_stream() << stce_10269 << ": Branch check:" << stce_10285 << std::boolalpha
                                    << " at current value returns " << stce_9843 << ", at minus h " << stce_10103
                                    << ", and at plus h " << stce_10105;
    stce_10272(stce_10277);
    stce_10273();
  }
  template <class data_t> void stce_10286(const data_t* data, const double& stce_10117) {
    if (stce_10265 == 0) {
      stce_10268.push_back(data);
      stce_10266.push_back(data->_tape_index());
      stce_10267.push_back(stce_10117);
    }
  }
  template <typename stce_10287> void stce_10288() {
    double stce_10289 = 0;
    for (size_t stce_9841 = 0; stce_9841 < stce_10268.size(); ++stce_9841) {
      const stce_10287& stce_9821 = *static_cast<const stce_10287*>(stce_10268[stce_9841]);
      stce_10289 = std::max(stce_10289, std::fabs(stce_9821.stce_10290[0]));
    }
    const double stce_10291 = 1e-14;
    stce_10265 = std::sqrt(stce_10291) * stce_10289;
    for (size_t stce_9841 = 0; stce_9841 < stce_10268.size(); ++stce_9841) {
      const stce_10287& stce_9821 = *static_cast<const stce_10287*>(stce_10268[stce_9841]);
      stce_9821.stce_10290[0] -= stce_10265 * stce_9821.stce_10116;
      stce_9821.stce_10290[1] += stce_10265 * stce_9821.stce_10116;
    }
  }
};
} // namespace internal
} // namespace dco

namespace dco {
namespace internal {
template <class stce_9971, memory_model::TYPE stce_9972>
class stce_9973<memory_model::stce_9769, stce_9971, stce_9972>
    : public stce_9973<stce_9972, stce_9971, memory_model::stce_9769> {
public:
  typedef typename stce_9789<stce_9971>::type stce_10168;
  typedef stce_9973<stce_9972, stce_9971, memory_model::stce_9769> stce_10258;
  explicit stce_9973(tape_options stce_9938, stce_9971& tape) : stce_10258(stce_10181, tape), stce_10181() {
    stce_10258::init(stce_9938);
  }
  struct iterator : public stce_10258::iterator {
    iterator() : stce_10292(1), stce_10293(0) {}
    iterator(const typename stce_10258::iterator& stce_10294)
        : stce_10258::iterator(stce_10294), stce_10292(-1), stce_10293(-1) {}
    index_t stce_10292;
    index_t stce_10293;
    const index_t& max_dist() const { return stce_10292; }
    void stce_10295(const index_t& stce_10296) {
      stce_10292 = stce_10296 + 1;
      DCO_LOG(logDEBUG3) << " updating max dist: " << stce_10292;
    }
    const index_t& stce_10297() const { return stce_10293; }
    index_t stce_10180() {
      stce_10293++;
      return stce_10258::iterator::stce_10180();
    }
  };
  class edge_inserter : public stce_10258::edge_inserter {
    iterator& stce_10181;

  public:
    edge_inserter(iterator& current) : stce_10258::edge_inserter(current), stce_10181(current) {}
    iterator& current() { return stce_10181; }
    DCO_ALWAYS_INLINE void insert(const index_t& stce_10175, const stce_10168& pval) {
      DCO_LOG(logDEBUG4) << "target = " << stce_10175 << ", parametercounter = " << current().stce_10297()
                         << ", max dist = " << current().max_dist();
      index_t stce_10298 = current().index();
      stce_10258::edge_inserter::insert(stce_10175, pval);
      if (stce_10175 > current().stce_10297()) {
        index_t stce_10299 = stce_10298 - stce_10175 + 1;
        DCO_LOG(logDEBUG4) << "curdist = " << stce_10299;
        if (stce_10299 - current().max_dist() > 0) {
          current().stce_10295(stce_10299);
        }
      }
    }

  private:
    edge_inserter(const edge_inserter& stce_9930);
  };
  DCO_ALWAYS_INLINE iterator& insert_ref() { return static_cast<iterator&>(stce_10258::insert_ref()); }
  iterator current() const { return stce_10181; }
  iterator current() { return stce_10181; }
  iterator& stce_9995() { return stce_10181; }
  iterator rbegin() const { return stce_10181; }
  index_t stce_10196() {
    using ::log;
    using ::pow;
    index_t max_dist = stce_10181.max_dist();
    bool stce_10300 = (max_dist & (max_dist - 1)) == 0;
    if (HAS_BITWISE_MODULO && !stce_10300) {
      index_t stce_10015 = static_cast<index_t>(floor(log(static_cast<double>(max_dist)) / log(2.0))) + 1;
      stce_10181.stce_10295((1 << stce_9752(stce_10015)) - 1);
      DCO_LOG(logDEBUG2) << "rounding adjoint vector size to " << stce_10181.max_dist();
    }
    return stce_10181.stce_10297() + stce_10181.max_dist() + 1;
  }

private:
  iterator stce_10181;
};
} // namespace internal
namespace helper {
template <typename stce_9787, memory_model::TYPE stce_9788, typename external_adjoint_object_t>
struct stce_10002<internal::tape<memory_model::stce_9769, stce_9787, stce_9788>, external_adjoint_object_t> {
  typedef internal::tape<memory_model::stce_9769, stce_9787, stce_9788> tape_t;
  index_t stce_10301;
  index_t stce_10302;
  tape_t*& stce_9978;
  stce_10002(external_adjoint_object_t* stce_10303)
      : stce_10301(std::numeric_limits<index_t>::max()), stce_10302(0), stce_9978(stce_10303->tape()) {}
  template <typename stce_9781> void register_input(const stce_9781& stce_9803) {
    index_t stce_9806 = stce_9803._tape_index();
    if (stce_9806 > stce_9978->current().stce_10297()) {
      stce_10301 = std::min(stce_10301, stce_9806);
    }
  }
  template <typename stce_9781> void register_output(const stce_9781& stce_10042) {
    stce_10302 = std::max(stce_10302, stce_10042._tape_index());
    if (stce_10301 != std::numeric_limits<index_t>::max()) {
      index_t max_dist = stce_10302 - stce_10301;
      if (max_dist > stce_9978->stce_9995().max_dist()) {
        stce_9978->stce_9995().stce_10295(max_dist);
      }
    }
  }
};
} // namespace helper
namespace internal {
template <typename stce_9790, typename stce_9971, memory_model::TYPE stce_9972>
class adjoint_vector_lazy<stce_9790, internal::stce_9973<memory_model::stce_9769, stce_9971, stce_9972>>
    : public adjoint_vector_lazy<stce_9790, internal::stce_9973<stce_9972, stce_9971, memory_model::stce_9769>> {
  typedef internal::stce_9973<memory_model::stce_9769, stce_9971, stce_9972> stce_9895;
  typedef typename stce_9895::stce_10258 stce_10258;
  typedef adjoint_vector_lazy<stce_9790, stce_10258> stce_10304;
  typedef typename stce_10304::stce_9763 stce_9763;

public:
  stce_9895& stce_9978;
  adjoint_vector_lazy(index_t size, stce_9895& tape, tape_options stce_9938)
      : stce_10304(size, static_cast<stce_10258&>(tape), stce_9938), stce_9978(tape), stce_10305(true), stce_10306(0) {}
  void init() {
    stce_10307 = stce_9978.current().stce_10297();
    if (HAS_BITWISE_MODULO) {
      stce_10308 = stce_9978.current().max_dist() - 1;
    } else {
      stce_10308 = stce_9978.current().max_dist();
    }
    stce_10309 = this->stce_9893.data() + stce_9752(stce_10307) + 1;
  }
  bool stce_9939(index_t stce_9940) const {
    if (stce_9940 > stce_9978.current().stce_10297()) {
      stce_9940 -= stce_9978.current().stce_10297();
      stce_9940 %= stce_9978.current().max_dist();
      stce_9940 += stce_9978.current().stce_10297() + 1;
    }
    return static_cast<index_t>(this->stce_9933) > stce_9940;
  }
  index_t stce_10310(index_t stce_9806) const {
    if (stce_9806 > stce_9978.current().stce_10297()) {
      stce_9806 -= stce_9978.current().stce_10297();
      stce_9806 %= stce_9978.current().max_dist();
      stce_9806 += stce_9978.current().stce_10297() + 1;
    }
    return stce_9806;
  }
  typename stce_10304::stce_9763& operator[](index_t stce_9806) {
    DCO_LOG(logDEBUG4) << "getting " << stce_9806;
    stce_9806 = stce_10310(stce_9806);
    DCO_LOG(logDEBUG4) << "matched to " << stce_9806;
    return stce_10304::operator[](stce_9806);
  }
  typename stce_10304::stce_9763 operator[](index_t stce_9806) const {
    DCO_LOG(logDEBUG4) << "getting " << stce_9806;
    stce_9806 = stce_10310(stce_9806);
    DCO_LOG(logDEBUG4) << "matched to " << stce_9806;
    return stce_10304::operator[](stce_9806);
  }
  stce_9763 at(index_t stce_9806) const { return stce_9939(stce_9806) ? (*this)[stce_9806] : 0; }
  stce_9763& at(const index_t stce_9806) {
    if (!stce_9939(stce_9806))
      this->resize(stce_9978.stce_10196());
    return (*this)[stce_9806];
  }
  void stce_9946(index_t stce_9806) {
    if (!stce_9939(stce_9806)) {
      DCO_LOG(logDEBUG2) << "Resizing internal adjoint vector to " << stce_9806;
      this->resize(stce_9978.stce_10196());
    }
  }
  template <typename iterator_t> void stce_9942(iterator_t& stce_9821) {
    index_t stce_9869 = stce_9821->arg();
    stce_9763 pval = stce_9821->pval();
    index_t stce_9868 = stce_9821.index();
    if (stce_10305) {
      DCO_LOG(logDEBUG3) << "setting " << stce_9868 << " to 0 ";
      stce_9763& stce_10311 = HAS_BITWISE_MODULO ? stce_10309[(stce_9868 - stce_10307) & stce_10308]
                                                 : stce_10309[(stce_9868 - stce_10307) % stce_10308];
      this->stce_10306 = stce_10311;
      stce_10311 = 0;
    }
    if (stce_9869 > stce_10307) {
      stce_9763& stce_10311 = HAS_BITWISE_MODULO ? stce_10309[(stce_9869 - stce_10307) & stce_10308]
                                                 : stce_10309[(stce_9869 - stce_10307) % stce_10308];
      stce_10311 += pval * this->stce_10306;
    } else {
      (*this)[stce_9869] += pval * this->stce_10306;
    }
    stce_10305 = stce_9821.stce_10000();
  }

private:
  stce_9763* stce_10309;
  index_t stce_10307;
  index_t stce_10308;
  bool stce_10305;
  stce_9763 stce_10306;
};
} // namespace internal
} // namespace dco

namespace dco {
namespace internal {
template <typename stce_10072> struct stce_10312 {
public:
  typedef stce_10072 mode_t;
  typedef stce_10078 stce_10134;

private:
  static const size_t size = mode_t::p1f_size;
  typedef std::bitset<size> stce_10313;

public:
  typedef stce_10313 derivative_t;

private:
  mutable stce_10313 stce_10314;

public:
  stce_10312() {}
  DCO_STRONG_INLINE stce_10312(stce_10312 const& stce_10027) : stce_10314(stce_10027.stce_10314) {}
  DCO_STRONG_INLINE stce_10312& operator=(const stce_10312& stce_10075) {
    stce_10314 = stce_10075.stce_10314;
    return *this;
  }
  stce_10313& stce_9963() const { return stce_10314; }
  void clear() { stce_10314.reset(); }
  template <class stce_9904> DCO_ALWAYS_INLINE void stce_9905(const stce_9904& stce_10135) {
    stce_10312 stce_10020;
    stce_10315(stce_10135, stce_10020.stce_10314);
    stce_10314 = stce_10020.stce_10314;
  }
  typedef typename mode_t::value_t stce_9770;

private:
  template <class stce_10119>
  static void stce_10315(const dco::internal::active_type<stce_9770, stce_10119>& stce_9803, stce_10313& stce_10175) {
    stce_10175 |= stce_9803.stce_10314;
  }
  template <class stce_10121, class stce_10122, class stce_10123>
  static void stce_10315(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803,
                         stce_10313& stce_10175) {
    stce_10315(stce_9803.stce_10125, stce_10175);
    stce_10315(stce_9803.stce_10127, stce_10175);
  }
  template <class stce_10129, class stce_10123>
  static void stce_10315(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_9803,
                         stce_10313& stce_10175) {
    stce_10315(stce_9803.stce_10130, stce_10175);
  }
  template <class stce_10121, class stce_10122, class stce_10123>
  static void stce_10315(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803,
                         stce_10313& stce_10175) {
    stce_10315(stce_9803.stce_10125, stce_10175);
  }
  template <class stce_10121, class stce_10122, class stce_10123>
  static void stce_10315(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803,
                         stce_10313& stce_10175) {
    stce_10315(stce_9803.stce_10127, stce_10175);
  }
};
} // namespace internal
} // namespace dco
namespace dco {
namespace internal {
namespace stce_10316 {
template <typename stce_10317, typename adjoint_vector>
void stce_10318(stce_10317 stce_9821, stce_10317 stce_9869, const adjoint_vector& stce_10319,
                const std::string& filename = "tape.dot") {
  stce_10318(stce_9821, stce_9869, stce_10319, stce_9854(filename));
}
template <typename stce_10317, typename adjoint_vector>
void stce_10318(stce_10317 stce_9821, stce_10317 stce_9869, const adjoint_vector& stce_10319, stce_9854& stce_9855) {
  if (stce_9821.index() == stce_9869.index()) {
    return;
  } else if (stce_9821.index() < stce_9869.index()) {
    std::swap(stce_9821, stce_9869);
  }
  for (; stce_9821 != stce_9869; stce_9821--) {
    if (stce_9821->stce_10000()) {
      stce_9855.stce_9864(stce_9821.index(), stce_10319.at(stce_9821.index()));
    }
    stce_9855.stce_9867(stce_9821->arg(), stce_9821.index(), stce_9821->pval());
  }
  for (int stce_9841 = 0; stce_9841 <= stce_9821.index(); ++stce_9841) {
    stce_9855.stce_9864(stce_9841, stce_10319.at(stce_9841));
  }
}
template <typename stce_10317, typename adjoint_vector, typename stce_10320>
void stce_10318(stce_10317 stce_9821, stce_10317 stce_9869, const adjoint_vector& stce_10319,
                const stce_10320& stce_10321, stce_9854& stce_9855) {
  if (stce_9821.index() < stce_9869.index()) {
    std::swap(stce_9821, stce_9869);
  }
  stce_10318(stce_9821, stce_9869, stce_10319, stce_9855);
  typedef typename stce_10320::const_reverse_iterator stce_10322;
  for (stce_10322 stce_9996 = stce_10321.rbegin();
       stce_9996 != stce_10321.rend() && stce_9869 <= stce_9996->stce_10323(); ++stce_9996) {
    if (stce_9821 < stce_9996->stce_10323())
      continue;
    stce_9996->stce_10324()->stce_10008(stce_9855, stce_9996->stce_10323().index() + 1);
  }
}
template <typename stce_10317>
void stce_10325(stce_10317 stce_9821, stce_10317 stce_9869, std::string const& filename) {
  if (stce_9821.index() < stce_9869.index()) {
    std::swap(stce_9821, stce_9869);
  }
  std::ofstream stce_9811(filename.c_str());
  stce_9811 << stce_9821.index() << "\n";
  for (; stce_9821 != stce_9869; --stce_9821) {
    stce_9811 << stce_9821->arg() << ", " << stce_9821->pval() << "; ";
    if (stce_9821->stce_10000())
      stce_9811 << "\n";
  }
}
template <bool USE_SPARSE_INTERPRET, typename stce_10317, typename adjoint_vector, typename stce_10326>
DCO_STRONG_INLINE void interpret(stce_10317 stce_9821, const stce_10317& stce_9869, adjoint_vector& stce_10319,
                                 stce_10326 const& stce_10327) {
  using stce_10328 = typename dco::mode<typename adjoint_vector::stce_9932>::data_t;
  using stce_10329 = typename stce_10328::mode_t;
  static constexpr bool sparse_interpret =
      USE_SPARSE_INTERPRET || std::is_base_of<stce_10328, internal::stce_10312<stce_10329>>::value;
  stce_9821.index()--;
  stce_1000002();
  ;
  stce_10319.stce_9946(stce_9808(stce_9752(stce_9821.index())));
  stce_10319.init();
  for (; stce_9821 != stce_9869; --stce_9821) {
    if (sparse_interpret && folding::is_zero(stce_10319[stce_9821.index()])) {
      continue;
    }
    DCO_LOG(logDEBUG3) << stce_10319[stce_9821->arg()] << " <=> adj[" << stce_9821->arg()
                       << "] += " << stce_9821->pval() * stce_10319[stce_9821.index()] << " from idx "
                       << stce_9821.index();
    stce_10319.stce_9942(stce_9821);
    helper::stce_9829(int(), stce_10327, stce_9821->arg(), stce_9821->pval() * stce_10319[stce_9821.index()]);
  }
}
template <bool USE_SPARSE_INTERPRET, typename stce_10317, typename adjoint_vector, typename stce_10326>
DCO_STRONG_INLINE void stce_10330(stce_10317 stce_9821, const stce_10317& stce_9869, adjoint_vector& stce_10319,
                                  stce_10326 const& stce_10327) {
  using stce_10328 = typename dco::mode<typename adjoint_vector::stce_9932>::data_t;
  using stce_10329 = typename stce_10328::mode_t;
  static constexpr bool sparse_interpret =
      USE_SPARSE_INTERPRET || std::is_base_of<stce_10328, internal::stce_10312<stce_10329>>::value;
  stce_9821.index()--;
  stce_1000002();
  ;
  stce_10319.stce_9946(stce_9808(stce_9752(stce_9821.index())));
  stce_10319.init();
  for (; stce_9821 != stce_9869; --stce_9821) {
    if (sparse_interpret && folding::is_zero(stce_10319[stce_9821.index()])) {
      continue;
    }
    DCO_LOG(logDEBUG3) << stce_10319[stce_9821->arg()] << " <=> adj[" << stce_9821->arg()
                       << "] += " << stce_9821->pval() * stce_10319[stce_9821.index()] << " from idx "
                       << stce_9821.index();
    stce_10319.stce_9942(stce_9821);
    helper::stce_9829(int(), stce_10327, stce_9821->arg(), stce_9821->pval() * stce_10319[stce_9821.index()]);
    if (stce_9821->stce_10000()) {
      stce_10319[stce_9821.index()] = 0;
    }
  }
}
template <typename stce_10317, typename adjoint_vector>
DCO_STRONG_INLINE void stce_10331(stce_10317 stce_9821, const stce_10317& stce_9869, adjoint_vector& stce_10319) {
  stce_10319.stce_9946(stce_9821.index());
  for (; stce_9821 != stce_9869; --stce_9821) {
    std::cout << stce_9821.index() << ": " << stce_9821->arg() << ", " << stce_9821->pval() << ", "
              << stce_10319[stce_9821.index()] << std::endl;
  }
}
template <typename tape_t> DCO_STRONG_INLINE void stce_10331(const tape_t* tape) {
  typename tape_t::iterator stce_9821 = tape->get_position();
  for (; stce_9821 != tape->begin(); --stce_9821) {
    std::cout << stce_9821.index() << ": " << stce_9821->arg() << ", " << stce_9821->pval() << std::endl;
  }
}
} // namespace stce_10316
} // namespace internal
} // namespace dco

namespace dco {
template <typename tape_t> struct stce_10332 {
  typedef std::map<std::string, mem_long_t> stce_10333;
  stce_10333 stce_10334;
  tape_t* stce_9978;
  stce_10332(tape_t* tape) : stce_9978(tape) {
    stce_10334["max_tape_memory"] = 0;
    stce_10334["max_adjoint_memory"] = 0;
    stce_10334["max_checkpoint_memory"] = 0;
    stce_10334["max_total_memory"] = 0;
  }
  mem_long_t operator[](std::string stce_10335) { return stce_10334[stce_10335]; }
  void stce_10336() {
    mem_long_t stce_10337 = dco::size_of(stce_9978, tape_t::size_of_stack);
    if (stce_10337 > stce_10334["max_tape_memory"]) {
      stce_10334["max_tape_memory"] = stce_10337;
    }
    stce_10337 = dco::size_of(stce_9978, tape_t::size_of_internal_adjoint_vector);
    if (stce_10337 > stce_10334["max_adjoint_memory"]) {
      stce_10334["max_adjoint_memory"] = stce_10337;
    }
    stce_10337 = dco::size_of(stce_9978, tape_t::size_of_checkpoints);
    if (stce_10337 > stce_10334["max_checkpoint_memory"]) {
      stce_10334["max_checkpoint_memory"] = stce_10337;
    }
    stce_10334["max_total_memory"] = 0;
    for (stce_10333::iterator stce_9841 = stce_10334.begin(); stce_9841 != stce_10334.end(); ++stce_9841) {
      stce_10334["max_total_memory"] += stce_9841->second;
    }
  }
  mem_long_t stce_10338() { return stce_10334["max_tape_memory"]; }
};
} // namespace dco

struct stce_10339 {
  int stce_10340;

public:
  DCO_ALWAYS_INLINE stce_10339() : stce_10340(DCO_COMPATIBILITY_VERSION) {}
  DCO_ALWAYS_INLINE bool is_compatible(int stce_10341, bool stce_10331 = false) {
    if (stce_10331)
      dco::cout_diffs_in_version(stce_10341, stce_10340);
    return stce_10341 == stce_10340;
  }
};
namespace dco {
namespace internal {
template <memory_model::TYPE MEMORY_MODEL, typename stce_10342, memory_model::TYPE stce_9788>
class tape
    : public stce_10339,
      public dco::adjoint_vector_abstract<typename helper::vecsize_info<typename stce_10342::stce_9763>::stce_9846>,
      public stce_9973<MEMORY_MODEL, tape<MEMORY_MODEL, stce_10342, stce_9788>, stce_9788> {
public:
  typedef stce_10342 types_config_t;
  typedef stce_9973<MEMORY_MODEL, tape, stce_9788> stce_9895;
  typedef typename stce_9895::iterator iterator_t;
  typedef iterator_t position_t;
  typedef typename types_config_t::stce_9763 stce_9763;
  typedef typename types_config_t::stce_9762 stce_9762;
  typedef typename helper::vecsize_info<typename stce_10342::stce_9763>::stce_9846 stce_9932;
  typedef tape<MEMORY_MODEL, types_config_t, stce_9788> tape_t;
  typedef adjoint_vector_lazy<typename types_config_t::stce_9763, stce_9895> vector_t;
  vector_t stce_9893;
  stce_10332<tape> stce_10343;
  stce_10332<tape>& stce_10344() { return stce_10343; }
  const stce_10332<tape>& stce_10344() const { return stce_10343; }
  tape& get_tape() { return *this; }

private:
  bool stce_10345;
  bool stce_10346;
  struct stce_10347 {
    stce_10347() {}
    template <typename stce_9761> void operator()(index_t, stce_9761&&) const {}
  };
  static const stce_10347 stce_10348;
  index_t stce_9950;
  tape_options stce_9937;
  bool stce_10349;
  bool stce_10350;
  void stce_9955(const iterator_t& stce_9868, const iterator_t& stce_9869 = stce_9895::start()) {
    stce_9893.stce_9944(stce_9868.index(), stce_9869.index());
  }
  void stce_10351() {
    stce_9893.resize(this->stce_10196());
    stce_9893.stce_9947();
  }
  template <typename stce_10317, typename adjoint_vector, typename stce_10326>
  DCO_STRONG_INLINE void stce_10352(stce_10317 stce_9821, const stce_10317& stce_9869, adjoint_vector& stce_10319,
                                    stce_10326 const& stce_10327) {
    if (stce_10349) {
      dco::internal::stce_10316::interpret<true>(stce_9821, stce_9869, stce_10319, stce_10327);
    } else {
      dco::internal::stce_10316::interpret<false>(stce_9821, stce_9869, stce_10319, stce_10327);
    }
  }
  template <typename stce_10317, typename adjoint_vector, typename stce_10326>
  DCO_STRONG_INLINE void stce_10353(stce_10317 stce_9821, const stce_10317& stce_9869, adjoint_vector& stce_10319,
                                    stce_10326 const& stce_10327) {
    if (stce_10349) {
      dco::internal::stce_10316::stce_10330<true>(stce_9821, stce_9869, stce_10319, stce_10327);
    } else {
      dco::internal::stce_10316::stce_10330<false>(stce_9821, stce_9869, stce_10319, stce_10327);
    }
  }

public:
  const tape_options& stce_9938() const { return stce_9937; }
  bool stce_10354() { return this->start() == this->current(); }
  DCO_ALWAYS_INLINE tape(tape_options stce_9938 = tape_options())
      : stce_10339(), stce_9895(stce_9938, *this), stce_9893(1, *this, stce_9938), stce_10343(this), stce_10345(false),
        stce_10346(true), stce_9950(0), stce_9937(stce_9938), stce_10349(false), stce_10350(true) {}
  DCO_ALWAYS_INLINE ~tape() {
    for (typename std::vector<stce_10355>::iterator stce_9996 = stce_10356.begin(); stce_9996 != stce_10356.end();
         ++stce_9996) {
      stce_9996->stce_10357();
    }
  }
  bool is_active() { return stce_9758 ? stce_10346 : true; }
  bool& sparse_interpret() { return stce_10349; }
  bool& scalar_callback_mode() { return stce_10350; }
  DCO_TAPE_INT current_vector_mode_index() { return stce_9950; }
  iterator_t current() const { return get_position(); }
  iterator_t begin() const { return stce_9895::start(); }
  vector_t& adjoints() { return stce_9893; }
  typedef helper::stce_10004<tape> stce_10358;
  static void stce_10359(stce_10358* stce_10360) { stce_10360->get_tape()->stce_10349 = true; }
  static void stce_10361(stce_10358* stce_10360) { stce_10360->get_tape()->stce_10349 = false; }
  void set_sparse_interpret() {
    if (stce_10349 == false) {
      stce_10358* stce_10360 = this->create_callback_object<stce_10358>();
      this->insert_callback(stce_10361, stce_10360);
    }
    stce_10349 = true;
  }
  void unset_sparse_interpret() {
    if (stce_10349 == true) {
      stce_10358* stce_10360 = this->create_callback_object<stce_10358>();
      this->insert_callback(stce_10359, stce_10360);
    }
    stce_10349 = false;
  }
  bool switch_to_active() {
    if (!stce_9758) {
      throw dco::exception::create<std::runtime_error>(
          "activity check disabled but switched",
          "/home/vagrant/builds/xXzkdLpY/0/stce/dco_cpp_make_release/dco_cpp_dev/src/dco_tape.hpp", 179);
    }
    if (!stce_10346) {
      stce_10346 = true;
      return false;
    }
    return true;
  }
  bool switch_to_passive() {
    if (!stce_9758) {
      throw dco::exception::create<std::runtime_error>(
          "activity check disabled but switched",
          "/home/vagrant/builds/xXzkdLpY/0/stce/dco_cpp_make_release/dco_cpp_dev/src/dco_tape.hpp", 190);
    }
    if (stce_10346) {
      stce_10346 = false;
      return true;
    }
    return false;
  }
  bool stce_10362(bool stce_10363) {
    bool stce_10364 = stce_10346;
    stce_10346 = stce_10363;
    return stce_10364;
  }
  template <bool stce_10365> index_t stce_10366() {
    if (!stce_10365 && this->empty()) {
      return stce_9895::insert_ref().stce_10180();
    } else {
      typename stce_9895::edge_inserter stce_10367(stce_9895::insert_ref());
      stce_10367.insert(0, static_cast<typename stce_9895::stce_10168>(0.0));
      return stce_10367.index();
    }
  }
  template <typename stce_10077, typename stce_10360>
  void register_variable(internal::active_type<stce_10077, stce_10360> const& stce_9803) {
    internal::active_type<stce_10077, stce_10360>::register_variable(stce_9803, stce_10366<false>(), this);
  }
  template <typename stce_10077> void register_variable(std::vector<stce_10077> const& stce_9803) {
    this->register_variable(stce_9803.data(), stce_9803.size());
  }
  template <typename stce_10368> void register_variable(stce_10368 first, stce_10368 stce_10369) {
    while (first != stce_10369) {
      this->register_variable(*first++);
    }
  }
  template <typename stce_10368, typename stce_10370>
  void register_variable(stce_10368 stce_10371, stce_10368 stce_10372, stce_10370 stce_10373) {
    while (stce_10371 != stce_10372) {
      *stce_10373 = *stce_10371++;
      this->register_variable(*stce_10373++);
    }
  }
  template <typename stce_10077> void register_variable(stce_10077* stce_9803, size_t stce_10023) {
    for (size_t stce_9841 = 0; stce_9841 < stce_10023; ++stce_9841) {
      stce_10077::register_variable(stce_9803[stce_9841], stce_10366<false>(), this);
    }
  }
  template <typename stce_10077> void register_output_variable(stce_10077& stce_9803) {
    typename stce_9895::edge_inserter stce_10367(stce_9895::insert_ref());
    stce_10367.insert(dco::tape_index(stce_9803), static_cast<typename stce_9895::stce_10168>(1.0));
    dco::tape_index(stce_9803) = stce_10367.index();
  }
  template <typename stce_10077> void register_output_variable(std::vector<stce_10077>& stce_9803) {
    this->register_output_variable(stce_9803.data(), stce_9803.size());
  }
  template <typename stce_10077> void register_output_variable(stce_10077* stce_9803, size_t stce_10023) {
    for (size_t stce_9841 = 0; stce_9841 < stce_10023; ++stce_9841) {
      this->register_output_variable(stce_9803[stce_9841]);
    }
  }
  template <typename stce_10368> void register_output_variable(stce_10368 first, stce_10368 stce_10369) {
    while (first != stce_10369) {
      this->register_output_variable(*first++);
    }
  }
  template <stce_9793 stce_10374, typename stce_9781, typename stce_9884>
  void register_output_variable(stce_9894<stce_10374, stce_9781, stce_9884> stce_9803) {
    for (size_t stce_9841 = 0; stce_9841 < stce_9803.size(); ++stce_9841) {
      this->register_output_variable(stce_9803[stce_9841]);
    }
  }
  void reset_to(const iterator_t& stce_9869) {
    stce_10284(stce_9869);
    stce_10375(stce_9869);
  }
  void reset() { reset_to(stce_9895::start()); }
  void interpret_adjoint(interpretation_settings stce_9953 = interpretation_settings()) {
    iterator_t stce_9869 = stce_9895::start();
    stce_9954(get_position(), stce_9869, stce_9953, stce_10348);
  }
  template <typename stce_10326 = decltype(stce_10348)>
  typename std::enable_if<!std::is_same<stce_10326, interpretation_settings>::value>::type
  interpret_adjoint(stce_10326 const& stce_10327 = stce_10348) {
    iterator_t stce_9869 = stce_9895::start();
    interpretation_settings stce_9953;
    stce_9954(get_position(), stce_9869, stce_9953, stce_10327);
  }
  template <typename stce_10326 = decltype(stce_10348)>
  void interpret_adjoint_to(const iterator_t& stce_9869, stce_10326 const& stce_10327 = stce_10348) {
    interpretation_settings stce_9953;
    stce_9954(get_position(), stce_9869, stce_9953, stce_10327);
  }
  template <typename stce_10326 = decltype(stce_10348)>
  void interpret_adjoint_from(const iterator_t& stce_9868, stce_10326 const& stce_10327 = stce_10348) {
    iterator_t stce_9869 = stce_9895::start();
    interpretation_settings stce_9953;
    stce_9954(stce_9868, stce_9869, stce_9953, stce_10327);
  }
  template <typename stce_10326 = decltype(stce_10348)>
  void interpret_adjoint_from_to(const iterator_t& stce_9868, const iterator_t& stce_9869,
                                 stce_10326 const& stce_10327 = stce_10348) {
    interpretation_settings stce_9953;
    stce_9954(stce_9868, stce_9869, stce_9953, stce_10327);
  }
  template <typename stce_10326 = decltype(stce_10348)>
  void interpret_adjoint_and_reset_to(const iterator_t& stce_9869, stce_10326 const& stce_10327 = stce_10348) {
    iterator_t stce_9868(get_position());
    interpretation_settings stce_9953;
    stce_9953.reset = true;
    stce_9953.stce_9913 = true;
    stce_9954(stce_9868, stce_9869, stce_9953, stce_10327);
    stce_10284(stce_9869);
    stce_10375(stce_9869);
  }
  template <typename stce_10326 = decltype(stce_10348)>
  void interpret_adjoint_and_zero_adjoints_to(const iterator_t& stce_9869, stce_10326 const& stce_10327 = stce_10348) {
    iterator_t stce_9868(get_position());
    interpretation_settings stce_9953;
    stce_9953.reset = false;
    stce_9953.stce_9913 = true;
    stce_9954(stce_9868, stce_9869, stce_9953, stce_10327);
  }
  template <typename stce_10326 = decltype(stce_10348)>
  void interpret_adjoint_and_zero_adjoints_from_to(const iterator_t& stce_9868, const iterator_t& stce_9869,
                                                   stce_10326 const& stce_10327 = stce_10348) {
    interpretation_settings stce_9953;
    stce_9953.reset = false;
    stce_9953.stce_9913 = true;
    stce_9954(stce_9868, stce_9869, stce_9953, stce_10327);
  }
  void zero_adjoints() {
    iterator_t stce_9869 = stce_9895::start();
    stce_9955(get_position(), stce_9869);
  }
  void zero_adjoints_to(const iterator_t& stce_9869) { stce_9955(get_position(), stce_9869); }
  void zero_adjoints_from(const iterator_t& stce_9868) {
    iterator_t stce_9869 = stce_9895::start();
    stce_9955(stce_9868, stce_9869);
  }
  void zero_adjoints_from_to(const iterator_t& stce_9868, const iterator_t& stce_9869) {
    stce_9955(stce_9868, stce_9869);
  }
  void stce_10284(const iterator_t& stce_9869) {
    bool alloc = stce_9893.stce_9939(stce_9869.index());
    stce_9893.resize(stce_9869.index() + 1);
    if (alloc) {
      stce_9893.stce_9947();
    }
    stce_9895::erase(stce_9869);
  }

public:
  iterator_t get_position() const { return stce_9895::current(); }
  stce_9932& stce_10376(const index_t tape_index) {
    stce_9763& stce_9919 = _adjoint(tape_index);
    stce_9932* stce_10377 = reinterpret_cast<stce_9932*>(&stce_9919);
    return stce_10377[stce_9950];
  }
  stce_9932 stce_10376(const index_t tape_index) const {
    stce_9763 stce_9919(_adjoint(tape_index));
    stce_9932* stce_10377 = reinterpret_cast<stce_9932*>(&stce_9919);
    return stce_10377[stce_9950];
  }
  stce_9763& _adjoint(index_t tape_index) {
    if (!stce_9893.stce_9939(get_position().index() + 1))
      stce_10351();
    return stce_9893[tape_index];
  }
  stce_9763 _adjoint(const index_t tape_index) const {
    return stce_9893.stce_9939(tape_index) ? stce_9893[tape_index] : 0;
  }
  enum stce_10378 {
    size_of_stack = 1,
    size_of_allocated_stack = 2,
    size_of_internal_adjoint_vector = 4,
    size_of_checkpoints = 8,
    stce_9882 = size_of_stack | size_of_internal_adjoint_vector
  };
  mem_long_t stce_10379() const {
    mem_long_t stce_10380 = 0;
    for (size_t stce_9841 = 0; stce_9841 < stce_10356.size(); stce_9841++) {
      stce_10380 += stce_10356[stce_9841].stce_10324()->size_in_byte();
    }
    return stce_10380;
  }
  mem_long_t stce_9883(const int stce_10381 = stce_9882) const {
    mem_long_t stce_10382 = 0;
    if (stce_10381 & size_of_allocated_stack) {
      stce_10382 += static_cast<size_t>(stce_9895::stce_10193());
    } else if (stce_10381 & size_of_stack) {
      stce_10382 += static_cast<size_t>(stce_9895::size_in_byte());
    }
    if (stce_10381 & size_of_internal_adjoint_vector) {
      stce_10382 += stce_9893.stce_9941();
    }
    if (stce_10381 & size_of_checkpoints) {
      stce_10382 += stce_10379();
    }
    return stce_10382;
  }
  static DCO_ALWAYS_INLINE tape_t* create(tape_options stce_9938 = tape_options()) {
    tape_t* tape = new tape_t(stce_9938);
    return tape;
  }
  static DCO_ALWAYS_INLINE void remove(tape_t*& tape) {
    if (tape == 0)
      return;
    delete tape;
    tape = 0;
  }
  virtual stce_9932 _read_adjoint(const index_t stce_9806) { return stce_10376(stce_9806); }
  virtual void _increment_adjoint(const index_t stce_9806, const stce_9932& stce_9919) {
    stce_10376(stce_9806) += stce_9919;
  }
  typedef dco::helper::stce_10004<tape_t> callback_object_t;
  template <typename stce_10383> class stce_10384 {
  public:
    typedef void (*stce_10385)(tape_t& stce_10386, const interpretation_settings& stce_10387, stce_10383* stce_10388);
    typedef void (*stce_10389)(tape_t& stce_10386, stce_10383* stce_10388);
    typedef void (*stce_10390)(stce_10383* stce_10388);
  };
  class stce_10391 {
  public:
    virtual void stce_10392(tape_t& stce_10386, const interpretation_settings& stce_10387,
                            callback_object_t* stce_10388) = 0;
    virtual ~stce_10391(){};
  };
  template <typename stce_10383> class stce_10393 : public stce_10391 {
  private:
    union {
      typename stce_10384<stce_10383>::stce_10390 stce_10394;
      typename stce_10384<stce_10383>::stce_10389 stce_10395;
      typename stce_10384<stce_10383>::stce_10385 stce_10396;
    } stce_10394;
    int stce_10397;

  public:
    stce_10393(typename stce_10384<stce_10383>::stce_10390 stce_10398) : stce_10397(0) {
      stce_10394.stce_10394 = stce_10398;
    }
    stce_10393(typename stce_10384<stce_10383>::stce_10389 stce_10398) : stce_10397(1) {
      stce_10394.stce_10395 = stce_10398;
    }
    stce_10393(typename stce_10384<stce_10383>::stce_10385 stce_10398) : stce_10397(2) {
      stce_10394.stce_10396 = stce_10398;
    }
    void stce_10392(tape_t& stce_10386, const interpretation_settings& stce_10387, callback_object_t* stce_10388) {
      stce_10383* stce_10399 = static_cast<stce_10383*>(stce_10388);
      switch (stce_10397) {
      case 0:
        stce_10394.stce_10394(stce_10399);
        break;
      case 1:
        stce_10394.stce_10395(stce_10386, stce_10399);
        break;
      case 2:
        stce_10394.stce_10396(stce_10386, stce_10387, stce_10399);
        break;
      default:
        if (helper::stce_9833) {
          throw dco::exception::create<std::runtime_error>(
              "Internal error: Unknown callback type. Please contact NAG.");
        }
        break;
      }
    }
    ~stce_10393() {}
  };
  class stce_10355 {
    callback_object_t* stce_10388;
    stce_10391* stce_10400;
    iterator_t stce_10401;

  public:
    stce_10355() = delete;
    stce_10355(const stce_10355& stce_10027) noexcept
        : stce_10388(stce_10027.stce_10388), stce_10400(stce_10027.stce_10400), stce_10401(stce_10027.stce_10401){};
    stce_10355& operator=(const stce_10355& stce_10027) noexcept {
      stce_10388 = stce_10027.stce_10388;
      stce_10400 = stce_10027.stce_10400;
      stce_10401 = stce_10027.stce_10401;
      return *this;
    }
    stce_10355(const iterator_t& stce_10173) : stce_10388(0), stce_10400(0), stce_10401(stce_10173) {}
    bool operator<(const stce_10355& stce_9930) const { return stce_10401 < stce_9930.stce_10401; }
    void stce_10357() {
      delete stce_10388;
      if (stce_10400)
        delete stce_10400;
    }
    template <typename stce_10383, typename stce_10402> void stce_10403(stce_10402 stce_10398) {
      if (stce_10400)
        throw dco::exception::create<std::runtime_error>(
            "Currently not supported to insert external_adjoint_object_bases twice.");
      stce_10400 = new stce_10393<stce_10383>(stce_10398);
    }
    callback_object_t*& stce_10324() { return stce_10388; }
    callback_object_t* stce_10324() const { return stce_10388; }
    iterator_t& stce_10323() { return stce_10401; }
    iterator_t stce_10323() const { return stce_10401; }
    void stce_10392(tape_t& stce_10386, const interpretation_settings& stce_10387) {
      if (stce_10400)
        stce_10400->stce_10392(stce_10386, stce_10387, stce_10388);
    }
  };
  std::vector<stce_10355> stce_10356;
  size_t number_of_callbacks() { return stce_10356.size(); }
  template <class stce_10404> void stce_10405(stce_10404* stce_10388) {
    stce_10356.emplace_back(stce_10355(stce_9895::current()));
    stce_10356.back().stce_10324() = stce_10388;
    stce_10388->set_tape(this);
    typedef typename stce_10404::active_t stce_9974;
    typedef dco::stce_10060::stce_10064<tape_t, stce_9974> stce_10406;
    stce_10406* stce_10059 = stce_10388;
    insert_callback(&dco::stce_10060::stce_10058<tape_t, stce_9974>, stce_10059);
  }
  template <class stce_10404, typename stce_10402> void insert_callback(stce_10402 stce_10400, stce_10404* stce_10360) {
    if (stce_10356.back().stce_10324() == stce_10360) {
      stce_10360->stce_10007();
      stce_10356.back().template stce_10403<stce_10404>(stce_10400);
      stce_10356.back().stce_10323() = stce_9895::current();
      stce_10366<true>();
    } else {
      throw dco::exception::create<std::runtime_error>(
          "please always insert most recently created external function object.");
    }
  }
  template <typename stce_10326> struct stce_10407 : helper::stce_10004<tape> {
    stce_10326 stce_10327;
    template <typename stce_10408>
    stce_10407(stce_10408&& stce_10327) : stce_10327(std::forward<stce_10408>(stce_10327)) {}
  };
  template <typename stce_10409> static auto stce_10410(stce_10409* stce_10360) -> decltype(stce_10360->stce_10327()) {
    stce_10360->stce_10327();
  }
  template <typename stce_10409>
  static auto stce_10410(stce_10409* stce_10360) -> decltype(stce_10360->stce_10327(*stce_10360->_adjoint_vector)) {
    stce_10360->stce_10327(*stce_10360->_adjoint_vector);
  }
  template <typename stce_10326> void insert_callback(stce_10326&& stce_9845) {
    using stce_10411 = stce_10407<typename std::decay<stce_10326>::type>;
    auto* stce_10360 = this->create_callback_object<stce_10411>(std::forward<stce_10326>(stce_9845));
    this->insert_callback(stce_10410<stce_10411>, stce_10360);
  }
  template <class stce_10404, typename... FCN_PARAMETERS>
  stce_10404* create_callback_object(FCN_PARAMETERS&&... parameters) {
    stce_10356.emplace_back(stce_10355(stce_9895::current()));
    stce_10404* stce_10388 = new stce_10404(std::forward<FCN_PARAMETERS>(parameters)...);
    stce_10356.back().stce_10324() = stce_10388;
    stce_10388->set_tape(this);
    return stce_10388;
  }
  template <class stce_10404> inline stce_10404* create_ACM_object() {
    stce_10404* stce_9843 = create_callback_object<stce_10404>();
    typedef typename stce_10404::active_t stce_9974;
    typedef dco::ACM::baseclass<tape_t, stce_9974> stce_10412;
    stce_10412* stce_10059 = stce_9843;
    insert_callback(&dco::ACM::stce_10058<tape_t, stce_9974>, stce_10059);
    return stce_9843;
  }
  template <class stce_10404, typename FCN_PARAMETERS>
  inline stce_10404* create_ACM_object(const FCN_PARAMETERS& parameters) {
    const stce_9851<FCN_PARAMETERS> stce_10413(parameters);
    stce_10355 stce_10414(stce_9895::current());
    stce_10356.push_back(stce_10414);
    stce_10404* stce_10388 = stce_10413.template create<stce_10404>();
    stce_10356.back().stce_10324() = stce_10388;
    stce_10388->set_tape(this);
    typedef typename stce_10404::active_t stce_9974;
    typedef dco::ACM::baseclass<tape_t, stce_9974> stce_10412;
    stce_10412* stce_10059 = stce_10388;
    insert_callback(&dco::ACM::stce_10058<tape_t, stce_9974>, stce_10059);
    return stce_10388;
  }
  template <class stce_10404> void insert_ACM_object(stce_10404* stce_10388) {
    stce_10355 stce_10414(stce_9895::current());
    stce_10356.push_back(stce_10414);
    stce_10356.back().stce_10324() = stce_10388;
    stce_10388->set_tape(this);
    typedef typename stce_10404::active_t stce_9974;
    typedef dco::ACM::baseclass<tape_t, stce_9974> stce_10412;
    stce_10412* stce_10059 = stce_10388;
    insert_callback(&dco::ACM::stce_10058<tape_t, stce_9974>, stce_10059);
  }
  void stce_10375(const iterator_t& stce_9869) {
    typedef typename std::vector<stce_10355>::iterator stce_10322;
    stce_10322 stce_10175 = stce_10356.begin();
    for (; stce_10175 != stce_10356.end() && stce_10175->stce_10323().index() < stce_9869.index(); ++stce_10175) {
    }
    for (stce_10322 stce_9996 = stce_10175; stce_9996 != stce_10356.end(); ++stce_9996)
      stce_9996->stce_10357();
    stce_10356.erase(stce_10175, stce_10356.end());
  }

public:
  void write_to_dot(const std::string& filename = "tape.dot") {
    write_to_dot(stce_9895::current(), stce_9895::start(), filename);
  }
  void write_to_dot(iterator_t stce_9868) { write_to_dot(stce_9868, stce_9895::start()); }
  void write_to_dot(iterator_t stce_9821, iterator_t stce_9869, const std::string& filename = "tape.dot") {
    stce_9854 stce_9855(filename);
    dco::internal::stce_10316::stce_10318(stce_9821, stce_9869, stce_9893, stce_10356, stce_9855);
  }
  void write_to_csv(const std::string& filename = "tape.csv") {
    write_to_csv(stce_9895::current(), stce_9895::start(), filename);
  }
  void write_to_csv(iterator_t stce_9868) { write_to_csv(stce_9868, stce_9895::start()); }
  void write_to_csv(iterator_t stce_9821, iterator_t stce_9869, const std::string& filename = "tape.csv") {
    if (stce_10356.size() != 0)
      throw dco::exception::create<std::runtime_error>(
          "write_to_csv not implemented for callbacks.",
          "/home/vagrant/builds/xXzkdLpY/0/stce/dco_cpp_make_release/dco_cpp_dev/src/dco_tape.hpp", 785);
    dco::internal::stce_10316::stce_10325(stce_9821, stce_9869, filename);
  }
  void stce_10415(iterator_t const& stce_9821, stce_10355& stce_10416, interpretation_settings const& stce_9953) {
    this->stce_10415(*this, stce_9821, stce_10416, stce_9953);
  }
  template <class stce_10417>
  void stce_10415(stce_10417& stce_10377, const iterator_t& stce_9821, stce_10355& stce_10416,
                  const interpretation_settings& stce_9953) {
    if (stce_10416.stce_10323() != stce_9821)
      throw dco::exception::create<std::runtime_error>(
          "invoking callback at wrong position",
          "/home/vagrant/builds/xXzkdLpY/0/stce/dco_cpp_make_release/dco_cpp_dev/src/dco_tape.hpp", 799);
    if (stce_9953.reset) {
      stce_10284(stce_9821);
      stce_10366<true>();
    }
    index_t vecsize = static_cast<index_t>(dco::helper::vecsize_info<typename types_config_t::stce_9763>::vecsize);
    if (stce_10350) {
      for (index_t stce_10418 = 0; stce_10418 < vecsize; stce_10418++) {
        stce_9950 = stce_10418;
        stce_10416.stce_10324()->_adjoint_vector = &stce_10377;
        stce_10416.stce_10392(*this, stce_9953);
      }
    } else {
      stce_10416.stce_10324()->_adjoint_vector = &stce_10377;
      stce_10416.stce_10392(*this, stce_9953);
    }
  }
  struct stce_10419 {
    tape* stce_9978;
    bool stce_10349;
    stce_10419(tape* stce_10006) : stce_9978(stce_10006), stce_10349(stce_10006->sparse_interpret()) {}
    ~stce_10419() { stce_9978->sparse_interpret() = stce_10349; }
  };
  template <typename stce_10326 = decltype(stce_10348)>
  void stce_9954(iterator_t stce_9821, const iterator_t& stce_9869, const interpretation_settings& stce_9953,
                 stce_10326 const& stce_10327) {
    stce_10351();
    stce_9960(stce_9893, *this, stce_9821, stce_9869, stce_9953, stce_10327);
  }
  template <typename stce_10417, typename stce_10420, typename stce_10326>
  void stce_9960(stce_10417& stce_10377, stce_10420& stce_10421, iterator_t stce_9821, const iterator_t& stce_9869,
                 const interpretation_settings& stce_9953, stce_10326 const& stce_10327) {
    stce_10419 stce_10422(this);
    if (stce_9821 > stce_9895::current()) {
      throw dco::exception::create<std::runtime_error>(
          "you try to use a tape position outside of the current tape.",
          "/home/vagrant/builds/xXzkdLpY/0/stce/dco_cpp_make_release/dco_cpp_dev/src/dco_tape.hpp", 852);
    }
    if (stce_9869 > stce_9821) {
      throw dco::exception::create<std::runtime_error>(
          "adjoint interpretation: from < to.",
          "/home/vagrant/builds/xXzkdLpY/0/stce/dco_cpp_make_release/dco_cpp_dev/src/dco_tape.hpp", 857);
    }
    for (int stce_9841 = static_cast<int>(stce_10356.size() - 1);
         stce_9841 >= 0 && stce_9869 <= stce_10356[stce_9841].stce_10323(); --stce_9841) {
      const iterator_t& stce_10423 = stce_10356[stce_9841].stce_10323();
      if (stce_9821 < stce_10423) {
        continue;
      }
      stce_9895::stce_10194(stce_9821);
      if (stce_9953.stce_9913)
        stce_10353(stce_9821, stce_10423, stce_10377, stce_10327);
      else {
        stce_10352(stce_9821, stce_10423, stce_10377, stce_10327);
      }
      stce_9821 = stce_10423;
      stce_9895::stce_10195();
      stce_10415(stce_10421, stce_9821, stce_10356[stce_9841], stce_9953);
      if (stce_9953.reset) {
        stce_10284(stce_9821);
        stce_10356[stce_9841].stce_10357();
        stce_10356.erase(stce_10356.begin() + stce_9841);
      }
    }
    stce_9895::stce_10194(stce_9821);
    if (stce_9953.stce_9913) {
      stce_10353(stce_9821, stce_9869, stce_10377, stce_10327);
    } else {
      stce_10352(stce_9821, stce_9869, stce_10377, stce_10327);
    }
    if (stce_9953.reset) {
      stce_10284(stce_9821);
    }
    stce_9895::stce_10195();
  }
};
template <memory_model::TYPE MEMORY_MODEL, typename stce_10342, memory_model::TYPE stce_9788>
const typename tape<MEMORY_MODEL, stce_10342, stce_9788>::stce_10347
    tape<MEMORY_MODEL, stce_10342, stce_9788>::stce_10348;
} // namespace internal
} // namespace dco
namespace dco {
template <class stce_9781, class stce_9760 = stce_9781, class stce_9761 = stce_9760,
          memory_model::TYPE MEMORY_MODEL = DCO_TAPE_MEMORY_MODEL>
class ga1sm_mod {
  typedef types_config_t<stce_9781, stce_9760, stce_9761> stce_10137;

public:
  typedef dco::internal::stce_10139<ga1sm_mod> data_t;
  static const memory_model::TYPE TAPE_MODEL = memory_model::stce_9769;
  static const memory_model::TYPE stce_10424 = MEMORY_MODEL;
  typedef typename stce_10137::value_t value_t;
  typedef typename stce_10137::value_t active_value_t;
  typedef value_t scalar_value_t;
  typedef typename stce_10137::stce_9763 derivative_t;
  typedef derivative_t stce_9975;
  typedef typename mode<value_t>::passive_t passive_t;
  typedef typename mode<value_t>::scalar_passive_t scalar_passive_t;
  typedef dco::internal::active_type<value_t, data_t> type;
  typedef type active_t;
  static const bool is_dco_type = true;
  static const bool is_adjoint_type = true;
  static const bool is_tangent_type = false;
  static const bool stce_10138 = false;
  static const int order = dco::mode<stce_9781>::order + 1;
  static const size_t p1f_size = 0;
  typedef dco::internal::tape<TAPE_MODEL, stce_10137, stce_10424> tape_t;
  typedef typename internal::stce_10067<type> local_gradient_t;
  typedef dco::helper::stce_10004<tape_t> callback_object_t;
  typedef dco::helper::stce_10010<type, tape_t> userdata_object_t;
  typedef dco::helper::stce_10028<type, tape_t> external_adjoint_object_t;
  typedef internal::jacobian_preaccumulator_t<type> jacobian_preaccumulator_t;
};
} // namespace dco

namespace dco {
template <class stce_9781, class stce_9760 = stce_9781, class stce_9761 = stce_9760,
          memory_model::TYPE MEMORY_MODEL = DCO_TAPE_MEMORY_MODEL>
class ga1s_mod {
  typedef types_config_t<stce_9781, stce_9760, stce_9761> stce_10137;

public:
  static const memory_model::TYPE TAPE_MODEL = memory_model::stce_9769;
  static const memory_model::TYPE stce_10424 = MEMORY_MODEL;
  typedef dco::internal::stce_10132<ga1s_mod> data_t;
  typedef typename stce_10137::value_t value_t;
  typedef typename stce_10137::value_t active_value_t;
  typedef value_t scalar_value_t;
  typedef typename stce_10137::stce_9763 derivative_t;
  typedef derivative_t stce_9975;
  typedef typename mode<value_t>::passive_t passive_t;
  typedef typename mode<value_t>::scalar_passive_t scalar_passive_t;
  typedef dco::internal::active_type<value_t, data_t> type;
  typedef type active_t;
  static const bool is_dco_type = true;
  static const bool is_adjoint_type = true;
  static const bool is_tangent_type = false;
  static const bool stce_10138 = false;
  static const int order = dco::mode<stce_9781>::order + 1;
  static const size_t p1f_size = 0;
  typedef dco::internal::tape<TAPE_MODEL, stce_10137, stce_10424> tape_t;
  static DCOi_THREAD_LOCAL tape_t* global_tape;
  typedef typename internal::stce_10067<type> local_gradient_t;
  typedef dco::helper::stce_10004<tape_t> callback_object_t;
  typedef dco::helper::stce_10010<type, tape_t> userdata_object_t;
  typedef dco::helper::stce_10028<type, tape_t> external_adjoint_object_t;
  typedef internal::jacobian_preaccumulator_t<type> jacobian_preaccumulator_t;
};
template <class stce_9781, class stce_9760, class stce_9761, memory_model::TYPE MEMORY_MODEL>
DCOi_THREAD_LOCAL typename ga1s_mod<stce_9781, stce_9760, stce_9761, MEMORY_MODEL>::tape_t*
    ga1s_mod<stce_9781, stce_9760, stce_9761, MEMORY_MODEL>::global_tape = 0;
} // namespace dco

namespace dco {
template <typename stce_9781, const size_t stce_10425 = 1, typename stce_9760 = stce_9781,
          typename stce_9761 = stce_9760, memory_model::TYPE MEMORY_MODEL = DCO_TAPE_MEMORY_MODEL>
class ga1v {
  typedef types_config_t<stce_9781, stce_9760, dco::helper::valvec<stce_9761, stce_10425>> stce_10137;

public:
  typedef ga1v mode_t;
  typedef dco::internal::stce_10132<ga1v> data_t;
  static const memory_model::TYPE TAPE_MODEL = MEMORY_MODEL;
  typedef typename stce_10137::value_t value_t;
  typedef typename stce_10137::value_t active_value_t;
  typedef value_t scalar_value_t;
  typedef typename stce_10137::stce_9763 derivative_t;
  typedef stce_9761 stce_9975;
  typedef typename mode<value_t>::passive_t passive_t;
  typedef typename mode<value_t>::scalar_passive_t scalar_passive_t;
  typedef dco::internal::active_type<value_t, data_t> type;
  typedef type active_t;
  static const bool is_dco_type = true;
  static const bool is_adjoint_type = true;
  static const bool is_tangent_type = false;
  static const bool stce_10138 = true;
  static const int order = dco::mode<stce_9781>::order + 1;
  static const size_t p1f_size = 0;
  typedef internal::tape<TAPE_MODEL, stce_10137> tape_t;
  static DCOi_THREAD_LOCAL tape_t* global_tape;
  typedef typename internal::stce_10067<type> local_gradient_t;
  typedef dco::helper::stce_10004<tape_t> callback_object_t;
  typedef dco::helper::stce_10010<type, tape_t> userdata_object_t;
  typedef dco::helper::stce_10028<type, tape_t> external_adjoint_object_t;
  typedef internal::jacobian_preaccumulator_t<type> jacobian_preaccumulator_t;
};
template <typename stce_9781, const size_t stce_10425, typename stce_9760, typename stce_9761,
          memory_model::TYPE MEMORY_MODEL>
DCOi_THREAD_LOCAL typename ga1v<stce_9781, stce_10425, stce_9760, stce_9761, MEMORY_MODEL>::tape_t*
    ga1v<stce_9781, stce_10425, stce_9760, stce_9761, MEMORY_MODEL>::global_tape;
} // namespace dco

namespace dco {
template <typename stce_9781, const size_t stce_10425 = 1, typename stce_9760 = stce_9781,
          typename stce_9761 = stce_9760, memory_model::TYPE MEMORY_MODEL = DCO_TAPE_MEMORY_MODEL>
class ga1vm {
  typedef types_config_t<stce_9781, stce_9760, dco::helper::valvec<stce_9761, stce_10425>> stce_10137;

public:
  typedef dco::internal::stce_10139<ga1vm> data_t;
  static const memory_model::TYPE TAPE_MODEL = MEMORY_MODEL;
  typedef typename stce_10137::value_t value_t;
  typedef typename stce_10137::value_t active_value_t;
  typedef value_t scalar_value_t;
  typedef typename stce_10137::stce_9763 derivative_t;
  typedef stce_9761 stce_9975;
  typedef typename mode<value_t>::passive_t passive_t;
  typedef typename mode<value_t>::scalar_passive_t scalar_passive_t;
  typedef dco::internal::active_type<value_t, data_t> type;
  typedef type active_t;
  static const bool is_dco_type = true;
  static const bool is_adjoint_type = true;
  static const bool is_tangent_type = false;
  static const bool stce_10138 = true;
  static const int order = dco::mode<stce_9781>::order + 1;
  static const size_t p1f_size = 0;
  typedef internal::tape<TAPE_MODEL, stce_10137> tape_t;
  typedef typename internal::stce_10067<type> local_gradient_t;
  typedef dco::helper::stce_10004<tape_t> callback_object_t;
  typedef dco::helper::stce_10010<type, tape_t> userdata_object_t;
  typedef dco::helper::stce_10028<type, tape_t> external_adjoint_object_t;
  typedef internal::jacobian_preaccumulator_t<type> jacobian_preaccumulator_t;
};
} // namespace dco

namespace dco {
template <typename stce_9781, const size_t stce_10425 = 1, typename stce_9760 = stce_9781,
          typename stce_9761 = stce_9760, memory_model::TYPE MEMORY_MODEL = DCO_TAPE_MEMORY_MODEL>
class ga1vm_mod {
  typedef types_config_t<stce_9781, stce_9760, dco::helper::valvec<stce_9761, stce_10425>> stce_10137;

public:
  typedef dco::internal::stce_10139<ga1vm_mod> data_t;
  static const memory_model::TYPE TAPE_MODEL = memory_model::stce_9769;
  static const memory_model::TYPE stce_10424 = MEMORY_MODEL;
  typedef typename stce_10137::value_t value_t;
  typedef typename stce_10137::value_t active_value_t;
  typedef value_t scalar_value_t;
  typedef typename stce_10137::stce_9763 derivative_t;
  typedef typename derivative_t::value_t stce_9975;
  typedef typename mode<value_t>::passive_t passive_t;
  typedef typename mode<value_t>::scalar_passive_t scalar_passive_t;
  typedef dco::internal::active_type<value_t, data_t> type;
  typedef type active_t;
  static const bool is_dco_type = true;
  static const bool is_adjoint_type = true;
  static const bool is_tangent_type = false;
  static const bool stce_10138 = true;
  static const int order = dco::mode<stce_9781>::order + 1;
  static const size_t p1f_size = 0;
  typedef dco::internal::tape<TAPE_MODEL, stce_10137, stce_10424> tape_t;
  typedef typename internal::stce_10067<type> local_gradient_t;
  typedef dco::helper::stce_10004<tape_t> callback_object_t;
  typedef dco::helper::stce_10010<type, tape_t> userdata_object_t;
  typedef dco::helper::stce_10028<type, tape_t> external_adjoint_object_t;
  typedef internal::jacobian_preaccumulator_t<type> jacobian_preaccumulator_t;
};
} // namespace dco

namespace dco {
template <typename stce_9781, const size_t stce_10425 = 1, typename stce_9760 = stce_9781,
          typename stce_9761 = stce_9760, memory_model::TYPE MEMORY_MODEL = DCO_TAPE_MEMORY_MODEL>
class ga1v_mod {
  typedef types_config_t<stce_9781, stce_9760, dco::helper::valvec<stce_9761, stce_10425>> stce_10137;

public:
  typedef dco::internal::stce_10132<ga1v_mod> data_t;
  static const memory_model::TYPE TAPE_MODEL = memory_model::stce_9769;
  static const memory_model::TYPE stce_10424 = MEMORY_MODEL;
  typedef typename stce_10137::value_t value_t;
  typedef value_t scalar_value_t;
  typedef typename stce_10137::value_t active_value_t;
  typedef typename stce_10137::stce_9763 derivative_t;
  typedef typename derivative_t::value_t stce_9975;
  typedef typename mode<value_t>::passive_t passive_t;
  typedef typename mode<value_t>::scalar_passive_t scalar_passive_t;
  typedef dco::internal::active_type<value_t, data_t> type;
  typedef type active_t;
  static const bool is_dco_type = true;
  static const bool is_adjoint_type = true;
  static const bool is_tangent_type = false;
  static const bool stce_10138 = true;
  static const int order = dco::mode<stce_9781>::order + 1;
  static const size_t p1f_size = 0;
  typedef dco::internal::tape<TAPE_MODEL, stce_10137, stce_10424> tape_t;
  static DCOi_THREAD_LOCAL tape_t* global_tape;
  typedef typename internal::stce_10067<type> local_gradient_t;
  typedef dco::helper::stce_10004<tape_t> callback_object_t;
  typedef dco::helper::stce_10010<type, tape_t> userdata_object_t;
  typedef dco::helper::stce_10028<type, tape_t> external_adjoint_object_t;
  typedef internal::jacobian_preaccumulator_t<type> jacobian_preaccumulator_t;
};
template <typename stce_9781, const size_t stce_10425, typename stce_9760, typename stce_9761,
          memory_model::TYPE MEMORY_MODEL>
DCOi_THREAD_LOCAL typename ga1v_mod<stce_9781, stce_10425, stce_9760, stce_9761, MEMORY_MODEL>::tape_t*
    ga1v_mod<stce_9781, stce_10425, stce_9760, stce_9761, MEMORY_MODEL>::global_tape;
} // namespace dco

namespace dco {
template <typename active_t, typename stce_10426 = void> struct gbcp;
template <typename stce_9974>
struct gbcp<stce_9974, typename dco::enable_if<(dco::mode<stce_9974>::is_dco_type &&
                                                !internal::is_gbcp_type<stce_9974>::value)>::type> {
  typedef stce_9974 binary_t;
  typedef typename dco::mode<binary_t>::value_t active_t;
  typedef active_t active_value_t;
  typedef typename dco::mode<active_value_t>::value_t value_t;
  typedef typename dco::mode<active_value_t>::scalar_value_t scalar_value_t;
  typedef typename mode<active_value_t>::passive_t passive_t;
  typedef typename mode<active_value_t>::scalar_passive_t scalar_passive_t;
  typedef internal::jacobian_preaccumulator_t<void> jacobian_preaccumulator_t;
  typedef dco::internal::stce_9903<gbcp> data_t;
  typedef dco::internal::active_type<active_value_t, data_t> type;
  static const bool is_dco_type = true;
  static const bool is_adjoint_type = dco::mode<active_value_t>::is_adjoint_type;
  static const bool is_tangent_type = dco::mode<active_value_t>::is_tangent_type;
  static const bool stce_10138 = dco::mode<active_value_t>::stce_10138;
  static const int gbcp_order = 1;
  static const int order = dco::mode<binary_t>::order - 1;
  static const size_t p1f_size = 0;
};
template <typename stce_10427>
struct gbcp<stce_10427, typename dco::enable_if<(dco::mode<stce_10427>::is_dco_type &&
                                                 internal::is_gbcp_type<stce_10427>::value)>::type> {
  typedef stce_10427 binary_t;
  typedef typename dco::mode<binary_t>::active_t active_t;
  typedef typename dco::mode<binary_t>::active_value_t active_value_t;
  typedef typename dco::mode<binary_t>::value_t value_t;
  typedef typename dco::mode<binary_t>::scalar_value_t scalar_value_t;
  typedef typename dco::mode<binary_t>::passive_t passive_t;
  typedef typename dco::mode<binary_t>::scalar_passive_t scalar_passive_t;
  typedef dco::internal::stce_9903<gbcp> data_t;
  typedef dco::internal::active_type<active_value_t, data_t> type;
  typedef internal::jacobian_preaccumulator_t<void> jacobian_preaccumulator_t;
  static const bool is_dco_type = true;
  static const bool is_adjoint_type = dco::mode<binary_t>::is_adjoint_type;
  static const bool is_tangent_type = dco::mode<binary_t>::is_tangent_type;
  static const int gbcp_order = dco::mode<binary_t>::gbcp_order + 1;
  static const int order = dco::mode<binary_t>::order - 1;
};
template <typename stce_9967>
struct gbcp<stce_9967, typename dco::enable_if<(!dco::mode<stce_9967>::is_dco_type)>::type> {
  typedef internal::jacobian_preaccumulator_t<void> jacobian_preaccumulator_t;
  typedef stce_9967 binary_t;
  typedef binary_t active_t;
  typedef binary_t active_value_t;
  typedef binary_t value_t;
  typedef binary_t scalar_value_t;
  typedef binary_t passive_t;
  typedef typename dco::mode<binary_t>::scalar_passive_t scalar_passive_t;
  typedef binary_t type;
  static const bool is_dco_type = true;
  static const bool is_adjoint_type = false;
  static const bool is_tangent_type = false;
  static const int gbcp_order = 1;
  static const int order = 0;
};
} // namespace dco

namespace dco {
template <typename stce_9781, size_t stce_10428 = 32> struct gp1f {
  typedef stce_9781 value_t;
  typedef value_t scalar_value_t;
  typedef typename mode<value_t>::passive_t passive_t;
  typedef typename mode<value_t>::scalar_passive_t scalar_passive_t;
  static const size_t p1f_size = stce_10428;
  typedef internal::stce_10312<gp1f> data_t;
  typedef internal::active_type<double, data_t> type;
  typedef typename data_t::derivative_t derivative_t;
  static const bool is_dco_type = true;
  static const bool is_intermediate_type = false;
  static const int order = dco::mode<stce_9781>::order + 1;
};
} // namespace dco

namespace dco {
namespace internal {
template <typename stce_10072> struct stce_10429 {
  typedef stce_10072 mode_t;
  index_t tape_index;
  stce_10429() : tape_index(0) {}
  void clear() { tape_index = 0; }
  typedef typename mode_t::value_t stce_9770;

private:
  template <class stce_10119>
  static void interpret(const dco::internal::active_type<stce_9770, stce_10119>& stce_9803, bool stce_10430) {
    (void)stce_10430;
    stce_10072::global_tape->stce_10431[stce_10072::global_tape->stce_10432] = stce_9803.tape_index;
    stce_10072::global_tape->stce_10432++;
  }
  template <class stce_10121, class stce_10122, class stce_10123>
  static void interpret(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803,
                        bool stce_10430) {
    interpret(stce_9803.stce_10125, stce_10430);
    interpret(stce_9803.stce_10127, stce_10430);
  }
  template <class stce_10129, class stce_10123>
  static void interpret(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_9803, bool stce_10430) {
    interpret(stce_9803.stce_10130, stce_10430);
  }
  template <class stce_10121, class stce_10122, class stce_10123>
  static void interpret(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803,
                        bool stce_10430) {
    interpret(stce_9803.stce_10125, stce_10430);
  }
  template <class stce_10121, class stce_10122, class stce_10123>
  static void interpret(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803,
                        bool stce_10430) {
    interpret(stce_9803.stce_10127, stce_10430);
  }

protected:
  template <class stce_9904, class stce_9792> static void stce_9905(const stce_9904& stce_9901, stce_9792& stce_10433) {
    const int stce_10434 = stce_10072::global_tape->stce_10432;
    interpret(stce_9901, false);
    stce_10429& data = const_cast<stce_10429&>(stce_10433);
    if (stce_10434 == stce_10072::global_tape->stce_10432) {
      data.clear();
    } else {
      stce_10072::global_tape->stce_10435++;
      data.tape_index = stce_10072::global_tape->stce_10435;
      stce_10072::global_tape->stce_10436[stce_10072::global_tape->stce_10435].stce_10437 =
          stce_10072::global_tape->stce_10432 - stce_10434;
      stce_10072::global_tape->stce_10436[stce_10072::global_tape->stce_10435].stce_10434 = stce_10434;
    }
  }
  template <class stce_9904> void stce_9905(const stce_9904& stce_9901) { stce_9905(stce_9901, *this); }
};
} // namespace internal
} // namespace dco
namespace dco {
namespace internal {
template <typename stce_9770> struct stce_10438 {
private:
  template <typename stce_10072> friend struct stce_10429;
  struct stce_10439 {
    index_t stce_10437;
    index_t stce_10434;
  };
  stce_10439* stce_10436;
  index_t stce_10435;
  int* stce_10431;
  index_t stce_10432;
  stce_10438(const stce_10438<stce_9770>&) {
    throw dco::exception::create<std::runtime_error>(
        "dco_error: Not implemented yet! Please report, why needed!",
        "/home/vagrant/builds/xXzkdLpY/0/stce/dco_cpp_make_release/dco_cpp_dev/src/dco_tape_blob_pattern.hpp", 32);
  }
  stce_10438(index_t stce_10437, index_t stce_10440) {
    stce_10436 = new stce_10439[stce_9752(stce_10440)];
    stce_10435 = 0;
    stce_10431 = new int[size_t(stce_10437)];
    stce_10432 = 0;
  }
  ~stce_10438() {
    if (stce_10436)
      delete[] stce_10436;
    if (stce_10431)
      delete[] stce_10431;
  }

public:
  struct stce_10441 {
    friend struct stce_10438<stce_9770>;

  private:
    index_t stce_10442;
    index_t stce_10443;
    stce_10441(index_t stce_10444, index_t stce_10445) : stce_10442(stce_10444), stce_10443(stce_10445) {}

  public:
    stce_10441() : stce_10442(0), stce_10443(0){};
    index_t stce_10446() { return stce_10442; }
    index_t stce_10447() {
      if (stce_10443 < 0)
        return -stce_10443;
      return stce_10443;
    }
    bool stce_10430() { return stce_10443 < 0; }
  };
  struct iterator_t {
  private:
    index_t _progvarcounter;

  public:
    index_t stce_10440() const { return _progvarcounter; }
    iterator_t(const index_t stce_10448) : _progvarcounter(stce_10448) {}
  };
  iterator_t get_position() { return iterator_t(stce_10435); }
  typedef std::vector<stce_10441> sparse_jacobi;
  template <class stce_9781>
  sparse_jacobi* build_pattern(stce_9781* stce_10446, index_t stce_10023, const iterator_t& stce_10449) {
    sparse_jacobi* stce_9843 = new sparse_jacobi();
    for (index_t stce_9841 = 0; stce_9841 < stce_10023; ++stce_9841) {
      stce_10450(stce_9841 + 1, stce_10446[stce_9841].tape_index, stce_10449, stce_9843);
    }
    return stce_9843;
  }
  void create_pattern_file(sparse_jacobi* stce_10451, std::string filename) {
    std::ofstream out(filename.c_str());
    for (size_t stce_9841 = 0; stce_9841 < stce_10451->size(); ++stce_9841) {
      stce_10441& stce_10452 = (*stce_10451)[stce_9841];
      out << stce_10452.stce_10446() << " " << stce_10452.stce_10447() << " 1" << std::endl;
    }
    out.close();
  }
  void stce_10453(std::string filename) {
    std::ofstream out(filename.c_str());
    out << "digraph {" << std::endl;
    for (index_t stce_9841 = 1; stce_9841 <= stce_10435; ++stce_9841) {
      out << stce_9841 << std::endl;
    }
    for (index_t stce_9841 = 1; stce_9841 <= stce_10435; ++stce_9841) {
      int stce_10437 = stce_10436[stce_9841].stce_10437;
      int stce_10454 = stce_10436[stce_9841].stce_10434;
      for (int stce_10455 = 0; stce_10455 < stce_10437; ++stce_10455) {
        int stce_10175 = stce_10431[stce_10455 + stce_10454];
        out << stce_9841 << " -> " << stce_10175 << std::endl;
      }
    }
    out << "}" << std::endl;
    out.close();
  }
  void stce_10450(index_t stce_10444, index_t stce_9863, const iterator_t& stce_10449, sparse_jacobi* stce_10456) {
    if (stce_9863 == 0)
      return;
    if (stce_9863 <= stce_10449.stce_10440()) {
      stce_10456->push_back(stce_10441(stce_10444, stce_9863));
    } else {
      index_t stce_10437 = stce_10436[stce_9863].stce_10437;
      index_t stce_10454 = stce_10436[stce_9863].stce_10434;
      for (int stce_9841 = 0; stce_9841 < stce_10437; ++stce_9841) {
        stce_10450(stce_10444, stce_10431[stce_9841 + stce_10454], stce_10449, stce_10456);
      }
    }
  }
  static stce_10438* create(index_t size, index_t stce_10457 = 0) {
    if (stce_10457 == 0)
      stce_10457 = size / 2;
    return new stce_10438(size, stce_10457);
  }
  static void remove(stce_10438*& tape) {
    delete tape;
    tape = 0;
  }
  template <class stce_10119> void register_variable(dco::internal::active_type<stce_9770, stce_10119>& stce_10458) {
    stce_10119& data = stce_10458.data();
    stce_10435++;
    data.tape_index = stce_10435;
  }
};
} // namespace internal
} // namespace dco
namespace dco {
template <typename stce_9781 = double> struct gp1t {
  typedef stce_9781 value_t;
  typedef value_t scalar_value_t;
  typedef typename mode<value_t>::passive_t passive_t;
  typedef typename mode<value_t>::scalar_passive_t scalar_passive_t;
  typedef typename internal::stce_10438<stce_9781> tape_t;
  static DCOi_THREAD_LOCAL tape_t* global_tape;
  typedef internal::stce_10429<gp1t> data_t;
  typedef internal::active_type<stce_9781, data_t> type;
  static const bool is_dco_type = true;
  static const bool is_intermediate_type = false;
  static const int order = dco::mode<stce_9781>::order + 1;
  static const size_t p1f_size = 0;
};
template <class stce_9781> DCOi_THREAD_LOCAL typename gp1t<stce_9781>::tape_t* gp1t<stce_9781>::global_tape = 0;
} // namespace dco

namespace dco {
namespace internal {
template <typename, typename, typename enable_if = void> struct stce_10459 {
  template <typename stce_9873, typename stce_10374>
  static auto get(stce_9873&& stce_9803, stce_10374&& pval) -> decltype(stce_9803.stce_10460 * pval) {
    return stce_9803.stce_10460 * pval;
  }
};
template <typename stce_10461, typename stce_10072>
struct stce_10459<
    stce_10461, stce_10072,
    typename std::enable_if<std::is_base_of<typename stce_10461::data_t,
                                            internal::stce_10312<typename stce_10461::data_t::mode_t>>::value>::type> {
  template <typename stce_9873, typename stce_10374>
  static typename stce_10072::derivative_t get(stce_9873&& stce_9803, stce_10374&& pval) {
    return (stce_9803.stce_10460 == 0) ? static_cast<typename stce_10072::derivative_t>(0.0)
                                       : stce_9803.stce_10460 * (pval == 0 ? pval + 1 : pval);
  }
};
template <typename stce_10072> struct stce_10462 {
  typedef stce_10072 mode_t;
  typedef stce_10078 stce_10134;
  typedef typename mode_t::derivative_t derivative_t;
  mutable derivative_t stce_10460;
  stce_10462() : stce_10460(0.0) {}
  DCO_STRONG_INLINE stce_10462(const stce_10462& stce_10075) : stce_10460(stce_10075.stce_10460) {}
  stce_10462& operator=(const stce_10462& stce_10075) {
    stce_10460 = stce_10075.stce_10460;
    return *this;
  }
  void stce_10076(const derivative_t& stce_9753) { stce_10460 = stce_9753; }
  void stce_9956(derivative_t& stce_9753) const { stce_9753 = stce_10460; }
  void clear() { stce_10460 = 0.0; }
  derivative_t& stce_9963() const {
    stce_1000002();
    ;
    return stce_10460;
  }
  template <class stce_9904> void stce_9905(const stce_9904& stce_10135) {
    stce_10460 = stce_10463(stce_10135, static_cast<derivative_t>(1.0));
  }
  template <class stce_9770, class stce_10119>
  static derivative_t stce_10463(const dco::internal::active_type<stce_9770, stce_10119>& stce_9803,
                                 const derivative_t& pval) {
    return stce_10459<dco::mode<typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::value_t>,
                      stce_10072>::get(stce_9803, pval);
  }
  template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
  static derivative_t
  stce_10463(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803,
             const derivative_t& pval) {
    return stce_10463(stce_9803.stce_10125, stce_9803.stce_10126() * pval) +
           stce_10463(stce_9803.stce_10127, stce_9803.stce_10128() * pval);
  }
  template <class stce_9770, class stce_10129, class stce_10123>
  static derivative_t stce_10463(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_9803,
                                 const derivative_t& pval) {
    return stce_10463(stce_9803.stce_10130, stce_9803.pval() * pval);
  }
  template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
  static derivative_t
  stce_10463(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803,
             const derivative_t& pval) {
    return stce_10463(stce_9803.stce_10125, stce_9803.stce_10126() * pval);
  }
  template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
  static derivative_t
  stce_10463(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803,
             const derivative_t& pval) {
    return stce_10463(stce_9803.stce_10127, stce_9803.stce_10128() * pval);
  }
  typedef void tape_t;
  typedef index_t stce_10464;
  void* tape() const { return NULL; }
  index_t _tape_index() const { return 0; }
};
} // namespace internal
} // namespace dco
namespace dco {
template <class stce_9781, typename stce_10465 = stce_9781> class gt1s {
public:
  typedef gt1s mode_t;
  typedef dco::internal::stce_10462<gt1s> data_t;
  typedef stce_9781 value_t;
  typedef stce_9781 active_value_t;
  typedef stce_9781 scalar_value_t;
  typedef stce_10465 derivative_t;
  typedef stce_10465 stce_9975;
  typedef typename mode<value_t>::passive_t passive_t;
  typedef typename mode<value_t>::scalar_passive_t scalar_passive_t;
  typedef dco::internal::active_type<stce_9781, data_t> type;
  typedef type active_t;
  static const bool is_dco_type = true;
  static const bool is_adjoint_type = false;
  static const bool is_tangent_type = true;
  static const bool stce_10138 = false;
  static const int order = dco::mode<stce_9781>::order + 1;
  static const size_t p1f_size = 0;
  typedef void tape_t;
  typedef void local_gradient_t;
  typedef void external_adjoint_object_t;
  typedef internal::jacobian_preaccumulator_t<void> jacobian_preaccumulator_t;
};
} // namespace dco

namespace dco {
namespace internal {
template <typename stce_10072> struct stce_10466 {
  typedef stce_10072 mode_t;
  typedef stce_10078 stce_10134;
  typedef typename mode_t::derivative_t derivative_t;
  typedef typename derivative_t::value_t stce_9975;

protected:
  typedef typename mode_t::value_t stce_9770;

public:
  static const int vecsize = derivative_t::stce_9837;
  mutable bool stce_10467;
  mutable derivative_t tlms;
  stce_10466() : stce_10467(false) {
    for (int stce_9841 = 0; stce_9841 < vecsize; ++stce_9841)
      tlms[stce_9841] = 0;
  }
  void stce_10076(const stce_9975& stce_9753, const int stce_10468) {
    if (!stce_10467) {
      stce_10467 = true;
    }
    tlms[stce_10468] = stce_9753;
  }
  derivative_t& stce_9963() const {
    stce_1000002();
    ;
    stce_10467 = true;
    return tlms;
  }
  void stce_9956(stce_9975& stce_9753, const int stce_10468) const {
    stce_1000002();
    ;
    if (stce_10467) {
      stce_9753 = tlms[stce_10468];
    } else {
      stce_9753 = 0;
    }
  }
  void clear() {
    for (int stce_9841 = 0; stce_9841 < vecsize; ++stce_9841) {
      tlms[stce_9841] = 0.0;
    }
  }
  template <class stce_9904> DCO_ALWAYS_INLINE void stce_9905(const stce_9904& stce_10135) {
    bool stce_10469 = this->stce_10470(stce_10135);
    if (stce_10469) {
      derivative_t stce_10471{};
      stce_10463(stce_10471, stce_10135, 1.0);
      tlms = stce_10471;
      stce_10467 = true;
    } else {
      stce_10467 = false;
    }
  }
  template <class stce_10119>
  static DCO_ALWAYS_INLINE void stce_10463(derivative_t& tlms,
                                           const dco::internal::active_type<stce_9770, stce_10119>& stce_9803,
                                           const stce_9975& pval) {
    if (stce_9803.stce_10467) {
      tlms += stce_9803.tlms * pval;
    }
  }
  template <class stce_10121, class stce_10122, class stce_10123>
  static DCO_ALWAYS_INLINE void
  stce_10463(derivative_t& tlms,
             const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803,
             const stce_9975& pval) {
    stce_10463(tlms, stce_9803.stce_10125, stce_9803.stce_10126() * pval);
    stce_10463(tlms, stce_9803.stce_10127, stce_9803.stce_10128() * pval);
  }
  template <class stce_10129, class stce_10123>
  static DCO_ALWAYS_INLINE void stce_10463(derivative_t& tlms,
                                           const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_9803,
                                           const stce_9975& pval) {
    stce_10463(tlms, stce_9803.stce_10130, stce_9803.pval() * pval);
  }
  template <class stce_10121, class stce_10122, class stce_10123>
  static DCO_ALWAYS_INLINE void
  stce_10463(derivative_t& tlms,
             const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803,
             const stce_9975& pval) {
    stce_10463(tlms, stce_9803.stce_10125, stce_9803.stce_10126() * pval);
  }
  template <class stce_10121, class stce_10122, class stce_10123>
  static DCO_ALWAYS_INLINE void
  stce_10463(derivative_t& tlms,
             const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803,
             const stce_9975& pval) {
    stce_10463(tlms, stce_9803.stce_10127, stce_9803.stce_10128() * pval);
  }
  template <class stce_10119>
  static bool stce_10470(const dco::internal::active_type<stce_9770, stce_10119>& stce_9803) {
    return stce_9803.stce_10467;
  }
  template <class stce_10121, class stce_10122, class stce_10123>
  static bool stce_10470(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
    return stce_10470(stce_9803.stce_10125) || stce_10470(stce_9803.stce_10127);
  }
  template <class stce_10129, class stce_10123>
  static bool stce_10470(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_9803) {
    return stce_10470(stce_9803.stce_10130);
  }
  template <class stce_10121, class stce_10122, class stce_10123>
  static bool stce_10470(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
    return stce_10470(stce_9803.stce_10125);
  }
  template <class stce_10121, class stce_10122, class stce_10123>
  static bool stce_10470(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
    return stce_10470(stce_9803.stce_10127);
  }
  typedef void stce_10472;
  typedef void tape_t;
  typedef index_t stce_10464;
  void* tape() const { return NULL; }
  index_t _tape_index() const { return 0; }
};
} // namespace internal
} // namespace dco
namespace dco {
template <class stce_9781, size_t stce_10473 = 1, typename stce_10465 = stce_9781> class gt1v {
public:
  typedef gt1v mode_t;
  typedef dco::internal::stce_10466<gt1v> data_t;
  typedef stce_9781 value_t;
  typedef stce_9781 active_value_t;
  typedef value_t scalar_value_t;
  typedef dco::helper::valvec<stce_10465, stce_10473> derivative_t;
  typedef stce_10465 stce_9975;
  typedef typename mode<value_t>::passive_t passive_t;
  typedef typename mode<value_t>::scalar_passive_t scalar_passive_t;
  typedef dco::internal::active_type<stce_9781, data_t> type;
  typedef type active_t;
  static const bool is_dco_type = true;
  static const bool is_adjoint_type = false;
  static const bool is_tangent_type = true;
  static const bool stce_10138 = true;
  static const int order = dco::mode<stce_9781>::order + 1;
  static const size_t p1f_size = 0;
  typedef void tape_t;
  typedef void local_gradient_t;
  typedef void external_adjoint_object_t;
  typedef internal::jacobian_preaccumulator_t<void> jacobian_preaccumulator_t;
};
} // namespace dco

namespace dco {
namespace internal {
template <typename stce_10072, size_t stce_10474 = 2> class stce_10475 : public stce_10073<stce_10072> {
  typedef stce_10073<stce_10072> stce_10133;

public:
  typedef stce_10072 mode_t;
  typedef stce_10102<typename stce_10072::tape_t, stce_10072::global_tape> stce_10134;
  typedef typename stce_10072::tape_t tape_t;
  typedef typename tape_t::stce_9763 derivative_t;
  mutable derivative_t stce_10116;
  mutable derivative_t stce_10290[stce_10474];
  void stce_10476(const derivative_t& value, const double& stce_10117) const {
    if (stce_10072::global_tape->stce_10265 == 0)
      this->stce_10290[0] = this->stce_10290[1] = value;
    stce_10072::global_tape->stce_10286(this, stce_10117);
    stce_10116 = stce_10117;
  }

public:
  stce_10475() : stce_10116(0) {
    for (size_t stce_9841 = 0; stce_9841 < stce_10474; ++stce_9841)
      stce_10290[stce_9841] = 0;
  }
  DCO_STRONG_INLINE stce_10475(const stce_10475& stce_10075)
      : stce_10133(stce_10075), stce_10116(stce_10075.stce_10116) {
    for (size_t stce_9841 = 0; stce_9841 < stce_10474; ++stce_9841)
      stce_10290[stce_9841] = stce_10075.stce_10290[stce_9841];
  }
  DCO_STRONG_INLINE stce_10475& operator=(const stce_10475& stce_9803) {
    stce_10133::operator=(static_cast<const stce_10133&>(stce_9803));
    stce_10116 = stce_9803.stce_10116;
    return *this;
  }
  inline void clear() {
    stce_10133::clear();
    stce_10116 = 0;
  }
  template <class stce_10061> DCO_STRONG_INLINE void stce_10071(const stce_10061& value, const double& stce_10117) {
    stce_10476(value, stce_10117);
  }
  template <typename stce_10077>
  static DCO_STRONG_INLINE void register_variable(stce_10077& stce_9803, index_t index, tape_t* tape) {
    stce_10133::register_variable(stce_9803, index, tape);
    stce_9803.stce_10476(trait_value<stce_10077>::value(stce_9803), stce_9820());
  }
  const derivative_t& stce_10104(const derivative_t& value, const int stce_9806) const {
    if (this->stce_10074 == 0)
      return value;
    return stce_10290[stce_9806];
  }
  template <class stce_9904> DCO_ALWAYS_INLINE void stce_9905(const stce_9904& stce_10135) {
    if (!stce_10072::global_tape || !stce_10072::global_tape->is_active()) {
      clear();
      return;
    }
    {
      using namespace folding;
      stce_10114<tape_t> stce_10136(stce_10072::global_tape);
      interpret(stce_10135, stce_10136);
      this->stce_10074 = stce_10136.index();
      if (this->stce_10074 == 0)
        return;
      stce_10116 = stce_10136.stce_10117();
    }
    stce_10290[0] = stce_10135.stce_10104(0);
    stce_10290[1] = stce_10135.stce_10104(1);
    derivative_t stce_10477 = stce_10290[1] - stce_10290[0];
    double stce_10275 = stce_10477 / (2 * stce_10072::global_tape->stce_10265);
    stce_10072::global_tape->stce_10274(stce_10116, stce_10275);
    stce_10072::global_tape->stce_10273();
    if (stce_10072::global_tape->stce_10260) {
      const double stce_10478 = 3.1415692;
      stce_10072::global_tape->_adjoint(this->stce_10074) = stce_10478;
      stce_10072::global_tape->interpret_adjoint();
      double stce_10279 = 0;
      for (size_t stce_9841 = 0; stce_9841 < stce_10072::global_tape->stce_10266.size(); ++stce_9841)
        stce_10279 += stce_10072::global_tape->_adjoint(stce_10072::global_tape->stce_10266[stce_9841]) *
                      stce_10072::global_tape->stce_10267[stce_9841];
      stce_10072::global_tape->zero_adjoints();
      stce_10072::global_tape->stce_10278(stce_10279, stce_10116 * stce_10478, stce_10275 * stce_10478);
    }
    stce_10072::global_tape->stce_10273();
  }
};
} // namespace internal
} // namespace dco
namespace dco {
template <typename stce_9781, typename stce_9760 = stce_9781, typename stce_9761 = stce_9760> class gtas {
  typedef types_config_t<stce_9781, stce_9760, stce_9761> stce_10137;

public:
  typedef dco::internal::stce_10475<gtas> data_t;
  static const memory_model::TYPE TAPE_MODEL = memory_model::stce_9768;
  typedef typename stce_10137::value_t value_t;
  typedef typename stce_10137::value_t active_value_t;
  typedef value_t scalar_value_t;
  typedef typename stce_10137::stce_9763 derivative_t;
  typedef derivative_t stce_9975;
  typedef typename mode<value_t>::passive_t passive_t;
  typedef typename mode<value_t>::scalar_passive_t scalar_passive_t;
  typedef dco::internal::active_type<value_t, data_t> type;
  typedef type active_t;
  static const bool is_dco_type = true;
  static const bool is_adjoint_type = true;
  static const bool is_tangent_type = true;
  static const bool stce_10138 = false;
  static const int order = dco::mode<stce_9781>::order + 1;
  static const size_t p1f_size = 0;
  typedef internal::tape<TAPE_MODEL, stce_10137> tape_t;
  static tape_t* global_tape;
  typedef typename internal::stce_10067<type> local_gradient_t;
  typedef dco::helper::stce_10004<tape_t> callback_object_t;
  typedef dco::helper::stce_10010<type, tape_t> userdata_object_t;
  typedef dco::helper::stce_10028<type, tape_t> external_adjoint_object_t;
  typedef internal::jacobian_preaccumulator_t<type> jacobian_preaccumulator_t;
  typedef typename tape_t::logger logger;
  enum stce_10479 {
    check_branch = 1,
    check_fd = 2,
    check_identity = 4,
    stce_10480 = check_branch | check_fd | check_identity
  };
  static double& fd_eps() {
    assert(global_tape);
    return global_tape->stce_10263;
  }
  static double& ta_eps() {
    assert(global_tape);
    return global_tape->stce_10264;
  }
  static void init(const int stce_10381 = stce_10480) {
    assert(global_tape);
    global_tape->template stce_10288<data_t>();
    global_tape->stce_10259 = (stce_10381 & check_branch) != 0;
    global_tape->stce_10261 = (stce_10381 & check_fd) != 0;
    global_tape->stce_10260 = (stce_10381 & check_identity) != 0;
    global_tape->stce_10269 = 0;
    global_tape->stce_10270 = -1;
  }
  static index_t& throw_on_event() {
    assert(global_tape);
    return global_tape->stce_10270;
  }
  static bool& throw_on_warning() {
    assert(global_tape);
    return global_tape->stce_10262;
  }
};
template <typename stce_9781, typename stce_10150, typename stce_10481>
typename gtas<stce_9781, stce_10150, stce_10481>::tape_t* gtas<stce_9781, stce_10150, stce_10481>::global_tape = 0;
} // namespace dco

namespace dco {
template <size_t stce_10482> struct subrange_t {
  static const size_t stce_10483 = stce_10482;
  subrange_t(size_t stce_10023) : stce_10022(stce_10023) {}
  size_t stce_10022;
};
template <size_t stce_10482> struct range_t {
  subrange_t<stce_10482> const& stce_10484;
  size_t global_index, stce_10176;
  range_t(subrange_t<stce_10482> const& stce_10387) : stce_10484(stce_10387), global_index(0), stce_10176(0) {}
  range_t& operator++() {
    global_index += stce_10484.stce_10483;
    ++stce_10176;
    return *this;
  }
  bool operator!=(range_t const& stce_9994) const {
    if (stce_9994.stce_10176 != stce_10176)
      return true;
    return false;
  }
  range_t& operator*() { return *this; }
  range_t const& operator*() const { return *this; }
  void stce_10204() {
    global_index = stce_10484.stce_10022;
    stce_10176 = static_cast<size_t>(std::ceil(static_cast<double>(stce_10484.stce_10022) / stce_10482));
  }
  bool is_last() const { return global_index + stce_10482 >= stce_10484.stce_10022; }
};
template <size_t stce_10482> struct inner_range_t {
  range_t<stce_10482> const& stce_10485;
  size_t global_index, sub_index;
  inner_range_t(range_t<stce_10482> const& stce_9824)
      : stce_10485(stce_9824), global_index(stce_9824.global_index), sub_index(0) {}
  inner_range_t& operator++() {
    ++sub_index;
    ++global_index;
    return *this;
  }
  void stce_10204() {
    if ((stce_10485.stce_10176 + 1) * stce_10485.stce_10484.stce_10483 > stce_10485.stce_10484.stce_10022) {
      sub_index = stce_10485.stce_10484.stce_10022 % stce_10485.stce_10484.stce_10483;
    } else {
      sub_index = stce_10485.stce_10484.stce_10483;
    }
  }
  bool operator!=(inner_range_t const& stce_9994) const {
    if (stce_9994.sub_index != sub_index)
      return true;
    return false;
  }
  inner_range_t& operator*() { return *this; }
  inner_range_t const& operator*() const { return *this; }
};
template <size_t stce_10482> static inner_range_t<stce_10482> begin(range_t<stce_10482> const& stce_9824) {
  return inner_range_t<stce_10482>(stce_9824);
}
template <size_t stce_10482> static range_t<stce_10482> begin(subrange_t<stce_10482> const& stce_10387) {
  return range_t<stce_10482>(stce_10387);
}
template <size_t stce_10482> static inner_range_t<stce_10482> end(range_t<stce_10482> const& stce_9824) {
  inner_range_t<stce_10482> stce_10486(stce_9824);
  stce_10486.stce_10204();
  return stce_10486;
}
template <size_t stce_10482> static range_t<stce_10482> end(subrange_t<stce_10482> const& stce_10387) {
  range_t<stce_10482> stce_10486(stce_10387);
  stce_10486.stce_10204();
  return stce_10486;
}
template <size_t stce_10482> static subrange_t<stce_10482> subranges(size_t stce_10023) {
  return subrange_t<stce_10482>(stce_10023);
}
} // namespace dco
namespace dco {
namespace stce_10487 {
template <class stce_9770> struct stce_10488 {
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10154(const stce_10489& stce_10156, const stce_10150& stce_10157) {
    return static_cast<stce_9770>(stce_10156 + stce_10157);
  }
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10158(const stce_9770& _value, const stce_10489& stce_10156,
                                           const stce_10150& stce_10157) {
    (void)_value;
    (void)stce_10156;
    (void)stce_10157;
    return static_cast<stce_9770>(static_cast<stce_9770>(1.0));
  }
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10159(const stce_9770& _value, const stce_10489& stce_10156,
                                           const stce_10150& stce_10157) {
    (void)_value;
    (void)stce_10156;
    (void)stce_10157;
    return static_cast<stce_9770>(static_cast<stce_9770>(1.0));
  }
};
template <class stce_9770> struct stce_10490 {
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10154(const stce_10489& stce_10156, const stce_10150& stce_10157) {
    return static_cast<stce_9770>(stce_10156 - stce_10157);
  }
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10158(const stce_9770& _value, const stce_10489& stce_10156,
                                           const stce_10150& stce_10157) {
    (void)_value;
    (void)stce_10156;
    (void)stce_10157;
    return static_cast<stce_9770>(static_cast<stce_9770>(1.0));
  }
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10159(const stce_9770& _value, const stce_10489& stce_10156,
                                           const stce_10150& stce_10157) {
    (void)_value;
    (void)stce_10156;
    (void)stce_10157;
    return static_cast<stce_9770>(static_cast<stce_9770>(-1.0));
  }
};
template <class stce_9770> struct stce_10491 {
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10154(const stce_10489& stce_10156, const stce_10150& stce_10157) {
    return static_cast<stce_9770>(stce_10156 * stce_10157);
  }
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10158(const stce_9770& _value, const stce_10489& stce_10156,
                                           const stce_10150& stce_10157) {
    (void)_value;
    (void)stce_10156;
    (void)stce_10157;
    return static_cast<stce_9770>(stce_10157);
  }
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10159(const stce_9770& _value, const stce_10489& stce_10156,
                                           const stce_10150& stce_10157) {
    (void)_value;
    (void)stce_10156;
    (void)stce_10157;
    return static_cast<stce_9770>(stce_10156);
  }
};
template <class stce_9770> struct stce_10492 {
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10154(const stce_10489& stce_10156, const stce_10150& stce_10157) {
    return static_cast<stce_9770>(stce_10156 / stce_10157);
  }
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10158(const stce_9770& _value, const stce_10489& stce_10156,
                                           const stce_10150& stce_10157) {
    (void)_value;
    (void)stce_10156;
    (void)stce_10157;
    return static_cast<stce_9770>(static_cast<stce_9770>(1.0) / stce_10157);
  }
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10159(const stce_9770& _value, const stce_10489& stce_10156,
                                           const stce_10150& stce_10157) {
    (void)_value;
    (void)stce_10156;
    (void)stce_10157;
    return static_cast<stce_9770>(-_value / stce_10157);
  }
};
template <class stce_9770> struct stce_10493 {
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10154(const stce_10489& stce_10156, const stce_10150& stce_10157) {
    return stce_10156 + stce_10157;
  }
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10158(const stce_9770& _value, const stce_10489& stce_10156,
                                           const stce_10150& stce_10157) {
    (void)_value;
    (void)stce_10156;
    (void)stce_10157;
    return static_cast<stce_9770>(static_cast<stce_9770>(1.0));
  }
};
template <class stce_9770> struct stce_10494 {
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10154(const stce_10489& stce_10156, const stce_10150& stce_10157) {
    return stce_10156 + stce_10157;
  }
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10159(const stce_9770& _value, const stce_10489& stce_10156,
                                           const stce_10150& stce_10157) {
    (void)_value;
    (void)stce_10156;
    (void)stce_10157;
    return static_cast<stce_9770>(static_cast<stce_9770>(1.0));
  }
};
template <class stce_9770> struct stce_10495 {
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10154(const stce_10489& stce_10156, const stce_10150& stce_10157) {
    return stce_10156 - stce_10157;
  }
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10158(const stce_9770& _value, const stce_10489& stce_10156,
                                           const stce_10150& stce_10157) {
    (void)_value;
    (void)stce_10156;
    (void)stce_10157;
    return static_cast<stce_9770>(static_cast<stce_9770>(1.0));
  }
};
template <class stce_9770> struct stce_10496 {
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10154(const stce_10489& stce_10156, const stce_10150& stce_10157) {
    return stce_10156 - stce_10157;
  }
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10159(const stce_9770& _value, const stce_10489& stce_10156,
                                           const stce_10150& stce_10157) {
    (void)_value;
    (void)stce_10156;
    (void)stce_10157;
    return static_cast<stce_9770>(static_cast<stce_9770>(-1.0));
  }
};
template <class stce_9770> struct stce_10497 {
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10154(const stce_10489& stce_10156, const stce_10150& stce_10157) {
    return stce_10156 * stce_10157;
  }
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10158(const stce_9770& _value, const stce_10489& stce_10156,
                                           const stce_10150& stce_10157) {
    (void)_value;
    (void)stce_10156;
    (void)stce_10157;
    return static_cast<stce_9770>(stce_10157);
  }
};
template <class stce_9770> struct stce_10498 {
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10154(const stce_10489& stce_10156, const stce_10150& stce_10157) {
    return stce_10156 * stce_10157;
  }
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10159(const stce_9770& _value, const stce_10489& stce_10156,
                                           const stce_10150& stce_10157) {
    (void)_value;
    (void)stce_10156;
    (void)stce_10157;
    return static_cast<stce_9770>(stce_10156);
  }
};
template <class stce_9770> struct stce_10499 {
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10154(const stce_10489& stce_10156, const stce_10150& stce_10157) {
    return stce_10156 / stce_10157;
  }
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10158(const stce_9770& _value, const stce_10489& stce_10156,
                                           const stce_10150& stce_10157) {
    (void)_value;
    (void)stce_10156;
    (void)stce_10157;
    return static_cast<stce_9770>(static_cast<stce_9770>(1.0) / stce_10157);
  }
};
template <class stce_9770> struct stce_10500 {
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10154(const stce_10489& stce_10156, const stce_10150& stce_10157) {
    return stce_10156 / stce_10157;
  }
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10159(const stce_9770& _value, const stce_10489& stce_10156,
                                           const stce_10150& stce_10157) {
    (void)_value;
    (void)stce_10156;
    (void)stce_10157;
    return static_cast<stce_9770>(-(stce_10156 / stce_10157) / stce_10157);
  }
};
template <class stce_9770> struct stce_10501 {
  template <class stce_9781> static inline const stce_9770 stce_10154(const stce_9781& arg) {
    using std::sin;
    return sin(arg);
  }
  template <class stce_9781>
  static inline const stce_9770 stce_10155(const stce_9770& _value, const stce_9781& stce_9803) {
    using std::cos;
    (void)_value;
    return static_cast<stce_9770>(cos(stce_9803));
  }
};
template <class stce_9770> struct stce_10502 {
  template <class stce_9781> static inline const stce_9770 stce_10154(const stce_9781& arg) {
    using std::cos;
    return cos(arg);
  }
  template <class stce_9781>
  static inline const stce_9770 stce_10155(const stce_9770& _value, const stce_9781& stce_9803) {
    using std::sin;
    (void)_value;
    return static_cast<stce_9770>(-sin(stce_9803));
  }
};
template <class stce_9770> struct stce_10503 {
  template <class stce_9781> static inline const stce_9770 stce_10154(const stce_9781& arg) {
    using std::tan;
    return tan(arg);
  }
  template <class stce_9781>
  static inline const stce_9770 stce_10155(const stce_9770& _value, const stce_9781& stce_9803) {
    using std::tan;
    (void)_value;
    return static_cast<stce_9770>((static_cast<stce_9770>(1.0) + (tan(stce_9803) * tan(stce_9803))));
  }
};
template <class stce_9770> struct stce_10504 {
  template <class stce_9781> static inline const stce_9770 stce_10154(const stce_9781& arg) {
    using std::cosh;
    return cosh(arg);
  }
  template <class stce_9781>
  static inline const stce_9770 stce_10155(const stce_9770& _value, const stce_9781& stce_9803) {
    using std::sinh;
    (void)_value;
    return static_cast<stce_9770>(sinh(stce_9803));
  }
};
template <class stce_9770> struct stce_10505 {
  template <class stce_9781> static inline const stce_9770 stce_10154(const stce_9781& arg) {
    using std::sinh;
    return sinh(arg);
  }
  template <class stce_9781>
  static inline const stce_9770 stce_10155(const stce_9770& _value, const stce_9781& stce_9803) {
    using std::cosh;
    (void)_value;
    return static_cast<stce_9770>(cosh(stce_9803));
  }
};
template <class stce_9770> struct stce_10506 {
  template <class stce_9781> static inline const stce_9770 stce_10154(const stce_9781& arg) {
    using std::tanh;
    return tanh(arg);
  }
  template <class stce_9781>
  static inline const stce_9770 stce_10155(const stce_9770& _value, const stce_9781& stce_9803) {
    using std::tanh;
    (void)_value;
    return static_cast<stce_9770>(static_cast<stce_9770>(1.0) - tanh(stce_9803) * tanh(stce_9803));
  }
};
template <class stce_9770> struct stce_10507 {
  template <class stce_9781> static inline const stce_9770 stce_10154(const stce_9781& arg) {
    using std::asin;
    return asin(arg);
  }
  template <class stce_9781>
  static inline const stce_9770 stce_10155(const stce_9770& _value, const stce_9781& stce_9803) {
    using std::sqrt;
    (void)_value;
    return static_cast<stce_9770>(static_cast<stce_9770>(1.0) /
                                  sqrt(static_cast<stce_9770>(1.0) - stce_9803 * stce_9803));
  }
};
template <class stce_9770> struct stce_10508 {
  template <class stce_9781> static inline const stce_9770 stce_10154(const stce_9781& arg) {
    using std::acos;
    return acos(arg);
  }
  template <class stce_9781>
  static inline const stce_9770 stce_10155(const stce_9770& _value, const stce_9781& stce_9803) {
    using std::sqrt;
    (void)_value;
    return static_cast<stce_9770>(static_cast<stce_9770>(-1.0) /
                                  sqrt(static_cast<stce_9770>(1.0) - stce_9803 * stce_9803));
  }
};
template <class stce_9770> struct stce_10509 {
  template <class stce_9781> static inline const stce_9770 stce_10154(const stce_9781& arg) {
    using std::atan;
    return atan(arg);
  }
  template <class stce_9781>
  static inline const stce_9770 stce_10155(const stce_9770& _value, const stce_9781& stce_9803) {
    using std::atan;
    (void)_value;
    return static_cast<stce_9770>(static_cast<stce_9770>(1.0) / (static_cast<stce_9770>(1.0) + stce_9803 * stce_9803));
  }
};
template <class stce_9770> struct stce_10510 {
  template <class stce_9781> static inline const stce_9770 stce_10154(const stce_9781& arg) {
    using std::exp;
    return exp(arg);
  }
  template <class stce_9781>
  static inline const stce_9770 stce_10155(const stce_9770& _value, const stce_9781& stce_9803) {
    using std::exp;
    (void)_value;
    return static_cast<stce_9770>(exp(stce_9803));
  }
};
template <class stce_9770> struct stce_10511 {
  template <class stce_9781> static inline const stce_9770 stce_10154(const stce_9781& arg) {
    using std::sqrt;
    return sqrt(arg);
  }
  template <class stce_9781>
  static inline const stce_9770 stce_10155(const stce_9770& _value, const stce_9781& stce_9803) {
    using std::sqrt;
    (void)_value;
    return static_cast<stce_9770>(
        static_cast<stce_9770>(1.0) /
        (static_cast<stce_9770>(2.0) *
         sqrt(stce_9803 + ((HAS_SQRT_AVOID_DIVZERO && stce_9803 == static_cast<stce_9770>(0.0))
                               ? static_cast<stce_9770>(DCO_SQRT_EPS)
                               : static_cast<stce_9770>(0.0)))));
  }
};
template <class stce_9770> struct stce_10512 {
  template <class stce_9781> static inline const stce_9770 stce_10154(const stce_9781& arg) {
    using std::log;
    return log(arg);
  }
  template <class stce_9781>
  static inline const stce_9770 stce_10155(const stce_9770& _value, const stce_9781& stce_9803) {
    using std::log;
    (void)_value;
    return static_cast<stce_9770>(static_cast<stce_9770>(1.0) / stce_9803);
  }
};
template <class stce_9770> struct stce_10513 {
  template <class stce_9781> static inline const stce_9770 stce_10154(const stce_9781& arg) {
    using ::erf;
    return erf(arg);
  }
  template <class stce_9781>
  static inline const stce_9770 stce_10155(const stce_9770& _value, const stce_9781& stce_9803) {
    using ::exp;
    (void)_value;
    return static_cast<stce_9770>(static_cast<stce_9770>(2.0) /
                                  sqrt(static_cast<stce_9770>(3.14159265358979323846264338327950288)) *
                                  exp(-stce_9803 * stce_9803));
  }
};
template <class stce_9770> struct stce_10514 {
  template <class stce_9781> static inline const stce_9770 stce_10154(const stce_9781& arg) {
    using ::erfc;
    return erfc(arg);
  }
  template <class stce_9781>
  static inline const stce_9770 stce_10155(const stce_9770& _value, const stce_9781& stce_9803) {
    using ::exp;
    (void)_value;
    return static_cast<stce_9770>(static_cast<stce_9770>(-2.0) /
                                  sqrt(static_cast<stce_9770>(3.14159265358979323846264338327950288)) *
                                  exp(-stce_9803 * stce_9803));
  }
};
template <class stce_9770> struct stce_10515 {
  template <class stce_9781> static inline const stce_9770 stce_10154(const stce_9781& arg) {
    using ::asinh;
    return asinh(arg);
  }
  template <class stce_9781>
  static inline const stce_9770 stce_10155(const stce_9770& _value, const stce_9781& stce_9803) {
    using ::sqrt;
    (void)_value;
    return static_cast<stce_9770>(static_cast<stce_9770>(1.) /
                                  sqrt(static_cast<stce_9770>(1.) + (stce_9803 * stce_9803)));
  }
};
template <class stce_9770> struct stce_10516 {
  template <class stce_9781> static inline const stce_9770 stce_10154(const stce_9781& arg) {
    using ::acosh;
    return acosh(arg);
  }
  template <class stce_9781>
  static inline const stce_9770 stce_10155(const stce_9770& _value, const stce_9781& stce_9803) {
    using ::sqrt;
    (void)_value;
    return static_cast<stce_9770>(static_cast<stce_9770>(1.) /
                                  sqrt((stce_9803 * stce_9803) - static_cast<stce_9770>(1.)));
  }
};
template <class stce_9770> struct stce_10517 {
  template <class stce_9781> static inline const stce_9770 stce_10154(const stce_9781& arg) {
    using ::atanh;
    return atanh(arg);
  }
  template <class stce_9781>
  static inline const stce_9770 stce_10155(const stce_9770& _value, const stce_9781& stce_9803) {
    using ::atanh;
    (void)_value;
    return static_cast<stce_9770>(static_cast<stce_9770>(1.) / (static_cast<stce_9770>(1.) - (stce_9803 * stce_9803)));
  }
};
template <class stce_9770> struct stce_10518 {
  template <class stce_9781> static inline const stce_9770 stce_10154(const stce_9781& arg) {
    using ::expm1;
    return expm1(arg);
  }
  template <class stce_9781>
  static inline const stce_9770 stce_10155(const stce_9770& _value, const stce_9781& stce_9803) {
    using ::exp;
    (void)_value;
    return static_cast<stce_9770>(exp(stce_9803));
  }
};
template <class stce_9770> struct stce_10519 {
  template <class stce_9781> static inline const stce_9770 stce_10154(const stce_9781& arg) {
    using ::log1p;
    return log1p(arg);
  }
  template <class stce_9781>
  static inline const stce_9770 stce_10155(const stce_9770& _value, const stce_9781& stce_9803) {
    using ::log1p;
    (void)_value;
    return static_cast<stce_9770>(static_cast<stce_9770>(1.0) / (stce_9803 + static_cast<stce_9770>(1.0)));
  }
};
template <class stce_9770> struct stce_10520 {
  template <class stce_9781> static inline const stce_9770 stce_10154(const stce_9781& arg) {
    using ::log10;
    return log10(arg);
  }
  template <class stce_9781>
  static inline const stce_9770 stce_10155(const stce_9770& _value, const stce_9781& stce_9803) {
    using ::log10;
    (void)_value;
    return static_cast<stce_9770>(static_cast<stce_9770>(1.0) / (stce_9803 * static_cast<stce_9770>(log(10))));
  }
};
template <class stce_9770> struct stce_10521 {
  template <class stce_9781> static inline const stce_9770 stce_10154(const stce_9781& stce_10156) {
    return -stce_10156;
  }
  template <class stce_9781> static inline const stce_9770 stce_10155(const stce_9770&, const stce_9781&) {
    return static_cast<stce_9770>(-1.0);
  }
};
template <class stce_9770> struct stce_10522 {
  template <class stce_9781> static inline const stce_9770 stce_10154(const stce_9781& stce_10156) {
    return stce_10156;
  }
  template <class stce_9781> static inline const stce_9770 stce_10155(const stce_9770&, const stce_9781&) {
    return static_cast<stce_9770>(1.0);
  }
};
using ::fabs;
template <class stce_9770> struct stce_10523 {
  template <class stce_9781> static inline const stce_9770 stce_10154(const stce_9781& stce_10156) {
    return fabs(stce_10156);
  }
  template <class stce_9781> static inline const stce_9770 stce_10155(const stce_9770&, const stce_9781& stce_10156) {
    if (stce_10156 < 0)
      return static_cast<stce_9770>(-1.0);
    else
      return static_cast<stce_9770>(1.0);
  }
};
using std::abs;
template <class stce_9770> struct stce_10524 {
  template <class stce_9781> static inline const stce_9770 stce_10154(const stce_9781& stce_10156) {
    return abs(stce_10156);
  }
  template <class stce_9781>
  static inline const stce_9770 stce_10155(const stce_9770& _value, const stce_9781& stce_10156) {
    (void)_value;
    if (stce_10156 < 0)
      return static_cast<stce_9770>(-1.0);
    else
      return static_cast<stce_9770>(1.0);
  }
};
using std::atan2;
template <class stce_9770> struct stce_10525 {
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10154(const stce_10489& stce_10156, const stce_10150& stce_10157) {
    (void)stce_10156;
    (void)stce_10157;
    return atan2(stce_10156, stce_10157);
  }
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10158(stce_9770 const& _value, const stce_10489& stce_10156,
                                           const stce_10150& stce_10157) {
    (void)_value;
    (void)stce_10156;
    (void)stce_10157;
    return stce_10157 / (stce_10157 * stce_10157 + stce_10156 * stce_10156);
  }
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10159(stce_9770 const& _value, const stce_10489& stce_10156,
                                           const stce_10150& stce_10157) {
    (void)_value;
    (void)stce_10156;
    (void)stce_10157;
    return -stce_10156 / (stce_10157 * stce_10157 + stce_10156 * stce_10156);
  }
};
template <class stce_9770> struct stce_10526 {
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10154(const stce_10489& stce_10156, const stce_10150& stce_10157) {
    (void)stce_10156;
    (void)stce_10157;
    return atan2(stce_10156, stce_10157);
  }
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10158(stce_9770 const& _value, const stce_10489& stce_10156,
                                           const stce_10150& stce_10157) {
    (void)_value;
    (void)stce_10156;
    (void)stce_10157;
    return stce_10157 / (stce_10157 * stce_10157 + stce_10156 * stce_10156);
  }
};
template <class stce_9770> struct stce_10527 {
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10154(const stce_10489& stce_10156, const stce_10150& stce_10157) {
    (void)stce_10156;
    (void)stce_10157;
    return atan2(stce_10156, stce_10157);
  }
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10159(stce_9770 const& _value, const stce_10489& stce_10156,
                                           const stce_10150& stce_10157) {
    (void)_value;
    (void)stce_10156;
    (void)stce_10157;
    return -stce_10156 / (stce_10157 * stce_10157 + stce_10156 * stce_10156);
  }
};
template <class stce_9770> struct stce_10528 {
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10154(const stce_10489& stce_10156, const stce_10150& stce_10157) {
    using std::pow;
    return pow(stce_10156, stce_10157);
  }
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10158(stce_9770 const& _value, const stce_10489& stce_10156,
                                           const stce_10150& stce_10157) {
    using std::pow;
    (void)_value;
    return stce_10157 * pow(stce_10156, stce_10157 - static_cast<stce_9770>(1.0));
  }
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10159(stce_9770 const& _value, const stce_10489& stce_10156, const stce_10150&) {
    using std::log;
    using std::pow;
    return log(stce_10156) * _value;
  }
};
template <class stce_9770> struct stce_10529 {
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10154(const stce_10489& stce_10156, const stce_10150& stce_10157) {
    using std::pow;
    return pow(stce_10156, stce_10157);
  }
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10158(stce_9770 const& _value, const stce_10489& stce_10156,
                                           const stce_10150& stce_10157) {
    using std::pow;
    (void)_value;
    return stce_10157 * pow(stce_10156, stce_10157 - static_cast<stce_10150>(1.0));
  }
};
template <class stce_9770> struct stce_10530 {
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10154(const stce_10489& stce_10156, const stce_10150& stce_10157) {
    using std::pow;
    return pow(stce_10156, stce_10157);
  }
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10159(stce_9770 const& _value, const stce_10489& stce_10156, const stce_10150&) {
    using std::log;
    using std::pow;
    return log(stce_10156) * _value;
  }
};
template <typename stce_9801, size_t stce_9802, typename stce_10531> struct stce_10532 {
  template <class stce_9781>
  static inline const vector_ns::vector_t<stce_9801, stce_9802>
  stce_10155(const vector_ns::vector_t<stce_9801, stce_9802>& _value, const stce_9781& stce_9803) {
    vector_ns::vector_t<stce_9801, stce_9802> stce_9843;
    for (size_t stce_9841 = 0; stce_9841 < stce_9802; ++stce_9841) {
      stce_9843[stce_9841] = stce_10531::stce_10155(_value[stce_9841], stce_9803[stce_9841]);
    }
    return stce_9843;
  }
};
template <typename stce_9801, size_t stce_9802>
struct stce_10524<vector_ns::vector_t<stce_9801, stce_9802>>
    : public stce_10532<stce_9801, stce_9802, stce_10524<stce_9801>> {
  template <class stce_9781>
  static inline const vector_ns::vector_t<stce_9801, stce_9802> stce_10154(const stce_9781& stce_10156) {
    return abs(stce_10156);
  }
};
template <typename stce_9801, size_t stce_9802>
struct stce_10523<vector_ns::vector_t<stce_9801, stce_9802>>
    : public stce_10532<stce_9801, stce_9802, stce_10523<stce_9801>> {
  template <class stce_9781>
  static inline const vector_ns::vector_t<stce_9801, stce_9802> stce_10154(const stce_9781& stce_10156) {
    return fabs(stce_10156);
  }
};
template <typename stce_9801, size_t stce_9802>
struct stce_10511<vector_ns::vector_t<stce_9801, stce_9802>>
    : public stce_10532<stce_9801, stce_9802, stce_10511<stce_9801>> {
  template <class stce_9781>
  static inline const vector_ns::vector_t<stce_9801, stce_9802> stce_10154(const stce_9781& arg) {
    return sqrt(arg);
  }
};
using ::hypot;
template <class stce_9770> struct stce_10533 {
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10154(const stce_10489& stce_10156, const stce_10150& stce_10157) {
    (void)stce_10156;
    (void)stce_10157;
    return hypot(stce_10156, stce_10157);
  }
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10158(stce_9770 const& _value, const stce_10489& stce_10156,
                                           const stce_10150& stce_10157) {
    (void)_value;
    (void)stce_10156;
    (void)stce_10157;
    return stce_10156 / _value;
  }
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10159(stce_9770 const& _value, const stce_10489& stce_10156,
                                           const stce_10150& stce_10157) {
    (void)_value;
    (void)stce_10156;
    (void)stce_10157;
    return stce_10157 / _value;
  }
};
template <class stce_9770> struct stce_10534 {
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10154(const stce_10489& stce_10156, const stce_10150& stce_10157) {
    (void)stce_10156;
    (void)stce_10157;
    return hypot(stce_10156, stce_10157);
  }
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10158(stce_9770 const& _value, const stce_10489& stce_10156,
                                           const stce_10150& stce_10157) {
    (void)_value;
    (void)stce_10156;
    (void)stce_10157;
    return stce_10156 / _value;
  }
};
template <class stce_9770> struct stce_10535 {
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10154(const stce_10489& stce_10156, const stce_10150& stce_10157) {
    (void)stce_10156;
    (void)stce_10157;
    return hypot(stce_10156, stce_10157);
  }
  template <class stce_10489, class stce_10150>
  static inline const stce_9770 stce_10159(stce_9770 const& _value, const stce_10489& stce_10156,
                                           const stce_10150& stce_10157) {
    (void)_value;
    (void)stce_10156;
    (void)stce_10157;
    return stce_10157 / _value;
  }
};
} // namespace stce_10487
} // namespace dco
namespace dco {
namespace internal {
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
operator-(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::stce_10487::stce_10521<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator-(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10521<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator-(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10521<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator-(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10521<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10129, class stce_10123>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
operator-(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::stce_10487::stce_10521<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
operator+(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::stce_10487::stce_10522<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator+(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10522<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator+(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10522<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator+(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10522<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10129, class stce_10123>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
operator+(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::stce_10487::stce_10522<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
sin(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::stce_10487::stce_10501<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
sin(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10501<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
sin(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10501<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
sin(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10501<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10129, class stce_10123>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
sin(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::stce_10487::stce_10501<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
cos(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::stce_10487::stce_10502<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
cos(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10502<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
cos(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10502<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
cos(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10502<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10129, class stce_10123>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
cos(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::stce_10487::stce_10502<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
tan(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::stce_10487::stce_10503<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
tan(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10503<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
tan(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10503<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
tan(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10503<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10129, class stce_10123>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
tan(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::stce_10487::stce_10503<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
cosh(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::stce_10487::stce_10504<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
cosh(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10504<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
cosh(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10504<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
cosh(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10504<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10129, class stce_10123>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
cosh(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::stce_10487::stce_10504<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
sinh(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::stce_10487::stce_10505<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
sinh(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10505<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
sinh(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10505<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
sinh(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10505<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10129, class stce_10123>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
sinh(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::stce_10487::stce_10505<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
asin(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::stce_10487::stce_10507<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
asin(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10507<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
asin(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10507<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
asin(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10507<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10129, class stce_10123>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
asin(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::stce_10487::stce_10507<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
acos(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::stce_10487::stce_10508<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
acos(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10508<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
acos(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10508<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
acos(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10508<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10129, class stce_10123>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
acos(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::stce_10487::stce_10508<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
exp(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::stce_10487::stce_10510<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
exp(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10510<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
exp(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10510<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
exp(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10510<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10129, class stce_10123>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
exp(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::stce_10487::stce_10510<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
atan(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::stce_10487::stce_10509<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
atan(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10509<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
atan(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10509<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
atan(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10509<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10129, class stce_10123>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
atan(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::stce_10487::stce_10509<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
tanh(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::stce_10487::stce_10506<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
tanh(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10506<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
tanh(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10506<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
tanh(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10506<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10129, class stce_10123>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
tanh(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::stce_10487::stce_10506<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
sqrt(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::stce_10487::stce_10511<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
sqrt(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10511<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
sqrt(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10511<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
sqrt(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10511<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10129, class stce_10123>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
sqrt(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::stce_10487::stce_10511<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
log(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::stce_10487::stce_10512<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
log(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10512<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
log(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10512<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
log(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10512<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10129, class stce_10123>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
log(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::stce_10487::stce_10512<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
erf(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::stce_10487::stce_10513<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
erf(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10513<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
erf(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10513<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
erf(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10513<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10129, class stce_10123>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
erf(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::stce_10487::stce_10513<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
erfc(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::stce_10487::stce_10514<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
erfc(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10514<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
erfc(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10514<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
erfc(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10514<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10129, class stce_10123>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
erfc(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::stce_10487::stce_10514<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
expm1(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::stce_10487::stce_10518<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
expm1(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10518<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
expm1(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10518<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
expm1(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10518<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10129, class stce_10123>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
expm1(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::stce_10487::stce_10518<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
asinh(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::stce_10487::stce_10515<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
asinh(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10515<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
asinh(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10515<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
asinh(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10515<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10129, class stce_10123>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
asinh(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::stce_10487::stce_10515<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
acosh(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::stce_10487::stce_10516<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
acosh(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10516<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
acosh(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10516<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
acosh(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10516<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10129, class stce_10123>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
acosh(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::stce_10487::stce_10516<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
atanh(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::stce_10487::stce_10517<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
atanh(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10517<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
atanh(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10517<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
atanh(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10517<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10129, class stce_10123>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
atanh(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::stce_10487::stce_10517<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
log1p(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::stce_10487::stce_10519<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
log1p(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10519<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
log1p(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10519<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
log1p(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10519<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10129, class stce_10123>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
log1p(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::stce_10487::stce_10519<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
log10(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::stce_10487::stce_10520<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
log10(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10520<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
log10(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10520<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
log10(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10520<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10129, class stce_10123>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
log10(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::stce_10487::stce_10520<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
fabs(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::stce_10487::stce_10523<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
fabs(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10523<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
fabs(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10523<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
fabs(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10523<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10129, class stce_10123>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
fabs(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::stce_10487::stce_10523<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
abs(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::stce_10487::stce_10524<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
abs(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10524<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
abs(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10524<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
abs(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::stce_10487::stce_10524<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10129, class stce_10123>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
abs(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082) {
  return dco::internal::stce_9775<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::stce_10487::stce_10524<stce_9770>>(stce_10082);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
operator+(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
          const dco::internal::active_type<stce_9770, stce_10119>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::stce_10487::stce_10488<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10536, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
operator+(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
          const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>,
                                  dco::stce_10487::stce_10488<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10538, class stce_10539, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
operator+(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
          const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10488<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10538, class stce_10539, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
operator+(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
          const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10488<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10538, class stce_10539, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
operator+(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
          const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10488<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10540>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
operator+(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
          const dco::internal::active_type<stce_9770, stce_10540>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::internal::active_type<stce_9770, stce_10540>,
                                  dco::stce_10487::stce_10488<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10536, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
operator+(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
          const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>,
                                  dco::stce_10487::stce_10488<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10538, class stce_10539, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
operator+(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
          const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10488<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10538, class stce_10539, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
operator+(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
          const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10488<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10538, class stce_10539, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
operator+(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
          const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10488<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10540>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator+(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::active_type<stce_9770, stce_10540>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::active_type<stce_9770, stce_10540>,
                                  dco::stce_10487::stce_10488<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10536, class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator+(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>,
                                  dco::stce_10487::stce_10488<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator+(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10488<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator+(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10488<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator+(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10488<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10540>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator+(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::active_type<stce_9770, stce_10540>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::active_type<stce_9770, stce_10540>,
                                  dco::stce_10487::stce_10488<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10536, class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator+(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>,
                                  dco::stce_10487::stce_10488<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator+(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10488<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator+(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10488<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator+(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10488<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10540>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator+(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::active_type<stce_9770, stce_10540>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::active_type<stce_9770, stce_10540>,
                                  dco::stce_10487::stce_10488<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10536, class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator+(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>,
                                  dco::stce_10487::stce_10488<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator+(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10488<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator+(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10488<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator+(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10488<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
operator+(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
          const typename dco::internal::active_type<stce_9770, stce_10119>::VALUE_TYPE& stce_10083) {
  return dco::internal::stce_9779<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  typename dco::internal::active_type<stce_9770, stce_10119>::VALUE_TYPE,
                                  dco::stce_10487::stce_10493<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
typename dco::enable_if<
    !dco::is_same<typename dco::internal::active_type<stce_9770, stce_10119>::VALUE_TYPE,
                  typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t>::value,
    dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>>::type
operator+(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
          const typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t& stce_10083) {
  return dco::internal::stce_9779<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t,
                                  dco::stce_10487::stce_10493<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
operator+(const typename dco::internal::active_type<stce_9770, stce_10119>::VALUE_TYPE& stce_10082,
          const dco::internal::active_type<stce_9770, stce_10119>& stce_10083) {
  return dco::internal::stce_9780<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::VALUE_TYPE,
                                  dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::stce_10487::stce_10494<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
typename dco::enable_if<
    !dco::is_same<typename dco::internal::active_type<stce_9770, stce_10119>::VALUE_TYPE,
                  typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t>::value,
    dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>>::type
operator+(const typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t& stce_10082,
          const dco::internal::active_type<stce_9770, stce_10119>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t,
      dco::internal::active_type<stce_9770, stce_10119>, dco::stce_10487::stce_10494<stce_9770>>(stce_10082,
                                                                                                 stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
operator+(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
          const typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::VALUE_TYPE& stce_10083) {
  return dco::internal::stce_9779<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::VALUE_TYPE,
                                  dco::stce_10487::stce_10493<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123>
typename dco::enable_if<
    !dco::is_same<typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::VALUE_TYPE,
                  typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t>::value,
    dco::internal::active_type<stce_9770,
                               typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>>::type
operator+(
    const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
    const typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t& stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
      typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t,
      dco::stce_10487::stce_10493<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
operator+(const typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::VALUE_TYPE& stce_10082,
          const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::VALUE_TYPE,
      dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>, dco::stce_10487::stce_10494<stce_9770>>(stce_10082,
                                                                                                           stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123>
typename dco::enable_if<
    !dco::is_same<typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::VALUE_TYPE,
                  typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t>::value,
    dco::internal::active_type<stce_9770,
                               typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>>::type
operator+(const typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t& stce_10082,
          const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t,
      dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>, dco::stce_10487::stce_10494<stce_9770>>(stce_10082,
                                                                                                           stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator+(
    const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
    const typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE& stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
      typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
      dco::stce_10487::stce_10493<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
typename dco::enable_if<
    !dco::is_same<
        typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
        typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t>::value,
    dco::internal::active_type<
        stce_9770, typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>>::type
operator+(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
              stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
      typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t,
      dco::stce_10487::stce_10493<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator+(
    const typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE& stce_10082,
    const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
      dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>, dco::stce_10487::stce_10494<stce_9770>>(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
typename dco::enable_if<
    !dco::is_same<
        typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
        typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t>::value,
    dco::internal::active_type<
        stce_9770, typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>>::type
operator+(const typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
              stce_10082,
          const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t,
      dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>, dco::stce_10487::stce_10494<stce_9770>>(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator+(
    const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
    const typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE& stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
      typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
      dco::stce_10487::stce_10493<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
typename dco::enable_if<
    !dco::is_same<
        typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
        typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t>::value,
    dco::internal::active_type<
        stce_9770, typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>>::type
operator+(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
              stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
      typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t,
      dco::stce_10487::stce_10493<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator+(
    const typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE& stce_10082,
    const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
      dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>, dco::stce_10487::stce_10494<stce_9770>>(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
typename dco::enable_if<
    !dco::is_same<
        typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
        typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t>::value,
    dco::internal::active_type<
        stce_9770, typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>>::type
operator+(const typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
              stce_10082,
          const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t,
      dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>, dco::stce_10487::stce_10494<stce_9770>>(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator+(
    const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
    const typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE& stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
      typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
      dco::stce_10487::stce_10493<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
typename dco::enable_if<
    !dco::is_same<
        typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
        typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t>::value,
    dco::internal::active_type<
        stce_9770, typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>>::type
operator+(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
              stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
      typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t,
      dco::stce_10487::stce_10493<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator+(
    const typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE& stce_10082,
    const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
      dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>, dco::stce_10487::stce_10494<stce_9770>>(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
typename dco::enable_if<
    !dco::is_same<
        typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
        typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t>::value,
    dco::internal::active_type<
        stce_9770, typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>>::type
operator+(const typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
              stce_10082,
          const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t,
      dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>, dco::stce_10487::stce_10494<stce_9770>>(
      stce_10082, stce_10083);
}
template <typename stce_9781, typename stce_9873>
typename enable_if<
    (dco::mode<stce_9873>::order > 0 &&
     (dco::internal::is_gbcp_type<stce_9781>::value ||
      (dco::mode<stce_9781>::is_intermediate_type && dco::internal::is_gbcp_type<typename stce_9781::data_t>::value)) &&
     dco::is_same<typename dco::mode<stce_9781>::active_t, typename dco::mode<stce_9873>::active_t>::value),
    dco::internal::stce_9778<typename dco::mode<stce_9873>::active_value_t, typename dco::mode<stce_9873>::active_t,
                             stce_9873,
                             dco::stce_10487::stce_10488<typename dco::mode<stce_9873>::active_value_t>>>::type
operator+(const stce_9781& stce_10082, const stce_9873& stce_10083) {
  return dco::internal::stce_9778<typename dco::mode<stce_9873>::active_value_t,
                                  typename dco::mode<stce_9873>::active_t, stce_9873,
                                  dco::stce_10487::stce_10488<typename dco::mode<stce_9873>::active_value_t>>(
      stce_10082, stce_10083);
}
template <typename stce_9781, typename stce_9873>
typename enable_if<
    (dco::mode<stce_9781>::order > 0 &&
     (dco::internal::is_gbcp_type<stce_9873>::value ||
      (dco::mode<stce_9873>::is_intermediate_type && dco::internal::is_gbcp_type<typename stce_9873::data_t>::value)) &&
     dco::is_same<typename dco::mode<stce_9873>::active_t, typename dco::mode<stce_9781>::active_t>::value),
    dco::internal::stce_9778<typename dco::mode<stce_9781>::active_value_t, stce_9781,
                             typename dco::mode<stce_9781>::active_t,
                             dco::stce_10487::stce_10488<typename dco::mode<stce_9781>::active_value_t>>>::type
operator+(const stce_9781& stce_10082, const stce_9873& stce_10083) {
  return dco::internal::stce_9778<typename dco::mode<stce_9781>::active_value_t, stce_9781,
                                  typename dco::mode<stce_9781>::active_t,
                                  dco::stce_10487::stce_10488<typename dco::mode<stce_9781>::active_value_t>>(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
operator-(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
          const dco::internal::active_type<stce_9770, stce_10119>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::stce_10487::stce_10490<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10536, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
operator-(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
          const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>,
                                  dco::stce_10487::stce_10490<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10538, class stce_10539, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
operator-(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
          const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10490<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10538, class stce_10539, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
operator-(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
          const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10490<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10538, class stce_10539, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
operator-(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
          const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10490<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10540>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
operator-(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
          const dco::internal::active_type<stce_9770, stce_10540>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::internal::active_type<stce_9770, stce_10540>,
                                  dco::stce_10487::stce_10490<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10536, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
operator-(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
          const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>,
                                  dco::stce_10487::stce_10490<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10538, class stce_10539, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
operator-(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
          const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10490<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10538, class stce_10539, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
operator-(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
          const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10490<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10538, class stce_10539, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
operator-(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
          const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10490<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10540>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator-(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::active_type<stce_9770, stce_10540>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::active_type<stce_9770, stce_10540>,
                                  dco::stce_10487::stce_10490<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10536, class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator-(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>,
                                  dco::stce_10487::stce_10490<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator-(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10490<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator-(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10490<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator-(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10490<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10540>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator-(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::active_type<stce_9770, stce_10540>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::active_type<stce_9770, stce_10540>,
                                  dco::stce_10487::stce_10490<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10536, class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator-(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>,
                                  dco::stce_10487::stce_10490<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator-(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10490<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator-(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10490<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator-(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10490<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10540>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator-(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::active_type<stce_9770, stce_10540>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::active_type<stce_9770, stce_10540>,
                                  dco::stce_10487::stce_10490<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10536, class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator-(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>,
                                  dco::stce_10487::stce_10490<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator-(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10490<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator-(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10490<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator-(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10490<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
operator-(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
          const typename dco::internal::active_type<stce_9770, stce_10119>::VALUE_TYPE& stce_10083) {
  return dco::internal::stce_9779<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  typename dco::internal::active_type<stce_9770, stce_10119>::VALUE_TYPE,
                                  dco::stce_10487::stce_10495<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
typename dco::enable_if<
    !dco::is_same<typename dco::internal::active_type<stce_9770, stce_10119>::VALUE_TYPE,
                  typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t>::value,
    dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>>::type
operator-(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
          const typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t& stce_10083) {
  return dco::internal::stce_9779<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t,
                                  dco::stce_10487::stce_10495<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
operator-(const typename dco::internal::active_type<stce_9770, stce_10119>::VALUE_TYPE& stce_10082,
          const dco::internal::active_type<stce_9770, stce_10119>& stce_10083) {
  return dco::internal::stce_9780<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::VALUE_TYPE,
                                  dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::stce_10487::stce_10496<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
typename dco::enable_if<
    !dco::is_same<typename dco::internal::active_type<stce_9770, stce_10119>::VALUE_TYPE,
                  typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t>::value,
    dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>>::type
operator-(const typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t& stce_10082,
          const dco::internal::active_type<stce_9770, stce_10119>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t,
      dco::internal::active_type<stce_9770, stce_10119>, dco::stce_10487::stce_10496<stce_9770>>(stce_10082,
                                                                                                 stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
operator-(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
          const typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::VALUE_TYPE& stce_10083) {
  return dco::internal::stce_9779<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::VALUE_TYPE,
                                  dco::stce_10487::stce_10495<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123>
typename dco::enable_if<
    !dco::is_same<typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::VALUE_TYPE,
                  typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t>::value,
    dco::internal::active_type<stce_9770,
                               typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>>::type
operator-(
    const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
    const typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t& stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
      typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t,
      dco::stce_10487::stce_10495<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
operator-(const typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::VALUE_TYPE& stce_10082,
          const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::VALUE_TYPE,
      dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>, dco::stce_10487::stce_10496<stce_9770>>(stce_10082,
                                                                                                           stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123>
typename dco::enable_if<
    !dco::is_same<typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::VALUE_TYPE,
                  typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t>::value,
    dco::internal::active_type<stce_9770,
                               typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>>::type
operator-(const typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t& stce_10082,
          const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t,
      dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>, dco::stce_10487::stce_10496<stce_9770>>(stce_10082,
                                                                                                           stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator-(
    const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
    const typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE& stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
      typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
      dco::stce_10487::stce_10495<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
typename dco::enable_if<
    !dco::is_same<
        typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
        typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t>::value,
    dco::internal::active_type<
        stce_9770, typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>>::type
operator-(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
              stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
      typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t,
      dco::stce_10487::stce_10495<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator-(
    const typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE& stce_10082,
    const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
      dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>, dco::stce_10487::stce_10496<stce_9770>>(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
typename dco::enable_if<
    !dco::is_same<
        typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
        typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t>::value,
    dco::internal::active_type<
        stce_9770, typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>>::type
operator-(const typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
              stce_10082,
          const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t,
      dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>, dco::stce_10487::stce_10496<stce_9770>>(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator-(
    const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
    const typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE& stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
      typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
      dco::stce_10487::stce_10495<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
typename dco::enable_if<
    !dco::is_same<
        typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
        typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t>::value,
    dco::internal::active_type<
        stce_9770, typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>>::type
operator-(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
              stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
      typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t,
      dco::stce_10487::stce_10495<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator-(
    const typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE& stce_10082,
    const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
      dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>, dco::stce_10487::stce_10496<stce_9770>>(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
typename dco::enable_if<
    !dco::is_same<
        typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
        typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t>::value,
    dco::internal::active_type<
        stce_9770, typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>>::type
operator-(const typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
              stce_10082,
          const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t,
      dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>, dco::stce_10487::stce_10496<stce_9770>>(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator-(
    const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
    const typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE& stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
      typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
      dco::stce_10487::stce_10495<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
typename dco::enable_if<
    !dco::is_same<
        typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
        typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t>::value,
    dco::internal::active_type<
        stce_9770, typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>>::type
operator-(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
              stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
      typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t,
      dco::stce_10487::stce_10495<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator-(
    const typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE& stce_10082,
    const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
      dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>, dco::stce_10487::stce_10496<stce_9770>>(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
typename dco::enable_if<
    !dco::is_same<
        typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
        typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t>::value,
    dco::internal::active_type<
        stce_9770, typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>>::type
operator-(const typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
              stce_10082,
          const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t,
      dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>, dco::stce_10487::stce_10496<stce_9770>>(
      stce_10082, stce_10083);
}
template <typename stce_9781, typename stce_9873>
typename enable_if<
    (dco::mode<stce_9873>::order > 0 &&
     (dco::internal::is_gbcp_type<stce_9781>::value ||
      (dco::mode<stce_9781>::is_intermediate_type && dco::internal::is_gbcp_type<typename stce_9781::data_t>::value)) &&
     dco::is_same<typename dco::mode<stce_9781>::active_t, typename dco::mode<stce_9873>::active_t>::value),
    dco::internal::stce_9778<typename dco::mode<stce_9873>::active_value_t, typename dco::mode<stce_9873>::active_t,
                             stce_9873,
                             dco::stce_10487::stce_10490<typename dco::mode<stce_9873>::active_value_t>>>::type
operator-(const stce_9781& stce_10082, const stce_9873& stce_10083) {
  return dco::internal::stce_9778<typename dco::mode<stce_9873>::active_value_t,
                                  typename dco::mode<stce_9873>::active_t, stce_9873,
                                  dco::stce_10487::stce_10490<typename dco::mode<stce_9873>::active_value_t>>(
      stce_10082, stce_10083);
}
template <typename stce_9781, typename stce_9873>
typename enable_if<
    (dco::mode<stce_9781>::order > 0 &&
     (dco::internal::is_gbcp_type<stce_9873>::value ||
      (dco::mode<stce_9873>::is_intermediate_type && dco::internal::is_gbcp_type<typename stce_9873::data_t>::value)) &&
     dco::is_same<typename dco::mode<stce_9873>::active_t, typename dco::mode<stce_9781>::active_t>::value),
    dco::internal::stce_9778<typename dco::mode<stce_9781>::active_value_t, stce_9781,
                             typename dco::mode<stce_9781>::active_t,
                             dco::stce_10487::stce_10490<typename dco::mode<stce_9781>::active_value_t>>>::type
operator-(const stce_9781& stce_10082, const stce_9873& stce_10083) {
  return dco::internal::stce_9778<typename dco::mode<stce_9781>::active_value_t, stce_9781,
                                  typename dco::mode<stce_9781>::active_t,
                                  dco::stce_10487::stce_10490<typename dco::mode<stce_9781>::active_value_t>>(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
operator*(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
          const dco::internal::active_type<stce_9770, stce_10119>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::stce_10487::stce_10491<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10536, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
operator*(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
          const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>,
                                  dco::stce_10487::stce_10491<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10538, class stce_10539, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
operator*(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
          const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10491<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10538, class stce_10539, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
operator*(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
          const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10491<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10538, class stce_10539, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
operator*(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
          const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10491<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10540>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
operator*(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
          const dco::internal::active_type<stce_9770, stce_10540>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::internal::active_type<stce_9770, stce_10540>,
                                  dco::stce_10487::stce_10491<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10536, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
operator*(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
          const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>,
                                  dco::stce_10487::stce_10491<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10538, class stce_10539, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
operator*(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
          const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10491<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10538, class stce_10539, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
operator*(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
          const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10491<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10538, class stce_10539, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
operator*(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
          const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10491<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10540>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator*(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::active_type<stce_9770, stce_10540>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::active_type<stce_9770, stce_10540>,
                                  dco::stce_10487::stce_10491<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10536, class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator*(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>,
                                  dco::stce_10487::stce_10491<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator*(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10491<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator*(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10491<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator*(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10491<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10540>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator*(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::active_type<stce_9770, stce_10540>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::active_type<stce_9770, stce_10540>,
                                  dco::stce_10487::stce_10491<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10536, class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator*(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>,
                                  dco::stce_10487::stce_10491<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator*(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10491<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator*(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10491<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator*(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10491<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10540>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator*(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::active_type<stce_9770, stce_10540>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::active_type<stce_9770, stce_10540>,
                                  dco::stce_10487::stce_10491<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10536, class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator*(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>,
                                  dco::stce_10487::stce_10491<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator*(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10491<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator*(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10491<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator*(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10491<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
operator*(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
          const typename dco::internal::active_type<stce_9770, stce_10119>::VALUE_TYPE& stce_10083) {
  return dco::internal::stce_9779<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  typename dco::internal::active_type<stce_9770, stce_10119>::VALUE_TYPE,
                                  dco::stce_10487::stce_10497<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
typename dco::enable_if<
    !dco::is_same<typename dco::internal::active_type<stce_9770, stce_10119>::VALUE_TYPE,
                  typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t>::value,
    dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>>::type
operator*(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
          const typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t& stce_10083) {
  return dco::internal::stce_9779<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t,
                                  dco::stce_10487::stce_10497<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
operator*(const typename dco::internal::active_type<stce_9770, stce_10119>::VALUE_TYPE& stce_10082,
          const dco::internal::active_type<stce_9770, stce_10119>& stce_10083) {
  return dco::internal::stce_9780<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::VALUE_TYPE,
                                  dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::stce_10487::stce_10498<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
typename dco::enable_if<
    !dco::is_same<typename dco::internal::active_type<stce_9770, stce_10119>::VALUE_TYPE,
                  typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t>::value,
    dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>>::type
operator*(const typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t& stce_10082,
          const dco::internal::active_type<stce_9770, stce_10119>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t,
      dco::internal::active_type<stce_9770, stce_10119>, dco::stce_10487::stce_10498<stce_9770>>(stce_10082,
                                                                                                 stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
operator*(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
          const typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::VALUE_TYPE& stce_10083) {
  return dco::internal::stce_9779<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::VALUE_TYPE,
                                  dco::stce_10487::stce_10497<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123>
typename dco::enable_if<
    !dco::is_same<typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::VALUE_TYPE,
                  typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t>::value,
    dco::internal::active_type<stce_9770,
                               typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>>::type
operator*(
    const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
    const typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t& stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
      typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t,
      dco::stce_10487::stce_10497<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
operator*(const typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::VALUE_TYPE& stce_10082,
          const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::VALUE_TYPE,
      dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>, dco::stce_10487::stce_10498<stce_9770>>(stce_10082,
                                                                                                           stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123>
typename dco::enable_if<
    !dco::is_same<typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::VALUE_TYPE,
                  typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t>::value,
    dco::internal::active_type<stce_9770,
                               typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>>::type
operator*(const typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t& stce_10082,
          const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t,
      dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>, dco::stce_10487::stce_10498<stce_9770>>(stce_10082,
                                                                                                           stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator*(
    const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
    const typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE& stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
      typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
      dco::stce_10487::stce_10497<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
typename dco::enable_if<
    !dco::is_same<
        typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
        typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t>::value,
    dco::internal::active_type<
        stce_9770, typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>>::type
operator*(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
              stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
      typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t,
      dco::stce_10487::stce_10497<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator*(
    const typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE& stce_10082,
    const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
      dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>, dco::stce_10487::stce_10498<stce_9770>>(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
typename dco::enable_if<
    !dco::is_same<
        typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
        typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t>::value,
    dco::internal::active_type<
        stce_9770, typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>>::type
operator*(const typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
              stce_10082,
          const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t,
      dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>, dco::stce_10487::stce_10498<stce_9770>>(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator*(
    const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
    const typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE& stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
      typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
      dco::stce_10487::stce_10497<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
typename dco::enable_if<
    !dco::is_same<
        typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
        typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t>::value,
    dco::internal::active_type<
        stce_9770, typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>>::type
operator*(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
              stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
      typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t,
      dco::stce_10487::stce_10497<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator*(
    const typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE& stce_10082,
    const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
      dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>, dco::stce_10487::stce_10498<stce_9770>>(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
typename dco::enable_if<
    !dco::is_same<
        typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
        typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t>::value,
    dco::internal::active_type<
        stce_9770, typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>>::type
operator*(const typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
              stce_10082,
          const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t,
      dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>, dco::stce_10487::stce_10498<stce_9770>>(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator*(
    const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
    const typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE& stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
      typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
      dco::stce_10487::stce_10497<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
typename dco::enable_if<
    !dco::is_same<
        typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
        typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t>::value,
    dco::internal::active_type<
        stce_9770, typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>>::type
operator*(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
              stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
      typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t,
      dco::stce_10487::stce_10497<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator*(
    const typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE& stce_10082,
    const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
      dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>, dco::stce_10487::stce_10498<stce_9770>>(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
typename dco::enable_if<
    !dco::is_same<
        typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
        typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t>::value,
    dco::internal::active_type<
        stce_9770, typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>>::type
operator*(const typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
              stce_10082,
          const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t,
      dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>, dco::stce_10487::stce_10498<stce_9770>>(
      stce_10082, stce_10083);
}
template <typename stce_9781, typename stce_9873>
typename enable_if<
    (dco::mode<stce_9873>::order > 0 &&
     (dco::internal::is_gbcp_type<stce_9781>::value ||
      (dco::mode<stce_9781>::is_intermediate_type && dco::internal::is_gbcp_type<typename stce_9781::data_t>::value)) &&
     dco::is_same<typename dco::mode<stce_9781>::active_t, typename dco::mode<stce_9873>::active_t>::value),
    dco::internal::stce_9778<typename dco::mode<stce_9873>::active_value_t, typename dco::mode<stce_9873>::active_t,
                             stce_9873,
                             dco::stce_10487::stce_10491<typename dco::mode<stce_9873>::active_value_t>>>::type
operator*(const stce_9781& stce_10082, const stce_9873& stce_10083) {
  return dco::internal::stce_9778<typename dco::mode<stce_9873>::active_value_t,
                                  typename dco::mode<stce_9873>::active_t, stce_9873,
                                  dco::stce_10487::stce_10491<typename dco::mode<stce_9873>::active_value_t>>(
      stce_10082, stce_10083);
}
template <typename stce_9781, typename stce_9873>
typename enable_if<
    (dco::mode<stce_9781>::order > 0 &&
     (dco::internal::is_gbcp_type<stce_9873>::value ||
      (dco::mode<stce_9873>::is_intermediate_type && dco::internal::is_gbcp_type<typename stce_9873::data_t>::value)) &&
     dco::is_same<typename dco::mode<stce_9873>::active_t, typename dco::mode<stce_9781>::active_t>::value),
    dco::internal::stce_9778<typename dco::mode<stce_9781>::active_value_t, stce_9781,
                             typename dco::mode<stce_9781>::active_t,
                             dco::stce_10487::stce_10491<typename dco::mode<stce_9781>::active_value_t>>>::type
operator*(const stce_9781& stce_10082, const stce_9873& stce_10083) {
  return dco::internal::stce_9778<typename dco::mode<stce_9781>::active_value_t, stce_9781,
                                  typename dco::mode<stce_9781>::active_t,
                                  dco::stce_10487::stce_10491<typename dco::mode<stce_9781>::active_value_t>>(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
operator/(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
          const dco::internal::active_type<stce_9770, stce_10119>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::stce_10487::stce_10492<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10536, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
operator/(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
          const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>,
                                  dco::stce_10487::stce_10492<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10538, class stce_10539, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
operator/(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
          const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10492<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10538, class stce_10539, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
operator/(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
          const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10492<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10538, class stce_10539, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
operator/(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
          const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10492<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10540>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
operator/(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
          const dco::internal::active_type<stce_9770, stce_10540>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::internal::active_type<stce_9770, stce_10540>,
                                  dco::stce_10487::stce_10492<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10536, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
operator/(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
          const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>,
                                  dco::stce_10487::stce_10492<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10538, class stce_10539, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
operator/(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
          const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10492<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10538, class stce_10539, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
operator/(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
          const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10492<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10538, class stce_10539, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
operator/(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
          const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10492<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10540>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator/(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::active_type<stce_9770, stce_10540>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::active_type<stce_9770, stce_10540>,
                                  dco::stce_10487::stce_10492<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10536, class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator/(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>,
                                  dco::stce_10487::stce_10492<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator/(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10492<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator/(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10492<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator/(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10492<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10540>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator/(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::active_type<stce_9770, stce_10540>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::active_type<stce_9770, stce_10540>,
                                  dco::stce_10487::stce_10492<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10536, class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator/(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>,
                                  dco::stce_10487::stce_10492<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator/(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10492<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator/(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10492<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator/(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10492<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10540>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator/(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::active_type<stce_9770, stce_10540>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::active_type<stce_9770, stce_10540>,
                                  dco::stce_10487::stce_10492<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10536, class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator/(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>,
                                  dco::stce_10487::stce_10492<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator/(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10492<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator/(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10492<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator/(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10492<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
operator/(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
          const typename dco::internal::active_type<stce_9770, stce_10119>::VALUE_TYPE& stce_10083) {
  return dco::internal::stce_9779<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  typename dco::internal::active_type<stce_9770, stce_10119>::VALUE_TYPE,
                                  dco::stce_10487::stce_10499<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
typename dco::enable_if<
    !dco::is_same<typename dco::internal::active_type<stce_9770, stce_10119>::VALUE_TYPE,
                  typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t>::value,
    dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>>::type
operator/(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
          const typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t& stce_10083) {
  return dco::internal::stce_9779<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t,
                                  dco::stce_10487::stce_10499<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
operator/(const typename dco::internal::active_type<stce_9770, stce_10119>::VALUE_TYPE& stce_10082,
          const dco::internal::active_type<stce_9770, stce_10119>& stce_10083) {
  return dco::internal::stce_9780<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::VALUE_TYPE,
                                  dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::stce_10487::stce_10500<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
typename dco::enable_if<
    !dco::is_same<typename dco::internal::active_type<stce_9770, stce_10119>::VALUE_TYPE,
                  typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t>::value,
    dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>>::type
operator/(const typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t& stce_10082,
          const dco::internal::active_type<stce_9770, stce_10119>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t,
      dco::internal::active_type<stce_9770, stce_10119>, dco::stce_10487::stce_10500<stce_9770>>(stce_10082,
                                                                                                 stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
operator/(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
          const typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::VALUE_TYPE& stce_10083) {
  return dco::internal::stce_9779<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::VALUE_TYPE,
                                  dco::stce_10487::stce_10499<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123>
typename dco::enable_if<
    !dco::is_same<typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::VALUE_TYPE,
                  typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t>::value,
    dco::internal::active_type<stce_9770,
                               typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>>::type
operator/(
    const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
    const typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t& stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
      typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t,
      dco::stce_10487::stce_10499<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
operator/(const typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::VALUE_TYPE& stce_10082,
          const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::VALUE_TYPE,
      dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>, dco::stce_10487::stce_10500<stce_9770>>(stce_10082,
                                                                                                           stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123>
typename dco::enable_if<
    !dco::is_same<typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::VALUE_TYPE,
                  typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t>::value,
    dco::internal::active_type<stce_9770,
                               typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>>::type
operator/(const typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t& stce_10082,
          const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t,
      dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>, dco::stce_10487::stce_10500<stce_9770>>(stce_10082,
                                                                                                           stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator/(
    const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
    const typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE& stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
      typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
      dco::stce_10487::stce_10499<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
typename dco::enable_if<
    !dco::is_same<
        typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
        typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t>::value,
    dco::internal::active_type<
        stce_9770, typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>>::type
operator/(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
              stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
      typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t,
      dco::stce_10487::stce_10499<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator/(
    const typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE& stce_10082,
    const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
      dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>, dco::stce_10487::stce_10500<stce_9770>>(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
typename dco::enable_if<
    !dco::is_same<
        typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
        typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t>::value,
    dco::internal::active_type<
        stce_9770, typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>>::type
operator/(const typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
              stce_10082,
          const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t,
      dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>, dco::stce_10487::stce_10500<stce_9770>>(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator/(
    const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
    const typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE& stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
      typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
      dco::stce_10487::stce_10499<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
typename dco::enable_if<
    !dco::is_same<
        typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
        typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t>::value,
    dco::internal::active_type<
        stce_9770, typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>>::type
operator/(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
              stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
      typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t,
      dco::stce_10487::stce_10499<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator/(
    const typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE& stce_10082,
    const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
      dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>, dco::stce_10487::stce_10500<stce_9770>>(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
typename dco::enable_if<
    !dco::is_same<
        typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
        typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t>::value,
    dco::internal::active_type<
        stce_9770, typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>>::type
operator/(const typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
              stce_10082,
          const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t,
      dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>, dco::stce_10487::stce_10500<stce_9770>>(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator/(
    const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
    const typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE& stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
      typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
      dco::stce_10487::stce_10499<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
typename dco::enable_if<
    !dco::is_same<
        typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
        typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t>::value,
    dco::internal::active_type<
        stce_9770, typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>>::type
operator/(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
              stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
      typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t,
      dco::stce_10487::stce_10499<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
operator/(
    const typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE& stce_10082,
    const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
      dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>, dco::stce_10487::stce_10500<stce_9770>>(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
typename dco::enable_if<
    !dco::is_same<
        typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
        typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t>::value,
    dco::internal::active_type<
        stce_9770, typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>>::type
operator/(const typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
              stce_10082,
          const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t,
      dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>, dco::stce_10487::stce_10500<stce_9770>>(
      stce_10082, stce_10083);
}
template <typename stce_9781, typename stce_9873>
typename enable_if<
    (dco::mode<stce_9873>::order > 0 &&
     (dco::internal::is_gbcp_type<stce_9781>::value ||
      (dco::mode<stce_9781>::is_intermediate_type && dco::internal::is_gbcp_type<typename stce_9781::data_t>::value)) &&
     dco::is_same<typename dco::mode<stce_9781>::active_t, typename dco::mode<stce_9873>::active_t>::value),
    dco::internal::stce_9778<typename dco::mode<stce_9873>::active_value_t, typename dco::mode<stce_9873>::active_t,
                             stce_9873,
                             dco::stce_10487::stce_10492<typename dco::mode<stce_9873>::active_value_t>>>::type
operator/(const stce_9781& stce_10082, const stce_9873& stce_10083) {
  return dco::internal::stce_9778<typename dco::mode<stce_9873>::active_value_t,
                                  typename dco::mode<stce_9873>::active_t, stce_9873,
                                  dco::stce_10487::stce_10492<typename dco::mode<stce_9873>::active_value_t>>(
      stce_10082, stce_10083);
}
template <typename stce_9781, typename stce_9873>
typename enable_if<
    (dco::mode<stce_9781>::order > 0 &&
     (dco::internal::is_gbcp_type<stce_9873>::value ||
      (dco::mode<stce_9873>::is_intermediate_type && dco::internal::is_gbcp_type<typename stce_9873::data_t>::value)) &&
     dco::is_same<typename dco::mode<stce_9873>::active_t, typename dco::mode<stce_9781>::active_t>::value),
    dco::internal::stce_9778<typename dco::mode<stce_9781>::active_value_t, stce_9781,
                             typename dco::mode<stce_9781>::active_t,
                             dco::stce_10487::stce_10492<typename dco::mode<stce_9781>::active_value_t>>>::type
operator/(const stce_9781& stce_10082, const stce_9873& stce_10083) {
  return dco::internal::stce_9778<typename dco::mode<stce_9781>::active_value_t, stce_9781,
                                  typename dco::mode<stce_9781>::active_t,
                                  dco::stce_10487::stce_10492<typename dco::mode<stce_9781>::active_value_t>>(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
atan2(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
      const dco::internal::active_type<stce_9770, stce_10119>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::stce_10487::stce_10525<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10536, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
atan2(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
      const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>,
                                  dco::stce_10487::stce_10525<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10538, class stce_10539, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
atan2(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
      const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10525<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10538, class stce_10539, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
atan2(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
      const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10525<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10538, class stce_10539, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
atan2(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
      const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10525<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10540>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
atan2(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
      const dco::internal::active_type<stce_9770, stce_10540>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::internal::active_type<stce_9770, stce_10540>,
                                  dco::stce_10487::stce_10525<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10536, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
atan2(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
      const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>,
                                  dco::stce_10487::stce_10525<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10538, class stce_10539, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
atan2(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
      const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10525<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10538, class stce_10539, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
atan2(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
      const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10525<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10538, class stce_10539, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
atan2(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
      const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10525<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10540>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
atan2(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
      const dco::internal::active_type<stce_9770, stce_10540>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::active_type<stce_9770, stce_10540>,
                                  dco::stce_10487::stce_10525<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10536, class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
atan2(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
      const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>,
                                  dco::stce_10487::stce_10525<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
atan2(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
      const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10525<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
atan2(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
      const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10525<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
atan2(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
      const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10525<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10540>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
atan2(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
      const dco::internal::active_type<stce_9770, stce_10540>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::active_type<stce_9770, stce_10540>,
                                  dco::stce_10487::stce_10525<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10536, class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
atan2(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
      const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>,
                                  dco::stce_10487::stce_10525<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
atan2(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
      const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10525<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
atan2(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
      const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10525<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
atan2(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
      const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10525<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10540>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
atan2(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
      const dco::internal::active_type<stce_9770, stce_10540>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::active_type<stce_9770, stce_10540>,
                                  dco::stce_10487::stce_10525<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10536, class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
atan2(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
      const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>,
                                  dco::stce_10487::stce_10525<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
atan2(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
      const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10525<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
atan2(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
      const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10525<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
atan2(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
      const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10525<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
atan2(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
      const typename dco::internal::active_type<stce_9770, stce_10119>::VALUE_TYPE& stce_10083) {
  return dco::internal::stce_9779<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  typename dco::internal::active_type<stce_9770, stce_10119>::VALUE_TYPE,
                                  dco::stce_10487::stce_10526<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
typename dco::enable_if<
    !dco::is_same<typename dco::internal::active_type<stce_9770, stce_10119>::VALUE_TYPE,
                  typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t>::value,
    dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>>::type
atan2(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
      const typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t& stce_10083) {
  return dco::internal::stce_9779<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t,
                                  dco::stce_10487::stce_10526<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
atan2(const typename dco::internal::active_type<stce_9770, stce_10119>::VALUE_TYPE& stce_10082,
      const dco::internal::active_type<stce_9770, stce_10119>& stce_10083) {
  return dco::internal::stce_9780<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::VALUE_TYPE,
                                  dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::stce_10487::stce_10527<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
typename dco::enable_if<
    !dco::is_same<typename dco::internal::active_type<stce_9770, stce_10119>::VALUE_TYPE,
                  typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t>::value,
    dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>>::type
atan2(const typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t& stce_10082,
      const dco::internal::active_type<stce_9770, stce_10119>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t,
      dco::internal::active_type<stce_9770, stce_10119>, dco::stce_10487::stce_10527<stce_9770>>(stce_10082,
                                                                                                 stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
atan2(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
      const typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::VALUE_TYPE& stce_10083) {
  return dco::internal::stce_9779<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::VALUE_TYPE,
                                  dco::stce_10487::stce_10526<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123>
typename dco::enable_if<
    !dco::is_same<typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::VALUE_TYPE,
                  typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t>::value,
    dco::internal::active_type<stce_9770,
                               typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>>::type
atan2(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
      const typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t& stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
      typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t,
      dco::stce_10487::stce_10526<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
atan2(const typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::VALUE_TYPE& stce_10082,
      const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::VALUE_TYPE,
      dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>, dco::stce_10487::stce_10527<stce_9770>>(stce_10082,
                                                                                                           stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123>
typename dco::enable_if<
    !dco::is_same<typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::VALUE_TYPE,
                  typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t>::value,
    dco::internal::active_type<stce_9770,
                               typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>>::type
atan2(const typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t& stce_10082,
      const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t,
      dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>, dco::stce_10487::stce_10527<stce_9770>>(stce_10082,
                                                                                                           stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
atan2(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
      const typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE& stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
      typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
      dco::stce_10487::stce_10526<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
typename dco::enable_if<
    !dco::is_same<
        typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
        typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t>::value,
    dco::internal::active_type<
        stce_9770, typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>>::type
atan2(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
      const typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
          stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
      typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t,
      dco::stce_10487::stce_10526<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
atan2(const typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE& stce_10082,
      const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
      dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>, dco::stce_10487::stce_10527<stce_9770>>(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
typename dco::enable_if<
    !dco::is_same<
        typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
        typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t>::value,
    dco::internal::active_type<
        stce_9770, typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>>::type
atan2(const typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
          stce_10082,
      const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t,
      dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>, dco::stce_10487::stce_10527<stce_9770>>(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
atan2(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
      const typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE& stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
      typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
      dco::stce_10487::stce_10526<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
typename dco::enable_if<
    !dco::is_same<
        typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
        typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t>::value,
    dco::internal::active_type<
        stce_9770, typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>>::type
atan2(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
      const typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
          stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
      typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t,
      dco::stce_10487::stce_10526<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
atan2(const typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE& stce_10082,
      const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
      dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>, dco::stce_10487::stce_10527<stce_9770>>(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
typename dco::enable_if<
    !dco::is_same<
        typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
        typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t>::value,
    dco::internal::active_type<
        stce_9770, typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>>::type
atan2(const typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
          stce_10082,
      const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t,
      dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>, dco::stce_10487::stce_10527<stce_9770>>(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
atan2(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
      const typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE& stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
      typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
      dco::stce_10487::stce_10526<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
typename dco::enable_if<
    !dco::is_same<
        typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
        typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t>::value,
    dco::internal::active_type<
        stce_9770, typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>>::type
atan2(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
      const typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
          stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
      typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t,
      dco::stce_10487::stce_10526<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
atan2(const typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE& stce_10082,
      const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
      dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>, dco::stce_10487::stce_10527<stce_9770>>(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
typename dco::enable_if<
    !dco::is_same<
        typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
        typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t>::value,
    dco::internal::active_type<
        stce_9770, typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>>::type
atan2(const typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
          stce_10082,
      const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t,
      dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>, dco::stce_10487::stce_10527<stce_9770>>(
      stce_10082, stce_10083);
}
template <typename stce_9781, typename stce_9873>
typename enable_if<
    (dco::mode<stce_9873>::order > 0 &&
     (dco::internal::is_gbcp_type<stce_9781>::value ||
      (dco::mode<stce_9781>::is_intermediate_type && dco::internal::is_gbcp_type<typename stce_9781::data_t>::value)) &&
     dco::is_same<typename dco::mode<stce_9781>::active_t, typename dco::mode<stce_9873>::active_t>::value),
    dco::internal::stce_9778<typename dco::mode<stce_9873>::active_value_t, typename dco::mode<stce_9873>::active_t,
                             stce_9873,
                             dco::stce_10487::stce_10525<typename dco::mode<stce_9873>::active_value_t>>>::type
atan2(const stce_9781& stce_10082, const stce_9873& stce_10083) {
  return dco::internal::stce_9778<typename dco::mode<stce_9873>::active_value_t,
                                  typename dco::mode<stce_9873>::active_t, stce_9873,
                                  dco::stce_10487::stce_10525<typename dco::mode<stce_9873>::active_value_t>>(
      stce_10082, stce_10083);
}
template <typename stce_9781, typename stce_9873>
typename enable_if<
    (dco::mode<stce_9781>::order > 0 &&
     (dco::internal::is_gbcp_type<stce_9873>::value ||
      (dco::mode<stce_9873>::is_intermediate_type && dco::internal::is_gbcp_type<typename stce_9873::data_t>::value)) &&
     dco::is_same<typename dco::mode<stce_9873>::active_t, typename dco::mode<stce_9781>::active_t>::value),
    dco::internal::stce_9778<typename dco::mode<stce_9781>::active_value_t, stce_9781,
                             typename dco::mode<stce_9781>::active_t,
                             dco::stce_10487::stce_10525<typename dco::mode<stce_9781>::active_value_t>>>::type
atan2(const stce_9781& stce_10082, const stce_9873& stce_10083) {
  return dco::internal::stce_9778<typename dco::mode<stce_9781>::active_value_t, stce_9781,
                                  typename dco::mode<stce_9781>::active_t,
                                  dco::stce_10487::stce_10525<typename dco::mode<stce_9781>::active_value_t>>(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
pow(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
    const dco::internal::active_type<stce_9770, stce_10119>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::stce_10487::stce_10528<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10536, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
pow(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
    const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>,
                                  dco::stce_10487::stce_10528<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10538, class stce_10539, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
pow(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
    const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10528<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10538, class stce_10539, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
pow(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
    const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10528<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10538, class stce_10539, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
pow(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
    const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10528<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10540>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
pow(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
    const dco::internal::active_type<stce_9770, stce_10540>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::internal::active_type<stce_9770, stce_10540>,
                                  dco::stce_10487::stce_10528<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10536, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
pow(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
    const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>,
                                  dco::stce_10487::stce_10528<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10538, class stce_10539, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
pow(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
    const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10528<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10538, class stce_10539, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
pow(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
    const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10528<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10538, class stce_10539, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
pow(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
    const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10528<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10540>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
pow(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
    const dco::internal::active_type<stce_9770, stce_10540>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::active_type<stce_9770, stce_10540>,
                                  dco::stce_10487::stce_10528<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10536, class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
pow(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
    const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>,
                                  dco::stce_10487::stce_10528<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
pow(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
    const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10528<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
pow(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
    const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10528<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
pow(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
    const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10528<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10540>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
pow(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
    const dco::internal::active_type<stce_9770, stce_10540>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::active_type<stce_9770, stce_10540>,
                                  dco::stce_10487::stce_10528<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10536, class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
pow(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
    const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>,
                                  dco::stce_10487::stce_10528<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
pow(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
    const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10528<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
pow(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
    const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10528<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
pow(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
    const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10528<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10540>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
pow(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
    const dco::internal::active_type<stce_9770, stce_10540>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::active_type<stce_9770, stce_10540>,
                                  dco::stce_10487::stce_10528<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10536, class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
pow(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
    const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>,
                                  dco::stce_10487::stce_10528<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
pow(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
    const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10528<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
pow(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
    const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10528<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
pow(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
    const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10528<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
pow(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
    const typename dco::internal::active_type<stce_9770, stce_10119>::VALUE_TYPE& stce_10083) {
  return dco::internal::stce_9779<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  typename dco::internal::active_type<stce_9770, stce_10119>::VALUE_TYPE,
                                  dco::stce_10487::stce_10529<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
typename dco::enable_if<
    !dco::is_same<typename dco::internal::active_type<stce_9770, stce_10119>::VALUE_TYPE,
                  typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t>::value,
    dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>>::type
pow(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
    const typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t& stce_10083) {
  return dco::internal::stce_9779<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t,
                                  dco::stce_10487::stce_10529<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
pow(const typename dco::internal::active_type<stce_9770, stce_10119>::VALUE_TYPE& stce_10082,
    const dco::internal::active_type<stce_9770, stce_10119>& stce_10083) {
  return dco::internal::stce_9780<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::VALUE_TYPE,
                                  dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::stce_10487::stce_10530<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
typename dco::enable_if<
    !dco::is_same<typename dco::internal::active_type<stce_9770, stce_10119>::VALUE_TYPE,
                  typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t>::value,
    dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>>::type
pow(const typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t& stce_10082,
    const dco::internal::active_type<stce_9770, stce_10119>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t,
      dco::internal::active_type<stce_9770, stce_10119>, dco::stce_10487::stce_10530<stce_9770>>(stce_10082,
                                                                                                 stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
pow(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
    const typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::VALUE_TYPE& stce_10083) {
  return dco::internal::stce_9779<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::VALUE_TYPE,
                                  dco::stce_10487::stce_10529<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123>
typename dco::enable_if<
    !dco::is_same<typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::VALUE_TYPE,
                  typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t>::value,
    dco::internal::active_type<stce_9770,
                               typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>>::type
pow(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
    const typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t& stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
      typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t,
      dco::stce_10487::stce_10529<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
pow(const typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::VALUE_TYPE& stce_10082,
    const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::VALUE_TYPE,
      dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>, dco::stce_10487::stce_10530<stce_9770>>(stce_10082,
                                                                                                           stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123>
typename dco::enable_if<
    !dco::is_same<typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::VALUE_TYPE,
                  typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t>::value,
    dco::internal::active_type<stce_9770,
                               typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>>::type
pow(const typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t& stce_10082,
    const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t,
      dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>, dco::stce_10487::stce_10530<stce_9770>>(stce_10082,
                                                                                                           stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
pow(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
    const typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE& stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
      typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
      dco::stce_10487::stce_10529<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
typename dco::enable_if<
    !dco::is_same<
        typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
        typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t>::value,
    dco::internal::active_type<
        stce_9770, typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>>::type
pow(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
    const typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
        stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
      typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t,
      dco::stce_10487::stce_10529<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
pow(const typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE& stce_10082,
    const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
      dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>, dco::stce_10487::stce_10530<stce_9770>>(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
typename dco::enable_if<
    !dco::is_same<
        typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
        typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t>::value,
    dco::internal::active_type<
        stce_9770, typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>>::type
pow(const typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
        stce_10082,
    const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t,
      dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>, dco::stce_10487::stce_10530<stce_9770>>(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
pow(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
    const typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE& stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
      typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
      dco::stce_10487::stce_10529<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
typename dco::enable_if<
    !dco::is_same<
        typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
        typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t>::value,
    dco::internal::active_type<
        stce_9770, typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>>::type
pow(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
    const typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
        stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
      typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t,
      dco::stce_10487::stce_10529<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
pow(const typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE& stce_10082,
    const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
      dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>, dco::stce_10487::stce_10530<stce_9770>>(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
typename dco::enable_if<
    !dco::is_same<
        typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
        typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t>::value,
    dco::internal::active_type<
        stce_9770, typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>>::type
pow(const typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
        stce_10082,
    const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t,
      dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>, dco::stce_10487::stce_10530<stce_9770>>(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
pow(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
    const typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE& stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
      typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
      dco::stce_10487::stce_10529<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
typename dco::enable_if<
    !dco::is_same<
        typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
        typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t>::value,
    dco::internal::active_type<
        stce_9770, typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>>::type
pow(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
    const typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
        stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
      typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t,
      dco::stce_10487::stce_10529<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
pow(const typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE& stce_10082,
    const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
      dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>, dco::stce_10487::stce_10530<stce_9770>>(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
typename dco::enable_if<
    !dco::is_same<
        typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
        typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t>::value,
    dco::internal::active_type<
        stce_9770, typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>>::type
pow(const typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
        stce_10082,
    const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t,
      dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>, dco::stce_10487::stce_10530<stce_9770>>(
      stce_10082, stce_10083);
}
template <typename stce_9781, typename stce_9873>
typename enable_if<
    (dco::mode<stce_9873>::order > 0 &&
     (dco::internal::is_gbcp_type<stce_9781>::value ||
      (dco::mode<stce_9781>::is_intermediate_type && dco::internal::is_gbcp_type<typename stce_9781::data_t>::value)) &&
     dco::is_same<typename dco::mode<stce_9781>::active_t, typename dco::mode<stce_9873>::active_t>::value),
    dco::internal::stce_9778<typename dco::mode<stce_9873>::active_value_t, typename dco::mode<stce_9873>::active_t,
                             stce_9873,
                             dco::stce_10487::stce_10528<typename dco::mode<stce_9873>::active_value_t>>>::type
pow(const stce_9781& stce_10082, const stce_9873& stce_10083) {
  return dco::internal::stce_9778<typename dco::mode<stce_9873>::active_value_t,
                                  typename dco::mode<stce_9873>::active_t, stce_9873,
                                  dco::stce_10487::stce_10528<typename dco::mode<stce_9873>::active_value_t>>(
      stce_10082, stce_10083);
}
template <typename stce_9781, typename stce_9873>
typename enable_if<
    (dco::mode<stce_9781>::order > 0 &&
     (dco::internal::is_gbcp_type<stce_9873>::value ||
      (dco::mode<stce_9873>::is_intermediate_type && dco::internal::is_gbcp_type<typename stce_9873::data_t>::value)) &&
     dco::is_same<typename dco::mode<stce_9873>::active_t, typename dco::mode<stce_9781>::active_t>::value),
    dco::internal::stce_9778<typename dco::mode<stce_9781>::active_value_t, stce_9781,
                             typename dco::mode<stce_9781>::active_t,
                             dco::stce_10487::stce_10528<typename dco::mode<stce_9781>::active_value_t>>>::type
pow(const stce_9781& stce_10082, const stce_9873& stce_10083) {
  return dco::internal::stce_9778<typename dco::mode<stce_9781>::active_value_t, stce_9781,
                                  typename dco::mode<stce_9781>::active_t,
                                  dco::stce_10487::stce_10528<typename dco::mode<stce_9781>::active_value_t>>(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
hypot(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
      const dco::internal::active_type<stce_9770, stce_10119>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::stce_10487::stce_10533<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10536, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
hypot(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
      const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>,
                                  dco::stce_10487::stce_10533<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10538, class stce_10539, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
hypot(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
      const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10533<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10538, class stce_10539, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
hypot(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
      const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10533<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10538, class stce_10539, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
hypot(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
      const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10533<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10540>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
hypot(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
      const dco::internal::active_type<stce_9770, stce_10540>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::internal::active_type<stce_9770, stce_10540>,
                                  dco::stce_10487::stce_10533<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10536, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
hypot(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
      const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>,
                                  dco::stce_10487::stce_10533<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10538, class stce_10539, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
hypot(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
      const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10533<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10538, class stce_10539, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
hypot(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
      const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10533<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10538, class stce_10539, class stce_10537>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
hypot(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
      const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10533<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10540>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
hypot(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
      const dco::internal::active_type<stce_9770, stce_10540>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::active_type<stce_9770, stce_10540>,
                                  dco::stce_10487::stce_10533<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10536, class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
hypot(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
      const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>,
                                  dco::stce_10487::stce_10533<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
hypot(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
      const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10533<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
hypot(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
      const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10533<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
hypot(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
      const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10533<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10540>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
hypot(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
      const dco::internal::active_type<stce_9770, stce_10540>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::active_type<stce_9770, stce_10540>,
                                  dco::stce_10487::stce_10533<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10536, class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
hypot(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
      const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>,
                                  dco::stce_10487::stce_10533<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
hypot(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
      const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10533<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
hypot(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
      const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10533<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
hypot(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
      const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10533<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10540>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
hypot(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
      const dco::internal::active_type<stce_9770, stce_10540>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::active_type<stce_9770, stce_10540>,
                                  dco::stce_10487::stce_10533<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10536, class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
hypot(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
      const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>,
                                  dco::stce_10487::stce_10533<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
hypot(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
      const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10533<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
hypot(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
      const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10533<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
hypot(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
      const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
                                  dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>,
                                  dco::stce_10487::stce_10533<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
hypot(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
      const typename dco::internal::active_type<stce_9770, stce_10119>::VALUE_TYPE& stce_10083) {
  return dco::internal::stce_9779<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  typename dco::internal::active_type<stce_9770, stce_10119>::VALUE_TYPE,
                                  dco::stce_10487::stce_10534<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
typename dco::enable_if<
    !dco::is_same<typename dco::internal::active_type<stce_9770, stce_10119>::VALUE_TYPE,
                  typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t>::value,
    dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>>::type
hypot(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
      const typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t& stce_10083) {
  return dco::internal::stce_9779<stce_9770, dco::internal::active_type<stce_9770, stce_10119>,
                                  typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t,
                                  dco::stce_10487::stce_10534<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>
hypot(const typename dco::internal::active_type<stce_9770, stce_10119>::VALUE_TYPE& stce_10082,
      const dco::internal::active_type<stce_9770, stce_10119>& stce_10083) {
  return dco::internal::stce_9780<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::VALUE_TYPE,
                                  dco::internal::active_type<stce_9770, stce_10119>,
                                  dco::stce_10487::stce_10535<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
typename dco::enable_if<
    !dco::is_same<typename dco::internal::active_type<stce_9770, stce_10119>::VALUE_TYPE,
                  typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t>::value,
    dco::internal::active_type<stce_9770, typename dco::internal::active_type<stce_9770, stce_10119>::data_t>>::type
hypot(const typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t& stce_10082,
      const dco::internal::active_type<stce_9770, stce_10119>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t,
      dco::internal::active_type<stce_9770, stce_10119>, dco::stce_10487::stce_10535<stce_9770>>(stce_10082,
                                                                                                 stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
hypot(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
      const typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::VALUE_TYPE& stce_10083) {
  return dco::internal::stce_9779<stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
                                  typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::VALUE_TYPE,
                                  dco::stce_10487::stce_10534<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123>
typename dco::enable_if<
    !dco::is_same<typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::VALUE_TYPE,
                  typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t>::value,
    dco::internal::active_type<stce_9770,
                               typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>>::type
hypot(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
      const typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t& stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>,
      typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t,
      dco::stce_10487::stce_10534<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123>
dco::internal::active_type<stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>
hypot(const typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::VALUE_TYPE& stce_10082,
      const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::VALUE_TYPE,
      dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>, dco::stce_10487::stce_10535<stce_9770>>(stce_10082,
                                                                                                           stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123>
typename dco::enable_if<
    !dco::is_same<typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::VALUE_TYPE,
                  typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t>::value,
    dco::internal::active_type<stce_9770,
                               typename dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t>>::type
hypot(const typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t& stce_10082,
      const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t,
      dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>, dco::stce_10487::stce_10535<stce_9770>>(stce_10082,
                                                                                                           stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
hypot(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
      const typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE& stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
      typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
      dco::stce_10487::stce_10534<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
typename dco::enable_if<
    !dco::is_same<
        typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
        typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t>::value,
    dco::internal::active_type<
        stce_9770, typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>>::type
hypot(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
      const typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
          stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>,
      typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t,
      dco::stce_10487::stce_10534<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
hypot(const typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE& stce_10082,
      const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
      dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>, dco::stce_10487::stce_10535<stce_9770>>(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
typename dco::enable_if<
    !dco::is_same<
        typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
        typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t>::value,
    dco::internal::active_type<
        stce_9770, typename dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>>::type
hypot(const typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
          stce_10082,
      const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t,
      dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>, dco::stce_10487::stce_10535<stce_9770>>(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
hypot(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
      const typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE& stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
      typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
      dco::stce_10487::stce_10534<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
typename dco::enable_if<
    !dco::is_same<
        typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
        typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t>::value,
    dco::internal::active_type<
        stce_9770, typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>>::type
hypot(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
      const typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
          stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>,
      typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t,
      dco::stce_10487::stce_10534<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
hypot(const typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE& stce_10082,
      const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
      dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>, dco::stce_10487::stce_10535<stce_9770>>(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
typename dco::enable_if<
    !dco::is_same<
        typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
        typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t>::value,
    dco::internal::active_type<
        stce_9770, typename dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>>::type
hypot(const typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
          stce_10082,
      const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t,
      dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>, dco::stce_10487::stce_10535<stce_9770>>(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
hypot(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
      const typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE& stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
      typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
      dco::stce_10487::stce_10534<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
typename dco::enable_if<
    !dco::is_same<
        typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
        typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t>::value,
    dco::internal::active_type<
        stce_9770, typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>>::type
hypot(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
      const typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
          stce_10083) {
  return dco::internal::stce_9779<
      stce_9770, dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>,
      typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t,
      dco::stce_10487::stce_10534<stce_9770>>(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
dco::internal::active_type<stce_9770,
                           typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>
hypot(const typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE& stce_10082,
      const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
      dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>, dco::stce_10487::stce_10535<stce_9770>>(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
typename dco::enable_if<
    !dco::is_same<
        typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::VALUE_TYPE,
        typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t>::value,
    dco::internal::active_type<
        stce_9770, typename dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t>>::type
hypot(const typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
          stce_10082,
      const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<
      stce_9770, typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t,
      dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>, dco::stce_10487::stce_10535<stce_9770>>(
      stce_10082, stce_10083);
}
template <typename stce_9781, typename stce_9873>
typename enable_if<
    (dco::mode<stce_9873>::order > 0 &&
     (dco::internal::is_gbcp_type<stce_9781>::value ||
      (dco::mode<stce_9781>::is_intermediate_type && dco::internal::is_gbcp_type<typename stce_9781::data_t>::value)) &&
     dco::is_same<typename dco::mode<stce_9781>::active_t, typename dco::mode<stce_9873>::active_t>::value),
    dco::internal::stce_9778<typename dco::mode<stce_9873>::active_value_t, typename dco::mode<stce_9873>::active_t,
                             stce_9873,
                             dco::stce_10487::stce_10533<typename dco::mode<stce_9873>::active_value_t>>>::type
hypot(const stce_9781& stce_10082, const stce_9873& stce_10083) {
  return dco::internal::stce_9778<typename dco::mode<stce_9873>::active_value_t,
                                  typename dco::mode<stce_9873>::active_t, stce_9873,
                                  dco::stce_10487::stce_10533<typename dco::mode<stce_9873>::active_value_t>>(
      stce_10082, stce_10083);
}
template <typename stce_9781, typename stce_9873>
typename enable_if<
    (dco::mode<stce_9781>::order > 0 &&
     (dco::internal::is_gbcp_type<stce_9873>::value ||
      (dco::mode<stce_9873>::is_intermediate_type && dco::internal::is_gbcp_type<typename stce_9873::data_t>::value)) &&
     dco::is_same<typename dco::mode<stce_9873>::active_t, typename dco::mode<stce_9781>::active_t>::value),
    dco::internal::stce_9778<typename dco::mode<stce_9781>::active_value_t, stce_9781,
                             typename dco::mode<stce_9781>::active_t,
                             dco::stce_10487::stce_10533<typename dco::mode<stce_9781>::active_value_t>>>::type
hypot(const stce_9781& stce_10082, const stce_9873& stce_10083) {
  return dco::internal::stce_9778<typename dco::mode<stce_9781>::active_value_t, stce_9781,
                                  typename dco::mode<stce_9781>::active_t,
                                  dco::stce_10487::stce_10533<typename dco::mode<stce_9781>::active_value_t>>(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
static inline auto operator==(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
                              const dco::internal::active_type<stce_9770, stce_10119>& stce_10083)
    -> decltype(dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10081(stce_10082,
                                                                                                  stce_10083)) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10081(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10536, class stce_10537>
static inline auto operator==(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
                              const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083)
    -> decltype(dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10081(stce_10082,
                                                                                                  stce_10083)) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10081(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10538, class stce_10539, class stce_10537>
static inline auto operator==(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
                              const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10081(stce_10082,
                                                                                                  stce_10083)) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10081(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10538, class stce_10539, class stce_10537>
static inline auto operator==(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
                              const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10081(stce_10082,
                                                                                                  stce_10083)) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10081(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10538, class stce_10539, class stce_10537>
static inline auto operator==(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
                              const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10081(stce_10082,
                                                                                                  stce_10083)) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10081(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10540>
static inline auto operator==(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
                              const dco::internal::active_type<stce_9770, stce_10540>& stce_10083)
    -> decltype(dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10081(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10081(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10536, class stce_10537>
static inline auto operator==(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
                              const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10081(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10081(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10538, class stce_10539, class stce_10537>
static inline auto operator==(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
                              const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10081(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10081(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10538, class stce_10539, class stce_10537>
static inline auto operator==(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
                              const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10081(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10081(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10538, class stce_10539, class stce_10537>
static inline auto operator==(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
                              const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10081(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10081(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10540>
static inline auto operator==(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::active_type<stce_9770, stce_10540>& stce_10083)
    -> decltype(dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10081(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10081(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10536, class stce_10537>
static inline auto operator==(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10081(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10081(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator==(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10081(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10081(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator==(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10081(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10081(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator==(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10081(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10081(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10540>
static inline auto operator==(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::active_type<stce_9770, stce_10540>& stce_10083)
    -> decltype(dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10081(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10081(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10536, class stce_10537>
static inline auto operator==(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10081(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10081(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator==(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10081(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10081(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator==(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10081(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10081(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator==(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10081(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10081(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10540>
static inline auto operator==(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::active_type<stce_9770, stce_10540>& stce_10083)
    -> decltype(dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10081(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10081(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10536, class stce_10537>
static inline auto operator==(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10081(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10081(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator==(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10081(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10081(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator==(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10081(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10081(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator==(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10081(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10081(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
static inline auto
operator==(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
           const typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t& stce_10083)
    -> decltype(dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10084(stce_10082,
                                                                                                  stce_10083)) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10084(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
static inline auto
operator==(const typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t& stce_10082,
           const dco::internal::active_type<stce_9770, stce_10119>& stce_10083)
    -> decltype(dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10085(stce_10082,
                                                                                                  stce_10083)) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10085(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123>
static inline auto
operator==(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
           const typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t& stce_10083)
    -> decltype(dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10084(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10084(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123>
static inline auto
operator==(const typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t& stce_10082,
           const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10083)
    -> decltype(dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10085(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10085(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline auto
operator==(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
           const typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
               stce_10083)
    -> decltype(dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10084(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10084(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline auto
operator==(const typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
               stce_10082,
           const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083)
    -> decltype(dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10085(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10085(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline auto
operator==(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
           const typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
               stce_10083)
    -> decltype(dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10084(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10084(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline auto
operator==(const typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
               stce_10082,
           const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083)
    -> decltype(dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10085(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10085(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline auto
operator==(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
           const typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
               stce_10083)
    -> decltype(dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10084(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10084(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline auto
operator==(const typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
               stce_10082,
           const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083)
    -> decltype(dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10085(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10085(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator==(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082, const stce_9781& stce_10083) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10084(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator==(const stce_9781& stce_10082, const dco::internal::active_type<stce_9770, stce_10119>& stce_10083) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10085(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator==(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082, const stce_9781& stce_10083) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10084(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator==(const stce_9781& stce_10082, const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10083) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10085(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator==(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
           const stce_9781& stce_10083) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10084(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator==(const stce_9781& stce_10082,
           const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10085(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator==(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
           const stce_9781& stce_10083) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10084(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator==(const stce_9781& stce_10082,
           const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10085(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator==(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
           const stce_9781& stce_10083) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10084(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator==(const stce_9781& stce_10082,
           const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10085(
      stce_10082, stce_10083);
}
template <typename stce_9781, typename stce_9873>
static inline typename enable_if<
    (dco::mode<stce_9873>::order > 0 &&
     (dco::internal::is_gbcp_type<stce_9781>::value ||
      (dco::mode<stce_9781>::is_intermediate_type && dco::internal::is_gbcp_type<typename stce_9781::data_t>::value)) &&
     dco::is_same<typename dco::mode<stce_9781>::active_t, typename dco::mode<stce_9873>::active_t>::value),
    bool>::type
operator==(const stce_9781& stce_10082, const stce_9873& stce_10083) {
  return dco::mode<stce_9873>::active_t::data_t::stce_10134::stce_10081(stce_10082, stce_10083);
}
template <typename stce_9781, typename stce_9873>
static inline typename enable_if<
    (dco::mode<stce_9781>::order > 0 &&
     (dco::internal::is_gbcp_type<stce_9873>::value ||
      (dco::mode<stce_9873>::is_intermediate_type && dco::internal::is_gbcp_type<typename stce_9873::data_t>::value)) &&
     dco::is_same<typename dco::mode<stce_9873>::active_t, typename dco::mode<stce_9781>::active_t>::value),
    bool>::type
operator==(const stce_9781& stce_10082, const stce_9873& stce_10083) {
  return dco::mode<stce_9781>::active_t::data_t::stce_10134::stce_10081(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
static inline auto operator!=(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
                              const dco::internal::active_type<stce_9770, stce_10119>& stce_10083)
    -> decltype(dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10086(stce_10082,
                                                                                                  stce_10083)) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10086(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10536, class stce_10537>
static inline auto operator!=(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
                              const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083)
    -> decltype(dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10086(stce_10082,
                                                                                                  stce_10083)) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10086(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10538, class stce_10539, class stce_10537>
static inline auto operator!=(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
                              const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10086(stce_10082,
                                                                                                  stce_10083)) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10086(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10538, class stce_10539, class stce_10537>
static inline auto operator!=(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
                              const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10086(stce_10082,
                                                                                                  stce_10083)) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10086(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10538, class stce_10539, class stce_10537>
static inline auto operator!=(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
                              const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10086(stce_10082,
                                                                                                  stce_10083)) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10086(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10540>
static inline auto operator!=(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
                              const dco::internal::active_type<stce_9770, stce_10540>& stce_10083)
    -> decltype(dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10086(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10086(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10536, class stce_10537>
static inline auto operator!=(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
                              const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10086(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10086(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10538, class stce_10539, class stce_10537>
static inline auto operator!=(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
                              const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10086(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10086(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10538, class stce_10539, class stce_10537>
static inline auto operator!=(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
                              const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10086(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10086(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10538, class stce_10539, class stce_10537>
static inline auto operator!=(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
                              const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10086(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10086(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10540>
static inline auto operator!=(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::active_type<stce_9770, stce_10540>& stce_10083)
    -> decltype(dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10086(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10086(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10536, class stce_10537>
static inline auto operator!=(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10086(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10086(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator!=(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10086(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10086(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator!=(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10086(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10086(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator!=(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10086(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10086(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10540>
static inline auto operator!=(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::active_type<stce_9770, stce_10540>& stce_10083)
    -> decltype(dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10086(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10086(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10536, class stce_10537>
static inline auto operator!=(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10086(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10086(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator!=(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10086(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10086(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator!=(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10086(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10086(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator!=(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10086(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10086(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10540>
static inline auto operator!=(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::active_type<stce_9770, stce_10540>& stce_10083)
    -> decltype(dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10086(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10086(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10536, class stce_10537>
static inline auto operator!=(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10086(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10086(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator!=(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10086(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10086(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator!=(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10086(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10086(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator!=(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10086(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10086(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
static inline auto
operator!=(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
           const typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t& stce_10083)
    -> decltype(dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10087(stce_10082,
                                                                                                  stce_10083)) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10087(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
static inline auto
operator!=(const typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t& stce_10082,
           const dco::internal::active_type<stce_9770, stce_10119>& stce_10083)
    -> decltype(dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10088(stce_10082,
                                                                                                  stce_10083)) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10088(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123>
static inline auto
operator!=(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
           const typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t& stce_10083)
    -> decltype(dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10087(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10087(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123>
static inline auto
operator!=(const typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t& stce_10082,
           const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10083)
    -> decltype(dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10088(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10088(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline auto
operator!=(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
           const typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
               stce_10083)
    -> decltype(dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10087(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10087(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline auto
operator!=(const typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
               stce_10082,
           const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083)
    -> decltype(dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10088(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10088(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline auto
operator!=(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
           const typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
               stce_10083)
    -> decltype(dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10087(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10087(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline auto
operator!=(const typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
               stce_10082,
           const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083)
    -> decltype(dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10088(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10088(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline auto
operator!=(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
           const typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
               stce_10083)
    -> decltype(dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10087(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10087(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline auto
operator!=(const typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
               stce_10082,
           const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083)
    -> decltype(dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10088(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10088(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator!=(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082, const stce_9781& stce_10083) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10087(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator!=(const stce_9781& stce_10082, const dco::internal::active_type<stce_9770, stce_10119>& stce_10083) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10088(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator!=(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082, const stce_9781& stce_10083) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10087(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator!=(const stce_9781& stce_10082, const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10083) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10088(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator!=(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
           const stce_9781& stce_10083) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10087(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator!=(const stce_9781& stce_10082,
           const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10088(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator!=(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
           const stce_9781& stce_10083) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10087(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator!=(const stce_9781& stce_10082,
           const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10088(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator!=(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
           const stce_9781& stce_10083) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10087(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator!=(const stce_9781& stce_10082,
           const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10088(
      stce_10082, stce_10083);
}
template <typename stce_9781, typename stce_9873>
static inline typename enable_if<
    (dco::mode<stce_9873>::order > 0 &&
     (dco::internal::is_gbcp_type<stce_9781>::value ||
      (dco::mode<stce_9781>::is_intermediate_type && dco::internal::is_gbcp_type<typename stce_9781::data_t>::value)) &&
     dco::is_same<typename dco::mode<stce_9781>::active_t, typename dco::mode<stce_9873>::active_t>::value),
    bool>::type
operator!=(const stce_9781& stce_10082, const stce_9873& stce_10083) {
  return dco::mode<stce_9873>::active_t::data_t::stce_10134::stce_10086(stce_10082, stce_10083);
}
template <typename stce_9781, typename stce_9873>
static inline typename enable_if<
    (dco::mode<stce_9781>::order > 0 &&
     (dco::internal::is_gbcp_type<stce_9873>::value ||
      (dco::mode<stce_9873>::is_intermediate_type && dco::internal::is_gbcp_type<typename stce_9873::data_t>::value)) &&
     dco::is_same<typename dco::mode<stce_9873>::active_t, typename dco::mode<stce_9781>::active_t>::value),
    bool>::type
operator!=(const stce_9781& stce_10082, const stce_9873& stce_10083) {
  return dco::mode<stce_9781>::active_t::data_t::stce_10134::stce_10086(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
static inline auto operator<(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
                             const dco::internal::active_type<stce_9770, stce_10119>& stce_10083)
    -> decltype(dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10089(stce_10082,
                                                                                                  stce_10083)) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10089(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10536, class stce_10537>
static inline auto operator<(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
                             const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083)
    -> decltype(dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10089(stce_10082,
                                                                                                  stce_10083)) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10089(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10538, class stce_10539, class stce_10537>
static inline auto operator<(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
                             const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10089(stce_10082,
                                                                                                  stce_10083)) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10089(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10538, class stce_10539, class stce_10537>
static inline auto operator<(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
                             const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10089(stce_10082,
                                                                                                  stce_10083)) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10089(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10538, class stce_10539, class stce_10537>
static inline auto operator<(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
                             const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10089(stce_10082,
                                                                                                  stce_10083)) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10089(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10540>
static inline auto operator<(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
                             const dco::internal::active_type<stce_9770, stce_10540>& stce_10083)
    -> decltype(dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10089(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10089(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10536, class stce_10537>
static inline auto operator<(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
                             const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10089(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10089(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10538, class stce_10539, class stce_10537>
static inline auto operator<(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
                             const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10089(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10089(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10538, class stce_10539, class stce_10537>
static inline auto operator<(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
                             const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10089(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10089(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10538, class stce_10539, class stce_10537>
static inline auto operator<(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
                             const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10089(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10089(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10540>
static inline auto operator<(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                             const dco::internal::active_type<stce_9770, stce_10540>& stce_10083)
    -> decltype(dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10089(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10089(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10536, class stce_10537>
static inline auto operator<(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                             const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10089(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10089(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator<(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                             const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10089(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10089(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator<(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                             const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10089(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10089(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator<(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                             const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10089(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10089(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10540>
static inline auto operator<(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                             const dco::internal::active_type<stce_9770, stce_10540>& stce_10083)
    -> decltype(dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10089(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10089(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10536, class stce_10537>
static inline auto operator<(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                             const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10089(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10089(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator<(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                             const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10089(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10089(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator<(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                             const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10089(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10089(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator<(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                             const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10089(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10089(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10540>
static inline auto operator<(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                             const dco::internal::active_type<stce_9770, stce_10540>& stce_10083)
    -> decltype(dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10089(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10089(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10536, class stce_10537>
static inline auto operator<(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                             const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10089(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10089(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator<(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                             const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10089(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10089(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator<(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                             const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10089(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10089(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator<(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                             const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10089(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10089(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
static inline auto
operator<(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
          const typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t& stce_10083)
    -> decltype(dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10090(stce_10082,
                                                                                                  stce_10083)) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10090(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
static inline auto
operator<(const typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t& stce_10082,
          const dco::internal::active_type<stce_9770, stce_10119>& stce_10083)
    -> decltype(dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10091(stce_10082,
                                                                                                  stce_10083)) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10091(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123>
static inline auto
operator<(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
          const typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t& stce_10083)
    -> decltype(dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10090(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10090(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123>
static inline auto
operator<(const typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t& stce_10082,
          const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10083)
    -> decltype(dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10091(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10091(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline auto
operator<(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
              stce_10083)
    -> decltype(dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10090(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10090(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline auto
operator<(const typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
              stce_10082,
          const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083)
    -> decltype(dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10091(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10091(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline auto
operator<(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
              stce_10083)
    -> decltype(dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10090(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10090(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline auto
operator<(const typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
              stce_10082,
          const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083)
    -> decltype(dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10091(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10091(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline auto
operator<(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
              stce_10083)
    -> decltype(dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10090(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10090(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline auto
operator<(const typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
              stce_10082,
          const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083)
    -> decltype(dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10091(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10091(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator<(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082, const stce_9781& stce_10083) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10090(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator<(const stce_9781& stce_10082, const dco::internal::active_type<stce_9770, stce_10119>& stce_10083) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10091(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator<(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082, const stce_9781& stce_10083) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10090(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator<(const stce_9781& stce_10082, const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10083) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10091(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator<(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const stce_9781& stce_10083) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10090(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator<(const stce_9781& stce_10082,
          const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10091(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator<(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const stce_9781& stce_10083) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10090(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator<(const stce_9781& stce_10082,
          const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10091(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator<(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const stce_9781& stce_10083) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10090(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator<(const stce_9781& stce_10082,
          const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10091(
      stce_10082, stce_10083);
}
template <typename stce_9781, typename stce_9873>
static inline typename enable_if<
    (dco::mode<stce_9873>::order > 0 &&
     (dco::internal::is_gbcp_type<stce_9781>::value ||
      (dco::mode<stce_9781>::is_intermediate_type && dco::internal::is_gbcp_type<typename stce_9781::data_t>::value)) &&
     dco::is_same<typename dco::mode<stce_9781>::active_t, typename dco::mode<stce_9873>::active_t>::value),
    bool>::type
operator<(const stce_9781& stce_10082, const stce_9873& stce_10083) {
  return dco::mode<stce_9873>::active_t::data_t::stce_10134::stce_10089(stce_10082, stce_10083);
}
template <typename stce_9781, typename stce_9873>
static inline typename enable_if<
    (dco::mode<stce_9781>::order > 0 &&
     (dco::internal::is_gbcp_type<stce_9873>::value ||
      (dco::mode<stce_9873>::is_intermediate_type && dco::internal::is_gbcp_type<typename stce_9873::data_t>::value)) &&
     dco::is_same<typename dco::mode<stce_9873>::active_t, typename dco::mode<stce_9781>::active_t>::value),
    bool>::type
operator<(const stce_9781& stce_10082, const stce_9873& stce_10083) {
  return dco::mode<stce_9781>::active_t::data_t::stce_10134::stce_10089(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
static inline auto operator<=(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
                              const dco::internal::active_type<stce_9770, stce_10119>& stce_10083)
    -> decltype(dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10092(stce_10082,
                                                                                                  stce_10083)) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10092(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10536, class stce_10537>
static inline auto operator<=(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
                              const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083)
    -> decltype(dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10092(stce_10082,
                                                                                                  stce_10083)) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10092(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10538, class stce_10539, class stce_10537>
static inline auto operator<=(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
                              const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10092(stce_10082,
                                                                                                  stce_10083)) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10092(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10538, class stce_10539, class stce_10537>
static inline auto operator<=(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
                              const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10092(stce_10082,
                                                                                                  stce_10083)) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10092(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10538, class stce_10539, class stce_10537>
static inline auto operator<=(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
                              const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10092(stce_10082,
                                                                                                  stce_10083)) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10092(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10540>
static inline auto operator<=(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
                              const dco::internal::active_type<stce_9770, stce_10540>& stce_10083)
    -> decltype(dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10092(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10092(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10536, class stce_10537>
static inline auto operator<=(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
                              const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10092(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10092(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10538, class stce_10539, class stce_10537>
static inline auto operator<=(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
                              const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10092(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10092(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10538, class stce_10539, class stce_10537>
static inline auto operator<=(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
                              const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10092(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10092(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10538, class stce_10539, class stce_10537>
static inline auto operator<=(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
                              const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10092(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10092(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10540>
static inline auto operator<=(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::active_type<stce_9770, stce_10540>& stce_10083)
    -> decltype(dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10092(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10092(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10536, class stce_10537>
static inline auto operator<=(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10092(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10092(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator<=(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10092(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10092(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator<=(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10092(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10092(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator<=(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10092(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10092(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10540>
static inline auto operator<=(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::active_type<stce_9770, stce_10540>& stce_10083)
    -> decltype(dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10092(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10092(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10536, class stce_10537>
static inline auto operator<=(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10092(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10092(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator<=(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10092(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10092(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator<=(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10092(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10092(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator<=(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10092(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10092(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10540>
static inline auto operator<=(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::active_type<stce_9770, stce_10540>& stce_10083)
    -> decltype(dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10092(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10092(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10536, class stce_10537>
static inline auto operator<=(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10092(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10092(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator<=(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10092(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10092(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator<=(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10092(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10092(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator<=(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10092(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10092(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
static inline auto
operator<=(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
           const typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t& stce_10083)
    -> decltype(dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10093(stce_10082,
                                                                                                  stce_10083)) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10093(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
static inline auto
operator<=(const typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t& stce_10082,
           const dco::internal::active_type<stce_9770, stce_10119>& stce_10083)
    -> decltype(dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10094(stce_10082,
                                                                                                  stce_10083)) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10094(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123>
static inline auto
operator<=(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
           const typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t& stce_10083)
    -> decltype(dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10093(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10093(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123>
static inline auto
operator<=(const typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t& stce_10082,
           const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10083)
    -> decltype(dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10094(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10094(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline auto
operator<=(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
           const typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
               stce_10083)
    -> decltype(dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10093(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10093(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline auto
operator<=(const typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
               stce_10082,
           const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083)
    -> decltype(dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10094(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10094(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline auto
operator<=(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
           const typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
               stce_10083)
    -> decltype(dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10093(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10093(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline auto
operator<=(const typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
               stce_10082,
           const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083)
    -> decltype(dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10094(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10094(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline auto
operator<=(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
           const typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
               stce_10083)
    -> decltype(dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10093(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10093(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline auto
operator<=(const typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
               stce_10082,
           const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083)
    -> decltype(dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10094(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10094(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator<=(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082, const stce_9781& stce_10083) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10093(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator<=(const stce_9781& stce_10082, const dco::internal::active_type<stce_9770, stce_10119>& stce_10083) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10094(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator<=(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082, const stce_9781& stce_10083) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10093(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator<=(const stce_9781& stce_10082, const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10083) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10094(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator<=(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
           const stce_9781& stce_10083) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10093(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator<=(const stce_9781& stce_10082,
           const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10094(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator<=(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
           const stce_9781& stce_10083) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10093(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator<=(const stce_9781& stce_10082,
           const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10094(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator<=(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
           const stce_9781& stce_10083) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10093(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator<=(const stce_9781& stce_10082,
           const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10094(
      stce_10082, stce_10083);
}
template <typename stce_9781, typename stce_9873>
static inline typename enable_if<
    (dco::mode<stce_9873>::order > 0 &&
     (dco::internal::is_gbcp_type<stce_9781>::value ||
      (dco::mode<stce_9781>::is_intermediate_type && dco::internal::is_gbcp_type<typename stce_9781::data_t>::value)) &&
     dco::is_same<typename dco::mode<stce_9781>::active_t, typename dco::mode<stce_9873>::active_t>::value),
    bool>::type
operator<=(const stce_9781& stce_10082, const stce_9873& stce_10083) {
  return dco::mode<stce_9873>::active_t::data_t::stce_10134::stce_10092(stce_10082, stce_10083);
}
template <typename stce_9781, typename stce_9873>
static inline typename enable_if<
    (dco::mode<stce_9781>::order > 0 &&
     (dco::internal::is_gbcp_type<stce_9873>::value ||
      (dco::mode<stce_9873>::is_intermediate_type && dco::internal::is_gbcp_type<typename stce_9873::data_t>::value)) &&
     dco::is_same<typename dco::mode<stce_9873>::active_t, typename dco::mode<stce_9781>::active_t>::value),
    bool>::type
operator<=(const stce_9781& stce_10082, const stce_9873& stce_10083) {
  return dco::mode<stce_9781>::active_t::data_t::stce_10134::stce_10092(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
static inline auto operator>(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
                             const dco::internal::active_type<stce_9770, stce_10119>& stce_10083)
    -> decltype(dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10095(stce_10082,
                                                                                                  stce_10083)) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10095(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10536, class stce_10537>
static inline auto operator>(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
                             const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083)
    -> decltype(dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10095(stce_10082,
                                                                                                  stce_10083)) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10095(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10538, class stce_10539, class stce_10537>
static inline auto operator>(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
                             const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10095(stce_10082,
                                                                                                  stce_10083)) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10095(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10538, class stce_10539, class stce_10537>
static inline auto operator>(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
                             const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10095(stce_10082,
                                                                                                  stce_10083)) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10095(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10538, class stce_10539, class stce_10537>
static inline auto operator>(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
                             const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10095(stce_10082,
                                                                                                  stce_10083)) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10095(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10540>
static inline auto operator>(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
                             const dco::internal::active_type<stce_9770, stce_10540>& stce_10083)
    -> decltype(dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10095(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10095(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10536, class stce_10537>
static inline auto operator>(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
                             const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10095(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10095(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10538, class stce_10539, class stce_10537>
static inline auto operator>(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
                             const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10095(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10095(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10538, class stce_10539, class stce_10537>
static inline auto operator>(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
                             const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10095(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10095(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10538, class stce_10539, class stce_10537>
static inline auto operator>(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
                             const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10095(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10095(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10540>
static inline auto operator>(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                             const dco::internal::active_type<stce_9770, stce_10540>& stce_10083)
    -> decltype(dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10095(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10095(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10536, class stce_10537>
static inline auto operator>(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                             const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10095(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10095(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator>(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                             const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10095(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10095(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator>(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                             const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10095(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10095(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator>(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                             const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10095(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10095(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10540>
static inline auto operator>(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                             const dco::internal::active_type<stce_9770, stce_10540>& stce_10083)
    -> decltype(dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10095(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10095(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10536, class stce_10537>
static inline auto operator>(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                             const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10095(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10095(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator>(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                             const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10095(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10095(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator>(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                             const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10095(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10095(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator>(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                             const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10095(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10095(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10540>
static inline auto operator>(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                             const dco::internal::active_type<stce_9770, stce_10540>& stce_10083)
    -> decltype(dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10095(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10095(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10536, class stce_10537>
static inline auto operator>(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                             const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10095(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10095(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator>(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                             const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10095(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10095(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator>(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                             const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10095(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10095(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator>(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                             const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10095(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10095(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
static inline auto
operator>(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
          const typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t& stce_10083)
    -> decltype(dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10096(stce_10082,
                                                                                                  stce_10083)) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10096(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
static inline auto
operator>(const typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t& stce_10082,
          const dco::internal::active_type<stce_9770, stce_10119>& stce_10083)
    -> decltype(dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10097(stce_10082,
                                                                                                  stce_10083)) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10097(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123>
static inline auto
operator>(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
          const typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t& stce_10083)
    -> decltype(dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10096(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10096(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123>
static inline auto
operator>(const typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t& stce_10082,
          const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10083)
    -> decltype(dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10097(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10097(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline auto
operator>(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
              stce_10083)
    -> decltype(dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10096(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10096(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline auto
operator>(const typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
              stce_10082,
          const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083)
    -> decltype(dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10097(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10097(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline auto
operator>(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
              stce_10083)
    -> decltype(dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10096(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10096(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline auto
operator>(const typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
              stce_10082,
          const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083)
    -> decltype(dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10097(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10097(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline auto
operator>(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
              stce_10083)
    -> decltype(dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10096(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10096(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline auto
operator>(const typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
              stce_10082,
          const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083)
    -> decltype(dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10097(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10097(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator>(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082, const stce_9781& stce_10083) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10096(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator>(const stce_9781& stce_10082, const dco::internal::active_type<stce_9770, stce_10119>& stce_10083) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10097(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator>(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082, const stce_9781& stce_10083) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10096(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator>(const stce_9781& stce_10082, const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10083) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10097(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator>(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const stce_9781& stce_10083) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10096(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator>(const stce_9781& stce_10082,
          const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10097(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator>(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const stce_9781& stce_10083) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10096(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator>(const stce_9781& stce_10082,
          const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10097(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator>(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
          const stce_9781& stce_10083) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10096(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator>(const stce_9781& stce_10082,
          const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10097(
      stce_10082, stce_10083);
}
template <typename stce_9781, typename stce_9873>
static inline typename enable_if<
    (dco::mode<stce_9873>::order > 0 &&
     (dco::internal::is_gbcp_type<stce_9781>::value ||
      (dco::mode<stce_9781>::is_intermediate_type && dco::internal::is_gbcp_type<typename stce_9781::data_t>::value)) &&
     dco::is_same<typename dco::mode<stce_9781>::active_t, typename dco::mode<stce_9873>::active_t>::value),
    bool>::type
operator>(const stce_9781& stce_10082, const stce_9873& stce_10083) {
  return dco::mode<stce_9873>::active_t::data_t::stce_10134::stce_10095(stce_10082, stce_10083);
}
template <typename stce_9781, typename stce_9873>
static inline typename enable_if<
    (dco::mode<stce_9781>::order > 0 &&
     (dco::internal::is_gbcp_type<stce_9873>::value ||
      (dco::mode<stce_9873>::is_intermediate_type && dco::internal::is_gbcp_type<typename stce_9873::data_t>::value)) &&
     dco::is_same<typename dco::mode<stce_9873>::active_t, typename dco::mode<stce_9781>::active_t>::value),
    bool>::type
operator>(const stce_9781& stce_10082, const stce_9873& stce_10083) {
  return dco::mode<stce_9781>::active_t::data_t::stce_10134::stce_10095(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
static inline auto operator>=(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
                              const dco::internal::active_type<stce_9770, stce_10119>& stce_10083)
    -> decltype(dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10098(stce_10082,
                                                                                                  stce_10083)) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10098(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10536, class stce_10537>
static inline auto operator>=(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
                              const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083)
    -> decltype(dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10098(stce_10082,
                                                                                                  stce_10083)) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10098(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10538, class stce_10539, class stce_10537>
static inline auto operator>=(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
                              const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10098(stce_10082,
                                                                                                  stce_10083)) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10098(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10538, class stce_10539, class stce_10537>
static inline auto operator>=(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
                              const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10098(stce_10082,
                                                                                                  stce_10083)) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10098(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, class stce_10538, class stce_10539, class stce_10537>
static inline auto operator>=(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
                              const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10098(stce_10082,
                                                                                                  stce_10083)) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10098(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10540>
static inline auto operator>=(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
                              const dco::internal::active_type<stce_9770, stce_10540>& stce_10083)
    -> decltype(dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10098(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10098(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10536, class stce_10537>
static inline auto operator>=(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
                              const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10098(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10098(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10538, class stce_10539, class stce_10537>
static inline auto operator>=(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
                              const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10098(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10098(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10538, class stce_10539, class stce_10537>
static inline auto operator>=(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
                              const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10098(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10098(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, class stce_10538, class stce_10539, class stce_10537>
static inline auto operator>=(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
                              const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10098(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10098(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10540>
static inline auto operator>=(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::active_type<stce_9770, stce_10540>& stce_10083)
    -> decltype(dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10098(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10098(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10536, class stce_10537>
static inline auto operator>=(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10098(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10098(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator>=(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10098(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10098(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator>=(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10098(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10098(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator>=(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10098(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10098(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10540>
static inline auto operator>=(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::active_type<stce_9770, stce_10540>& stce_10083)
    -> decltype(dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10098(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10098(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10536, class stce_10537>
static inline auto operator>=(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10098(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10098(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator>=(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10098(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10098(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator>=(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10098(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10098(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator>=(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10098(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10098(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10540>
static inline auto operator>=(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::active_type<stce_9770, stce_10540>& stce_10083)
    -> decltype(dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10098(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10098(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10536, class stce_10537>
static inline auto operator>=(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9775<stce_9770, stce_10536, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10098(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10098(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator>=(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9778<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10098(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10098(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator>=(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9779<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10098(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10098(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, class stce_10538, class stce_10539,
          class stce_10537>
static inline auto operator>=(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
                              const dco::internal::stce_9780<stce_9770, stce_10538, stce_10539, stce_10537>& stce_10083)
    -> decltype(dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10098(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10098(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
static inline auto
operator>=(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082,
           const typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t& stce_10083)
    -> decltype(dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10099(stce_10082,
                                                                                                  stce_10083)) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10099(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
static inline auto
operator>=(const typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t& stce_10082,
           const dco::internal::active_type<stce_9770, stce_10119>& stce_10083)
    -> decltype(dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10100(stce_10082,
                                                                                                  stce_10083)) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10100(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123>
static inline auto
operator>=(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082,
           const typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t& stce_10083)
    -> decltype(dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10099(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10099(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123>
static inline auto
operator>=(const typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t& stce_10082,
           const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10083)
    -> decltype(dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10100(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10100(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline auto
operator>=(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
           const typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
               stce_10083)
    -> decltype(dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10099(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10099(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline auto
operator>=(const typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
               stce_10082,
           const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083)
    -> decltype(dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10100(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10100(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline auto
operator>=(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
           const typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
               stce_10083)
    -> decltype(dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10099(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10099(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline auto
operator>=(const typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
               stce_10082,
           const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083)
    -> decltype(dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10100(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10100(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline auto
operator>=(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
           const typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
               stce_10083)
    -> decltype(dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10099(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10099(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline auto
operator>=(const typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t&
               stce_10082,
           const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083)
    -> decltype(dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10100(
        stce_10082, stce_10083)) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10100(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator>=(const dco::internal::active_type<stce_9770, stce_10119>& stce_10082, const stce_9781& stce_10083) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10099(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator>=(const stce_9781& stce_10082, const dco::internal::active_type<stce_9770, stce_10119>& stce_10083) {
  return dco::internal::active_type<stce_9770, stce_10119>::data_t::stce_10134::stce_10100(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator>=(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10082, const stce_9781& stce_10083) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10099(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10129, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator>=(const stce_9781& stce_10082, const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_10083) {
  return dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>::data_t::stce_10134::stce_10100(stce_10082,
                                                                                                     stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator>=(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
           const stce_9781& stce_10083) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10099(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator>=(const stce_9781& stce_10082,
           const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10100(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator>=(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
           const stce_9781& stce_10083) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10099(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator>=(const stce_9781& stce_10082,
           const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10100(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator>=(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10082,
           const stce_9781& stce_10083) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10099(
      stce_10082, stce_10083);
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123, typename stce_9781>
static inline typename dco::dco_type_constructable_from<stce_9781, bool>::type
operator>=(const stce_9781& stce_10082,
           const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_10083) {
  return dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>::data_t::stce_10134::stce_10100(
      stce_10082, stce_10083);
}
template <typename stce_9781, typename stce_9873>
static inline typename enable_if<
    (dco::mode<stce_9873>::order > 0 &&
     (dco::internal::is_gbcp_type<stce_9781>::value ||
      (dco::mode<stce_9781>::is_intermediate_type && dco::internal::is_gbcp_type<typename stce_9781::data_t>::value)) &&
     dco::is_same<typename dco::mode<stce_9781>::active_t, typename dco::mode<stce_9873>::active_t>::value),
    bool>::type
operator>=(const stce_9781& stce_10082, const stce_9873& stce_10083) {
  return dco::mode<stce_9873>::active_t::data_t::stce_10134::stce_10098(stce_10082, stce_10083);
}
template <typename stce_9781, typename stce_9873>
static inline typename enable_if<
    (dco::mode<stce_9781>::order > 0 &&
     (dco::internal::is_gbcp_type<stce_9873>::value ||
      (dco::mode<stce_9873>::is_intermediate_type && dco::internal::is_gbcp_type<typename stce_9873::data_t>::value)) &&
     dco::is_same<typename dco::mode<stce_9873>::active_t, typename dco::mode<stce_9781>::active_t>::value),
    bool>::type
operator>=(const stce_9781& stce_10082, const stce_9873& stce_10083) {
  return dco::mode<stce_9781>::active_t::data_t::stce_10134::stce_10098(stce_10082, stce_10083);
}
template <class stce_9770, class stce_10119>
static inline void stce_10541(dco::internal::active_type<stce_9770, stce_10119>& stce_9803) {
  double stce_10020 = 0;
  get(stce_9803, stce_10020);
  stce_9803 = stce_10020;
}
template <class stce_9770, class stce_10119>
static inline std::istream& operator>>(std::istream& in, dco::internal::active_type<stce_9770, stce_10119>& stce_9803) {
  stce_9770& stce_10020 = stce_9803._value();
  in >> stce_10020;
  return in;
}
using std::ceil;
using std::floor;
using std::isfinite;
using std::isinf;
using std::isnan;
using std::isnormal;
using std::lround;
using std::round;
template <class stce_9770, class stce_10119>
static inline bool isnan(const dco::internal::active_type<stce_9770, stce_10119>& stce_9803) {
  return isnan(stce_9803._value());
}
template <class stce_9770, class stce_10119>
static inline bool isnormal(const dco::internal::active_type<stce_9770, stce_10119>& stce_9803) {
  return isnormal(stce_9803._value());
}
template <class stce_9770, class stce_10119>
static inline bool isinf(const dco::internal::active_type<stce_9770, stce_10119>& stce_9803) {
  return isinf(stce_9803._value());
}
template <class stce_9770, class stce_10119>
static inline double ceil(const dco::internal::active_type<stce_9770, stce_10119>& stce_9803) {
  return ceil(stce_9803._value());
}
template <class stce_9770, class stce_10119>
static inline double floor(const dco::internal::active_type<stce_9770, stce_10119>& stce_9803) {
  return floor(stce_9803._value());
}
template <class stce_9770, class stce_10119>
static inline bool isfinite(const dco::internal::active_type<stce_9770, stce_10119>& stce_9803) {
  return isfinite(stce_9803._value());
}
template <class stce_9770, class stce_10119>
static inline typename dco::mode<dco::internal::active_type<stce_9770, stce_10119>>::passive_t
round(const dco::internal::active_type<stce_9770, stce_10119>& stce_9803) {
  return round(dco::passive_value(stce_9803));
}
template <class stce_9770, class stce_10119>
static inline long int lround(const dco::internal::active_type<stce_9770, stce_10119>& stce_9803) {
  return lround(dco::passive_value(stce_9803));
}
using std::ceil;
using std::floor;
using std::isfinite;
using std::isinf;
using std::isnan;
using std::isnormal;
using std::lround;
using std::round;
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline bool isnan(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
  return isnan(stce_9803._value());
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline bool isnormal(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
  return isnormal(stce_9803._value());
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline bool isinf(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
  return isinf(stce_9803._value());
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline double ceil(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
  return ceil(stce_9803._value());
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline double floor(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
  return floor(stce_9803._value());
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline bool isfinite(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
  return isfinite(stce_9803._value());
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t
round(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
  return round(dco::passive_value(stce_9803));
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline long int
lround(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
  return lround(dco::passive_value(stce_9803));
}
using std::ceil;
using std::floor;
using std::isfinite;
using std::isinf;
using std::isnan;
using std::isnormal;
using std::lround;
using std::round;
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline bool isnan(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
  return isnan(stce_9803._value());
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline bool isnormal(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
  return isnormal(stce_9803._value());
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline bool isinf(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
  return isinf(stce_9803._value());
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline double ceil(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
  return ceil(stce_9803._value());
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline double floor(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
  return floor(stce_9803._value());
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline bool isfinite(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
  return isfinite(stce_9803._value());
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t
round(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
  return round(dco::passive_value(stce_9803));
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline long int
lround(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
  return lround(dco::passive_value(stce_9803));
}
using std::ceil;
using std::floor;
using std::isfinite;
using std::isinf;
using std::isnan;
using std::isnormal;
using std::lround;
using std::round;
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline bool isnan(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
  return isnan(stce_9803._value());
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline bool isnormal(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
  return isnormal(stce_9803._value());
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline bool isinf(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
  return isinf(stce_9803._value());
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline double ceil(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
  return ceil(stce_9803._value());
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline double floor(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
  return floor(stce_9803._value());
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline bool isfinite(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
  return isfinite(stce_9803._value());
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::passive_t
round(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
  return round(dco::passive_value(stce_9803));
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline long int
lround(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
  return lround(dco::passive_value(stce_9803));
}
using std::ceil;
using std::floor;
using std::isfinite;
using std::isinf;
using std::isnan;
using std::isnormal;
using std::lround;
using std::round;
template <class stce_9770, class stce_10129, class stce_10123>
static inline bool isnan(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_9803) {
  return isnan(stce_9803._value());
}
template <class stce_9770, class stce_10129, class stce_10123>
static inline bool isnormal(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_9803) {
  return isnormal(stce_9803._value());
}
template <class stce_9770, class stce_10129, class stce_10123>
static inline bool isinf(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_9803) {
  return isinf(stce_9803._value());
}
template <class stce_9770, class stce_10129, class stce_10123>
static inline double ceil(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_9803) {
  return ceil(stce_9803._value());
}
template <class stce_9770, class stce_10129, class stce_10123>
static inline double floor(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_9803) {
  return floor(stce_9803._value());
}
template <class stce_9770, class stce_10129, class stce_10123>
static inline bool isfinite(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_9803) {
  return isfinite(stce_9803._value());
}
template <class stce_9770, class stce_10129, class stce_10123>
static inline typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::passive_t
round(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_9803) {
  return round(dco::passive_value(stce_9803));
}
template <class stce_9770, class stce_10129, class stce_10123>
static inline long int lround(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_9803) {
  return lround(dco::passive_value(stce_9803));
}
template <class stce_9770, class stce_10119>
static inline std::ostream& operator<<(std::ostream& out,
                                       const dco::internal::active_type<stce_9770, stce_10119>& stce_9803) {
  out << stce_9803._value();
  return out;
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline std::ostream&
operator<<(std::ostream& out,
           const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
  out << stce_9803._value();
  return out;
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline std::ostream&
operator<<(std::ostream& out,
           const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
  out << stce_9803._value();
  return out;
}
template <class stce_9770, class stce_10121, class stce_10122, class stce_10123>
static inline std::ostream&
operator<<(std::ostream& out,
           const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
  out << stce_9803._value();
  return out;
}
template <class stce_9770, class stce_10129, class stce_10123>
static inline std::ostream& operator<<(std::ostream& out,
                                       const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_9803) {
  out << stce_9803._value();
  return out;
}
template <typename stce_9781, typename stce_9873,
          typename stce_10542 = decltype(passive_value(std::declval<stce_9781>()) <
                                         passive_value(std::declval<stce_9873>()))>
typename enable_if<mode<stce_9781>::is_dco_type || mode<stce_9873>::is_dco_type,
                   typename stce_9872<(mode<stce_9781>::order > mode<stce_9873>::order), typename mode<stce_9781>::type,
                                      typename mode<stce_9873>::type>::type>::type
min(stce_9781 const& stce_10006, stce_9873 const& stce_10543) {
  if (passive_value(stce_10006) < passive_value(stce_10543))
    return stce_10006;
  else
    return stce_10543;
}
template <typename stce_9781, typename stce_9873,
          typename stce_10542 = decltype(passive_value(std::declval<stce_9781>()) >
                                         passive_value(std::declval<stce_9873>()))>
typename enable_if<mode<stce_9781>::is_dco_type || mode<stce_9873>::is_dco_type,
                   typename stce_9872<(mode<stce_9781>::order > mode<stce_9873>::order), typename mode<stce_9781>::type,
                                      typename mode<stce_9873>::type>::type>::type
max(stce_9781 const& stce_10006, stce_9873 const& stce_10543) {
  if (passive_value(stce_10006) > passive_value(stce_10543))
    return stce_10006;
  else
    return stce_10543;
}
} // namespace internal
} // namespace dco

namespace dco {
namespace helper {
template <typename stce_9781> class complex_t {
private:
  stce_9781 stce_10544;
  stce_9781 stce_10545;

public:
  DCO_STRONG_INLINE complex_t(stce_9781 const& real = 0.0, stce_9781 const& imag = 0.0)
      : stce_10544(real), stce_10545(imag) {}
  template <typename stce_9873> complex_t(std::complex<stce_9873> const& stce_10546) {
    stce_10544 = stce_10546.real();
    stce_10545 = stce_10546.imag();
  }
  template <typename stce_9873> complex_t& operator=(stce_9873 const& stce_9901) {
    stce_10544 = stce_9901;
    stce_10545 = stce_9781();
    return *this;
  }
  template <typename stce_9873> complex_t& operator=(std::complex<stce_9873> const& stce_9901) {
    stce_10544 = stce_9901.real();
    stce_10545 = stce_9901.imag();
    return *this;
  }
  DCO_STRONG_INLINE stce_9781 real() const { return stce_10544; }
  DCO_STRONG_INLINE stce_9781 imag() const { return stce_10545; }
  DCO_STRONG_INLINE stce_9781& real() { return stce_10544; }
  DCO_STRONG_INLINE stce_9781& imag() { return stce_10545; }
  DCO_STRONG_INLINE void real(stce_9781 const& real) { stce_10544 = real; }
  DCO_STRONG_INLINE void imag(stce_9781 const& imag) { stce_10545 = imag; }
};
} // namespace helper
} // namespace dco
namespace std {
template <class stce_9770, typename stce_10547>
class complex<dco::internal::active_type<stce_9770, stce_10547>>
    : public dco::helper::complex_t<dco::internal::active_type<stce_9770, stce_10547>> {
public:
  typedef dco::internal::active_type<stce_9770, stce_10547> active_t;
  typedef dco::helper::complex_t<active_t> stce_10548;
  complex(active_t const& real = active_t(), active_t const& imag = active_t()) : stce_10548(real, imag) {}
  template <typename TYPE>
  complex(TYPE const& real, typename dco::dco_type_constructable_from<TYPE>::type* = 0) : stce_10548(real, TYPE()) {}
  template <typename TYPE>
  complex(TYPE const& real,
          typename dco::enable_if<(dco::mode<TYPE>::is_dco_type &&
                                   dco::stce_9878<dco::mode<TYPE>, dco::mode<active_t>>::value) ||
                                      dco::is_same<TYPE, typename dco::mode<active_t>::passive_t>::value,
                                  void*>::type = NULL)
      : stce_10548(real, TYPE()) {}
  template <typename stce_9873> complex(complex<stce_9873> const& stce_10546) : stce_10548(stce_10546) {}
  complex& operator=(active_t const& stce_9901) {
    static_cast<stce_10548&>(*this) = stce_9901;
    return *this;
  }
  template <typename stce_9873> complex& operator=(complex<stce_9873> const& stce_9901) {
    static_cast<stce_10548&>(*this) = stce_9901;
    return *this;
  }
  template <typename TYPE>
  typename dco::dco_type_constructable_from<TYPE, complex>::type& operator=(const TYPE& stce_9901) {
    static_cast<stce_10548&>(*this) = stce_9901;
    return *this;
  }
  complex& operator=(typename dco::mode<active_t>::passive_t const& stce_9901) {
    static_cast<stce_10548&>(*this) = stce_9901;
    return *this;
  }
  template <class stce_10121, class stce_10122, class stce_10123>
  DCO_ALWAYS_INLINE complex(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803)
      : stce_10548(
            stce_9803,
            typename dco::mode<dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>>::active_t()) {}
  template <class stce_10121, class stce_10122, class stce_10123>
  DCO_ALWAYS_INLINE complex&
  operator=(const dco::internal::stce_9778<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
    static_cast<stce_10548&>(*this) = stce_9803;
    return *this;
  }
  template <class stce_10121, class stce_10122, class stce_10123>
  DCO_ALWAYS_INLINE complex(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803)
      : stce_10548(
            stce_9803,
            typename dco::mode<dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>>::active_t()) {}
  template <class stce_10121, class stce_10122, class stce_10123>
  DCO_ALWAYS_INLINE complex&
  operator=(const dco::internal::stce_9779<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
    static_cast<stce_10548&>(*this) = stce_9803;
    return *this;
  }
  template <class stce_10121, class stce_10122, class stce_10123>
  DCO_ALWAYS_INLINE complex(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803)
      : stce_10548(
            stce_9803,
            typename dco::mode<dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>>::active_t()) {}
  template <class stce_10121, class stce_10122, class stce_10123>
  DCO_ALWAYS_INLINE complex&
  operator=(const dco::internal::stce_9780<stce_9770, stce_10121, stce_10122, stce_10123>& stce_9803) {
    static_cast<stce_10548&>(*this) = stce_9803;
    return *this;
  }
  template <class stce_10129, class stce_10123>
  DCO_ALWAYS_INLINE complex(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_9803)
      : stce_10548(stce_9803,
                   typename dco::mode<dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>>::active_t()) {}
  template <class stce_10129, class stce_10123>
  DCO_ALWAYS_INLINE complex& operator=(const dco::internal::stce_9775<stce_9770, stce_10129, stce_10123>& stce_9803) {
    static_cast<stce_10548&>(*this) = stce_9803;
    return *this;
  }
  DCO_STRONG_INLINE complex operator-() const { return complex(-this->real(), -this->imag()); }
};
template <typename stce_10489, typename stce_10150, bool stce_10549 = true> struct stce_10550 {
  typedef typename dco::stce_9872<
      dco::mode<stce_10489>::is_dco_type && !dco::mode<stce_10489>::is_intermediate_type, stce_10489,
      typename dco::stce_9872<dco::mode<stce_10150>::is_dco_type && !dco::mode<stce_10150>::is_intermediate_type,
                              stce_10150, void>::type>::type stce_10551;
  typedef typename dco::stce_9872<dco::is_same<stce_10551, stce_10489>::value, stce_10150, stce_10489>::type stce_10552;
  static const bool stce_10553 =
      (stce_10549 || dco::is_same<stce_10551, stce_10489>::value) && !dco::is_same<stce_10551, void>::value &&
      (dco::is_same<stce_10551, typename dco::mode<stce_10552>::active_t>::value ||
       (dco::mode<stce_10552>::is_dco_type && dco::stce_9878<dco::mode<stce_10552>, dco::mode<stce_10551>>::value) ||
       dco::is_same<stce_10552, typename dco::mode<stce_10551>::passive_t>::value);
};
template <typename stce_10489, typename stce_10150, bool stce_10426 = false> struct stce_10554 {};
template <typename stce_10489, typename stce_10150> struct stce_10554<stce_10489, stce_10150, true> {
  typedef typename stce_10550<stce_10489, stce_10150>::stce_10551 type;
  typedef complex<type> stce_10555;
};
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE std::complex<dco::internal::active_type<stce_9770, stce_10547>>
cos(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_9803);
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE std::complex<dco::internal::active_type<stce_9770, stce_10547>>
cosh(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_9803);
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE std::complex<dco::internal::active_type<stce_9770, stce_10547>>
exp(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_9803);
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE std::complex<dco::internal::active_type<stce_9770, stce_10547>>
log(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_9803);
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE std::complex<dco::internal::active_type<stce_9770, stce_10547>>
log10(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_9803);
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE std::complex<dco::internal::active_type<stce_9770, stce_10547>>
sin(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_9803);
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE std::complex<dco::internal::active_type<stce_9770, stce_10547>>
sinh(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_9803);
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE std::complex<dco::internal::active_type<stce_9770, stce_10547>>
sqrt(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_9803);
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE std::complex<dco::internal::active_type<stce_9770, stce_10547>>
tan(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_9803);
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE std::complex<dco::internal::active_type<stce_9770, stce_10547>>
tanh(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_9803);
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE std::complex<dco::internal::active_type<stce_9770, stce_10547>>
asin(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_9803);
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE std::complex<dco::internal::active_type<stce_9770, stce_10547>>
asinh(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_9803);
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE std::complex<dco::internal::active_type<stce_9770, stce_10547>>
acos(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_9803);
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE std::complex<dco::internal::active_type<stce_9770, stce_10547>>
acosh(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_9803);
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE std::complex<dco::internal::active_type<stce_9770, stce_10547>>
atan(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_9803);
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE std::complex<dco::internal::active_type<stce_9770, stce_10547>>
atanh(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_9803);
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE std::complex<dco::internal::active_type<stce_9770, stce_10547>>
proj(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_9803);
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE dco::internal::active_type<stce_9770, stce_10547>
abs(complex<dco::internal::active_type<stce_9770, stce_10547>> const&);
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE dco::internal::active_type<stce_9770, stce_10547>
arg(complex<dco::internal::active_type<stce_9770, stce_10547>> const&);
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE complex<dco::internal::active_type<stce_9770, stce_10547>>
stce_10556(dco::internal::active_type<stce_9770, stce_10547> const&,
           const dco::internal::active_type<stce_9770, stce_10547>& = 0);
template <typename stce_9781>
complex<stce_9781> stce_10557(complex<stce_9781> const& stce_10082, complex<stce_9781> const& stce_10083) {
  if (dco::HAS_INTRINSIC_COMPLEX_PRIMALS) {
    complex<stce_9781> stce_10558;
    typedef typename dco::mode<stce_9781>::passive_t passive_t;
    complex<passive_t> stce_10559;
    complex<passive_t> stce_10560(dco::passive_value(stce_10082.real()), dco::passive_value(stce_10082.imag()));
    complex<passive_t> stce_10561(dco::passive_value(stce_10083.real()), dco::passive_value(stce_10083.imag()));
    stce_10559 = stce_10560 + stce_10561;
    stce_10558.real(stce_10082.real() + stce_10083.real());
    stce_10558.imag(stce_10082.imag() + stce_10083.imag());
    dco::passive_value(stce_10558.real()) = stce_10559.real();
    dco::passive_value(stce_10558.imag()) = stce_10559.imag();
    return stce_10558;
  } else {
    complex<stce_9781> stce_10558;
    stce_10558.real(stce_10082.real() + stce_10083.real());
    stce_10558.imag(stce_10082.imag() + stce_10083.imag());
    return stce_10558;
  }
}
template <typename stce_9781>
complex<stce_9781> stce_10557(complex<stce_9781> const& stce_10082, stce_9781 const& stce_10083) {
  if (dco::HAS_INTRINSIC_COMPLEX_PRIMALS) {
    complex<stce_9781> stce_10558;
    typedef typename dco::mode<stce_9781>::passive_t passive_t;
    complex<passive_t> stce_10559;
    complex<passive_t> stce_10560(dco::passive_value(stce_10082.real()), dco::passive_value(stce_10082.imag()));
    passive_t stce_10561(dco::passive_value(stce_10083));
    stce_10559 = stce_10560 + stce_10561;
    stce_10558.real(stce_10082.real() + stce_10083);
    stce_10558.imag(stce_10082.imag());
    dco::passive_value(stce_10558.real()) = stce_10559.real();
    dco::passive_value(stce_10558.imag()) = stce_10559.imag();
    return stce_10558;
  } else {
    complex<stce_9781> stce_10558;
    stce_10558.real(stce_10082.real() + stce_10083);
    stce_10558.imag(stce_10082.imag());
    return stce_10558;
  }
}
template <typename stce_9781>
complex<stce_9781> stce_10557(stce_9781 const& stce_10082, complex<stce_9781> const& stce_10083) {
  if (dco::HAS_INTRINSIC_COMPLEX_PRIMALS) {
    complex<stce_9781> stce_10558;
    typedef typename dco::mode<stce_9781>::passive_t passive_t;
    complex<passive_t> stce_10559;
    passive_t stce_10560(dco::passive_value(stce_10082));
    complex<passive_t> stce_10561(dco::passive_value(stce_10083.real()), dco::passive_value(stce_10083.imag()));
    stce_10559 = stce_10560 + stce_10561;
    stce_10558.real(stce_10082 + stce_10083.real());
    stce_10558.imag(stce_10083.imag());
    dco::passive_value(stce_10558.real()) = stce_10559.real();
    dco::passive_value(stce_10558.imag()) = stce_10559.imag();
    return stce_10558;
  } else {
    complex<stce_9781> stce_10558;
    stce_10558.real(stce_10082 + stce_10083.real());
    stce_10558.imag(stce_10083.imag());
    return stce_10558;
  }
}
template <typename stce_9781>
complex<stce_9781> stce_10562(complex<stce_9781> const& stce_10082, complex<stce_9781> const& stce_10083) {
  if (dco::HAS_INTRINSIC_COMPLEX_PRIMALS) {
    complex<stce_9781> stce_10558;
    typedef typename dco::mode<stce_9781>::passive_t passive_t;
    complex<passive_t> stce_10559;
    complex<passive_t> stce_10560(dco::passive_value(stce_10082.real()), dco::passive_value(stce_10082.imag()));
    complex<passive_t> stce_10561(dco::passive_value(stce_10083.real()), dco::passive_value(stce_10083.imag()));
    stce_10559 = stce_10560 - stce_10561;
    stce_10558.real(stce_10082.real() - stce_10083.real());
    stce_10558.imag(stce_10082.imag() - stce_10083.imag());
    dco::passive_value(stce_10558.real()) = stce_10559.real();
    dco::passive_value(stce_10558.imag()) = stce_10559.imag();
    return stce_10558;
  } else {
    complex<stce_9781> stce_10558;
    stce_10558.real(stce_10082.real() - stce_10083.real());
    stce_10558.imag(stce_10082.imag() - stce_10083.imag());
    return stce_10558;
  }
}
template <typename stce_9781>
complex<stce_9781> stce_10562(complex<stce_9781> const& stce_10082, stce_9781 const& stce_10083) {
  if (dco::HAS_INTRINSIC_COMPLEX_PRIMALS) {
    complex<stce_9781> stce_10558;
    typedef typename dco::mode<stce_9781>::passive_t passive_t;
    complex<passive_t> stce_10559;
    complex<passive_t> stce_10560(dco::passive_value(stce_10082.real()), dco::passive_value(stce_10082.imag()));
    passive_t stce_10561(dco::passive_value(stce_10083));
    stce_10559 = stce_10560 - stce_10561;
    stce_10558.real(stce_10082.real() - stce_10083);
    stce_10558.imag(stce_10082.imag());
    dco::passive_value(stce_10558.real()) = stce_10559.real();
    dco::passive_value(stce_10558.imag()) = stce_10559.imag();
    return stce_10558;
  } else {
    complex<stce_9781> stce_10558;
    stce_10558.real(stce_10082.real() - stce_10083);
    stce_10558.imag(stce_10082.imag());
    return stce_10558;
  }
}
template <typename stce_9781>
complex<stce_9781> stce_10562(stce_9781 const& stce_10082, complex<stce_9781> const& stce_10083) {
  if (dco::HAS_INTRINSIC_COMPLEX_PRIMALS) {
    complex<stce_9781> stce_10558;
    typedef typename dco::mode<stce_9781>::passive_t passive_t;
    complex<passive_t> stce_10559;
    passive_t stce_10560(dco::passive_value(stce_10082));
    complex<passive_t> stce_10561(dco::passive_value(stce_10083.real()), dco::passive_value(stce_10083.imag()));
    stce_10559 = stce_10560 - stce_10561;
    stce_10558.real(stce_10082 - stce_10083.real());
    stce_10558.imag(-stce_10083.imag());
    dco::passive_value(stce_10558.real()) = stce_10559.real();
    dco::passive_value(stce_10558.imag()) = stce_10559.imag();
    return stce_10558;
  } else {
    complex<stce_9781> stce_10558;
    stce_10558.real(stce_10082 - stce_10083.real());
    stce_10558.imag(-stce_10083.imag());
    return stce_10558;
  }
}
template <typename stce_9781>
complex<stce_9781> stce_10563(complex<stce_9781> const& stce_10082, complex<stce_9781> const& stce_10083) {
  if (dco::HAS_INTRINSIC_COMPLEX_PRIMALS) {
    complex<stce_9781> stce_10558;
    typedef typename dco::mode<stce_9781>::passive_t passive_t;
    complex<passive_t> stce_10559;
    complex<passive_t> stce_10560(dco::passive_value(stce_10082.real()), dco::passive_value(stce_10082.imag()));
    complex<passive_t> stce_10561(dco::passive_value(stce_10083.real()), dco::passive_value(stce_10083.imag()));
    stce_10559 = stce_10560 * stce_10561;
    stce_10558.real(stce_10082.real() * stce_10083.real() - stce_10082.imag() * stce_10083.imag());
    stce_10558.imag(stce_10082.real() * stce_10083.imag() + stce_10082.imag() * stce_10083.real());
    dco::passive_value(stce_10558.real()) = stce_10559.real();
    dco::passive_value(stce_10558.imag()) = stce_10559.imag();
    return stce_10558;
  } else {
    complex<stce_9781> stce_10558;
    stce_10558.real(stce_10082.real() * stce_10083.real() - stce_10082.imag() * stce_10083.imag());
    stce_10558.imag(stce_10082.real() * stce_10083.imag() + stce_10082.imag() * stce_10083.real());
    return stce_10558;
  }
}
template <typename stce_9781>
complex<stce_9781> stce_10563(complex<stce_9781> const& stce_10082, stce_9781 const& stce_10083) {
  if (dco::HAS_INTRINSIC_COMPLEX_PRIMALS) {
    complex<stce_9781> stce_10558;
    typedef typename dco::mode<stce_9781>::passive_t passive_t;
    complex<passive_t> stce_10559;
    complex<passive_t> stce_10560(dco::passive_value(stce_10082.real()), dco::passive_value(stce_10082.imag()));
    passive_t stce_10561(dco::passive_value(stce_10083));
    stce_10559 = stce_10560 * stce_10561;
    stce_10558.real(stce_10082.real() * stce_10083);
    stce_10558.imag(stce_10082.imag() * stce_10083);
    dco::passive_value(stce_10558.real()) = stce_10559.real();
    dco::passive_value(stce_10558.imag()) = stce_10559.imag();
    return stce_10558;
  } else {
    complex<stce_9781> stce_10558;
    stce_10558.real(stce_10082.real() * stce_10083);
    stce_10558.imag(stce_10082.imag() * stce_10083);
    return stce_10558;
  }
}
template <typename stce_9781>
complex<stce_9781> stce_10563(stce_9781 const& stce_10082, complex<stce_9781> const& stce_10083) {
  if (dco::HAS_INTRINSIC_COMPLEX_PRIMALS) {
    complex<stce_9781> stce_10558;
    typedef typename dco::mode<stce_9781>::passive_t passive_t;
    complex<passive_t> stce_10559;
    passive_t stce_10560(dco::passive_value(stce_10082));
    complex<passive_t> stce_10561(dco::passive_value(stce_10083.real()), dco::passive_value(stce_10083.imag()));
    stce_10559 = stce_10560 * stce_10561;
    stce_10558.real(stce_10082 * stce_10083.real());
    stce_10558.imag(stce_10082 * stce_10083.imag());
    dco::passive_value(stce_10558.real()) = stce_10559.real();
    dco::passive_value(stce_10558.imag()) = stce_10559.imag();
    return stce_10558;
  } else {
    complex<stce_9781> stce_10558;
    stce_10558.real(stce_10082 * stce_10083.real());
    stce_10558.imag(stce_10082 * stce_10083.imag());
    return stce_10558;
  }
}
template <typename stce_9781>
complex<stce_9781> stce_10564(complex<stce_9781> const& stce_10082, complex<stce_9781> const& stce_10083) {
  complex<stce_9781> stce_10037 = stce_10082 * complex<stce_9781>(stce_10083.real(), -stce_10083.imag());
  stce_9781 stce_10075 = stce_10083.real() * stce_10083.real() + stce_10083.imag() * stce_10083.imag();
  if (dco::HAS_INTRINSIC_COMPLEX_PRIMALS) {
    complex<stce_9781> stce_10558;
    typedef typename dco::mode<stce_9781>::passive_t passive_t;
    complex<passive_t> stce_10559;
    complex<passive_t> stce_10560(dco::passive_value(stce_10082.real()), dco::passive_value(stce_10082.imag()));
    complex<passive_t> stce_10561(dco::passive_value(stce_10083.real()), dco::passive_value(stce_10083.imag()));
    stce_10559 = stce_10560 / stce_10561;
    stce_10558.real(stce_10037.real() / stce_10075);
    stce_10558.imag(stce_10037.imag() / stce_10075);
    dco::passive_value(stce_10558.real()) = stce_10559.real();
    dco::passive_value(stce_10558.imag()) = stce_10559.imag();
    return stce_10558;
  } else {
    complex<stce_9781> stce_10558;
    stce_10558.real(stce_10037.real() / stce_10075);
    stce_10558.imag(stce_10037.imag() / stce_10075);
    return stce_10558;
  }
}
template <typename stce_9781>
complex<stce_9781> stce_10564(complex<stce_9781> const& stce_10082, stce_9781 const& stce_10083) {
  complex<stce_9781> stce_10037 = stce_10082 * stce_10083;
  stce_9781 stce_10075 = stce_10083 * stce_10083;
  if (dco::HAS_INTRINSIC_COMPLEX_PRIMALS) {
    complex<stce_9781> stce_10558;
    typedef typename dco::mode<stce_9781>::passive_t passive_t;
    complex<passive_t> stce_10559;
    complex<passive_t> stce_10560(dco::passive_value(stce_10082.real()), dco::passive_value(stce_10082.imag()));
    passive_t stce_10561(dco::passive_value(stce_10083));
    stce_10559 = stce_10560 / stce_10561;
    stce_10558.real(stce_10037.real() / stce_10075);
    stce_10558.imag(stce_10037.imag() / stce_10075);
    dco::passive_value(stce_10558.real()) = stce_10559.real();
    dco::passive_value(stce_10558.imag()) = stce_10559.imag();
    return stce_10558;
  } else {
    complex<stce_9781> stce_10558;
    stce_10558.real(stce_10037.real() / stce_10075);
    stce_10558.imag(stce_10037.imag() / stce_10075);
    return stce_10558;
  }
}
template <typename stce_9781>
complex<stce_9781> stce_10564(stce_9781 const& stce_10082, complex<stce_9781> const& stce_10083) {
  complex<stce_9781> stce_10037 = stce_10082 * complex<stce_9781>(stce_10083.real(), -stce_10083.imag());
  stce_9781 stce_10075 = stce_10083.real() * stce_10083.real() + stce_10083.imag() * stce_10083.imag();
  if (dco::HAS_INTRINSIC_COMPLEX_PRIMALS) {
    complex<stce_9781> stce_10558;
    typedef typename dco::mode<stce_9781>::passive_t passive_t;
    complex<passive_t> stce_10559;
    passive_t stce_10560(dco::passive_value(stce_10082));
    complex<passive_t> stce_10561(dco::passive_value(stce_10083.real()), dco::passive_value(stce_10083.imag()));
    stce_10559 = stce_10560 / stce_10561;
    stce_10558.real(stce_10037.real() / stce_10075);
    stce_10558.imag(stce_10037.imag() / stce_10075);
    dco::passive_value(stce_10558.real()) = stce_10559.real();
    dco::passive_value(stce_10558.imag()) = stce_10559.imag();
    return stce_10558;
  } else {
    complex<stce_9781> stce_10558;
    stce_10558.real(stce_10037.real() / stce_10075);
    stce_10558.imag(stce_10037.imag() / stce_10075);
    return stce_10558;
  }
}
template <typename stce_9781>
complex<stce_9781> stce_10565(complex<stce_9781> const& stce_10082, complex<stce_9781> const& stce_10083) {
  complex<stce_9781> stce_10020;
  if (stce_10082 == stce_9781()) {
    stce_10020 = complex<stce_9781>();
  } else {
    stce_10020 = exp(stce_10083 * log(stce_10082));
  }
  if (dco::HAS_INTRINSIC_COMPLEX_PRIMALS) {
    complex<stce_9781> stce_10558;
    typedef typename dco::mode<stce_9781>::passive_t passive_t;
    complex<passive_t> stce_10559;
    complex<passive_t> stce_10560(dco::passive_value(stce_10082.real()), dco::passive_value(stce_10082.imag()));
    complex<passive_t> stce_10561(dco::passive_value(stce_10083.real()), dco::passive_value(stce_10083.imag()));
    stce_10559 = pow(stce_10560, stce_10561);
    stce_10558.real(stce_10020.real());
    stce_10558.imag(stce_10020.imag());
    dco::passive_value(stce_10558.real()) = stce_10559.real();
    dco::passive_value(stce_10558.imag()) = stce_10559.imag();
    return stce_10558;
  } else {
    complex<stce_9781> stce_10558;
    stce_10558.real(stce_10020.real());
    stce_10558.imag(stce_10020.imag());
    return stce_10558;
  }
}
template <typename stce_9781>
complex<stce_9781> stce_10565(complex<stce_9781> const& stce_10082, stce_9781 const& stce_10083) {
  complex<stce_9781> stce_10020;
  if (stce_10082.imag() == typename dco::mode<stce_9781>::active_t() &&
      stce_10082.real() > typename dco::mode<stce_9781>::active_t()) {
    stce_10020 = pow(stce_10082.real(), stce_10083);
  } else {
    complex<stce_9781> stce_10006 = log(stce_10082);
    stce_10020 = stce_10556(static_cast<const stce_9781>(exp(stce_10083 * stce_10006.real())),
                            static_cast<const stce_9781>(stce_10083 * stce_10006.imag()));
  }
  if (dco::HAS_INTRINSIC_COMPLEX_PRIMALS) {
    complex<stce_9781> stce_10558;
    typedef typename dco::mode<stce_9781>::passive_t passive_t;
    complex<passive_t> stce_10559;
    complex<passive_t> stce_10560(dco::passive_value(stce_10082.real()), dco::passive_value(stce_10082.imag()));
    passive_t stce_10561(dco::passive_value(stce_10083));
    stce_10559 = pow(stce_10560, stce_10561);
    stce_10558.real(stce_10020.real());
    stce_10558.imag(stce_10020.imag());
    dco::passive_value(stce_10558.real()) = stce_10559.real();
    dco::passive_value(stce_10558.imag()) = stce_10559.imag();
    return stce_10558;
  } else {
    complex<stce_9781> stce_10558;
    stce_10558.real(stce_10020.real());
    stce_10558.imag(stce_10020.imag());
    return stce_10558;
  }
}
template <typename stce_9781>
complex<stce_9781> stce_10565(stce_9781 const& stce_10082, complex<stce_9781> const& stce_10083) {
  complex<stce_9781> stce_10020;
  if (stce_10082 > stce_9781()) {
    stce_10020 = stce_10556(static_cast<const stce_9781>(pow(stce_10082, stce_10083.real())),
                            static_cast<const stce_9781>(stce_10083.imag() * log(stce_10082)));
  } else {
    stce_10020 = pow(complex<stce_9781>(stce_10082), stce_10083);
  }
  if (dco::HAS_INTRINSIC_COMPLEX_PRIMALS) {
    complex<stce_9781> stce_10558;
    typedef typename dco::mode<stce_9781>::passive_t passive_t;
    complex<passive_t> stce_10559;
    passive_t stce_10560(dco::passive_value(stce_10082));
    complex<passive_t> stce_10561(dco::passive_value(stce_10083.real()), dco::passive_value(stce_10083.imag()));
    stce_10559 = pow(stce_10560, stce_10561);
    stce_10558.real(stce_10020.real());
    stce_10558.imag(stce_10020.imag());
    dco::passive_value(stce_10558.real()) = stce_10559.real();
    dco::passive_value(stce_10558.imag()) = stce_10559.imag();
    return stce_10558;
  } else {
    complex<stce_9781> stce_10558;
    stce_10558.real(stce_10020.real());
    stce_10558.imag(stce_10020.imag());
    return stce_10558;
  }
}
template <typename stce_9781>
complex<stce_9781>& stce_10566(complex<stce_9781>& stce_10082, complex<stce_9781> const& stce_10083) {
  if (dco::HAS_INTRINSIC_COMPLEX_PRIMALS) {
    typedef typename dco::mode<stce_9781>::passive_t passive_t;
    complex<passive_t> stce_10560(dco::passive_value(stce_10082.real()), dco::passive_value(stce_10082.imag()));
    complex<passive_t> stce_10561(dco::passive_value(stce_10083.real()), dco::passive_value(stce_10083.imag()));
    stce_10560 += stce_10561;
    complex<stce_9781> stce_10020;
    stce_10020.real(stce_10082.real() + stce_10083.real());
    stce_10020.imag(stce_10082.imag() + stce_10083.imag());
    stce_10082 = stce_10020;
    dco::passive_value(stce_10082.real()) = stce_10560.real();
    dco::passive_value(stce_10082.imag()) = stce_10560.imag();
    return stce_10082;
  } else {
    complex<stce_9781> stce_10020;
    stce_10020.real(stce_10082.real() + stce_10083.real());
    stce_10020.imag(stce_10082.imag() + stce_10083.imag());
    stce_10082 = stce_10020;
    return stce_10082;
  }
}
template <typename stce_9781>
complex<stce_9781>& stce_10566(complex<stce_9781>& stce_10082, stce_9781 const& stce_10083) {
  if (dco::HAS_INTRINSIC_COMPLEX_PRIMALS) {
    typedef typename dco::mode<stce_9781>::passive_t passive_t;
    complex<passive_t> stce_10560(dco::passive_value(stce_10082.real()), dco::passive_value(stce_10082.imag()));
    passive_t stce_10561(dco::passive_value(stce_10083));
    stce_10560 += stce_10561;
    complex<stce_9781> stce_10020;
    stce_10020.real(stce_10082.real() + stce_10083);
    stce_10020.imag(stce_10082.imag());
    stce_10082 = stce_10020;
    dco::passive_value(stce_10082.real()) = stce_10560.real();
    dco::passive_value(stce_10082.imag()) = stce_10560.imag();
    return stce_10082;
  } else {
    complex<stce_9781> stce_10020;
    stce_10020.real(stce_10082.real() + stce_10083);
    stce_10020.imag(stce_10082.imag());
    stce_10082 = stce_10020;
    return stce_10082;
  }
}
template <typename stce_9781>
complex<stce_9781>& stce_10567(complex<stce_9781>& stce_10082, complex<stce_9781> const& stce_10083) {
  if (dco::HAS_INTRINSIC_COMPLEX_PRIMALS) {
    typedef typename dco::mode<stce_9781>::passive_t passive_t;
    complex<passive_t> stce_10560(dco::passive_value(stce_10082.real()), dco::passive_value(stce_10082.imag()));
    complex<passive_t> stce_10561(dco::passive_value(stce_10083.real()), dco::passive_value(stce_10083.imag()));
    stce_10560 -= stce_10561;
    complex<stce_9781> stce_10020;
    stce_10020.real(stce_10082.real() - stce_10083.real());
    stce_10020.imag(stce_10082.imag() - stce_10083.imag());
    stce_10082 = stce_10020;
    dco::passive_value(stce_10082.real()) = stce_10560.real();
    dco::passive_value(stce_10082.imag()) = stce_10560.imag();
    return stce_10082;
  } else {
    complex<stce_9781> stce_10020;
    stce_10020.real(stce_10082.real() - stce_10083.real());
    stce_10020.imag(stce_10082.imag() - stce_10083.imag());
    stce_10082 = stce_10020;
    return stce_10082;
  }
}
template <typename stce_9781>
complex<stce_9781>& stce_10567(complex<stce_9781>& stce_10082, stce_9781 const& stce_10083) {
  if (dco::HAS_INTRINSIC_COMPLEX_PRIMALS) {
    typedef typename dco::mode<stce_9781>::passive_t passive_t;
    complex<passive_t> stce_10560(dco::passive_value(stce_10082.real()), dco::passive_value(stce_10082.imag()));
    passive_t stce_10561(dco::passive_value(stce_10083));
    stce_10560 -= stce_10561;
    complex<stce_9781> stce_10020;
    stce_10020.real(stce_10082.real() - stce_10083);
    stce_10020.imag(stce_10082.imag());
    stce_10082 = stce_10020;
    dco::passive_value(stce_10082.real()) = stce_10560.real();
    dco::passive_value(stce_10082.imag()) = stce_10560.imag();
    return stce_10082;
  } else {
    complex<stce_9781> stce_10020;
    stce_10020.real(stce_10082.real() - stce_10083);
    stce_10020.imag(stce_10082.imag());
    stce_10082 = stce_10020;
    return stce_10082;
  }
}
template <typename stce_9781>
complex<stce_9781>& stce_10568(complex<stce_9781>& stce_10082, complex<stce_9781> const& stce_10083) {
  if (dco::HAS_INTRINSIC_COMPLEX_PRIMALS) {
    typedef typename dco::mode<stce_9781>::passive_t passive_t;
    complex<passive_t> stce_10560(dco::passive_value(stce_10082.real()), dco::passive_value(stce_10082.imag()));
    complex<passive_t> stce_10561(dco::passive_value(stce_10083.real()), dco::passive_value(stce_10083.imag()));
    stce_10560 *= stce_10561;
    complex<stce_9781> stce_10020;
    stce_10020.real(stce_10082.real() * stce_10083.real() - stce_10082.imag() * stce_10083.imag());
    stce_10020.imag(stce_10082.real() * stce_10083.imag() + stce_10082.imag() * stce_10083.real());
    stce_10082 = stce_10020;
    dco::passive_value(stce_10082.real()) = stce_10560.real();
    dco::passive_value(stce_10082.imag()) = stce_10560.imag();
    return stce_10082;
  } else {
    complex<stce_9781> stce_10020;
    stce_10020.real(stce_10082.real() * stce_10083.real() - stce_10082.imag() * stce_10083.imag());
    stce_10020.imag(stce_10082.real() * stce_10083.imag() + stce_10082.imag() * stce_10083.real());
    stce_10082 = stce_10020;
    return stce_10082;
  }
}
template <typename stce_9781>
complex<stce_9781>& stce_10568(complex<stce_9781>& stce_10082, stce_9781 const& stce_10083) {
  if (dco::HAS_INTRINSIC_COMPLEX_PRIMALS) {
    typedef typename dco::mode<stce_9781>::passive_t passive_t;
    complex<passive_t> stce_10560(dco::passive_value(stce_10082.real()), dco::passive_value(stce_10082.imag()));
    passive_t stce_10561(dco::passive_value(stce_10083));
    stce_10560 *= stce_10561;
    complex<stce_9781> stce_10020;
    stce_10020.real(stce_10082.real() * stce_10083);
    stce_10020.imag(stce_10082.imag() * stce_10083);
    stce_10082 = stce_10020;
    dco::passive_value(stce_10082.real()) = stce_10560.real();
    dco::passive_value(stce_10082.imag()) = stce_10560.imag();
    return stce_10082;
  } else {
    complex<stce_9781> stce_10020;
    stce_10020.real(stce_10082.real() * stce_10083);
    stce_10020.imag(stce_10082.imag() * stce_10083);
    stce_10082 = stce_10020;
    return stce_10082;
  }
}
template <typename stce_9781>
complex<stce_9781>& stce_10569(complex<stce_9781>& stce_10082, complex<stce_9781> const& stce_10083) {
  complex<stce_9781> stce_10037 = stce_10082 * complex<stce_9781>(stce_10083.real(), -stce_10083.imag());
  stce_9781 stce_10075 = stce_10083.real() * stce_10083.real() + stce_10083.imag() * stce_10083.imag();
  if (dco::HAS_INTRINSIC_COMPLEX_PRIMALS) {
    typedef typename dco::mode<stce_9781>::passive_t passive_t;
    complex<passive_t> stce_10560(dco::passive_value(stce_10082.real()), dco::passive_value(stce_10082.imag()));
    complex<passive_t> stce_10561(dco::passive_value(stce_10083.real()), dco::passive_value(stce_10083.imag()));
    stce_10560 /= stce_10561;
    complex<stce_9781> stce_10020;
    stce_10020.real(stce_10037.real() / stce_10075);
    stce_10020.imag(stce_10037.imag() / stce_10075);
    stce_10082 = stce_10020;
    dco::passive_value(stce_10082.real()) = stce_10560.real();
    dco::passive_value(stce_10082.imag()) = stce_10560.imag();
    return stce_10082;
  } else {
    complex<stce_9781> stce_10020;
    stce_10020.real(stce_10037.real() / stce_10075);
    stce_10020.imag(stce_10037.imag() / stce_10075);
    stce_10082 = stce_10020;
    return stce_10082;
  }
}
template <typename stce_9781>
complex<stce_9781>& stce_10569(complex<stce_9781>& stce_10082, stce_9781 const& stce_10083) {
  complex<stce_9781> stce_10037 = stce_10082 * stce_10083;
  stce_9781 stce_10075 = stce_10083 * stce_10083;
  if (dco::HAS_INTRINSIC_COMPLEX_PRIMALS) {
    typedef typename dco::mode<stce_9781>::passive_t passive_t;
    complex<passive_t> stce_10560(dco::passive_value(stce_10082.real()), dco::passive_value(stce_10082.imag()));
    passive_t stce_10561(dco::passive_value(stce_10083));
    stce_10560 /= stce_10561;
    complex<stce_9781> stce_10020;
    stce_10020.real(stce_10037.real() / stce_10075);
    stce_10020.imag(stce_10037.imag() / stce_10075);
    stce_10082 = stce_10020;
    dco::passive_value(stce_10082.real()) = stce_10560.real();
    dco::passive_value(stce_10082.imag()) = stce_10560.imag();
    return stce_10082;
  } else {
    complex<stce_9781> stce_10020;
    stce_10020.real(stce_10037.real() / stce_10075);
    stce_10020.imag(stce_10037.imag() / stce_10075);
    stce_10082 = stce_10020;
    return stce_10082;
  }
}
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE complex<dco::internal::active_type<stce_9770, stce_10547>>
operator+(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_10082,
          complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_10083) {
  return stce_10557(stce_10082, stce_10083);
}
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE complex<dco::internal::active_type<stce_9770, stce_10547>>
operator+(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_10082,
          dco::internal::active_type<stce_9770, stce_10547> const& stce_10083) {
  return stce_10557(static_cast<complex<dco::internal::active_type<stce_9770, stce_10547>>>(stce_10082),
                    static_cast<dco::internal::active_type<stce_9770, stce_10547>>(stce_10083));
}
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE complex<dco::internal::active_type<stce_9770, stce_10547>>
operator+(dco::internal::active_type<stce_9770, stce_10547> const& stce_10082,
          complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_10083) {
  return stce_10557(static_cast<dco::internal::active_type<stce_9770, stce_10547>>(stce_10082),
                    static_cast<complex<dco::internal::active_type<stce_9770, stce_10547>>>(stce_10083));
}
template <typename stce_10489, typename stce_10150>
DCO_STRONG_INLINE
    typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150>::stce_10553>::stce_10555
    operator+(complex<stce_10489> const& stce_10082, complex<stce_10150> const& stce_10083) {
  return stce_10557(stce_10082, stce_10083);
}
template <typename stce_10489, typename stce_10150>
DCO_STRONG_INLINE
    typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150>::stce_10553>::stce_10555
    operator+(complex<stce_10489> const& stce_10082, stce_10150 const& stce_10083) {
  return stce_10557(
      static_cast<
          complex<typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150>::stce_10553>::type>>(
          stce_10082),
      static_cast<typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150>::stce_10553>::type>(
          stce_10083));
}
template <typename stce_10489, typename stce_10150>
DCO_STRONG_INLINE
    typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150>::stce_10553>::stce_10555
    operator+(stce_10489 const& stce_10082, complex<stce_10150> const& stce_10083) {
  return stce_10557(
      static_cast<typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150>::stce_10553>::type>(
          stce_10082),
      static_cast<
          complex<typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150>::stce_10553>::type>>(
          stce_10083));
}
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE complex<dco::internal::active_type<stce_9770, stce_10547>>
operator-(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_10082,
          complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_10083) {
  return stce_10562(stce_10082, stce_10083);
}
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE complex<dco::internal::active_type<stce_9770, stce_10547>>
operator-(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_10082,
          dco::internal::active_type<stce_9770, stce_10547> const& stce_10083) {
  return stce_10562(static_cast<complex<dco::internal::active_type<stce_9770, stce_10547>>>(stce_10082),
                    static_cast<dco::internal::active_type<stce_9770, stce_10547>>(stce_10083));
}
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE complex<dco::internal::active_type<stce_9770, stce_10547>>
operator-(dco::internal::active_type<stce_9770, stce_10547> const& stce_10082,
          complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_10083) {
  return stce_10562(static_cast<dco::internal::active_type<stce_9770, stce_10547>>(stce_10082),
                    static_cast<complex<dco::internal::active_type<stce_9770, stce_10547>>>(stce_10083));
}
template <typename stce_10489, typename stce_10150>
DCO_STRONG_INLINE
    typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150>::stce_10553>::stce_10555
    operator-(complex<stce_10489> const& stce_10082, complex<stce_10150> const& stce_10083) {
  return stce_10562(stce_10082, stce_10083);
}
template <typename stce_10489, typename stce_10150>
DCO_STRONG_INLINE
    typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150>::stce_10553>::stce_10555
    operator-(complex<stce_10489> const& stce_10082, stce_10150 const& stce_10083) {
  return stce_10562(
      static_cast<
          complex<typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150>::stce_10553>::type>>(
          stce_10082),
      static_cast<typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150>::stce_10553>::type>(
          stce_10083));
}
template <typename stce_10489, typename stce_10150>
DCO_STRONG_INLINE
    typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150>::stce_10553>::stce_10555
    operator-(stce_10489 const& stce_10082, complex<stce_10150> const& stce_10083) {
  return stce_10562(
      static_cast<typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150>::stce_10553>::type>(
          stce_10082),
      static_cast<
          complex<typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150>::stce_10553>::type>>(
          stce_10083));
}
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE complex<dco::internal::active_type<stce_9770, stce_10547>>
operator*(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_10082,
          complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_10083) {
  return stce_10563(stce_10082, stce_10083);
}
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE complex<dco::internal::active_type<stce_9770, stce_10547>>
operator*(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_10082,
          dco::internal::active_type<stce_9770, stce_10547> const& stce_10083) {
  return stce_10563(static_cast<complex<dco::internal::active_type<stce_9770, stce_10547>>>(stce_10082),
                    static_cast<dco::internal::active_type<stce_9770, stce_10547>>(stce_10083));
}
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE complex<dco::internal::active_type<stce_9770, stce_10547>>
operator*(dco::internal::active_type<stce_9770, stce_10547> const& stce_10082,
          complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_10083) {
  return stce_10563(static_cast<dco::internal::active_type<stce_9770, stce_10547>>(stce_10082),
                    static_cast<complex<dco::internal::active_type<stce_9770, stce_10547>>>(stce_10083));
}
template <typename stce_10489, typename stce_10150>
DCO_STRONG_INLINE
    typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150>::stce_10553>::stce_10555
    operator*(complex<stce_10489> const& stce_10082, complex<stce_10150> const& stce_10083) {
  return stce_10563(stce_10082, stce_10083);
}
template <typename stce_10489, typename stce_10150>
DCO_STRONG_INLINE
    typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150>::stce_10553>::stce_10555
    operator*(complex<stce_10489> const& stce_10082, stce_10150 const& stce_10083) {
  return stce_10563(
      static_cast<
          complex<typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150>::stce_10553>::type>>(
          stce_10082),
      static_cast<typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150>::stce_10553>::type>(
          stce_10083));
}
template <typename stce_10489, typename stce_10150>
DCO_STRONG_INLINE
    typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150>::stce_10553>::stce_10555
    operator*(stce_10489 const& stce_10082, complex<stce_10150> const& stce_10083) {
  return stce_10563(
      static_cast<typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150>::stce_10553>::type>(
          stce_10082),
      static_cast<
          complex<typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150>::stce_10553>::type>>(
          stce_10083));
}
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE complex<dco::internal::active_type<stce_9770, stce_10547>>
operator/(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_10082,
          complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_10083) {
  return stce_10564(stce_10082, stce_10083);
}
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE complex<dco::internal::active_type<stce_9770, stce_10547>>
operator/(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_10082,
          dco::internal::active_type<stce_9770, stce_10547> const& stce_10083) {
  return stce_10564(static_cast<complex<dco::internal::active_type<stce_9770, stce_10547>>>(stce_10082),
                    static_cast<dco::internal::active_type<stce_9770, stce_10547>>(stce_10083));
}
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE complex<dco::internal::active_type<stce_9770, stce_10547>>
operator/(dco::internal::active_type<stce_9770, stce_10547> const& stce_10082,
          complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_10083) {
  return stce_10564(static_cast<dco::internal::active_type<stce_9770, stce_10547>>(stce_10082),
                    static_cast<complex<dco::internal::active_type<stce_9770, stce_10547>>>(stce_10083));
}
template <typename stce_10489, typename stce_10150>
DCO_STRONG_INLINE
    typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150>::stce_10553>::stce_10555
    operator/(complex<stce_10489> const& stce_10082, complex<stce_10150> const& stce_10083) {
  return stce_10564(stce_10082, stce_10083);
}
template <typename stce_10489, typename stce_10150>
DCO_STRONG_INLINE
    typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150>::stce_10553>::stce_10555
    operator/(complex<stce_10489> const& stce_10082, stce_10150 const& stce_10083) {
  return stce_10564(
      static_cast<
          complex<typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150>::stce_10553>::type>>(
          stce_10082),
      static_cast<typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150>::stce_10553>::type>(
          stce_10083));
}
template <typename stce_10489, typename stce_10150>
DCO_STRONG_INLINE
    typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150>::stce_10553>::stce_10555
    operator/(stce_10489 const& stce_10082, complex<stce_10150> const& stce_10083) {
  return stce_10564(
      static_cast<typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150>::stce_10553>::type>(
          stce_10082),
      static_cast<
          complex<typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150>::stce_10553>::type>>(
          stce_10083));
}
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE complex<dco::internal::active_type<stce_9770, stce_10547>>
pow(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_10082,
    complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_10083) {
  return stce_10565(stce_10082, stce_10083);
}
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE complex<dco::internal::active_type<stce_9770, stce_10547>>
pow(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_10082,
    dco::internal::active_type<stce_9770, stce_10547> const& stce_10083) {
  return stce_10565(static_cast<complex<dco::internal::active_type<stce_9770, stce_10547>>>(stce_10082),
                    static_cast<dco::internal::active_type<stce_9770, stce_10547>>(stce_10083));
}
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE complex<dco::internal::active_type<stce_9770, stce_10547>>
pow(dco::internal::active_type<stce_9770, stce_10547> const& stce_10082,
    complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_10083) {
  return stce_10565(static_cast<dco::internal::active_type<stce_9770, stce_10547>>(stce_10082),
                    static_cast<complex<dco::internal::active_type<stce_9770, stce_10547>>>(stce_10083));
}
template <typename stce_10489, typename stce_10150>
DCO_STRONG_INLINE
    typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150>::stce_10553>::stce_10555
    pow(complex<stce_10489> const& stce_10082, complex<stce_10150> const& stce_10083) {
  return stce_10565(stce_10082, stce_10083);
}
template <typename stce_10489, typename stce_10150>
DCO_STRONG_INLINE
    typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150>::stce_10553>::stce_10555
    pow(complex<stce_10489> const& stce_10082, stce_10150 const& stce_10083) {
  return stce_10565(
      static_cast<
          complex<typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150>::stce_10553>::type>>(
          stce_10082),
      static_cast<typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150>::stce_10553>::type>(
          stce_10083));
}
template <typename stce_10489, typename stce_10150>
DCO_STRONG_INLINE
    typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150>::stce_10553>::stce_10555
    pow(stce_10489 const& stce_10082, complex<stce_10150> const& stce_10083) {
  return stce_10565(
      static_cast<typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150>::stce_10553>::type>(
          stce_10082),
      static_cast<
          complex<typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150>::stce_10553>::type>>(
          stce_10083));
}
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE complex<dco::internal::active_type<stce_9770, stce_10547>>&
operator+=(complex<dco::internal::active_type<stce_9770, stce_10547>>& stce_10082,
           complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_10083) {
  return stce_10566(stce_10082, stce_10083);
}
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE complex<dco::internal::active_type<stce_9770, stce_10547>>&
operator+=(complex<dco::internal::active_type<stce_9770, stce_10547>>& stce_10082,
           dco::internal::active_type<stce_9770, stce_10547> const& stce_10083) {
  return stce_10566(static_cast<complex<dco::internal::active_type<stce_9770, stce_10547>>&>(stce_10082),
                    static_cast<dco::internal::active_type<stce_9770, stce_10547>>(stce_10083));
}
template <typename stce_10489, typename stce_10150>
DCO_STRONG_INLINE
    typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150, false>::stce_10553>::stce_10555&
    operator+=(complex<stce_10489>& stce_10082, complex<stce_10150> const& stce_10083) {
  return stce_10566(stce_10082, stce_10083);
}
template <typename stce_10489, typename stce_10150>
DCO_STRONG_INLINE
    typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150, false>::stce_10553>::stce_10555&
    operator+=(complex<stce_10489>& stce_10082, stce_10150 const& stce_10083) {
  return stce_10566(
      static_cast<
          complex<typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150>::stce_10553>::type>&>(
          stce_10082),
      static_cast<typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150>::stce_10553>::type>(
          stce_10083));
}
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE complex<dco::internal::active_type<stce_9770, stce_10547>>&
operator-=(complex<dco::internal::active_type<stce_9770, stce_10547>>& stce_10082,
           complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_10083) {
  return stce_10567(stce_10082, stce_10083);
}
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE complex<dco::internal::active_type<stce_9770, stce_10547>>&
operator-=(complex<dco::internal::active_type<stce_9770, stce_10547>>& stce_10082,
           dco::internal::active_type<stce_9770, stce_10547> const& stce_10083) {
  return stce_10567(static_cast<complex<dco::internal::active_type<stce_9770, stce_10547>>&>(stce_10082),
                    static_cast<dco::internal::active_type<stce_9770, stce_10547>>(stce_10083));
}
template <typename stce_10489, typename stce_10150>
DCO_STRONG_INLINE
    typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150, false>::stce_10553>::stce_10555&
    operator-=(complex<stce_10489>& stce_10082, complex<stce_10150> const& stce_10083) {
  return stce_10567(stce_10082, stce_10083);
}
template <typename stce_10489, typename stce_10150>
DCO_STRONG_INLINE
    typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150, false>::stce_10553>::stce_10555&
    operator-=(complex<stce_10489>& stce_10082, stce_10150 const& stce_10083) {
  return stce_10567(
      static_cast<
          complex<typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150>::stce_10553>::type>&>(
          stce_10082),
      static_cast<typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150>::stce_10553>::type>(
          stce_10083));
}
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE complex<dco::internal::active_type<stce_9770, stce_10547>>&
operator*=(complex<dco::internal::active_type<stce_9770, stce_10547>>& stce_10082,
           complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_10083) {
  return stce_10568(stce_10082, stce_10083);
}
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE complex<dco::internal::active_type<stce_9770, stce_10547>>&
operator*=(complex<dco::internal::active_type<stce_9770, stce_10547>>& stce_10082,
           dco::internal::active_type<stce_9770, stce_10547> const& stce_10083) {
  return stce_10568(static_cast<complex<dco::internal::active_type<stce_9770, stce_10547>>&>(stce_10082),
                    static_cast<dco::internal::active_type<stce_9770, stce_10547>>(stce_10083));
}
template <typename stce_10489, typename stce_10150>
DCO_STRONG_INLINE
    typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150, false>::stce_10553>::stce_10555&
    operator*=(complex<stce_10489>& stce_10082, complex<stce_10150> const& stce_10083) {
  return stce_10568(stce_10082, stce_10083);
}
template <typename stce_10489, typename stce_10150>
DCO_STRONG_INLINE
    typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150, false>::stce_10553>::stce_10555&
    operator*=(complex<stce_10489>& stce_10082, stce_10150 const& stce_10083) {
  return stce_10568(
      static_cast<
          complex<typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150>::stce_10553>::type>&>(
          stce_10082),
      static_cast<typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150>::stce_10553>::type>(
          stce_10083));
}
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE complex<dco::internal::active_type<stce_9770, stce_10547>>&
operator/=(complex<dco::internal::active_type<stce_9770, stce_10547>>& stce_10082,
           complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_10083) {
  return stce_10569(stce_10082, stce_10083);
}
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE complex<dco::internal::active_type<stce_9770, stce_10547>>&
operator/=(complex<dco::internal::active_type<stce_9770, stce_10547>>& stce_10082,
           dco::internal::active_type<stce_9770, stce_10547> const& stce_10083) {
  return stce_10569(static_cast<complex<dco::internal::active_type<stce_9770, stce_10547>>&>(stce_10082),
                    static_cast<dco::internal::active_type<stce_9770, stce_10547>>(stce_10083));
}
template <typename stce_10489, typename stce_10150>
DCO_STRONG_INLINE
    typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150, false>::stce_10553>::stce_10555&
    operator/=(complex<stce_10489>& stce_10082, complex<stce_10150> const& stce_10083) {
  return stce_10569(stce_10082, stce_10083);
}
template <typename stce_10489, typename stce_10150>
DCO_STRONG_INLINE
    typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150, false>::stce_10553>::stce_10555&
    operator/=(complex<stce_10489>& stce_10082, stce_10150 const& stce_10083) {
  return stce_10569(
      static_cast<
          complex<typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150>::stce_10553>::type>&>(
          stce_10082),
      static_cast<typename stce_10554<stce_10489, stce_10150, stce_10550<stce_10489, stce_10150>::stce_10553>::type>(
          stce_10083));
}
template <typename stce_9781> complex<stce_9781> stce_10570(complex<stce_9781> const& stce_10082) {
  if (dco::HAS_INTRINSIC_COMPLEX_PRIMALS) {
    complex<stce_9781> stce_10558;
    typedef typename dco::mode<stce_9781>::passive_t passive_t;
    complex<passive_t> stce_10559;
    complex<passive_t> stce_10560(dco::passive_value(stce_10082.real()), dco::passive_value(stce_10082.imag()));
    stce_10559 = sin(stce_10560);
    stce_10558.real(sin(stce_10082.real()) * cosh(stce_10082.imag()));
    stce_10558.imag(cos(stce_10082.real()) * sinh(stce_10082.imag()));
    dco::passive_value(stce_10558.real()) = stce_10559.real();
    dco::passive_value(stce_10558.imag()) = stce_10559.imag();
    return stce_10558;
  } else {
    complex<stce_9781> stce_10558;
    stce_10558.real(sin(stce_10082.real()) * cosh(stce_10082.imag()));
    stce_10558.imag(cos(stce_10082.real()) * sinh(stce_10082.imag()));
    return stce_10558;
  }
}
template <typename stce_9781> complex<stce_9781> stce_10571(complex<stce_9781> const& stce_10082) {
  if (dco::HAS_INTRINSIC_COMPLEX_PRIMALS) {
    complex<stce_9781> stce_10558;
    typedef typename dco::mode<stce_9781>::passive_t passive_t;
    complex<passive_t> stce_10559;
    complex<passive_t> stce_10560(dco::passive_value(stce_10082.real()), dco::passive_value(stce_10082.imag()));
    stce_10559 = sinh(stce_10560);
    stce_10558.real(sinh(stce_10082.real()) * cos(stce_10082.imag()));
    stce_10558.imag(cosh(stce_10082.real()) * sin(stce_10082.imag()));
    dco::passive_value(stce_10558.real()) = stce_10559.real();
    dco::passive_value(stce_10558.imag()) = stce_10559.imag();
    return stce_10558;
  } else {
    complex<stce_9781> stce_10558;
    stce_10558.real(sinh(stce_10082.real()) * cos(stce_10082.imag()));
    stce_10558.imag(cosh(stce_10082.real()) * sin(stce_10082.imag()));
    return stce_10558;
  }
}
template <typename stce_9781> complex<stce_9781> stce_10572(complex<stce_9781> const& stce_10082) {
  if (dco::HAS_INTRINSIC_COMPLEX_PRIMALS) {
    complex<stce_9781> stce_10558;
    typedef typename dco::mode<stce_9781>::passive_t passive_t;
    complex<passive_t> stce_10559;
    complex<passive_t> stce_10560(dco::passive_value(stce_10082.real()), dco::passive_value(stce_10082.imag()));
    stce_10559 = cos(stce_10560);
    stce_10558.real(cos(stce_10082.real()) * cosh(stce_10082.imag()));
    stce_10558.imag(-sin(stce_10082.real()) * sinh(stce_10082.imag()));
    dco::passive_value(stce_10558.real()) = stce_10559.real();
    dco::passive_value(stce_10558.imag()) = stce_10559.imag();
    return stce_10558;
  } else {
    complex<stce_9781> stce_10558;
    stce_10558.real(cos(stce_10082.real()) * cosh(stce_10082.imag()));
    stce_10558.imag(-sin(stce_10082.real()) * sinh(stce_10082.imag()));
    return stce_10558;
  }
}
template <typename stce_9781> complex<stce_9781> stce_10573(complex<stce_9781> const& stce_10082) {
  if (dco::HAS_INTRINSIC_COMPLEX_PRIMALS) {
    complex<stce_9781> stce_10558;
    typedef typename dco::mode<stce_9781>::passive_t passive_t;
    complex<passive_t> stce_10559;
    complex<passive_t> stce_10560(dco::passive_value(stce_10082.real()), dco::passive_value(stce_10082.imag()));
    stce_10559 = cosh(stce_10560);
    stce_10558.real(cosh(stce_10082.real()) * cos(stce_10082.imag()));
    stce_10558.imag(sinh(stce_10082.real()) * sin(stce_10082.imag()));
    dco::passive_value(stce_10558.real()) = stce_10559.real();
    dco::passive_value(stce_10558.imag()) = stce_10559.imag();
    return stce_10558;
  } else {
    complex<stce_9781> stce_10558;
    stce_10558.real(cosh(stce_10082.real()) * cos(stce_10082.imag()));
    stce_10558.imag(sinh(stce_10082.real()) * sin(stce_10082.imag()));
    return stce_10558;
  }
}
template <typename stce_9781> complex<stce_9781> stce_10574(complex<stce_9781> const& stce_10082) {
  complex<stce_9781> stce_10020 = sin(stce_10082) / cos(stce_10082);
  if (dco::HAS_INTRINSIC_COMPLEX_PRIMALS) {
    complex<stce_9781> stce_10558;
    typedef typename dco::mode<stce_9781>::passive_t passive_t;
    complex<passive_t> stce_10559;
    complex<passive_t> stce_10560(dco::passive_value(stce_10082.real()), dco::passive_value(stce_10082.imag()));
    stce_10559 = tan(stce_10560);
    stce_10558.real(stce_10020.real());
    stce_10558.imag(stce_10020.imag());
    dco::passive_value(stce_10558.real()) = stce_10559.real();
    dco::passive_value(stce_10558.imag()) = stce_10559.imag();
    return stce_10558;
  } else {
    complex<stce_9781> stce_10558;
    stce_10558.real(stce_10020.real());
    stce_10558.imag(stce_10020.imag());
    return stce_10558;
  }
}
template <typename stce_9781> complex<stce_9781> stce_10575(complex<stce_9781> const& stce_10082) {
  complex<stce_9781> stce_10020 = sinh(stce_10082) / cosh(stce_10082);
  if (dco::HAS_INTRINSIC_COMPLEX_PRIMALS) {
    complex<stce_9781> stce_10558;
    typedef typename dco::mode<stce_9781>::passive_t passive_t;
    complex<passive_t> stce_10559;
    complex<passive_t> stce_10560(dco::passive_value(stce_10082.real()), dco::passive_value(stce_10082.imag()));
    stce_10559 = tanh(stce_10560);
    stce_10558.real(stce_10020.real());
    stce_10558.imag(stce_10020.imag());
    dco::passive_value(stce_10558.real()) = stce_10559.real();
    dco::passive_value(stce_10558.imag()) = stce_10559.imag();
    return stce_10558;
  } else {
    complex<stce_9781> stce_10558;
    stce_10558.real(stce_10020.real());
    stce_10558.imag(stce_10020.imag());
    return stce_10558;
  }
}
template <typename stce_9781> complex<stce_9781> stce_10576(complex<stce_9781> const& stce_10082) {
  complex<stce_9781> stce_10020 = stce_10556(static_cast<const stce_9781>(exp(stce_10082.real())), stce_10082.imag());
  if (dco::HAS_INTRINSIC_COMPLEX_PRIMALS) {
    complex<stce_9781> stce_10558;
    typedef typename dco::mode<stce_9781>::passive_t passive_t;
    complex<passive_t> stce_10559;
    complex<passive_t> stce_10560(dco::passive_value(stce_10082.real()), dco::passive_value(stce_10082.imag()));
    stce_10559 = exp(stce_10560);
    stce_10558.real(stce_10020.real());
    stce_10558.imag(stce_10020.imag());
    dco::passive_value(stce_10558.real()) = stce_10559.real();
    dco::passive_value(stce_10558.imag()) = stce_10559.imag();
    return stce_10558;
  } else {
    complex<stce_9781> stce_10558;
    stce_10558.real(stce_10020.real());
    stce_10558.imag(stce_10020.imag());
    return stce_10558;
  }
}
template <typename stce_9781> complex<stce_9781> stce_10577(complex<stce_9781> const& stce_10082) {
  if (dco::HAS_INTRINSIC_COMPLEX_PRIMALS) {
    complex<stce_9781> stce_10558;
    typedef typename dco::mode<stce_9781>::passive_t passive_t;
    complex<passive_t> stce_10559;
    complex<passive_t> stce_10560(dco::passive_value(stce_10082.real()), dco::passive_value(stce_10082.imag()));
    stce_10559 = log(stce_10560);
    stce_10558.real(log(abs(stce_10082)));
    stce_10558.imag(arg(stce_10082));
    dco::passive_value(stce_10558.real()) = stce_10559.real();
    dco::passive_value(stce_10558.imag()) = stce_10559.imag();
    return stce_10558;
  } else {
    complex<stce_9781> stce_10558;
    stce_10558.real(log(abs(stce_10082)));
    stce_10558.imag(arg(stce_10082));
    return stce_10558;
  }
}
template <typename stce_9781> complex<stce_9781> stce_10578(complex<stce_9781> const& stce_10082) {
  complex<stce_9781> stce_10020 = log(stce_10082) / log(typename dco::mode<stce_9781>::active_t(10.0));
  if (dco::HAS_INTRINSIC_COMPLEX_PRIMALS) {
    complex<stce_9781> stce_10558;
    typedef typename dco::mode<stce_9781>::passive_t passive_t;
    complex<passive_t> stce_10559;
    complex<passive_t> stce_10560(dco::passive_value(stce_10082.real()), dco::passive_value(stce_10082.imag()));
    stce_10559 = log10(stce_10560);
    stce_10558.real(stce_10020.real());
    stce_10558.imag(stce_10020.imag());
    dco::passive_value(stce_10558.real()) = stce_10559.real();
    dco::passive_value(stce_10558.imag()) = stce_10559.imag();
    return stce_10558;
  } else {
    complex<stce_9781> stce_10558;
    stce_10558.real(stce_10020.real());
    stce_10558.imag(stce_10020.imag());
    return stce_10558;
  }
}
template <typename stce_9781> complex<stce_9781> stce_10579(complex<stce_9781> const& stce_10082) {
  complex<stce_9781> stce_10020;
  if (stce_10082.real() == typename dco::mode<stce_9781>::active_t()) {
    stce_9781 stce_10580 = sqrt(abs(stce_10082.imag()) / 2);
    stce_10020 = complex<stce_9781>(stce_10580, stce_10082.imag() < 0.0 ? stce_9781(-stce_10580) : stce_10580);
  } else {
    stce_9781 stce_10580 = sqrt(2 * (abs(stce_10082) + abs(stce_10082.real())));
    stce_9781 stce_10581 = stce_10580 / 2;
    stce_10020 = stce_10082.real() > typename dco::mode<stce_9781>::active_t()
                     ? complex<stce_9781>(stce_10581, stce_9781(stce_10082.imag() / stce_10580))
                     : complex<stce_9781>(abs(stce_10082.imag()) / stce_10580,
                                          stce_10082.imag() < stce_9781() ? stce_9781(-stce_10581) : stce_10581);
  }
  if (dco::HAS_INTRINSIC_COMPLEX_PRIMALS) {
    complex<stce_9781> stce_10558;
    typedef typename dco::mode<stce_9781>::passive_t passive_t;
    complex<passive_t> stce_10559;
    complex<passive_t> stce_10560(dco::passive_value(stce_10082.real()), dco::passive_value(stce_10082.imag()));
    stce_10559 = sqrt(stce_10560);
    stce_10558.real(stce_10020.real());
    stce_10558.imag(stce_10020.imag());
    dco::passive_value(stce_10558.real()) = stce_10559.real();
    dco::passive_value(stce_10558.imag()) = stce_10559.imag();
    return stce_10558;
  } else {
    complex<stce_9781> stce_10558;
    stce_10558.real(stce_10020.real());
    stce_10558.imag(stce_10020.imag());
    return stce_10558;
  }
}
template <typename stce_9781> complex<stce_9781> stce_10582(complex<stce_9781> const& stce_10082) {
  complex<stce_9781> stce_10020(-stce_10082.imag(), stce_10082.real());
  stce_10020 = asinh(stce_10020);
  if (dco::HAS_INTRINSIC_COMPLEX_PRIMALS) {
    complex<stce_9781> stce_10558;
    typedef typename dco::mode<stce_9781>::passive_t passive_t;
    complex<passive_t> stce_10559;
    complex<passive_t> stce_10560(dco::passive_value(stce_10082.real()), dco::passive_value(stce_10082.imag()));
    stce_10559 = asin(stce_10560);
    stce_10558.real(stce_10020.imag());
    stce_10558.imag(-stce_10020.real());
    dco::passive_value(stce_10558.real()) = stce_10559.real();
    dco::passive_value(stce_10558.imag()) = stce_10559.imag();
    return stce_10558;
  } else {
    complex<stce_9781> stce_10558;
    stce_10558.real(stce_10020.imag());
    stce_10558.imag(-stce_10020.real());
    return stce_10558;
  }
}
template <typename stce_9781> complex<stce_9781> stce_10583(complex<stce_9781> const& stce_10082) {
  complex<stce_9781> stce_10020((stce_10082.real() - stce_10082.imag()) * (stce_10082.real() + stce_10082.imag()) +
                                    stce_9781(1.0),
                                stce_9781(2.0) * stce_10082.real() * stce_10082.imag());
  stce_10020 = sqrt(stce_10020);
  stce_10020 = log(stce_10020 + stce_10082);
  if (dco::HAS_INTRINSIC_COMPLEX_PRIMALS) {
    complex<stce_9781> stce_10558;
    typedef typename dco::mode<stce_9781>::passive_t passive_t;
    complex<passive_t> stce_10559;
    complex<passive_t> stce_10560(dco::passive_value(stce_10082.real()), dco::passive_value(stce_10082.imag()));
    stce_10559 = asinh(stce_10560);
    stce_10558.real(stce_10020.real());
    stce_10558.imag(stce_10020.imag());
    dco::passive_value(stce_10558.real()) = stce_10559.real();
    dco::passive_value(stce_10558.imag()) = stce_10559.imag();
    return stce_10558;
  } else {
    complex<stce_9781> stce_10558;
    stce_10558.real(stce_10020.real());
    stce_10558.imag(stce_10020.imag());
    return stce_10558;
  }
}
template <typename stce_9781> complex<stce_9781> stce_10584(complex<stce_9781> const& stce_10082) {
  complex<stce_9781> stce_10020 = asin(stce_10082);
  const stce_9781 stce_10585 = 1.5707963267948966192313216916397514L;
  stce_10020 = complex<stce_9781>(stce_10585 - stce_10020.real(), -stce_10020.imag());
  if (dco::HAS_INTRINSIC_COMPLEX_PRIMALS) {
    complex<stce_9781> stce_10558;
    typedef typename dco::mode<stce_9781>::passive_t passive_t;
    complex<passive_t> stce_10559;
    complex<passive_t> stce_10560(dco::passive_value(stce_10082.real()), dco::passive_value(stce_10082.imag()));
    stce_10559 = acos(stce_10560);
    stce_10558.real(stce_10020.real());
    stce_10558.imag(stce_10020.imag());
    dco::passive_value(stce_10558.real()) = stce_10559.real();
    dco::passive_value(stce_10558.imag()) = stce_10559.imag();
    return stce_10558;
  } else {
    complex<stce_9781> stce_10558;
    stce_10558.real(stce_10020.real());
    stce_10558.imag(stce_10020.imag());
    return stce_10558;
  }
}
template <typename stce_9781> complex<stce_9781> stce_10586(complex<stce_9781> const& stce_10082) {
  complex<stce_9781> stce_10020 = stce_9781(2.0) * log(sqrt(stce_9781(0.5) * (stce_10082 + stce_9781(1.0))) +
                                                       sqrt(stce_9781(0.5) * (stce_10082 - stce_9781(1.0))));
  if (dco::HAS_INTRINSIC_COMPLEX_PRIMALS) {
    complex<stce_9781> stce_10558;
    typedef typename dco::mode<stce_9781>::passive_t passive_t;
    complex<passive_t> stce_10559;
    complex<passive_t> stce_10560(dco::passive_value(stce_10082.real()), dco::passive_value(stce_10082.imag()));
    stce_10559 = acosh(stce_10560);
    stce_10558.real(stce_10020.real());
    stce_10558.imag(stce_10020.imag());
    dco::passive_value(stce_10558.real()) = stce_10559.real();
    dco::passive_value(stce_10558.imag()) = stce_10559.imag();
    return stce_10558;
  } else {
    complex<stce_9781> stce_10558;
    stce_10558.real(stce_10020.real());
    stce_10558.imag(stce_10020.imag());
    return stce_10558;
  }
}
template <typename stce_9781> complex<stce_9781> stce_10587(complex<stce_9781> const& stce_10082) {
  const stce_9781 stce_10588 = stce_10082.real() * stce_10082.real();
  const stce_9781 stce_10546 = stce_9781(1.0) - stce_10588 - stce_10082.imag() * stce_10082.imag();
  stce_9781 stce_10589 = stce_10082.imag() + stce_9781(1.0);
  stce_9781 stce_10590 = stce_10082.imag() - stce_9781(1.0);
  stce_10589 = stce_10588 + stce_10589 * stce_10589;
  stce_10590 = stce_10588 + stce_10590 * stce_10590;
  complex<stce_9781> stce_10020 =
      complex<stce_9781>(stce_9781(0.5) * atan2(stce_9781(2.0) * stce_10082.real(), stce_10546),
                         stce_9781(0.25) * log(stce_10589 / stce_10590));
  if (dco::HAS_INTRINSIC_COMPLEX_PRIMALS) {
    complex<stce_9781> stce_10558;
    typedef typename dco::mode<stce_9781>::passive_t passive_t;
    complex<passive_t> stce_10559;
    complex<passive_t> stce_10560(dco::passive_value(stce_10082.real()), dco::passive_value(stce_10082.imag()));
    stce_10559 = atan(stce_10560);
    stce_10558.real(stce_10020.real());
    stce_10558.imag(stce_10020.imag());
    dco::passive_value(stce_10558.real()) = stce_10559.real();
    dco::passive_value(stce_10558.imag()) = stce_10559.imag();
    return stce_10558;
  } else {
    complex<stce_9781> stce_10558;
    stce_10558.real(stce_10020.real());
    stce_10558.imag(stce_10020.imag());
    return stce_10558;
  }
}
template <typename stce_9781> complex<stce_9781> stce_10591(complex<stce_9781> const& stce_10082) {
  const stce_9781 stce_10592 = stce_10082.imag() * stce_10082.imag();
  const stce_9781 stce_10546 = stce_9781(1.0) - stce_10592 - stce_10082.real() * stce_10082.real();
  stce_9781 stce_10589 = stce_9781(1.0) + stce_10082.real();
  stce_9781 stce_10590 = stce_9781(1.0) - stce_10082.real();
  stce_10589 = stce_10592 + stce_10589 * stce_10589;
  stce_10590 = stce_10592 + stce_10590 * stce_10590;
  complex<stce_9781> stce_10020 =
      complex<stce_9781>(stce_9781(0.25) * (log(stce_10589) - log(stce_10590)),
                         stce_9781(0.5) * atan2(stce_9781(2.0) * stce_10082.imag(), stce_10546));
  if (dco::HAS_INTRINSIC_COMPLEX_PRIMALS) {
    complex<stce_9781> stce_10558;
    typedef typename dco::mode<stce_9781>::passive_t passive_t;
    complex<passive_t> stce_10559;
    complex<passive_t> stce_10560(dco::passive_value(stce_10082.real()), dco::passive_value(stce_10082.imag()));
    stce_10559 = atanh(stce_10560);
    stce_10558.real(stce_10020.real());
    stce_10558.imag(stce_10020.imag());
    dco::passive_value(stce_10558.real()) = stce_10559.real();
    dco::passive_value(stce_10558.imag()) = stce_10559.imag();
    return stce_10558;
  } else {
    complex<stce_9781> stce_10558;
    stce_10558.real(stce_10020.real());
    stce_10558.imag(stce_10020.imag());
    return stce_10558;
  }
}
template <typename stce_9781> complex<stce_9781> stce_10593(complex<stce_9781> const& stce_10082) {
  if (dco::IS_DEBUG && (isinf(stce_10082.real()) || isinf(stce_10082.imag()))) {
    throw dco::exception::create<std::runtime_error>(
        "std::proj(std::complex<T>): One value is inf; derivatives undefined. Please contact NAG (support@nag.co.uk).");
  }
  return stce_10082;
}
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE std::complex<dco::internal::active_type<stce_9770, stce_10547>>
cos(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_9803) {
  return stce_10572(stce_9803);
}
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE std::complex<dco::internal::active_type<stce_9770, stce_10547>>
cosh(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_9803) {
  return stce_10573(stce_9803);
}
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE std::complex<dco::internal::active_type<stce_9770, stce_10547>>
exp(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_9803) {
  return stce_10576(stce_9803);
}
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE std::complex<dco::internal::active_type<stce_9770, stce_10547>>
log(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_9803) {
  return stce_10577(stce_9803);
}
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE std::complex<dco::internal::active_type<stce_9770, stce_10547>>
log10(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_9803) {
  return stce_10578(stce_9803);
}
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE std::complex<dco::internal::active_type<stce_9770, stce_10547>>
sin(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_9803) {
  return stce_10570(stce_9803);
}
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE std::complex<dco::internal::active_type<stce_9770, stce_10547>>
sinh(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_9803) {
  return stce_10571(stce_9803);
}
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE std::complex<dco::internal::active_type<stce_9770, stce_10547>>
sqrt(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_9803) {
  return stce_10579(stce_9803);
}
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE std::complex<dco::internal::active_type<stce_9770, stce_10547>>
tan(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_9803) {
  return stce_10574(stce_9803);
}
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE std::complex<dco::internal::active_type<stce_9770, stce_10547>>
tanh(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_9803) {
  return stce_10575(stce_9803);
}
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE std::complex<dco::internal::active_type<stce_9770, stce_10547>>
asin(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_9803) {
  return stce_10582(stce_9803);
}
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE std::complex<dco::internal::active_type<stce_9770, stce_10547>>
asinh(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_9803) {
  return stce_10583(stce_9803);
}
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE std::complex<dco::internal::active_type<stce_9770, stce_10547>>
acos(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_9803) {
  return stce_10584(stce_9803);
}
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE std::complex<dco::internal::active_type<stce_9770, stce_10547>>
acosh(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_9803) {
  return stce_10586(stce_9803);
}
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE std::complex<dco::internal::active_type<stce_9770, stce_10547>>
atan(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_9803) {
  return stce_10587(stce_9803);
}
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE std::complex<dco::internal::active_type<stce_9770, stce_10547>>
atanh(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_9803) {
  return stce_10591(stce_9803);
}
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE std::complex<dco::internal::active_type<stce_9770, stce_10547>>
proj(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_9803) {
  return stce_10593(stce_9803);
}
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE dco::internal::active_type<stce_9770, stce_10547>
abs(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_9803) {
  return sqrt(pow(stce_9803.real(), 2) + pow(stce_9803.imag(), 2));
}
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE dco::internal::active_type<stce_9770, stce_10547>
arg(complex<dco::internal::active_type<stce_9770, stce_10547>> const& stce_9803) {
  return atan2(stce_9803.imag(), stce_9803.real());
}
template <class stce_9770, typename stce_10547>
DCO_STRONG_INLINE complex<dco::internal::active_type<stce_9770, stce_10547>>
stce_10556(dco::internal::active_type<stce_9770, stce_10547> const& stce_10594,
           dco::internal::active_type<stce_9770, stce_10547> const& stce_10595) {
  return complex<dco::internal::active_type<stce_9770, stce_10547>>(stce_10594 * cos(stce_10595),
                                                                    stce_10594 * sin(stce_10595));
}
} // namespace std
